"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var semantic_ui_react_1 = require("semantic-ui-react");
var FacetTypes_1 = require("./FacetTypes");
var RadioFacet = (function (_super) {
    __extends(RadioFacet, _super);
    function RadioFacet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RadioFacet.prototype.onClick = function (value) {
        var _this = this;
        return function () {
            var selections = [value[0]];
            var thisFacet = {};
            thisFacet[_this.props.facet] = selections;
            _this.context.transition({
                start: 0,
                facets: thisFacet
            });
        };
    };
    RadioFacet.prototype.render = function () {
        var _this = this;
        var title = this.props.title;
        var help = this.props.help;
        var render = this.props.render || FacetTypes_1.defaultRenderer;
        return (React.createElement("div", { className: "ui", style: { marginBottom: '1em' } },
            title ? (help ? (React.createElement(semantic_ui_react_1.Popup, { trigger: React.createElement("h4", null, title), content: help })) :
                React.createElement("h4", null, title))
                : null,
            _.sortBy(this.props.values, function (v) { return v[0]; }).filter(!this.props.initialValues ? _.stubTrue : (function (row) {
                return _.includes(_this.props.initialValues, row.value);
            })).map(function (_a, i) {
                var value = _a.value, count = _a.count, checked = _a.checked;
                return (React.createElement("div", { style: { display: 'block' }, className: "ui radio checkbox" },
                    React.createElement("input", { onClick: _this.onClick({ value: value, count: count, checked: checked }), checked: checked, type: "radio", name: "frequency" }),
                    React.createElement("label", null, render(value, count))));
            })));
    };
    RadioFacet.contextTypes = {
        searchState: React.PropTypes.object,
        transition: React.PropTypes.func
    };
    return RadioFacet;
}(React.Component));
exports.RadioFacet = RadioFacet;
//# sourceMappingURL=RadioFacet.js.map