"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var lodash_1 = require("lodash");
var Radium = require("radium");
var SelectedFilters = (function (_super) {
    __extends(SelectedFilters, _super);
    function SelectedFilters() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SelectedFilters.prototype.onClick = function (facet, value) {
        var _this = this;
        return function () {
            var selections = lodash_1.get(_this.context.searchState.facets, facet, []);
            selections = selections.filter(function (f) { return f !== value; });
            var thisFacet = {};
            thisFacet[facet] = selections;
            _this.context.transition({
                start: 0,
                facets: thisFacet
            });
        };
    };
    SelectedFilters.prototype.render = function () {
        var _this = this;
        var lastType = '';
        var title = this.props.title || lodash_1.identity;
        var facetSelections = lodash_1.flatten(lodash_1.toPairs(this.context.searchState.facets).map(function (_a) {
            var facet = _a[0], values = _a[1];
            return values.map(function (value) { return [facet, value]; });
        })).map(function (_a, i) {
            var facet = _a[0], value = _a[1];
            var display = lastType !== facet ?
                (title(facet) + ': ' + value) :
                value;
            lastType = facet;
            var iconStyle = {
                ':hover': {
                    'transform': 'scale(1.5)'
                }
            };
            return (React.createElement("div", { className: "item", key: facet + '_' + value + '_' + i, onClick: _this.onClick(facet, value) },
                React.createElement("i", { className: "remove circle outline icon", key: facet + '_' + value + '_' + i, style: iconStyle }),
                React.createElement("div", { className: "content" },
                    React.createElement("div", { className: "header" }, display))));
        });
        return (React.createElement("div", { className: "ui mini horizontal list" }, facetSelections));
    };
    SelectedFilters.contextTypes = {
        searchState: React.PropTypes.object,
        transition: React.PropTypes.func
    };
    SelectedFilters = __decorate([
        Radium
    ], SelectedFilters);
    return SelectedFilters;
}(React.Component));
exports.SelectedFilters = SelectedFilters;
//# sourceMappingURL=SelectedFilters.js.map