"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var lodash_1 = require("lodash");
var semantic_ui_react_1 = require("semantic-ui-react");
var CountryFacet = (function (_super) {
    __extends(CountryFacet, _super);
    function CountryFacet() {
        var _this = _super.call(this) || this;
        _this.state = {
            showMoreLink: true,
            typeahead: ''
        };
        _this.onShowMore = _this.onShowMore.bind(_this);
        _this.onChangeTypeahead = _this.onChangeTypeahead.bind(_this);
        return _this;
    }
    CountryFacet.prototype.onClick = function (value) {
        var _this = this;
        return function () {
            var selections = lodash_1.get(_this.context.searchState.facets, _this.props.facet, []);
            if (lodash_1.includes(selections, value)) {
                selections = selections.filter(function (f) { return f !== value; });
            }
            else {
                selections.push(value);
            }
            var thisFacet = {};
            thisFacet[_this.props.facet] = selections;
            _this.context.transition({
                start: 0,
                facets: thisFacet
            });
        };
    };
    CountryFacet.prototype.onShowMore = function () {
        this.setState({ showMoreLink: false });
    };
    CountryFacet.prototype.onChangeTypeahead = function (event) {
        this.setState({ typeahead: event.currentTarget.value });
    };
    CountryFacet.prototype.render = function () {
        var title = this.props.title;
        var help = this.props.help;
        var countryStyle = {
            fill: 'rgb(204, 204, 204)',
            stroke: 'rgb(17, 17, 17)'
        };
        var mainStyle = {
            fill: 'rgb(255, 255, 255)'
        };
        return (React.createElement("div", { className: "ui", style: { marginBottom: '1em' } },
            title ? (help ? (React.createElement(semantic_ui_react_1.Popup, { trigger: React.createElement("h4", null, title), content: help })) :
                React.createElement("h4", null, title))
                : null,
            React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1009", height: "504.5", version: "1.1" },
                React.createElement("rect", { width: "1009", height: "504.5", style: mainStyle }),
                React.createElement("g", { transform: "translate(504.5,252.25)" },
                    React.createElement("g", { id: "innerg", transform: "", style: { strokeWidth: 1 } },
                        React.createElement("path", { className: "country", d: "M186.43139313931405,-112.98640822861826L187.94504450445058,-112.98640822861826L190.06415641564172,-112.25270716795471L190.87143714371453,-111.82564827003178L192.99054905490567,-112.9251888772137L193.89873987398758,-112.25270716795471L194.8069306930695,-113.90640466648199L196.42149214921503,-113.78355289683907L196.9260426042606,-114.33683837454709L197.22877287728787,-115.7561224555002L198.43969396939713,-116.99660702160907L199.9533453345336,-116.18961705497156L199.6506150615063,-115.07637230601468L200.4578957895791,-114.95297142030842L200.15516551655185,-111.94759525974666L201.26517651765192,-110.79133919811852L202.27427742774293,-111.58192137524087L203.4851985198521,-111.88661479305814L205.30158015801595,-113.4766738620303L207.21887188718893,-113.23142736654036L210.14526452645282,-113.23142736654036L210.64981498149828,-112.19165680297333L208.93434343434356,-111.82564827003178L207.5216021602162,-111.15593338170349L204.29247924792494,-110.73062162391348L201.36608660866102,-110.00307737764064L199.6506150615063,-108.49361658928967L200.35698569857,-107.05235088188772L200.6597159715973,-105.32081244523957L199.24697469746994,-103.89590354198543L199.34788478847904,-102.59603564447055L198.64151415141532,-101.36076619778107L195.9169416941696,-101.47818159528731L197.0269526952697,-99.25541087967176L195.31148114811495,-98.38265297617185L194.10056005600575,-96.41390946869599L194.20147014701485,-94.40071603399998L193.09145914591477,-93.48483515663999L192.08235823582376,-93.77075287462644L189.96324632463262,-93.37054278554655L189.66051605160533,-92.40076954922667L187.54140414041424,-92.45773067258064L186.0277527752777,-90.58350319319383L185.9268426842686,-87.82096372459209L182.29407940794098,-86.47650991521938L180.27587758775888,-86.75614591336587L179.77132713271342,-86.02958962024246L178.0558555855587,-86.47650991521938L175.2303730373039,-85.97376744282154L170.58850885088526,-87.65260148400151L173.1112611261127,-90.58350319319383L172.90944094409454,-92.68568025193736L170.79032903290346,-93.25629299862275L170.4875987598761,-95.31936510314455L169.5794079407942,-97.97625162635373L170.79032903290346,-99.83870051032879L169.5794079407942,-100.30617594144081L170.386688668867,-102.7729399369714L171.49669966996717,-107.05235088188772L174.322182218222,-105.73778205520729L176.44129412941308,-106.21508549674039L177.04675467546772,-107.77203669207955L179.2667766776679,-108.25287829758554L180.88133813381356,-109.33787986825297L181.38588858885907,-112.13062044168399L183.80773077307745,-112.80279260886824L184.21137113711387,-114.09078993879515L185.52320232023214,-113.10888942674002Z", id: "Afghanistan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M66.95384538453861,30.82605579167544L67.25657565756589,31.7188493505635L66.95384538453861,33.10957572179128L67.45839583958406,34.45295517115473L67.0547554755477,35.54931504481883L67.25657565756589,36.49748338081867L61.40379037903807,36.49748338081867L61.302880288028895,45.69917732157037L63.22017201720188,48.085086797891215L65.0365536553657,49.91956351241081L59.89013901390153,51.146050749998174L53.12916291629173,50.685783194709146L51.11096109610973,49.30738041671596L39.8090309030904,49.40936247205049L39.30448044804494,49.61338460087158L37.68991899189931,48.28861287513535L35.87353735373549,48.237724306937366L34.15806580658077,48.6958913929712L32.8462346234625,49.256396621718906L32.54350435043514,47.42414305384596L32.94714471447159,44.838627692376235L33.95624562456259,42.214026164983956L34.057155715571675,40.956151652044426L34.965346534653584,38.34754265993348L35.67171717171731,37.19693327625232L37.28627862786294,35.30000089130712L38.194469446944844,34.004902556247714L38.49719971997212,31.91737848573563L38.29537953795394,30.280924427158624L37.48809880988112,29.241170664108175L36.68081808180831,27.51091683644181L36.075357535753675,25.83312382689568L36.17626762676277,25.241637634840068L37.084458445844675,24.108897579437784L36.17626762676277,21.35578041307944L35.67171717171731,19.491189627520907L34.25897589758986,17.678178271022475L34.460796079608045,17.139617683251753L35.67171717171731,16.7969976503142L36.47899789979012,16.84593866935041L37.48809880988112,16.503384017620633L45.661816181618285,16.503384017620633L46.36818681868201,18.608889401518454L47.175467546754824,20.325010679654028L47.88183818381847,21.257574829223493L48.890939093909545,22.73150937398053L50.808230823082454,22.485724767238985L51.71642164216437,22.092577980131992L53.230073007300824,22.485724767238985L53.63371337133727,21.79780434457996L54.34008400840099,20.128769268904943L56.15646564656481,20.030659793914996L56.2573757375739,19.54022323578924L57.670117011701265,19.54022323578924L57.468296829683084,20.52128228616534L60.798329832983434,20.52128228616534L60.899239923992525,22.289134781112036L61.50470047004716,23.370798427993517L61.10106010601071,25.093819447035035L61.302880288028895,26.819710833626168L62.211071107110804,27.9061176379638L62.00925092509262,31.2723332524899L62.71562156215634,31.024372097319333L63.92654265426553,31.073958465519958L65.74292429242934,30.6773490508687ZM34.057155715571675,16.25874802059144L33.350785078507954,14.156370602649469L34.460796079608045,12.935192644521091L35.368986898689954,12.495754894364326L36.37808780878103,13.4235703366513L35.368986898689954,14.009787510644156L34.86443644364449,14.74282185670641L34.7635263526354,15.965234402319519Z", id: "Angola", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M58.881038103810525,-125.5962548744404L58.78012801280144,-124.63312051543778L57.87193719371953,-124.05703958029399L57.771027102710356,-122.90887783726718L56.459195919592084,-121.13328193667843L55.954645464546545,-121.38617026925643L55.853735373537454,-122.14636636936588L54.34008400840099,-123.41851711778801L54.138263826382726,-125.14632327745841L54.34008400840099,-127.66367918975254L54.74372437243736,-128.83437381539443L54.2391739173919,-129.42185510429445L54.037353735373635,-130.66682883458947L55.2482748274829,-132.51343599530549L55.45009500950109,-131.78627291931437L56.15646564656481,-132.11652543080137L56.76192619261936,-131.12714015531202L57.468296829683084,-130.7325333164501L57.670117011701265,-129.35650861388103L57.266476647664895,-128.11827708258738L57.670117011701265,-126.49860067844905Z", id: "Albania", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M157.0665566556657,-75.63895284475264L157.6720172017203,-74.61109526438247L157.9747474747476,-72.13428817937357L156.56200620062023,-72.13428817937357L156.36018601860204,-70.10031895368218L156.8647364736475,-69.67346900855256L155.55290529052922,-69.08730566191038L155.55290529052922,-67.86448019003224L154.7456245624564,-66.59243742095391L154.64471447144732,-65.37709669417173L154.14016401640177,-64.69173606049952L145.66371637163732,-66.2221715713642L144.65461546154634,-69.35363560617964L144.55370537053716,-70.04693726828388L145.0582558255827,-70.20710420100825L145.1591659165918,-69.35363560617964L147.27827782778294,-69.83348328766169L149.59920992099225,-69.78013794833463L151.31468146814694,-69.67346900855256L153.23197319731986,-71.75880134235781L155.35108510851106,-73.74774066044235Z", id: "United Arab Emirates", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-187.74322432243218,184.88110726389817L-189.4586958695869,184.79647040029997L-192.3850885088508,184.79647040029997L-192.3850885088508,174.17074434055849L-191.3759875987598,176.34841832223537L-189.9632463246324,179.86613964429586L-186.33048304830479,182.6923016162835L-182.39498949894983,183.9521013524195L-183.60591059105906,186.410852774133L-186.33048304830479,186.58156480395087ZM-175.73492349234917,64.00392658682911L-170.58850885088506,68.97721482850022L-168.26757675767567,69.45660449274624L-164.83663366336629,71.70155611015878L-162.0111511151114,72.93650635984514L-161.607510751075,74.28344306262406L-164.3320832083208,79.06440986321915L-161.5066006600659,79.9405941365719L-158.3783878387838,80.37951170851734L-156.15836583658358,79.88576830639626L-153.63561356135608,77.48184773707906L-153.1310631063106,74.71549234090557L-151.71832183218314,74.1215541477784L-150.40649064906484,75.90624556134068L-150.40649064906484,78.40870064660811L-152.72742274227417,80.15998372338596L-154.6447144714471,81.47924507997803L-157.7729272927292,84.52193210430146L-161.607510751075,88.94181914181625L-162.21297129712963,91.5437557058387L-163.02025202520247,94.91321980646123L-163.02025202520247,98.26254388035684L-163.62571257125708,98.96025605784968L-163.82753275327525,101.18075612679235L-164.02935293529347,102.94595287207818L-160.39658965896584,105.85298790232476L-160.80023002300223,108.24879985087384L-159.0847584758475,109.75689696836888L-159.1856685668566,111.45601414769297L-161.91024102410233,115.9995461296276L-166.04755475547546,117.92666582211082L-171.69851985198514,118.67654049973486L-174.72582258225816,118.3013286644475L-174.22127212721267,120.43487232320095L-174.72582258225816,123.15924814411729L-174.22127212721267,125.0135710096409L-175.93674367436734,126.36511495807194L-178.76222622262222,126.88195697394664L-181.48679867986792,125.52756802416441L-182.59680968096802,126.49422297783921L-182.1931693169316,130.2029566633517L-180.2758775877587,131.32022240761682L-178.76222622262222,130.13739735254765L-177.9549454945494,132.11204439654742L-180.47769776977694,133.30475538005106L-182.69771977197715,135.70845271425912L-183.20227022702264,139.6340739714208L-183.80773077307722,141.6912020082901L-186.43139313931388,141.76009416296202L-188.6514151415141,143.76714705534835L-189.4586958695869,146.77652927705307L-186.7341234123412,149.75582035549354L-184.00955095509545,150.61450751702012L-185.01865186518646,154.37509251009624L-188.34868486848677,156.72227102572754L-190.1650665066506,161.79757154216747L-192.68781878187812,163.46609117593835L-193.79782978297823,165.5322181160973L-192.8896389638963,170.1988655758016L-191.0732573257325,172.89127069064617L-192.2841784178417,172.65226646577793L-194.80693069306926,171.9369374155585L-201.56790679067902,171.30319517190532L-202.77882788278822,168.6315250562744L-202.67791779177912,165.30163200718113L-204.59520952095204,165.60913714346253L-205.60431043104305,163.9997882982524L-205.80613061306124,159.39403850780474L-203.68701870187016,157.5350922671787L-202.77882788278822,154.81323975201045L-203.08155815581551,152.70371637728977L-201.66881688168812,149.1852239530244L-200.55880588058804,143.8366753409746L-200.86153615361528,141.4846509054871L-199.6506150615061,140.72889837442048L-199.95334533453337,139.22486166119478L-201.26517651765172,138.47652823009327L-200.3569856985698,136.7847486643149L-201.56790679067902,135.37312739321084L-202.2742774277427,130.92529646973958L-201.16426642664263,130.13739735254765L-201.56790679067902,125.59189326855996L-200.96244624462437,121.82504209858209L-200.2560756075607,118.6139669483481L-198.54060406040597,117.30344003043938L-199.34788478847878,113.8408072174696L-199.34788478847878,110.60511356245155L-197.22877287728767,108.30896363142658L-197.32968296829677,105.4358458745682L-195.71512151215117,102.12083730701548L-195.71512151215117,99.01847373523178L-196.42149214921486,98.43681660992698L-197.73332333233316,92.6818153302234L-196.01785178517844,89.33638704101212L-196.32058205820576,86.19332645685476L-195.31148114811475,83.30156409111798L-193.49509950995096,80.32461671019112L-191.4768976897689,78.35411301930634L-192.2841784178417,77.10089967228937L-191.67871787178711,76.12316294772097L-191.7796279627962,70.95179477971016L-188.7523252325232,69.4033102377762L-187.84413441344128,66.27146134004488L-188.1468646864686,65.47905877432335L-185.8259325932593,62.74360324345393L-182.0922592259225,63.47834036723699L-180.47769776977694,65.6902177060105L-179.3676867686768,63.215789849438316L-176.23947394739466,63.373300829754356Z", id: "Argentina", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M130.325382538254,-117.99330304037177L129.31628162816293,-117.9308962081159L128.10536053605375,-119.99841143817851L128.10536053605375,-120.56520947633581L126.89443944394456,-120.56520947633581L126.08715871587175,-121.51270985244123L125.48169816981711,-121.44943209792974L124.37168716871702,-122.52733117047603L122.35348534853503,-123.41851711778801L122.55530553055321,-125.21054884926697L122.15166516651675,-126.49860067844905L125.98624862486265,-127.08044345570988L126.59170917091721,-126.11147394852577L127.60081008100828,-125.46761894065286L127.09625962596274,-124.56904517803083L128.6099109910993,-123.291009415627L127.80263026302646,-122.14636636936588L129.01355135513563,-121.13328193667843L130.22447244724484,-120.50216916399786Z", id: "Armenia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-167.0566556655665,392.02533279652295L-167.86393639363928,400.4056301379219L-168.6712171217121,408.30428455651315L-174.52400240023994,405.8328296575796L-180.7804280428042,407.06386204481373L-184.3122812281227,401.2976873672945L-184.3122812281227,400.4056301379219L-185.8259325932593,395.44092112511794L-179.56950695069503,396.3061223184136L-173.51490149014896,397.7584146883105L-171.39578957895782,391.1825018988931L-169.8821382138213,385.4015611042073ZM-446.27487748774877,383.5192051930283L-451.6231123112312,385.6722494557406L-455.3567856785678,380.07993310985955L-456.97134713471354,374.9261315425668L-457.0722572257226,374.1668780669791L-458.8886388638864,370.1759488816518L-457.1731673167317,364.84248126028245L-452.0267526752675,367.0034233604129L-449.2012701270127,371.41269728982195L-447.0821582158216,376.71154604194ZM-126.59170917091704,362.4743556319724L-123.1607660766076,368.46003827704914L-121.94984498449834,377.22526440194L-121.64711471147106,383.7867883167169L-121.54620462046196,391.74390481066223L-125.88533853385331,396.8854864156802L-130.42629262926286,401.2976873672945L-135.67361736173612,405.2207899825524L-141.5264026402639,408.9280626658426L-148.1864686468646,407.6828904762975L-151.81923192319226,401.89511981354144L-151.41559155915584,394.86666223589197L-145.36098609860983,390.62302515150526L-142.93914391439137,385.1313208365213L-141.22367236723665,378.77617401175826L-139.9118411841183,373.159988413561L-138.29727972797275,368.2163684210227L-136.48089808980893,362.4743556319724L-134.9672467246724,362.4743556319724L-130.82993299329922,359.67697687991483ZM-339.8147314731473,310.12560818634967L-336.18196819681964,311.67533973187597L-332.8519351935193,309.9542978498273L-334.3655865586559,313.5891563904051L-336.9892489248925,316.0570461217098L-340.9247424742474,315.348207041567L-343.7502250225022,311.67533973187597L-343.1447644764476,308.42033669416514ZM-351.9239423942394,309.9542978498273L-347.6857185718572,313.9394884838064L-349.30028002800276,313.5891563904051L-352.9330433043304,312.54254284132827L-356.76762676267623,309.78316254411936L-354.7494249424942,307.7430566754324ZM-277.45229522952286,295.3676533283493L-274.42499249924987,296.62833175115014L-271.2967796779678,295.52472437217176L-269.68221822182215,300.79185034691267L-271.90224022402236,300.14457516789645L-275.23227322732265,300.46790174086226L-278.76412641264125,300.14457516789645L-282.497799779978,300.6297981327584L-285.4241924192419,298.8574393766057L-286.8369336933693,295.05394873414696L-285.12146214621464,293.4941020410156L-281.48869886988695,294.7408255667491ZM-191.8805380538053,286.7965371688289L-191.577807780778,290.7221206581261L-192.08235823582353,294.11631446169906L-192.7887288728872,297.5800585460571L-196.11876187618756,298.8574393766057L-199.24697469746968,300.6297981327584L-202.98064806480642,300.46790174086226L-201.56790679067902,296.7865805745597L-204.89793979397933,298.0579430617432L-208.02615261526145,299.3389637434172L-210.1452645264526,296.62833175115014L-210.2461746174617,293.0289405411159L-207.21887188718864,289.5045435181593L-205.30158015801572,288.44628911269615L-202.07245724572454,288.747974429958L-201.26517651765172,284.4251369246292L-201.06335633563353,281.36198972357795L-201.16426642664263,274.6992517860194L-199.54970497049698,270.98574253913L-196.92604260426035,269.76552708674063L-195.51330133013295,272.76370585889913L-194.80693069306926,275.67527948824176L-193.59600960096006,279.35004335569306L-192.68781878187812,282.9596241070887ZM-401.1819238419252,504.5L-401.1680668066806,504.48343362440994L-400.562606260626,489.9281942940645L-411.5618061806181,488.900532790167L-420.6437143714371,481.8845510014571L-422.9646464646465,470.98190371085116L-430.53290329032905,465.5729536855664L-430.0283528352835,454.44000827738705L-429.0192519251925,444.8022209355799L-427.9092409240924,436.81567054896715L-428.51470147014703,428.1457378290028L-433.15656565656565,422.6130919981032L-435.2756775677568,415.95244581146443L-439.614811481148,410.1828455673658L-432.8538353835383,411.4473905671106L-426.3955895589559,408.30428455651315L-422.25827582758274,414.65248842422295L-417.3136813681367,409.24085153375523L-412.67181718171815,402.49475337295644L-410.45179517951794,396.8854864156802L-411.4608960896089,390.06546119221053L-414.9927492749275,385.9433874044713L-419.1300630063007,381.3941761617918L-424.88193819381934,380.34193752719494L-429.92744274427446,378.25756791183005L-435.37658765876586,376.9682035210608L-437.1929692969297,371.41269728982195L-440.82573257325737,367.0034233604129L-443.0457545754575,362.23941173179423L-443.9539453945394,347.64632658076573L-442.54120412041203,348.7240711329241L-440.0184518451845,352.6633869998537L-435.37658765876586,351.559647884376L-430.93654365436544,349.8089095407758L-428.6156115611561,355.34295787468545L-424.17556755675565,353.99771795734335L-420.4418941894189,351.12021557060035L-416.9100410041004,347.86131255143533L-413.78182818281834,343.6139477678763L-409.543604360436,342.56896893581984L-409.64451445144516,338.04799158600986L-410.65361536153614,333.8448048188408L-409.8463346334633,329.93853022605197L-406.2135713571357,328.01935033178887L-404.5990099009901,331.6849755962888L-400.2598759875987,329.3604429982865L-397.03075307530753,326.6890001754942L-392.99434943494344,326.49981673977373L-389.26067606760677,325.3692159013719L-385.4260926092609,322.7606596976539L-382.3987898789879,320.5568373433465L-379.06875687568754,318.38178292295163L-376.8487348734873,318.92289213828695L-374.9314431443144,319.8286613986756L-370.69321932193213,318.38178292295163L-366.95954595459546,320.19235166275587L-363.12496249624957,320.0104073290412L-359.492199219922,318.56195766133794L-355.65761576157615,319.4657629539264L-351.52030203020297,320.5568373433465L-347.58480848084804,320.19235166275587L-343.548404840484,320.3744948502192L-339.4110911091109,320.5568373433465L-335.57650765076505,320.19235166275587L-332.6501150115011,317.12597913134175L-329.3200820082008,315.5251349717778L-325.7882288228822,317.6630237886557L-322.45819581958193,315.87955409654074L-319.4308930893089,312.3687422408174L-317.61451145114506,315.5251349717778L-316.6054105410541,319.1036527553526L-314.78902890289027,322.57588972634005L-311.8626362636263,319.4657629539264L-308.532603260326,323.5017975453011L-304.7989298929893,324.8067856627433L-301.46889688968895,327.63816191832206L-297.53340334033396,327.0680144258627L-294.0015501550155,325.1815277094487L-289.7633263326332,325.55711619913535L-286.0296529652965,327.0680144258627L-282.09415941594153,328.97616701841224L-280.68141814181416,324.24625105391704L-282.497799779978,320.7393795955741L-283.80963096309625,317.12597913134175L-287.4423942394239,316.2347270114152L-289.0569556955695,312.54254284132827L-289.6624162416241,308.7600055514175L-290.67151715171514,301.76745361411764L-288.552405240524,302.9128536481983L-284.8187318731873,303.57088787018427L-281.18596859685965,302.9128536481983L-277.95684568456846,304.3970701243498L-275.03045304530445,307.2368857850409L-273.8195319531953,310.81260734169354L-270.08585858585855,311.3297129844922L-266.4530953095309,309.9542978498273L-262.6185118511851,308.08135470095516L-259.08665866586654,306.9002851249287L-256.26117611761174,309.27080308785173L-252.52750275027498,308.42033669416514L-250.10566056605654,301.11642350356544L-247.88563856385633,305.39388204055075L-244.6565156515651,307.06850103187L-241.12466246624658,306.2291029017915L-238.80373037303724,309.9542978498273L-235.17096709670963,310.2970939278535L-231.7400240024002,311.5024371375244L-228.40999099909985,313.7642306653071L-226.18996899689964,309.9542978498273L-225.07995799579953,306.56435843602134L-222.25447544754468,310.2970939278535L-218.41989198919885,309.4414155343638L-215.59440944094402,311.5024371375244L-213.6771177117711,314.818544824278L-209.94344434443443,313.9394884838064L-207.01705170517045,311.67533973187597L-204.19156915691565,309.27080308785173L-200.76062606260618,307.9121203725503L-196.82513251325125,306.73223771051545L-193.2932793279327,305.39388204055075L-190.4677967796779,303.40613767943876L-188.8532353235323,300.46790174086226L-188.2477747774777,296.4702311661548L-188.550505050505,292.71954199123263L-189.4586958695869,289.3529594497783L-190.3668866886688,285.90338119765323L-191.27507750775072,282.52241825034787L-191.98144814481438,279.6360165270084L-192.1832683268326,276.51632367611154L-191.8805380538053,273.31449473341024L-190.56870687068698,270.4423559091748L-189.4586958695869,267.2175633992294L-189.0550555055505,264.1826904896378L-189.559605960596,260.9431934906341L-189.9632463246324,258.1416200544584L-188.550505050505,254.88777893223354L-187.03685368536847,252.7926021865055L-185.22047204720462,250.23859808213086L-183.30318031803174,248.07865757891145L-180.98224822482243,246.0627834472633L-179.97314731473142,243.13949946732217L-178.3585858585858,241.29364220135292L-176.64311431143105,239.5804302061383L-173.91854185418535,239.23976205704855L-172.20307030703063,237.20933934817705L-170.18486848684864,235.9798199959874L-167.86393639363928,235.20178521965687L-165.8457345734573,233.5458822230212L-164.23117311731167,231.57879349118411L-162.11206120612053,230.81959847869896L-160.39658965896584,232.45039297868703L-161.5066006600659,234.53758368567455L-164.3320832083208,236.42593813849845L-164.3320832083208,236.42593813849845L-165.54300430042997,237.88357732742242L-167.66211621162108,236.87317448739992L-169.8821382138213,237.43380197391392L-171.90034003400334,239.01301209871752L-173.91854185418535,240.60637185958905L-175.23037303730365,242.56059970733148L-175.63401340134007,245.23937366661167L-175.43219321932185,247.72123376012792L-174.12036203620355,249.99728876488334L-176.03765376537646,251.69346749953328L-178.76222622262222,252.30324585450012L-180.2758775877587,254.6399797215802L-181.89043904390434,256.8829435386413L-183.60591059105906,260.0468743637111L-184.11046104610455,262.7498443917623L-183.10136013601354,265.8914977625338L-181.58770877087701,268.285802697078L-179.3676867686768,270.0359392845896L-177.14766476647657,272.48897259051483L-176.03765376537646,275.67527948824176L-175.43219321932185,278.6371979304238L-174.62491249124906,281.9412165836576L-173.31308130813076,284.71975977207114L-172.50580058005795,287.99476444631597L-172.10216021602156,296.1544735444143L-171.29487948794875,299.4997781256793L-170.99214921492143,303.24154879913766L-170.18486848684864,306.9002851249287L-170.48759875987588,312.1951220189356L-172.10216021602156,316.2347270114152L-173.71672167216715,319.8286613986756L-177.45039503950386,321.10506519872746L-178.76222622262222,324.9940511278424L-180.3767876787678,328.59277846873505L-184.61501150115004,332.66322891686457L-188.34868486848677,334.4387673919258L-191.8805380538053,337.03750964396403L-195.71512151215117,339.47311732129333L-197.93514351435138,344.45471917087093L-202.47609760976093,344.87671636023254L-207.42069206920686,344.45471917087093L-211.8607360736073,345.29979542440554L-216.50260026002596,345.29979542440554L-215.69531953195312,350.2448527405763L-211.35618561856182,352.44204640727025L-208.2279727972797,356.0197261278436L-206.51250125012496,360.604151719782L-209.6407140714071,364.84248126028245L-214.48439843984391,363.6541464457996L-218.41989198919885,367.0034233604129L-218.62171217121707,372.90923080176674L-218.72262226222617,378.77617401175826L-215.39258925892582,383.7867883167169L-214.7871287128712,389.50979678284773L-211.2552755275527,395.7288113175534L-205.30158015801572,398.342976933966L-200.2560756075607,402.7954007194703L-196.32058205820576,408.30428455651315L-191.17416741674162,414.32911822309455L-184.21137113711364,417.26289265661507L-177.3494849484948,422.27348748815695L-172.60671067106705,428.1457378290028L-167.35938593859376,434.9707846764953L-164.63481348134806,445.58380240925646L-163.22207220722066,454.0267577984608L-159.7911291129112,445.9760131353004L-155.25017501750168,439.43432870537634L-150.30558055805574,432.7842981181837L-144.553705370537,427.44374745599896L-139.50820082008192,421.9345922474966L-132.54540454045394,421.5964032886515L-125.68351835183513,424.32185948252516L-120.03255325532544,429.2044549911611L-118.2161716171616,420.586044508896L-114.2806780678067,414.97650366729357L-107.21697169716963,414.65248842422295L-101.6669166916691,410.49806062904867L-96.41959195919584,406.7552292612209L-90.56680668066795,404.30702667046046L-84.41129112911278,401.2976873672945L-80.07215721572152,396.8854864156802L-82.09035903590352,391.1825018988931L-83.30128012801269,385.6722494557406L-83.30128012801269,379.81834803738036L-88.64951495149505,380.34193752719494L-94.40139013901384,382.7190762127857L-99.95144514451438,382.7190762127857L-100.75872587258719,377.22526440194L-100.35508550855076,366.520747076253L-99.04325432543247,363.6541464457996L-95.0068506850684,360.3718668663818L-90.36498649864977,357.3816766308306L-86.93404340434033,353.5517378378412L-83.50310031003087,349.8089095407758L-80.98034803480343,344.87671636023254L-77.14576457645752,342.77743635610244L-73.4120912091208,341.11701750917126L-71.4947994799479,340.29302375361107L-67.15566556655655,339.6777130254376L-63.01835183518346,338.04799158600986L-59.58740874087401,335.83301962856433L-56.15646564656457,333.25296385667383L-53.0282528252824,330.5186382680148L-49.19366936693658,327.0680144258627L-46.67091709170905,323.5017975453011L-44.04725472547241,320.3744948502192L-43.2399739973996,316.2347270114152L-46.16636663666359,313.9394884838064L-45.25817581758169,309.78316254411936L-43.34088408840878,306.73223771051545L-40.4144914491448,304.8947365850191L-37.3871887188718,302.5847997839917L-34.46079607960789,299.66074615012366L-32.34168416841672,296.1544735444143L-30.92894289428935,291.9485116274211L-28.910741074107275,289.5045435181593L-25.580708070807002,289.9601105719317L-24.167966796679554,292.87417053696305L-20.837933793379204,293.3389060186727L-20.73702370237011,289.9601105719317L-19.32428242824274,286.64735142934126L-16.296979697969665,287.3945938918859L-15.59060906090602,290.7221206581261L-12.260576057605668,291.1809771709342L-8.62781278127804,289.6562632232495L-5.095959595959502,288.5970647162732L-1.866836683668241,289.0501971990479L-0.6559155915590579,292.71954199123263L2.3713871387140193,289.8081188219634L5.1968696869688324,288.2956473672497L8.425992599260013,287.0953022873913L11.554205420542184,285.90338119765323L14.379687968796999,283.83741707887737L17.507900790079088,282.52241825034787L19.929742974297532,280.7847234498956L21.645214521452253,277.9273135289341L23.764326432643347,279.9224693999055L26.69071907190733,278.7795292919394L28.70892089208933,282.8137641214321L30.222572257225867,285.754977151756L33.451695169517045,284.1310233152462L34.7635263526354,280.7847234498956L37.589008900890214,278.4949850087656L41.221772177217844,279.0645481772665L42.331783178317934,282.08633130341485L44.65271527152729,279.0645481772665L47.680018001800285,278.06905478569L51.01005100510064,277.7856896674828L53.936443644364545,277.9273135289341L57.06465646564672,278.7795292919394L60.09195919591971,279.35004335569306L61.40379037903807,282.08633130341485L63.22017201720188,284.57238457663453L66.24747474747488,283.1056090956424L69.57750775077523,282.8137641214321L72.80663066306641,282.8137641214321L75.93484348434858,282.52241825034787L78.6594159415943,281.50661208071983L81.6867186718673,280.49682113011346L84.10856085608576,278.21091364557884L86.73222322232238,276.7975923607111L89.65861586158628,275.9551688498133L91.77772777277737,273.7287494182766L93.2913791379139,269.4955389895227L94.90594059405954,266.9515340590437L97.83233323332344,268.1519103086504L98.84143414341445,270.84973485888304L101.2632763276329,272.62628428479945L104.1896689668968,272.0776949072037L106.20787078707889,274.8383444627203L108.22607260726087,276.9384002292967L111.15246524652478,274.9775500952828L112.16156615661578,271.66739939626854L114.68431843184332,270.171304869144L117.50980098009812,267.6173781271112L120.33528352835295,266.55325736038253L123.5644064406442,265.1007180588881L125.78442844284447,263.5299263503285L128.10536053605375,261.71516870949L130.325382538254,260.17463702861676L132.94904490449065,260.9431934906341L135.4717971797181,258.39445113111105L137.28817881788189,256.3820083935634L139.91184118411854,256.63229599602664L142.23277327732788,254.88777893223354L142.73732373237334,252.42545674293422L145.1591659165918,250.48023969306803L147.37918791879204,249.15530855344034L150.20467046704687,248.07865757891145L152.8283328332835,247.48335390960597L155.25017501750187,247.84029437403504L157.8738373837385,248.55635527195494L160.19476947694787,250.48023969306803L160.39658965896604,253.52921239064216L162.91934193419357,255.88250851815735L164.6348134813483,257.88915577064563L167.96484648464866,258.64765016112466L169.78122812281245,260.68662976398133L172.10216021602173,262.7498443917623L174.82673267326746,263.1394461445105L177.04675467546772,261.71516870949L179.46859685968616,258.64765016112466L182.09225922592273,260.3024937505693L184.81683168316843,261.2001370753666L187.44049404940506,261.9732592184315L190.26597659765997,262.62017161473386L192.99054905490567,262.62017161473386L195.31148114811495,270.5780417258511L195.21057105710585,272.48897259051483L194.90784078407856,276.09528524259673L192.18326832683286,278.21091364557884L189.96324632463262,281.21748990235534L190.36688668866907,284.57238457663453L193.49509950995113,284.4251369246292L193.19236923692387,287.69441395151426L191.67871787178734,291.0278868494184L190.36688668866907,294.7408255667491L192.58690869086922,297.5800585460571L195.81603160316052,298.3772867641461L199.04515451545169,296.7865805745597L200.5588058805882,293.3389060186727L201.46699669967012,289.9601105719317L202.98064806480664,287.24488215607505L204.7970297029705,284.71975977207114L205.5034003400342,281.79622528857254L207.01705170517067,277.7856896674828L208.73252325232536,276.9384002292967L211.96164616461667,276.65690024400175L214.68621862186228,275.67527948824176L217.61261126112637,274.4214045170163L218.92444244424465,271.25808104020507L219.73172317231737,268.41979916979807L221.64901490149035,265.49565556734393L224.4744974497451,263.66028237213243L226.79542954295442,262.23173450462656L228.30908090809106,259.6641492129784L229.92364236423654,258.39445113111105L231.94184418441867,257.2595922117222L234.76732673267344,258.01534213577156L237.29007900790094,257.2595922117222L240.01465146514667,256.3820083935634L243.1428642864288,256.8829435386413L245.16106610661078,254.88777893223354L246.5738073807382,250.23859808213086L247.58290829082927,252.0590796843421L248.89473947394754,255.38443498127452L251.31658165816594,256.8829435386413L253.94024402440263,257.3853229659883L256.66481648164836,256.63229599602664L259.4902990299031,257.1339521505351L262.1139613961398,257.2595922117222L263.9303430343036,256.63229599602664L266.251275127513,257.00840264015704L268.370387038704,258.5210045792068L270.8931393139315,257.51114455592887L273.9204420442046,257.51114455592887L276.5441044104413,256.63229599602664L279.4704970497052,257.51114455592887L281.28687868786903,255.13593032082457L282.69961996199635,252.7926021865055L284.6169116911693,250.84332736081467L288.14876487648775,245.70942277900457L289.96514651465174,246.6532963801118L292.08425842584273,248.55635527195494L294.0015501550157,250.96452382230598L297.5334033403342,255.26013842350466L300.2579757975799,255.38443498127452L302.8816381638166,255.38443498127452L305.90894089408954,254.6399797215802L308.9362436243626,253.652282951137L311.25717571757195,251.69346749953328L313.1744674467448,249.63594565100036L316.302680268027,249.39546269776304L318.32088208820903,247.84029437403504L320.54090409040924,249.27534458620858L321.95364536453667,251.45014924946065L323.9718471847186,253.652282951137L326.99914991499173,253.40622839215862L328.9164416441646,255.13593032082457L332.347384738474,257.00840264015704L335.7783278327834,257.76306081484523L338.70472047204737,257.1339521505351L340.9247424742475,254.88777893223354L342.74112411241146,252.67013477817136L345.2638763876389,252.0590796843421L347.78662866286646,253.03779444061306L350.7130213021303,253.77544020690416L353.3366836683671,252.67013477817136L355.8594359435946,252.67013477817136L358.38218821882214,253.40622839215862L361.0058505850587,254.02201533878886L363.52860286028624,252.7926021865055L366.4549954995501,251.69346749953328L369.38138813881403,251.45014924946065L372.5096009600963,251.45014924946065L375.13326332633284,250.7222146031654L377.6560156015604,250.23859808213086L378.4632963296331,246.77163679059325L378.5642064206423,244.0696976415105L380.27967796779694,245.82713101547057L380.78422842284243,248.91548223209887L381.69241924192437,251.81525345761023L382.9033403340336,254.14543348292116L385.22427242724297,255.38443498127452L388.4533953395342,255.01181053603216L392.08615861586185,254.88777893223354L394.60891089108924,254.51621184247327L398.24167416741705,254.51621184247327L400.96624662466274,254.2689388583564L404.5990099009904,254.6399797215802L407.7272227222725,255.13593032082457L409.7454245424545,257.3853229659883L409.13996399639996,260.17463702861676L410.9563456345637,262.3611168278025L413.98364836483665,264.05194053456484L417.1118611861189,266.0236469763445L420.7446244624465,267.3507320419238L424.4782978297832,268.5538999010901L427.40469046904707,269.76552708674063L430.53290329032933,269.90068008361794L432.3492849284931,267.3507320419238L434.87203720372054,269.4955389895227L436.9911491149117,271.940820855179L439.4129912991302,273.7287494182766L442.8439343934395,274.5602718692594L446.07305730573074,275.5355061200509L447.48579857985817,278.6371979304238L450.6140114011403,280.640711570947L452.83403340334064,283.5443163604852L455.96224622462273,284.8672627456451L459.191369136914,284.71975977207114L462.2186718671869,285.1626529692044L465.5487048704873,285.01489373269703L468.87873787378766,285.754977151756L472.0069506950697,286.9458540400223L474.9333433343336,288.8990185064248L477.8597359735977,290.7221206581261L479.77702770277045,293.3389060186727L479.47429742974316,296.7865805745597L477.9606460646067,299.9831443611816L476.7497249724974,304.2315083861346L475.7406240624065,307.7430566754324L474.42879287928827,311.67533973187597L470.7960296029606,313.2395568723201L469.0805580558058,316.9473476106089L465.44779477947816,319.1036527553526L464.23687368736887,323.3162034380694L462.31958195819607,327.2578462613297L460.3013801380141,330.71245921459894L459.0904590459048,335.43346258933985L458.3840884088411,339.6777130254376L458.08135813581373,345.08812030165836L458.1822682268229,349.8089095407758L459.7968296829685,354.66896288069114L460.4022902290231,359.67697687991483L461.71412141214137,364.3661139622679L466.86053605360564,366.27994073014673L467.9705470547057,372.4088649216963L462.92504250425065,374.67265543191763L458.6868186818685,377.7406015502953L453.3385838583861,378.25756791183005L451.0176517651768,387.03246570669495L450.51310131013133,394.58028992010657L449.302180218022,400.99979145505114L447.7885288528856,407.3730816949635L451.52220222022214,413.3628520213713L452.9349434943497,421.2589176429202L455.35678567856803,428.4978759818617L458.7877287728775,435.706219828719L462.72322232223246,442.4798686402755L466.86053605360564,449.549356013578L473.31878187818796,456.9419385073678L474.73152315231545,469.15872119731483L482.8043304330436,474.6912039492684L483.40979097909815,477.0535483578574L485.42799279928016,485.3544104953091L493.1980698069809,478.00825099886976L499.6563156315634,486.864643259451L504.5,494.1048632272314L504.5,504.5L504.5,504.5ZM-504.5,504.5L-504.5,494.1048632272314L-504.5,494.1048632272314L-504.49949549999985,494.10559319885164L-504.39908990899096,494.6354587480173L-501.8763376337634,477.53019390576185L-496.83083308330833,486.35965999645293L-496.52810281028104,485.3544104953091L-493.6017101710171,476.5783060005016L-493.19806980698064,476.5783060005016L-492.8953395339534,477.0535483578574L-488.7580258025802,488.900532790167L-485.2261726172617,477.0535483578574L-484.6207120712071,475.6319978070836L-476.3460846084609,470.52417500104116L-473.7224222422243,477.0535483578574L-472.4105910591059,480.42000733516204L-468.1723672367237,489.9281942940645L-460.2004700470048,497.85174271497L-456.0628572402664,504.5L-504.5,504.5Z", id: "Antarctica", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M193.19236923692387,156.42746481609123L195.00875087508766,157.75730947954568L197.63241324132431,158.27672017598044L197.7333233323334,159.09551091487353L196.9260426042606,161.04351860426974L192.58690869086922,161.34481537139587L192.58690869086922,159.09551091487353L192.99054905490567,157.31310651284687Z", id: "French Southern Territories", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M407.4244924492451,125.46325961796607L410.1490649064909,126.7526438659563L411.6627162716275,126.23607506180514L413.88273827382767,125.52756802416441L415.5982098209823,125.78497017832886L415.8000300030005,130.2029566633517L414.79092909290955,131.5179309863604L414.4881988198822,134.5703034699388L413.58000800080026,133.57062169370155L411.5618061806183,136.2459782958354L411.0572557255727,136.0442608081406L409.24087408740894,135.9098794995093L407.52540254025433,132.5751626265072L407.2226722672269,130.07185596368967L405.6081108110813,126.81729185212063L405.6081108110813,125.14196964531942ZM402.278077807781,38.99873916768746L403.28717871787194,41.25781455717988L405.10356035603576,40.15240548091283L406.0117511751177,41.35840047741106L407.4244924492451,42.51629045883097L407.1217621762177,43.77732330760329L407.7272227222725,46.30739314184323L408.13086308630886,47.77993816138457L408.83723372337255,48.13596127385703L409.6445144514453,50.634667290324266L409.3417841784181,52.17033026792641L410.2499749975,54.173627824990916L413.2772777277729,55.720158931799084L415.2954795479551,57.11629538733716L417.1118611861189,58.4127175112897L416.8091309130915,59.140305521026335L418.42369236923713,61.01663093591298L419.43279327932805,64.31959099764424L420.5428042804282,63.63594812757204L421.7537253725374,64.95162986098435L422.3591859185921,64.47751169585308L422.86373637363755,67.70165859521175L424.88193819381956,69.56321463043678L426.19376937693795,70.73784450380772L428.41379137913816,73.2593302884753L429.12016201620185,75.74364217216511L429.22107210721083,77.53630193094625L429.0192519251927,79.50222817336864L430.33108310831096,82.1959635673248L430.230173017302,85.0224632625763L429.72562256225643,86.47271991997452L428.9183418341837,89.39279384786947L429.0192519251927,91.25989075281342L428.51470147014714,93.59529375601247L427.2028702870289,96.58318340568583L425.18466846684686,98.26254388035684L424.17556755675594,100.8290171971084L423.1664666466649,102.5330962716101L422.3591859185921,105.4358458745682L421.24917491749187,107.16810539895276L420.5428042804282,109.75689696836888L420.240074007401,112.18751833776851L420.34098409841,113.28856195840046L418.72642264226437,114.51735105289282L415.5982098209823,114.6405466234647L413.0754575457547,116.1234440003958L411.7636263626365,117.49024925127657L410.0481548154818,119.05230418378721L407.7272227222725,117.42796444892595L406.0117511751177,116.80594293595752L406.4153915391542,114.94878939627606L404.90174017401756,115.6282065987189L402.4798979897992,118.23884680976872L400.0580558055808,117.24120038830537L398.4434943494352,116.68171828967226L396.82893289328956,116.43344782806552L394.10436043604386,115.38094096379234L392.28797879788004,113.22727264361268L391.78342834283455,110.54443803492225L391.17796779677997,108.7907519908901L389.76522652265254,107.40789229069975L387.0406540654068,106.9884021915575L387.94884488448866,105.31677708186746L387.34338433843396,102.76894091875019L385.93064306430665,105.13826910217252L383.4078907890792,105.73374064732694L384.9215421542156,103.89188862940061L385.325182518252,101.88552770424158L386.4351935193521,100.24373630883028L386.23337333733394,97.79831991798115L383.9124412441247,100.65330847761945L382.19696969696986,101.76794543669638L381.08695869586984,104.4847128696928L378.86693669366963,103.0640221737833L378.9678467846786,101.29809799348061L377.252375237524,98.84385541583212L375.73872387238737,97.62442391941256L376.24327432743297,96.81425536032522L372.7114211421145,94.79839034660384L370.6932193219325,94.74099193845994L368.06955695569576,93.13821506643167L363.02405240524064,93.42380938369016L359.39128912891306,94.62622771877787L356.1621662166219,95.71825070219086L353.53850385038527,95.48802242642536L350.51120112011216,97.21906329628673L348.08935893589376,97.97231830798367L347.58480848084827,99.71799228536712L346.57570757075734,101.12210313598194L344.15386538653877,101.18075612679235L342.43839383938416,101.47420066034111L339.9156415641566,100.88761055032332L337.89743974397464,101.23942107586895L335.9801480148016,101.3567868899046L334.365586558656,103.18214064002925L333.4573957395741,103.0640221737833L332.04465446544685,104.01035361869596L330.73282328232835,105.07879178793763L328.7146214621464,104.95987511282674L326.79732973297354,104.95987511282674L323.87093709370953,102.76894091875019L322.357285728573,102.12083730701548L322.357285728573,100.18527326060466L323.7700270027005,99.71799228536712L324.27457745774603,98.96025605784968L324.1736673667368,97.79831991798115L324.47639763976423,95.43049285957703L324.1736673667368,93.48096017419128L322.7609260926094,90.18354493802137L322.256375637564,88.32276753184927L322.357285728573,86.47271991997452L321.2472747274729,84.41080525477548L321.1463646364638,83.46771659460049L319.93544354435465,82.1959635673248L319.6327132713273,79.72134245160827L318.0181518151817,77.20970074936317L317.6145114511453,75.90624556134068L318.8254325432546,77.2641136410497L317.9172417241727,74.33742170522655L319.32998299829995,75.2562652298817L320.13726372637285,76.44878184686843L320.0363536353637,74.87764094338857L318.7245224522454,72.45278709351552L318.421792179218,71.43361649619557L317.8163316331635,70.52401218721803L318.11906190619084,68.76433883469973L318.6236123612364,68.02016691854637L319.0272527252728,66.48302630295481L318.7245224522454,64.68816478991327L319.93544354435465,62.53390839895774L320.13726372637285,64.84622395992113L321.2472747274729,62.74360324345393L323.5682068206823,61.74845337478782L324.88003800380056,60.442475568320916L327.1000600060008,59.348400838732026L328.31098109811,59.140305521026335L329.11826182618273,59.504534911208964L331.33828382838306,58.360791029826196L333.0537553755378,58.049354699004475L333.4573957395741,57.375291743800936L334.1637663766378,57.11629538733716L335.7783278327834,57.16808323247833L338.70472047204737,56.28846112650183L340.218371837184,54.99783366204368L340.9247424742475,53.40218224591405L342.53930393039315,51.91406953145835L342.74112411241146,50.73690407099467L342.74112411241146,49.15444346909493L344.7593259325935,46.66248394998287L345.8693369336936,49.15444346909493L347.0802580258027,48.594043357042224L346.0711571157118,47.22093320525073L346.97934793479374,45.80050208453124L348.19026902690297,46.40882510666905L348.59390939093936,44.181407399089004L350.10756075607577,42.768289824741316L350.8139313931395,41.60993484123813L352.1257625762577,41.15724447415758L352.22667266726694,40.30303227858977L353.43759375937606,40.654630150667785L353.53850385038527,39.951623548271904L354.7494249424945,39.500087376315044L356.0612561256128,39.14910427978331L358.18036803680394,40.453693816532606L359.69401940194035,42.16366302099862L361.5104010401042,42.214026164983956L363.22587258725883,42.465902879860934L362.6204120412043,40.85562882918438L364.03315331533173,38.54784444072012L365.24407440744096,37.797013593121115L364.84043404340446,37.09696969891958L366.05135513551375,35.44957929783458L367.7668266826684,34.45295517115473L369.17956795679584,34.751803532156266L371.5005000500052,34.25378826058236L371.5005000500052,32.76166841650032L369.38138813881403,31.818107917771428L370.89503950395067,31.421145259919463L372.8123312331235,32.11595578151798L374.2250725072509,33.308448617850054L376.64691469146925,34.004902556247714L377.4541954195422,33.75609730716666L379.1696669666968,34.60236459983648L380.78422842284243,33.805851950483756L381.89423942394257,34.05467324073919L382.49969996999727,33.50737189027317L383.81153115311554,34.901272103375995L383.0042504250428,36.44754886120189L381.99514951495166,37.59692962439238L380.9860486048606,37.69696442515655L381.3896889688972,38.84840758324684L380.48149814981525,40.30303227858977L379.5733073307333,41.71057652236684L379.7751275127515,42.56668212881029L381.99514951495166,44.13088201002963L384.1142614261429,45.091599234791L385.52700270027015,46.10458309631862L387.5452045204523,47.83078460235155L388.35248524852506,47.83078460235155L389.8661366136615,48.594043357042224L390.26977697769803,49.46036074358352L392.8934393439346,50.48134935196625L394.8107310731076,49.46036074358352L395.3152815281529,47.88163570199488L395.9207420742076,46.6117431387505L396.22347234723486,44.99039756451601L397.13166316631674,42.66747776297686L396.7280228022804,41.30810553502246L396.92984298429855,40.453693816532606L396.6271127112714,38.79830448162826L396.92984298429855,36.597362834018966L397.53530353035336,36.048197003111326L397.03075307530776,35.10060987065315L397.7371237123715,33.55711061695148L398.24167416741705,31.96701828230995L398.3425842584261,31.173139986365996L399.3516851685171,30.082780630194968L400.1589658965899,31.52036806097035L400.36078607860804,33.308448617850054L401.06715671567173,33.65659759540591L401.16806680668094,34.85144594473682L402.17716771677186,36.29776606946359L402.37898789879006,37.94711437305275Z", id: "Australia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M45.35908590859101,-148.97645615762292L44.85453545354547,-148.26595802067237L42.331783178317934,-148.19503392243496L40.91904190419057,-147.2750852785407L38.598109810981214,-147.55773927150724L34.66261626162631,-148.6209208409061L34.057155715571675,-150.04652385365222L31.231673167316867,-149.33256663969692L30.92894289428951,-148.5498825622713L29.213471347134867,-149.11883118062914L27.800730073007422,-149.26129840142363L26.488898889889146,-149.97502350309435L26.993449344934607,-150.97815945831675L26.791629162916422,-151.76958192611866L27.69981998199833,-151.98592424939255L29.112561256125694,-150.8345723392135L29.516201620162146,-151.91378624312767L31.93804380438059,-151.76958192611866L33.95624562456259,-152.4915615533224L35.368986898689954,-152.34697365858983L36.17626762676277,-151.48145944623857L36.47899789979012,-152.20248192914818L36.075357535753675,-154.96444642304232L37.084458445844675,-155.47710900057626L38.093559355935675,-157.39209185997177L40.11176117611775,-156.06451198457782L41.72632263226339,-157.76233397390777L42.73542354235438,-158.1332209234009L44.85453545354547,-156.80103804066624L46.16636663666383,-157.02249149582772L47.4781978197821,-156.21161456853704L47.276377637763915,-155.69719666096088L47.579107910791194,-154.23418361015095L47.37728772877301,-152.56389161930989L45.76272627262738,-152.4915615533224L46.26727672767292,-151.6254730535378Z", id: "Austria", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M129.31628162816293,-117.9308962081159L127.39898989899002,-118.36806337661478L125.98624862486265,-120.06132637223287L125.48169816981711,-121.44943209792974L126.08715871587175,-121.51270985244123L126.89443944394456,-120.56520947633581L128.10536053605375,-120.56520947633581L128.10536053605375,-119.99841143817851ZM136.0772577257727,-129.16057548600796L137.59090909090926,-127.20993063026697L139.00365036503663,-124.56904517803083L140.315481548155,-124.44094434853574L141.2236723672369,-123.41851711778801L138.90274027402754,-123.09987032143538L138.39818981898208,-120.31314249178743L137.89363936393653,-119.05655322860457L136.88453845384555,-118.18061469902857L136.98544854485465,-116.43765378278637L136.2790779077909,-116.25160399076537L134.4626962696271,-118.11816227269321L135.4717971797181,-119.872628390288L134.66451645164528,-120.94378223253293L133.55450545054518,-120.69133731522253L130.325382538254,-117.99330304037177L130.22447244724484,-120.50216916399786L129.01355135513563,-121.13328193667843L127.80263026302646,-122.14636636936588L128.6099109910993,-123.291009415627L127.09625962596274,-124.56904517803083L127.60081008100828,-125.46761894065286L126.59170917091721,-126.11147394852577L125.98624862486265,-127.08044345570988L126.69261926192637,-127.72856962406507L128.81173117311747,-126.62777925657417L130.325382538254,-126.43403698948921L130.62811281128128,-126.8216753488414L129.31628162816293,-128.83437381539443L130.02265226522667,-129.35650861388103L130.82993299329948,-129.2258688203514L132.74722472247237,-127.01572567132133L133.95814581458163,-126.75702620142187L134.4626962696271,-127.66367918975254Z", id: "Azerbaijan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M81.28307830783093,8.008497533624597L82.99854985498567,8.2034405867717L83.90674067406756,6.595495096790317L85.31948194819493,6.790359183687252L85.52130213021319,7.911030446747442L86.12676267626775,8.54462016867334L86.12676267626775,9.42211976494248L85.42039203920403,10.056042778656648L84.31038103810394,11.519555993249359L83.30128012801292,12.495754894364326L82.19126912691284,12.64222360748974L81.98944894489465,9.275851021649405Z", id: "Burundi", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M17.205170517051812,-165.7682805655061L16.902440244024532,-162.7870525317744L16.196069606960812,-162.6353113117805L15.893339333933536,-160.22225080475494L13.370587058705999,-162.18074607431268L11.95784578457855,-161.8782491283136L10.040554055405645,-163.92863592295623L8.72872287228737,-165.69130248677163L7.416891689169015,-165.7682805655061L7.013251325132647,-167.31388627270053L9.23327332733283,-168.24683658381812L11.251475147514828,-167.85759348852892L13.875137513751458,-168.79301786537914L15.691519151915273,-166.84898972193514Z", id: "Belgium", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M2.4722972297231114,-30.978150119215698L3.48139813981411,-31.325297163188257L3.98594859485957,-32.56630038567768L5.3986898689870175,-32.814729152025265L6.004150415041648,-33.70971870700007L6.912341234123555,-34.50613139601044L7.921442144214555,-34.55593475898612L10.040554055405645,-32.86442418328632L9.939643964396552,-31.920743771574646L10.545104510451186,-30.23474275719105L10.040554055405645,-29.096088514571687L10.34328432843292,-28.30483711109034L8.930543054305554,-26.576316626163745L8.123262326232739,-25.68856219730808L7.618711871187199,-23.9153588768622L7.618711871187199,-22.095909147892034L7.517801780178107,-17.534598295459922L5.1968696869688324,-17.240842250101682L4.49049904990511,-19.151328117556726L4.591409140914202,-25.68856219730808L4.086858685868662,-26.230984601012867L3.98594859485957,-27.662446636071305L2.9768476847685714,-28.650924815915257L2.0686568656866635,-29.49197523996061Z", id: "Benin", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-15.186968696869572,-29.19504370752278L-15.388788878887757,-30.87899157644864L-14.581508150814942,-32.06967282485451L-14.682418241824113,-33.01352792218591L-12.462396239623851,-35.40309686747903L-12.058755875587485,-37.40029273867859L-11.25147514751467,-38.100640901247175L-9.939643964396314,-37.70035565773935L-8.72872287228713,-38.300870553388876L-8.325082508250683,-39.05225507391249L-6.205970597059593,-40.30643664564345L-5.701420142014054,-41.21093667372175L-3.0777577757775036,-42.41893505829885L-1.4631963196318731,-42.82211992559482L-0.7568256825681499,-42.267808211611964L0.9586458645865727,-42.31817975520221L0.7568256825683887,-40.90929581227642L1.1604660466047565,-39.55364336624699L2.775027502750387,-37.70035565773935L2.775027502750387,-36.30115061884937L6.004150415041648,-35.65244582434926L6.004150415041648,-33.70971870700007L5.3986898689870175,-32.814729152025265L3.98594859485957,-32.56630038567768L3.48139813981411,-31.325297163188257L2.4722972297231114,-30.978150119215698L0.050455045504665466,-31.027733763721287L-1.2613761376136892,-31.275695913471427L-2.1695669566955966,-30.829416668393517L-3.3804880488047795,-31.027733763721287L-8.325082508250683,-30.87899157644864L-8.325082508250683,-29.294009866863473L-8.022352235223408,-27.11922801829336L-9.939643964396314,-27.860058098867512L-11.25147514751467,-27.761247164464056L-12.159665966596576,-27.020494191640378L-13.47149714971485,-27.662446636071305L-13.97604760476039,-28.601475688896187Z", id: "Burkina Faso", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M258.88483848384857,-59.19584704744593L258.0775577557758,-60.759098207752984L257.87573757375765,-62.32786660683065L257.3711871187121,-63.744615624301744L256.1602660266028,-65.53541692783999L253.63751375137528,-65.640997298041L253.83933393339348,-64.37579325116087L252.93114311431157,-62.69472455962523L251.82113211321146,-63.32435050503823L251.31658165816594,-62.79959828952928L250.61021102110237,-63.114372701463815L249.5002000200021,-63.376861038975974L249.09655965596573,-65.85223878924114L248.08745874587484,-68.1831176139511L248.5920092009202,-69.99356286586973L246.87653765376555,-70.84843113041033L247.4819981998201,-71.97332006047243L249.19746974697492,-73.1015314677506L247.1792679267929,-74.77319806064888L248.18836883688382,-76.88708150930648L250.408390839084,-75.53062178839136L251.72022202220245,-75.36818524907763L252.02295229522966,-73.20915583915264L254.64661466146634,-72.77884251024285L257.2702770277029,-72.83260486174503L258.88483848384857,-72.29532429289583L257.5730073007303,-69.67346900855256L256.362086208621,-69.51351984309598L255.4538953895391,-67.7583238182548L256.9675467546757,-66.2221715713642L257.4720972097211,-68.12999380520579L258.1784678467848,-68.1831176139511L259.6921192119214,-63.32435050503823L259.59120912091225,-61.176890026313835L258.6830183018304,-61.647378753793014Z", id: "Bangladesh", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M79.97124712471258,-136.4524353611541L78.55850585058522,-134.84213881063582L77.54940494049421,-132.11652543080137L78.45759575957612,-129.94526734250175L76.03575357535767,-130.46982362599897L73.10936093609376,-129.2258688203514L73.10936093609376,-127.40429063315905L70.58660866086623,-127.01572567132133L68.56840684068423,-128.31336604808814L66.34838483848397,-127.33948671321927L64.33018301830197,-127.40429063315905L64.12836283628378,-129.87977841333847L62.71562156215634,-131.12714015531202L63.11926192619271,-131.65430029477523L62.816531653165434,-132.11652543080137L63.32108210821097,-133.30925905434054L64.33018301830197,-134.5080521903453L63.018351835183616,-136.18327895768655L62.71562156215634,-137.59984499620404L63.42199219922007,-138.48113296560075L64.22927292729288,-136.85675541475484L65.33928392839297,-137.1942278663368L67.45839583958406,-136.58713051254088L71.59570957095723,-136.3851170490797L73.00845084508468,-137.32935460036225L76.33848384838495,-138.27745971293373L78.35668566856695,-136.85675541475484Z", id: "Bulgaria", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-217.41079107910787,-68.55518189398704L-218.01625162516248,-68.39568335949447L-218.72262226222617,-70.15370792895783L-219.8326332633263,-71.06244255969357L-219.22717271727166,-73.04773080967169L-218.31898189818975,-72.8863748603199L-217.41079107910787,-70.36733686684485ZM-218.11716171617158,-77.32222461370696L-221.2453745374537,-76.778377818354L-221.44719471947187,-77.97593088844837L-220.13536353635357,-78.19409933870047L-218.21807180718068,-78.08499839564085ZM-215.89713971397134,-77.32222461370696L-216.30078007800776,-75.0976173152805L-216.90624062406235,-75.53062178839136L-216.80533053305328,-77.15898425484104L-218.11716171617158,-78.35781357817541L-218.11716171617158,-78.74010771662967Z", id: "Bahamas", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M53.835533553355454,-135.7130027717005L53.33098309831,-135.3776709190678L52.422792279228084,-134.5080521903453L52.01915191519164,-132.3810586351686L49.4963996399641,-133.8413021373733L48.38638863886401,-135.44469876899245L47.37728772877301,-136.2505388647929L46.065456545654655,-137.73520894233232L45.4599959996001,-138.9570726728605L44.047254725472655,-140.80215120008398L44.65271527152729,-142.45485537111196L45.661816181618285,-141.48931661264172L46.26727672767292,-142.3166690741936L47.579107910791194,-142.45485537111196L50.00095009500964,-141.7647655345702L51.91824182418255,-141.83368003381196L53.230073007300824,-140.93941838488473L54.2391739173919,-140.93941838488473L53.53280328032818,-139.22948141286477L54.844634463446454,-137.73520894233232L54.440994099410084,-135.9144334899488Z", id: "Bosnia and Herzegovina", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M74.21937193719386,-188.30278759523182L75.93484348434858,-189.16620372784845L78.96214621462158,-191.07935030811402L81.88853885388549,-189.85971048915653L82.29217921792193,-188.64769410098708L83.7049204920493,-189.16620372784845L86.53040304030421,-188.0445082658126L86.73222322232238,-185.73525485060614L86.12676267626775,-184.37955695901428L87.94314431443156,-181.19671069374965L89.05315531553165,-180.36756524874312L88.85133513351347,-179.5418673729234L90.76862686268638,-178.63753861262234L91.5759075907592,-177.41093010509704L90.4658965896591,-176.43502743835043L88.24587458745891,-176.59734839914566L87.74132413241338,-176.11077871626642L88.34678467846801,-174.57769549495896L89.05315531553165,-171.6251903575002L86.63131313131328,-171.38766960593992L85.72312231223137,-170.36159922071928L85.62221222122228,-168.09105097236656L84.51220122012212,-168.55876236228272L81.98944894489465,-168.32477366464244L81.18216821682184,-169.34065613425008L80.17306730673084,-168.55876236228272L79.06305630563068,-169.26233250423184L76.94394439443958,-169.34065613425008L73.81573157315742,-170.44034482010503L70.8893389338935,-170.7556312156865L68.77022702270241,-170.67676395565096L67.25657565756589,-169.41900970818688L65.8438343834385,-169.26233250423184L65.8438343834385,-171.3085575435662L64.93564356435652,-173.37554333607406L66.65111511151125,-174.33669222821592L66.65111511151125,-176.1917918315964L65.8438343834385,-177.98241067157554L65.74292429242934,-180.0368744217502L68.46749674967506,-180.0368744217502L71.49479947994814,-181.8625338715236L72.20117011701187,-184.5485079765775L74.42119211921204,-186.16084064465113Z", id: "Belarus", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-247.58290829082907,-52.7380364040547L-247.48199819981994,-52.32762493023249L-246.97744774477442,-52.32762493023249L-247.07835783578355,-51.50778877926865L-247.48199819981994,-50.22938098165493L-247.28017801780175,-49.7699117695587L-247.58290829082907,-48.69934417199367L-247.38108810881084,-48.444758025429465L-247.68381838183817,-46.97046622542489L-248.28927892789275,-46.20941659184457L-248.79382938293824,-46.10801992807351L-249.29837983798373,-45.09503007602514L-250.10566056605654,-45.09503007602514L-249.90384038403838,-48.393854994920204L-249.90384038403838,-50.68924882986594L-249.90384038403838,-51.14951943451949L-249.60111011101105,-51.303033185412275L-249.09655965596556,-50.9449047338751L-248.08745874587456,-52.68671682713986Z", id: "Belize", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-188.1468646864686,65.47905877432335L-190.1650665066506,65.9014843333601L-191.27507750775072,61.74845337478782L-192.7887288728872,58.360791029826196L-191.8805380538053,55.462061819577855L-193.39418941894186,54.225100217414834L-193.69691969196913,52.11906786911505L-195.10966096609656,50.07271887001871L-193.2932793279327,46.91625609895335L-194.50420042004194,44.48464952455695L-193.89873987398735,43.47443779672528L-194.40329032903287,42.415519386607635L-193.2932793279327,40.956151652044426L-193.2932793279327,38.49776348995306L-193.09145914591454,36.49748338081867L-192.4859985998599,35.49944548704029L-194.90784078407836,30.925208120861335L-192.8896389638963,31.173139986365996L-191.3759875987598,31.073958465519958L-190.7705270527052,30.23138421769636L-188.34868486848677,29.09273432179211L-186.83503350335027,28.00494389826379L-183.20227022702264,27.51091683644181L-183.5050005000499,29.63712209544359L-183.10136013601354,30.7269150705986L-183.40409040904083,32.66229424936479L-180.2758775877587,35.25014812605353L-177.14766476647657,35.6989439799719L-176.03765376537646,36.79716353832187L-174.22127212721267,37.34690521080784L-173.01035103510344,38.19735475547804L-171.29487948794875,38.147299413499866L-169.579407940794,38.99873916768746L-169.4784978497849,40.70487396245986L-168.97394739473938,41.509309144327304L-168.8730373037303,42.768289824741316L-169.7812281228122,42.8187020292257L-168.6712171217121,46.2059791529345L-163.32298229822976,46.35810687453857L-163.72662266226615,48.0342170082567L-163.4238923892389,49.205417641042445L-161.91024102410233,50.02166218753282L-161.20387038703865,51.862832732785094L-161.70842084208414,54.173627824990916L-162.51570157015692,55.462061819577855L-162.21297129712963,57.16808323247833L-163.12116211621156,57.789984247728455L-163.12116211621156,56.85744155709604L-165.7448244824482,55.35886158732448L-168.3684868486848,55.30726972166332L-173.21217121712164,56.185083240004296L-174.52400240023994,58.776367087774176L-174.62491249124906,60.390316303756705L-175.73492349234917,64.00392658682911L-176.23947394739466,63.373300829754356L-179.3676867686768,63.215789849438316L-180.47769776977694,65.6902177060105L-182.0922592259225,63.47834036723699L-185.8259325932593,62.74360324345393Z", id: "Bolivia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-153.1310631063106,74.71549234090557L-152.62651265126505,72.93650635984514L-152.22287228722863,71.11233516511894L-152.22287228722863,69.4033102377762L-153.2319731973197,68.87076256776882L-154.24107410741067,69.35002318293039L-155.35108510851077,69.24347064625822L-155.65381538153807,68.02016691854637L-155.9565456545654,65.26800711849036L-156.46109610961088,64.31959099764424L-158.3783878387838,63.53086982038509L-159.48839883988393,64.1091218973497L-162.41479147914782,63.53086982038509L-162.21297129712963,59.45248424768818L-163.12116211621156,57.789984247728455L-162.21297129712963,57.16808323247833L-162.51570157015692,55.462061819577855L-161.70842084208414,54.173627824990916L-161.20387038703865,51.862832732785094L-161.91024102410233,50.02166218753282L-163.4238923892389,49.205417641042445L-163.72662266226615,48.0342170082567L-163.32298229822976,46.35810687453857L-168.6712171217121,46.2059791529345L-169.7812281228122,42.8187020292257L-168.8730373037303,42.768289824741316L-168.97394739473938,41.509309144327304L-169.4784978497849,40.70487396245986L-169.579407940794,38.99873916768746L-171.29487948794875,38.147299413499866L-173.01035103510344,38.19735475547804L-174.22127212721267,37.34690521080784L-176.03765376537646,36.79716353832187L-177.14766476647657,35.6989439799719L-180.2758775877587,35.25014812605353L-183.40409040904083,32.66229424936479L-183.10136013601354,30.7269150705986L-183.5050005000499,29.63712209544359L-183.20227022702264,27.51091683644181L-186.83503350335027,28.00494389826379L-188.34868486848677,29.09273432179211L-190.7705270527052,30.23138421769636L-191.3759875987598,31.073958465519958L-192.8896389638963,31.173139986365996L-194.90784078407836,30.925208120861335L-196.52240224022398,31.421145259919463L-197.73332333233316,31.073958465519958L-197.63241324132406,26.770357956772298L-199.85243524352427,28.40035433533L-202.37518751875183,28.35091875791928L-203.38428842884284,26.819710833626168L-205.30158015801572,26.671659713790085L-204.69611961196114,25.438761576259267L-206.20977097709763,23.71518276065759L-207.42069206920686,21.159377148552995L-206.71432143214312,20.668505986204032L-206.71432143214312,19.44215782751771L-204.99884988498843,18.657891169872986L-205.30158015801572,17.139617683251753L-204.59520952095204,16.16090418116679L-204.39338933893384,14.84058258772047L-201.16426642664263,12.935192644521091L-198.8433343334333,12.349296554698416L-198.43969396939687,11.958790765123398L-195.91694169416937,12.105222041231084L-194.70602060206014,4.403875280318411L-194.60511051105104,3.186689054122882L-195.10966096609656,1.5802720634112344L-196.32058205820576,0.5580991735268765L-196.32058205820576,-1.4862201844259346L-194.70602060206014,-1.9729859878951386L-194.10056005600555,-1.6809246168046172L-194.10056005600555,-2.7518508395307024L-195.71512151215117,-3.0439408631704223L-195.71512151215117,-4.7967263109388645L-190.26597659765972,-4.699336279315192L-189.35778577857778,-5.673320266247903L-188.550505050505,-4.7967263109388645L-188.0459545954595,-3.1413063943214032L-187.4404940494049,-3.4820950811633753L-185.9268426842684,-2.021663491441054L-183.80773077307722,-2.167697134453958L-183.20227022702264,-3.0439408631704223L-181.18406840684062,-3.6768384150597204L-179.97314731473142,-4.163721029982863L-179.67041704170413,-5.332403972815976L-177.65221522152206,-6.160388262828348L-177.8540354035403,-6.744945032199435L-180.17496749674962,-6.988536273523168L-180.57860786078604,-8.742901908945642L-180.47769776977694,-10.644648332357841L-181.6886188618861,-11.376471848030993L-181.18406840684062,-11.620464697634409L-179.06495649564948,-11.230088758183719L-176.84493449344927,-10.547088869947137L-176.03765376537646,-11.230088758183719L-174.01945194519445,-11.669266463293505L-170.89123912391233,-12.69435903727728L-169.8821382138213,-13.768820188582136L-170.28577857785774,-14.550630140710071L-168.7721272127212,-14.697257249509834L-168.16666666666657,-14.061959784237192L-168.570307030703,-12.792013175059987L-167.56120612061198,-12.401424584462399L-166.95574557455737,-11.083714983868296L-167.66211621162108,-10.10811886802566L-168.16666666666657,-7.719408670177772L-167.46029602960292,-6.306519504403868L-167.2584758475847,-4.991511701206058L-165.54300430042997,-3.6768384150597204L-164.13026302630257,-3.530780423452073L-163.82753275327525,-4.066341588823973L-162.9193419341933,-4.212411322352487L-161.70842084208414,-4.699336279315192L-160.80023002300223,-5.429806109615318L-159.1856685668566,-5.1863044332106965L-158.4792979297929,-5.283703642018867L-156.96564656465637,-5.08890713156123L-156.7638263826382,-5.624616409595504L-157.16746674667462,-6.209098104201242L-156.96564656465637,-7.037256432330943L-155.75472547254716,-6.744945032199435L-154.44289428942886,-7.037256432330943L-152.82833283328324,-6.452655965680684L-151.61741174117404,-5.868140954049999L-150.81013101310123,-6.64751290975341L-150.10376037603754,-6.501369300322488L-149.80103010301022,-5.7220246445338L-148.38828882888282,-5.916847463728824L-147.3791879187918,-6.988536273523168L-146.4709970997099,-9.084143131696031L-144.85643564356428,-11.620464697634409L-143.84733473347328,-11.76687322659182L-143.14096409640956,-10.20566112389478L-141.627312731273,-5.283703642018867L-140.11366136613657,-4.845421985905639L-140.01275127512747,-2.897894653075956L-142.13186318631855,-0.6100731421827668L-141.32458245824574,0.2660557405851277L-136.27907790779068,0.7041215218044721L-136.17816781678158,3.478794419994138L-134.0590559055905,1.6776245502672165L-130.52720272027196,2.651189232526742L-125.88533853385331,4.355183439710228L-124.57350735073497,6.010959920398451L-124.9771477147714,7.569918336990442L-121.74802480248015,6.692925909075353L-116.29887988798872,8.2034405867717L-112.06065606560645,8.057232180237731L-107.92334233423337,10.397450145592366L-104.39148914891483,13.570107596985169L-102.17146714671456,14.351833048432663L-99.8505350535053,14.498443784706968L-98.84143414341428,15.37836562627746L-97.83233323332321,18.951938262230044L-97.42869286928685,20.668505986204032L-98.53870387038693,25.340194871941552L-99.95144514451438,27.21462460952023L-103.88693869386927,31.173139986365996L-105.7033203320331,34.4031585612648L-107.72152215221509,36.89708487064882L-108.42789278927883,36.9470507996374L-109.23517351735164,39.04885713954657L-109.03335333533346,44.48464952455695L-109.84063406340627,49.00154974974677L-110.14336433643354,50.94143740847462L-110.95064506450635,52.11906786911505L-111.4551955195519,56.081727726718704L-114.3815881588158,59.97326076306958L-114.78522852285217,63.05833670660166L-117.10616061606153,64.37222466026314L-117.71162116211615,66.21858712444529L-120.73892389238915,66.21858712444529L-125.1789678967896,67.3834016700048L-127.1971697169716,68.71113764904447L-130.32538253825376,69.61653052685635L-133.55450545054495,72.07698668958061L-135.97634763476339,75.14804711538555L-136.37998799879983,77.48184773707906L-135.8754375437543,79.22852780163946L-136.48089808980893,82.41679551457788L-137.0863586358635,83.9666677673656L-139.0036503650364,85.74679200636547L-142.13186318631855,91.43017872521793L-144.6546154615461,94.05305611750325L-146.4709970997099,95.60311454364466L-147.78282828282823,98.78567243131197L-149.59920992099205,100.711866170962L-150.40649064906484,98.78567243131197L-149.19556955695563,97.21906329628673L-150.81013101310123,94.91321980646123L-153.03015301530144,93.13821506643167L-155.8556355635563,91.03298441029295L-156.96564656465637,91.08969556342065L-159.7911291129112,88.60400615156568L-161.607510751075,88.94181914181625L-157.7729272927292,84.52193210430146L-154.6447144714471,81.47924507997803L-152.72742274227417,80.15998372338596L-150.40649064906484,78.40870064660811L-150.40649064906484,75.90624556134068L-151.71832183218314,74.1215541477784Z", id: "Brazil", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M323.5682068206823,-15.283889117144811L323.3663866386641,-13.866528254026315L323.265476547655,-12.108531309795499L321.95364536453667,-12.157344037576852L321.3481848184821,-11.230088758183719L320.0363536353637,-12.69435903727728L321.1463646364638,-13.71996806483214Z", id: "Brunei Darussalam", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M248.89473947394754,-79.56070709589736L250.71112111211139,-81.92386341004479L252.22477247724785,-82.69678456483527L254.24297429742998,-81.97901394405302L255.75662566256645,-81.92386341004479L256.9675467546757,-81.04266011646972L258.0775577557758,-80.05399011635528L257.87573757375765,-78.08499839564085L255.65571557155727,-78.03046046634702L253.23387338733892,-78.24866236762198L251.51840184018428,-77.75789593957396L248.89473947394754,-78.90407466228153Z", id: "Bhutan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M82.39308930893102,63.53086982038509L78.45759575957612,65.79583753145201L75.93484348434858,68.0732761825039L75.02665266526668,70.09669965719206L74.21937193719386,71.27294234111376L72.70572057205732,71.4871894647615L72.20117011701187,72.99029115428891L71.8984398439845,73.9597356006053L70.0820582058207,74.66145861315434L67.76112611261142,74.49940474733681L66.44929492949306,73.63630883034772L65.23837383738389,73.2593302884753L63.92654265426553,73.9597356006053L63.22017201720188,75.4727971733187L61.90834083408353,76.39449173984663L60.495599559956155,77.80869729551247L58.477397739774084,78.13584639794783L57.87193719371953,77.04651147192581L58.17466746674681,75.14804711538555L56.459195919592084,72.18432039054247L55.752825282528356,71.70155611015878L55.752825282528356,62.7960428610823L58.477397739774084,62.69116999478825L58.578307830783174,52.06781060179651L60.596509650965245,51.96531143869938L64.93564356435652,50.94143740847462L66.0456545654567,52.17033026792641L67.8620362036205,50.99258322928428L68.66931693169333,50.99258322928428L70.28387838783888,50.328075957034315L70.78842884288441,50.53245037461104L71.79752975297542,52.88854587612344L72.40299029903004,53.45357480385669L73.31118111811196,55.15252705562653L76.43939393939404,58.4127175112897L77.6503150315033,58.7243995120563L77.6503150315033,59.81696470689092L78.45759575957612,61.69613993145593L80.6776177617763,62.167186403010604Z", id: "Botswana", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M64.02745274527462,-31.424508521639755L64.33018301830197,-30.185205198510292L65.9447444744476,-28.403705967459736L65.9447444744476,-27.217972001119108L65.54110411041115,-26.033706084060217L65.74292429242934,-25.195703134908943L66.65111511151125,-24.35838017197814L68.77022702270241,-23.128209202192284L70.38478847884805,-21.997642819994088L70.38478847884805,-21.06451564500956L72.30208020802095,-19.592583129456774L73.41209120912104,-18.36722783088425L74.11846184618477,-16.6535015439252L76.23757375737586,-15.577280837913507L76.6412141214123,-14.648380194895534L75.7330233023304,-14.35514612471865L73.91664166416659,-14.45288546281981L71.79752975297542,-14.746135661892204L70.78842884288441,-14.501757132009935L70.38478847884805,-13.817673583462076L69.47659765976614,-13.71996806483214L68.36658665866597,-14.30627844668355L65.23837383738389,-12.889672033488196L63.92654265426553,-13.182677296159705L63.62381238123825,-12.987335648908855L62.71562156215634,-11.278882080371623L60.69741974197434,-11.81567823329369L58.578307830783174,-12.108531309795499L56.862836283628454,-13.133840070931502L54.541904190419174,-14.11082090156109L53.02825282528264,-13.182677296159705L51.91824182418255,-11.76687322659182L51.71642164216437,-9.815514301679384L49.90004000400055,-9.961812455980416L47.98274827482764,-10.449533294474987L46.26727672767292,-8.937891965537345L44.85453545354547,-6.355231072210803L44.5518051805182,-7.134698696431206L44.4508950895091,-8.401700120770261L43.13906390639075,-9.327911861974366L42.129962996299746,-10.79099489309289L41.82723272327248,-11.76687322659182L40.515401540154116,-13.23151573790938L40.717221722172305,-14.11082090156109L40.515401540154116,-15.283889117144811L40.717221722172305,-17.48563492214732L41.32268226822694,-17.975342275252157L42.73542354235438,-20.819074616432324L45.05635563556366,-21.06451564500956L45.560906090609194,-21.752012727970705L46.065456545654655,-21.702892796863054L46.77182718271838,-21.06451564500956L50.30368036803692,-22.145045392953346L51.5146014601461,-23.275757176340587L52.927342734273545,-24.25991521094031L52.72552255225536,-25.24497837480348L53.43189318931909,-25.540679490563203L56.15646564656481,-25.343535932202006L58.78012801280144,-26.67500522451294L60.798329832983434,-29.739494333961126L62.211071107110804,-30.92856939175736Z", id: "Central African Republic", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-178.4594959495949,-147.69920168390706L-176.44129412941288,-147.20447808180265L-173.81763176317625,-147.2750852785407L-175.23037303730365,-145.6567703190166L-176.23947394739466,-145.37652068428923L-179.8722372237223,-147.0633311043563L-180.57860786078604,-148.47886716216973L-179.4685968596859,-149.68925497162454ZM-173.31308130813076,-158.43039685043303L-174.62491249124906,-158.35606390499626L-178.25767576757673,-159.69805813612732L-180.88133813381333,-161.72716397992357L-179.8722372237223,-162.1050809402373L-176.23947394739466,-160.97336302215737L-173.31308130813076,-159.17516140990605ZM-346.1720672067206,-155.84404728718616L-347.58480848084804,-155.2572467019392L-352.22667266726677,-157.17025482820864L-353.03395339533955,-158.72798905755914L-355.55670567056706,-160.22225080475494L-356.06125612561254,-161.4253192726159L-358.9876487648765,-162.25643851781925L-360.0976597659766,-164.61659670924757L-359.7949294929493,-165.61435298076623L-356.8685368536853,-164.69317732882007L-355.1530653065306,-164.00496391617412L-352.529402940294,-163.54741438479508L-351.52030203020297,-162.0294430889477L-350.2084708470847,-159.997437553716L-347.3829882988299,-158.2074759664579ZM-157.36928692869282,-165.30684011923512L-159.2865786578657,-161.4253192726159L-157.36928692869282,-162.9389038470763L-155.55290529052897,-161.95383249383227L-156.46109610961088,-160.4473037034272L-154.0392539253925,-159.32442874623817L-152.72742274227417,-160.37225939999306L-149.90194019401932,-159.02599915131336L-150.81013101310123,-155.91751032791075L-148.7919291929192,-156.65352981466935L-148.48919891989192,-154.3800383105455L-147.58100810081,-151.76958192611866L-148.7919291929192,-148.19503392243496L-150.10376037603754,-147.9823981783649L-151.92014201420136,-148.76306611890644L-151.31468146814672,-152.1302720698759L-152.12196219621953,-152.7086241020381L-155.35108510851077,-149.11883118062914L-156.96564656465637,-149.26129840142363L-155.04835483548348,-151.1937173130244L-157.6720172017201,-152.20248192914818L-160.6993199319931,-151.91378624312767L-166.1484648464846,-152.05808618413744L-166.552105210521,-153.28852205228338L-164.83663366336629,-154.74510747404193L-166.04755475547546,-155.91751032791075L-163.72662266226615,-158.50475581333686L-160.80023002300223,-165.38367561663236L-159.0847584758475,-167.93538323126702L-156.66291629162907,-169.49739325615022L-155.35108510851077,-169.34065613425008L-155.8556355635563,-168.09105097236656ZM-373.3168816881688,-181.2798162587977L-372.0050505050505,-180.69880768100998L-369.28047804780476,-181.0306040503465L-370.1886688668867,-175.70620227188553L-367.66591659165914,-172.02167536708433L-368.8768376837683,-172.02167536708433L-370.49139913991394,-174.09597625986027L-371.60141014101407,-176.27283763448594L-373.0141514151415,-177.7372904660639L-373.51870187018704,-179.7892168972201ZM-222.25447544754468,-223.92556318649295L-223.26357635763569,-220.82681478199572L-224.57540754075401,-221.3396262069144L-225.28177817781776,-223.09405797117137L-225.18086808680866,-223.50933505741756L-224.07085708570852,-225.2849331952615L-222.9608460846084,-225.1800038238669ZM-229.62091209120908,-227.29023135270722L-232.85003500350032,-223.92556318649295L-234.8682368236823,-224.13403544710133L-235.47369736973693,-225.7052592743447L-233.3545854585458,-228.56829300626657L-229.52000200019995,-228.46144154118514ZM-238.70282028202814,-246.30675564293128L-238.19826982698265,-243.26337462960493L-236.78552855285525,-244.31092836167718L-235.17096709670963,-242.56843647988367L-232.0427542754275,-240.27146819829983L-228.91454145414536,-238.22930338051157L-228.61181118111804,-235.2093043746684L-226.59360936093606,-235.76472087073662L-224.57540754075401,-233.55333210658972L-227.09815981598155,-231.5861621143552L-231.43729372937293,-233.1143144099913L-232.95094509450942,-235.9873719741938L-235.77642764276422,-232.56705018157342L-239.71192119211918,-229.4253919188417L-240.72102210221016,-233.00472783609575L-244.555605560556,-232.45779747047186L-242.03285328532849,-235.54234701265824L-241.7301230123012,-240.72848803714732L-240.72102210221016,-246.77966267833972ZM-212.66801680168012,-256.7660713637399L-215.79622962296227,-256.390486764394L-216.50260026002596,-259.92785807605935L-215.2916791679167,-264.0608017406188L-212.76892689268922,-265.1096331647197L-210.548904890489,-263.0182895044817L-210.548904890489,-259.92785807605935L-210.8516351635163,-258.9098202491445ZM-268.16856685668563,-271.40365885503377L-269.88403840384035,-268.6972074271321L-273.6177117711771,-271.1310898518859L-275.9386438643864,-270.1804859731944L-279.7732273227322,-273.73812259106944L-277.2504750475047,-276.24502764923864L-275.3331833183318,-279.78889335071733L-272.40679067906785,-277.5123752689276L-270.69131913191313,-275.9646645628825L-269.88403840384035,-274.4308156187876ZM-188.2477747774777,-142.0405492813035L-190.0641564156415,-144.3287013754282L-190.0641564156415,-149.83209270667763L-191.27507750775072,-151.04998843093642L-193.1923692369236,-150.3327587800466L-194.10056005600555,-151.40948831120278L-196.21967196719666,-148.3369049125849L-197.12786278627857,-145.16656396337L-198.13696369636958,-143.35513221530394L-199.24697469746968,-142.73148153522553L-200.1551655165516,-142.5239801869494L-200.45789578957886,-141.55814751988666L-205.60431043104305,-141.55814751988666L-209.84253425342527,-141.48931661264172L-211.1543654365436,-140.80215120008398L-214.08075807580752,-137.93840369778903L-214.48439843984391,-137.6675170587483L-215.39258925892582,-136.11603848403993L-217.91534153415336,-136.11603848403993L-220.63991399139906,-136.11603848403993L-221.95174517451738,-135.51174586199383L-221.54810481048096,-134.77528337673195L-221.2453745374537,-133.57513044848278L-221.3462846284628,-133.17643563426716L-224.97904790479043,-131.32468854811478L-227.80453045304523,-130.66682883458947L-231.13456345634557,-128.70401652428697L-231.8409340934093,-128.70401652428697L-232.7491249124912,-129.2911798577739L-233.0518551855185,-129.81430734403148L-233.0518551855185,-130.20740197328706L-232.4463946394639,-131.5224008354673L-231.03365336533648,-133.6416451763044L-230.22637263726367,-135.9144334899488L-230.83183318331825,-139.2976341428012L-231.43729372937293,-142.86992171118652L-234.36368636863682,-144.747240892162L-233.9600460046004,-145.4465501232649L-234.36368636863682,-146.00757812425763L-235.17096709670963,-146.00757812425763L-235.77642764276422,-146.64042800646874L-235.87733773377332,-147.55773927150724L-236.38188818881883,-147.13389336400417L-237.18916891689162,-147.2750852785407L-236.98734873487342,-147.69920168390706L-237.69371937193714,-148.05325402239748L-237.89553955395533,-149.19005325556805L-240.11556155615557,-150.4760166636491L-242.33558355835578,-151.84167214285637L-245.1610661066106,-153.43373945985812L-247.78472847284723,-154.96444642304232L-250.30748074807477,-153.79721010100718L-251.21567156715668,-153.79721010100718L-254.6466146614661,-154.81819562237962L-256.8666366636663,-154.30709862912784L-259.5912091209121,-155.62380902755012L-262.517601760176,-156.28520376848738L-264.4348934893489,-156.5798138518421L-265.3430843084308,-157.24417487650322L-265.84763476347626,-159.62327946494017L-266.7558255825582,-159.62327946494017L-266.7558255825582,-157.98478856505434L-272.6086108610861,-157.98478856505434L-282.19506950695063,-157.98478856505434L-291.6806180618061,-157.98478856505434L-300.0561556155615,-157.98478856505434L-308.532603260326,-157.98478856505434L-316.8072307230723,-157.98478856505434L-325.2836783678367,-157.98478856505434L-328.10916091609164,-157.98478856505434L-336.38378837883783,-157.98478856505434L-344.3556855685568,-157.98478856505434L-344.75932593259324,-157.98478856505434L-350.1075607560756,-162.18074607431268L-352.1257625762576,-164.0813198686138L-357.2721772177218,-165.9223225544151L-358.7858285828583,-169.88976166296342L-358.3821882188219,-172.6576645362425L-362.01495149514955,-174.65809391438407L-362.4185918591859,-178.39161367468134L-365.8495349534953,-181.8625338715236L-365.9504450445045,-184.37955695901428L-364.33588358835874,-186.6727687062858L-364.43679367936795,-189.85971048915653L-369.1795679567957,-193.0116161054394L-372.10596059605956,-198.92794788077597L-373.8214321432143,-202.69806226087735L-376.34418441844184,-205.12848851400156L-378.2614761476147,-207.4002431090608L-379.7751275127512,-210.27935534019898L-382.6006100610061,-208.45076053821066L-385.32518251825184,-205.4109558725899L-387.7470247024702,-209.02627369567816L-389.76522652265226,-211.4435934686095L-392.489798979898,-213.00737152039665L-395.21437143714377,-213.20377608164998L-395.21437143714377,-248.5644629680492L-395.21437143714377,-276.24502764923864L-389.96704670467045,-274.2920530240701L-385.52700270027003,-270.5872445599875L-382.6006100610061,-269.77468657063827L-380.1787678767877,-273.048214971254L-376.74782478247823,-275.54497859634023L-372.6105110511051,-274.5696905962923L-368.4731973197319,-278.22053537471544L-363.8313331333133,-280.2191386512763L-361.9140414041404,-276.80713491480435L-359.7949294929493,-278.7891830851497L-359.18946894689475,-282.6779052414281L-357.2721772177218,-281.66117478770684L-352.529402940294,-274.4308156187876L-348.79572957295727,-279.93218800977496L-348.3920892089209,-273.73812259106944L-344.96114611461144,-275.1263182408768L-343.95204520452046,-277.37109444141026L-340.521102110211,-276.94795063827047L-336.18196819681964,-273.59991900307017L-329.6228122812281,-270.72304475058297L-325.7882288228822,-269.3698415052773L-323.0636563656365,-269.9098467620684L-319.3299829982998,-266.0326098287171L-323.26547654765477,-262.2405030608525L-318.11906190619055,-260.69532055779365L-310.550805080508,-261.4661912267634L-308.2298729872987,-262.8884157046632L-305.2025702570256,-258.4030280437002L-302.17526752675263,-262.111210705217L-305.00075007500743,-265.37283812251445L-303.18436843684367,-267.89349710949364L-299.8543354335433,-268.2948838346133L-297.53340334033396,-269.10047260493167L-295.31338133813375,-267.22658845679325L-292.48789878987895,-263.1482607623589L-289.3596859685968,-263.66912354677186L-284.41509150915084,-260.31116533665363L-280.0759575957595,-261.4661912267634L-275.9386438643864,-261.3374747084694L-276.2413741374137,-266.0326098287171L-273.8195319531953,-267.35976406867655L-269.48039803980396,-264.71557559688256L-269.48039803980396,-257.77160666633836L-267.66401640164014,-263.66912354677186L-265.44399439943993,-263.4084962860014L-264.1321632163216,-271.1310898518859L-267.1594659465946,-276.1047887283627L-270.3885888588859,-279.35972944168157L-270.18676867686764,-288.75821036962054L-266.8567356735673,-295.064573163407L-263.2239723972397,-293.65997712509005L-260.3984898489848,-289.8184189535532L-256.56390639063903,-280.2191386512763L-259.08665866586654,-276.1047887283627L-253.83933393339328,-274.5696905962923L-253.83933393339328,-266.5622477450602L-250.10566056605654,-272.635597447303L-246.77562756275626,-267.6264241270781L-247.58290829082907,-261.98201470970145L-244.8583358335833,-257.01691153970637L-241.9319431943194,-262.3698919323495L-239.9137413741374,-268.96594596575756L-239.71192119211918,-277.65377288544795L-235.77642764276422,-277.0888823310121L-231.6391139113911,-275.8246549522944L-227.90544054405436,-271.9500969274699L-227.70362036203613,-268.0271888779627L-229.82273227322725,-263.93014382188886L-227.80453045304523,-259.92785807605935L-228.20817081708165,-256.390486764394L-233.65731573157314,-251.45839172487396L-237.592809280928,-250.36756864858336L-240.4182918291829,-252.55604730171703L-241.3264826482648,-249.04348429896686L-243.9501450145014,-243.26337462960493L-244.75742574257418,-240.38561289332975L-248.08745874587456,-235.9873719741938L-252.0229522952295,-235.54234701265824L-254.24297429742973,-232.8952082180332L-254.44479447944792,-228.78218602428808L-257.6739173917391,-228.03466733036115L-261.10486048604855,-223.19778835345915L-264.2330733073307,-216.57504089318365L-265.2421742174217,-212.02846403438068L-265.44399439943993,-205.59950405681218L-261.30668066806675,-204.7525255286587L-260.0957595759576,-199.74912980325107L-258.78392839283924,-195.76772238741253L-254.8484348434843,-196.8453398570625L-249.60111011101105,-194.6071122035922L-246.77562756275626,-192.6588518215416L-244.75742574257418,-190.29441488695576L-241.3264826482648,-188.90677599315433L-238.29917991799172,-186.7582205494889L-233.65731573157314,-186.50197703830432L-230.63001300130006,-186.07564942420927L-231.13456345634557,-181.8625338715236L-230.22637263726367,-177.08510094731508L-228.20817081708165,-171.86298861170792L-224.07085708570852,-167.62440041935042L-221.8508350835083,-169.0275409772047L-220.3371837183718,-173.77546701883458L-221.8508350835083,-181.19671069374965L-223.76812681268117,-183.70520100927374L-219.32808280828075,-185.99049527461938L-216.0989598959895,-189.4259784446923L-214.585308530853,-192.92336442982992L-214.7871287128712,-196.39559377821843L-216.70442044204418,-200.8495993129109L-220.13536353635357,-204.84644571118892L-216.80533053305328,-210.5697311922257L-218.01625162516248,-215.77623413333342L-218.9244424442444,-224.97032709889353L-217.00715071507145,-226.33758303115388L-212.16346634663458,-224.65626586108442L-209.33798379837978,-224.13403544710133L-207.01705170517045,-225.7052592743447L-204.39338933893384,-223.61330273549612L-200.96244624462437,-220.21333683775487L-200.05425542554246,-217.88055452616192L-195.10966096609656,-217.47786822396893L-195.21057105710568,-212.71315521366085L-194.20147014701465,-205.69384930129215L-191.67871787178711,-204.84644571118892L-189.6605160516051,-201.67917021865222L-185.62411241124104,-204.65865229588326L-182.89953995399532,-210.6666240993489L-181.08315831583153,-213.30205666241247L-178.86313631363132,-208.35501418819888L-175.23037303730365,-201.4022419900541L-172.10216021602156,-195.14190483658822L-173.21217121712164,-191.95525469283194L-169.579407940794,-189.16620372784845L-167.0566556655665,-186.33133445864476L-162.51570157015692,-185.05623488886596L-160.6993199319931,-183.53697250363967L-159.58930893089303,-179.45948580836236L-157.47019701970189,-178.80165713051593L-156.36018601860178,-177.0037263998385L-156.15836583658358,-171.86298861170792L-158.17656765676563,-170.12554433106115L-160.1947694769476,-168.55876236228272L-164.73572357235716,-166.92639980883794L-168.26757675767567,-163.3190152195687L-173.01035103510344,-162.6353113117805L-179.06495649564948,-163.54741438479508L-183.20227022702264,-163.54741438479508L-186.12866286628656,-163.242937627185L-188.44959495949587,-160.1472864612845L-192.08235823582353,-158.2074759664579L-196.11876187618756,-152.63624579463877L-199.34788478847878,-148.8341731608989L-196.92604260426035,-149.5465101244095L-192.4859985998599,-154.96444642304232L-186.53230323032298,-158.50475581333686L-182.39498949894983,-158.9514573628455L-179.8722372237223,-156.87483035251395L-182.59680968096802,-154.01558629434294L-181.6886188618861,-149.5465101244095L-180.7804280428042,-146.4996390338186L-177.14766476647657,-144.4681277522181L-172.50580058005795,-145.0267022779338L-169.68031803180313,-149.61787094786663L-169.4784978497849,-146.64042800646874L-167.66211621162108,-145.16656396337L-171.09305930593055,-142.5239801869494L-177.3494849484948,-140.18546947825917L-180.07405740574052,-138.61701528581924L-183.20227022702264,-135.78012700934408L-185.42229222922288,-136.11603848403993L-185.52320232023197,-139.36580712726035L-180.57860786078604,-142.66229324970837L-185.11956195619553,-142.5239801869494ZM-317.61451145114506,-266.96054521292535L-319.1281628162816,-270.72304475058297L-322.9627462746274,-272.7730264776403L-325.4854985498549,-271.9500969274699L-328.9164416441644,-278.22053537471544L-327.1000600060006,-279.21691411503576L-322.7609260926093,-280.50657249739857L-318.8254325432543,-280.2191386512763L-315.0917591759176,-281.66117478770684L-320.540904090409,-283.5542436348991L-326.4945994599459,-282.96951735674577L-330.53100310031,-283.11551082824064L-331.9437443744374,-286.21066207950406L-325.4854985498549,-289.6665541324744L-329.8246324632463,-289.514825222463L-334.66831683168317,-291.95894273127874L-332.3473847384738,-298.70809280332446L-330.43009300930095,-302.4321116031277L-322.8618361836183,-308.2622512269816L-320.0363536353635,-306.4080118274882L-321.44909490949095,-301.94167223729943L-315.19266926692666,-304.73993641292884L-311.2571757175717,-299.99408384066567L-308.12896289628964,-304.73993641292884L-305.6062106210621,-301.6155051593675L-303.28527852785277,-292.7300207278473L-301.87253725372534,-296.4809450793877L-303.89073907390735,-306.0730681623208L-301.36798679867985,-307.41687316104674L-298.6434143414341,-305.9058466497639L-295.515201520152,-302.10499320319684L-293.6988198819882,-293.1943598142686L-292.89153915391535,-286.9559818832804L-288.1487648764876,-282.6779052414281L-283.10326032603257,-278.7891830851497L-283.40599059905986,-275.2657580666869L-287.94694469446944,-274.5696905962923L-286.2314731473147,-271.5401055879838L-287.1396639663966,-268.6972074271321L-292.1851685168516,-269.9098467620684L-297.0288528852885,-272.08697837217943L-300.25797579757966,-271.5401055879838L-305.505300530053,-268.96594596575756L-312.66991699169915,-267.7599089167377ZM-292.89153915391535,-309.2823644457832L-295.4142914291429,-302.92398524538953L-299.7534253425342,-309.6237868374239L-298.8452345234523,-310.9964787559514L-295.11156115611556,-311.34141736500806ZM-213.97984798479843,-306.0730681623208L-213.7780278027802,-303.58206312572656L-216.70442044204418,-303.74698592930946L-219.73172317231717,-303.9120707302741L-222.85993599359927,-302.75986745761946L-223.66721672167208,-303.2527021807318L-226.69451945194515,-308.43183953031917L-226.59360936093606,-311.8601618677425L-225.28177817781776,-312.5543323703782L-218.82353235323527,-311.514153603512ZM-242.6383138313831,-306.7436253404773L-240.4182918291829,-300.80284249129704L-237.89553955395533,-308.43183953031917L-230.73092309230915,-312.5543323703782L-225.9881488148814,-302.4321116031277L-226.39178917891783,-296.4809450793877L-220.84173417341728,-299.02867165201724L-218.21807180718068,-302.75986745761946L-211.9616461646164,-298.06875828144837L-208.12706270627052,-293.8154682299933L-207.72342234223416,-289.8184189535532L-202.57700770077003,-291.8051477681577L-199.6506150615061,-286.3594647171362L-192.8896389638963,-282.96951735674577L-190.3668866886688,-279.64571884589844L-187.74322432243218,-272.08697837217943L-192.8896389638963,-268.42888737013834L-186.33048304830479,-263.4084962860014L-181.89043904390434,-261.85291491892883L-177.8540354035403,-255.1443483443885L-173.41399139913986,-254.6483738675971L-174.32218221822177,-249.76447400259505L-179.1658665866586,-241.87621540491008L-182.69771977197715,-244.66149737531185L-187.03685368536847,-251.33685346197643L-190.66961696169608,-250.48843669860796L-191.0732573257325,-246.54305051756097L-188.0459545954595,-242.56843647988367L-184.3122812281227,-239.58813640526847L-183.10136013601354,-237.7786551964242L-181.2849784978497,-231.4775046319231L-182.29407940794073,-227.0780975541229L-185.8259325932593,-228.78218602428808L-192.7887288728872,-233.77324509047244L-188.8532353235323,-228.3546533256073L-185.9268426842684,-224.65626586108442L-185.52320232023197,-222.5762914892197L-193.09145914591454,-224.97032709889353L-199.14606460646056,-228.56829300626657L-202.47609760976093,-231.5861621143552L-201.56790679067902,-233.33368879345545L-205.70522052205214,-236.5452177697038L-209.84253425342527,-239.70184265644028L-209.7416241624162,-237.89121036921352L-217.81443144314426,-236.7688453492458L-220.2362736273627,-239.02069373908915L-218.41989198919885,-243.9610535845476L-213.07165716571652,-244.07760156044216L-207.31978197819777,-244.89559724416065L-208.32888288828875,-247.3725873885227L-207.31978197819777,-250.73042292455656L-203.68701870187016,-257.645596793066L-204.4942994299429,-260.95189714094585L-205.50340034003395,-263.5387608695615L-209.84253425342527,-267.22658845679325L-215.49349934993492,-269.77468657063827L-213.6771177117711,-271.81332443903204L-216.70442044204418,-276.80713491480435L-219.12626262626256,-277.22993019717L-221.3462846284628,-279.93218800977496L-222.85993599359927,-277.5123752689276L-227.90544054405436,-276.52585056176474L-238.09735973597353,-278.36252004081166L-244.0510551055105,-280.7944912842334L-248.59200920092005,-281.95105088246623L-250.91294129412935,-285.02490716662805L-247.98654865486546,-288.90926356451354L-252.0229522952295,-288.90926356451354L-252.83023302330227,-297.90930271629884L-250.7111211121112,-306.4080118274882L-247.88563856385633,-310.30872633823674L-240.6201120112011,-313.0768572509053ZM-281.28687868786875,-313.42611640376856L-277.95684568456846,-311.34141736500806L-273.0122512251225,-312.5543323703782L-272.30588058805876,-309.7947593146505L-274.8286328632863,-305.07222842772904L-270.59040904090404,-300.9650614397942L-271.0949594959496,-292.7300207278473L-275.7368236823682,-289.36323196655593L-278.46139613961395,-290.12255736034996L-280.3786878687868,-293.5046288716928L-287.34148414841485,-300.47887275552944L-287.2405740574057,-303.58206312572656L-281.58960896089604,-302.4321116031277L-284.61691169116904,-308.6015995740086ZM-261.30668066806675,-302.92398524538953L-264.2330733073307,-296.00749983566953L-267.4621962196219,-296.4809450793877L-269.1776677667766,-304.5740365983367L-269.1776677667766,-309.4529886713772L-267.66401640164014,-313.6010199389491L-264.9394439443944,-316.4246629373037L-259.08665866586654,-316.0690862073899L-253.73842384238415,-313.6010199389491L-257.87573757375736,-304.9060002427558ZM-345.0620562056206,-286.21066207950406L-346.57570757075706,-289.970419943379L-353.03395339533955,-294.5950762594524L-351.8230323032303,-298.5480317305691L-349.90574057405735,-305.4051792279675L-347.3829882988299,-311.8601618677425L-350.2084708470847,-318.0341989397547L-340.7229222922292,-319.65941540810525L-336.68651865186513,-317.4959602350284L-329.521902190219,-316.95945207862496L-326.79732973297325,-313.9513769212607L-323.77002700270026,-309.7947593146505L-327.3018801880188,-307.24830772282013L-334.16376637663757,-300.64077970161577L-337.69561956195616,-294.2828014304307L-337.69561956195616,-290.2748314635861ZM-262.4166916691669,-325.3819480870179L-263.9303430343034,-321.1174752915788L-268.0676567656765,-322.0352856951689L-271.3976897689769,-324.81947485612756L-269.88403840384035,-329.56597203097414L-265.84763476347626,-332.67653299925814L-263.4257925792579,-328.79735869286554ZM-276.1404640464046,-345.31415599041105L-274.0213521352135,-339.69159296999766L-273.9204420442044,-333.6606728510349L-275.13136313631355,-325.56986278269335L-279.7732273227322,-324.4455468139581L-282.8005300530052,-326.1348846889666L-282.6996199619961,-332.67653299925814L-287.34148414841485,-331.6982014097382L-287.543304330433,-340.7184735310157L-284.51600160015994,-340.3069554602577L-280.27777777777777,-344.2583934988445L-276.3422842284228,-343.6281623930176ZM-303.38618861886187,-339.0785124218465L-302.27617761776173,-334.84940857719096L-299.7534253425342,-336.84979516481735L-296.8270327032703,-336.4477794839757L-296.3224822482248,-330.725607704665L-298.03795379537945,-325.56986278269335L-307.523502350235,-323.88622612469555L-314.587208720872,-319.2968848096029L-318.8254325432543,-319.1159147028758L-319.2290729072907,-322.5884099178735L-313.37628762876284,-327.2707239601286L-326.09095909590957,-325.9463305837091L-329.9255425542554,-327.84156879830874L-326.19186918691867,-339.0785124218465L-323.46729672967297,-342.3748714730493L-315.5963096309631,-338.2645913935633L-310.65171517151714,-331.5032258677396L-305.7071207120712,-330.725607704665L-309.74352435243526,-341.7517745257213L-307.2207720772077,-346.16365679121486L-304.29437943794375,-344.67988836529724ZM-265.44399439943993,-349.8236682762929L-262.3157815781578,-345.95087114718297L-256.76572657265723,-345.95087114718297L-254.34388438843882,-341.95921246971994L-255.0502550255025,-337.6567681843512L-251.82113211321126,-335.04836322611686L-250.00475047504744,-332.2845073416512L-246.2710771077107,-331.6982014097382L-242.13376337633755,-330.725607704665L-237.69371937193714,-333.2663153614606L-231.94184418441841,-334.25397448640103L-227.40089008900887,-333.4633767985427L-224.47449744974494,-329.18122051158724L-223.76812681268117,-324.6324057514484L-225.58450845084502,-321.85131852589956L-229.72182218221818,-319.65941540810525L-233.3545854585458,-320.93451853348967L-241.3264826482648,-319.2968848096029L-247.07835783578355,-319.1159147028758L-251.61931193119307,-320.38685064376494L-259.08665866586654,-323.7002029844168L-260.0957595759576,-329.75868276343306L-260.3984898489848,-335.44699100361123L-263.2239723972397,-340.51258641844555L-268.9758475847584,-341.95921246971994L-272.30588058805876,-345.73835961509127L-271.1958695869586,-350.69678980818355ZM-325.6873187318731,-356.941849431441L-326.09095909590957,-347.23172225909224L-328.3109810981098,-343.0003279425009L-330.93464346434644,-342.3748714730493L-336.0810581058106,-337.2527897556914L-340.62201220122006,-335.64666532370785L-344.3556855685568,-338.0617354154561L-339.6129112911291,-347.01755508292143L-333.8610361036103,-355.1332283753172L-329.6228122812281,-355.1332283753172ZM-263.02215221522147,-355.3582212253546L-264.3339833983398,-354.90854285873814L-269.58130813081306,-355.8091323799833L-270.3885888588859,-359.4616477520787L-264.7376237623762,-359.23097181333986L-262.7194219421942,-356.71468088980464ZM-308.8353335333533,-357.62524464873843L-314.0826582658265,-353.78969533515215L-318.2199719971997,-358.08242508854187L-315.9999499949995,-362.2553293732193L-311.8626362636263,-363.67020189746074L-307.92714271427144,-361.5524404411449ZM-307.42259225922584,-369.9463977360212L-310.85353535353534,-367.2617063241005L-315.49539953995395,-367.2617063241005L-315.39448944894485,-369.209836393705L-312.56900690069006,-373.42817114480687L-311.05535553555353,-372.9262190392897ZM-268.6731173117311,-362.4902960735918L-272.81043104310424,-359.69264805129L-275.03045304530445,-362.72559960604866L-276.2413741374137,-367.9895442164819L-276.544104410441,-373.9316672548746L-272.91134113411334,-373.1770026950791L-271.1958695869586,-372.42580131434903L-267.86583658365834,-367.5039600531412ZM-280.4795979597959,-366.0557781356845L-279.36958695869583,-360.3876044793782L-284.01145114511445,-362.0206985204487L-288.552405240524,-366.29625527351783L-294.80883088308826,-366.7782701695011L-292.0842584258425,-370.9336595133548L-295.515201520152,-374.43671708368987L-295.7170217021702,-380.0976827019072L-290.26787678767874,-378.27512071899105L-282.5987098709871,-372.9262190392897ZM-243.9501450145014,-385.6906173072798L-240.519201920192,-380.62216930432953L-244.45469546954692,-376.21676942522123L-249.60111011101105,-365.57587919814586L-254.54570457045702,-364.6202733899397L-260.3984898489848,-366.29625527351783L-263.3248824882488,-372.17616486150024L-263.3248824882488,-377.5001998024692L-261.10486048604855,-381.41206908746443L-266.2512751275127,-381.14834466063235L-269.3794879487948,-386.50547795501205L-271.0949594959496,-393.7434773443597L-269.1776677667766,-401.01997039601054L-267.26037603760375,-406.4680471065185L-264.3339833983398,-407.70391566197924L-265.544904490449,-411.786630140107L-259.08665866586654,-412.7435398886148L-255.4538953895389,-403.1170451640978L-250.7111211121112,-399.53843056936495L-246.17016701670158,-396.3257279087029ZM-192.08235823582353,-450.78564956397946L-184.51410141014094,-449.17555037310194L-178.560406040604,-446.39586623387567L-173.41399139913986,-440.2160501740756L-173.51490149014896,-434.6291341915451L-180.3767876787678,-425.72544482960313L-187.1377637763776,-421.61930889870104L-189.6605160516051,-417.2851948229235L-183.60591059105906,-417.2851948229235L-190.1650665066506,-406.16054190166443L-194.80693069306926,-401.31790327411665L-199.54970497049698,-387.87268556817594L-205.30158015801572,-385.41989852274963L-207.11796179617954,-382.2058061629962L-215.59440944094402,-380.62216930432953L-211.75982598259822,-378.53424597959673L-213.6771177117711,-375.9612874018375L-211.35618561856182,-368.96504992244695L-213.97984798479843,-364.14454995079217L-218.31898189818975,-360.3876044793782L-219.73172317231717,-355.1332283753172L-223.566306630663,-351.35468170122846L-223.1626662666266,-348.5226004456661L-218.41989198919885,-348.95514939922055L-218.31898189818975,-345.95087114718297L-225.88723872387234,-338.87465633038255L-233.1527652765276,-341.95921246971994L-241.4273927392739,-340.1015800010106L-245.564706470647,-341.5445967216916L-250.91294129412935,-342.16691122689616L-251.21567156715668,-348.09118364229073L-246.06925692569249,-350.91579523724926L-247.38108810881084,-360.3876044793782L-245.6656165616561,-361.31881126693344L-238.19826982698265,-355.5835222714939L-242.03285328532849,-364.14454995079217L-246.573807380738,-366.7782701695011L-244.3537853785378,-372.17616486150024L-239.30828082808276,-375.7062037521219L-238.60191019101907,-380.88504519674416L-242.53740374037397,-386.77800469967525L-243.74832483248318,-395.1730060807898L-236.0791579157915,-394.59968893097164L-233.8591359135913,-392.6088138583702L-229.41909190919085,-398.65593486513137L-235.77642764276422,-400.7225818277116L-245.564706470647,-399.53843056936495L-250.50930093009296,-405.54727017975677L-252.83023302330227,-412.7435398886148L-256.16026602660264,-418.27515372956174L-256.76572657265723,-425.0338308147425L-252.62841284128407,-428.8747339331837L-249.29837983798373,-429.58296083638385L-243.84923492349228,-432.8088398958412L-239.71192119211918,-440.59545401209203L-236.1800680068006,-439.45989896049736L-233.1527652765276,-433.5345056949236L-231.03365336533648,-445.2190360555047L-227.40089008900887,-449.17555037310194L-222.35538553855378,-451.59674894488364L-213.7780278027802,-452.4119360937735L-212.2643764376437,-449.9785968640873L-204.19156915691565,-454.0547411931687L-198.13696369636958,-452.4119360937735Z", id: "Canada", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M29.213471347134867,-149.11883118062914L29.011651165116604,-147.4870419506414L27.800730073007422,-146.78130623233125L25.68161816181633,-147.2750852785407L25.076157615761698,-145.6567703190166L23.764326432643347,-145.51660152855774L23.259775977597883,-146.14805600513608L21.645214521452253,-144.81707354058406L20.33338333833398,-144.60764087135283L19.122462246224718,-145.4465501232649L18.21427142714281,-147.2750852785407L16.80153015301544,-146.64042800646874L16.902440244024532,-148.47886716216973L18.920642064206532,-150.76281414852357L18.81973197319744,-151.84167214285637L20.131563156315718,-151.40948831120278L20.837933793379438,-152.1302720698759L23.259775977597883,-152.1302720698759L23.865236523652516,-152.99837910788L26.791629162916422,-151.76958192611866L26.993449344934607,-150.97815945831675L26.488898889889146,-149.97502350309435L27.800730073007422,-149.26129840142363Z", id: "Switzerland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-187.74322432243218,184.88110726389817L-188.6514151415141,186.83791277310752L-191.0732573257325,188.38311377328694L-192.3850885088508,188.21081843414188L-194.10056005600555,187.86668449398647L-196.11876187618756,186.410852774133L-199.04515451545146,185.64448683224543L-202.57700770077003,182.9436182654859L-205.40249024902482,180.36195577886184L-209.33798379837978,175.13569392356848L-207.01705170517045,176.1052875311967L-203.08155815581551,179.20696845537162L-199.34788478847878,180.94197700755115L-197.93514351435138,178.71401777834035L-197.02695269526947,175.5391235829339L-194.40329032903287,173.60997904677146L-192.3850885088508,174.17074434055849L-192.3850885088508,184.79647040029997L-189.4586958695869,184.79647040029997ZM-188.1468646864686,65.47905877432335L-187.84413441344128,66.27146134004488L-188.7523252325232,69.4033102377762L-191.7796279627962,70.95179477971016L-191.67871787178711,76.12316294772097L-192.2841784178417,77.10089967228937L-191.4768976897689,78.35411301930634L-193.49509950995096,80.32461671019112L-195.31148114811475,83.30156409111798L-196.32058205820576,86.19332645685476L-196.01785178517844,89.33638704101212L-197.73332333233316,92.6818153302234L-196.42149214921486,98.43681660992698L-195.71512151215117,99.01847373523178L-195.71512151215117,102.12083730701548L-197.32968296829677,105.4358458745682L-197.22877287728767,108.30896363142658L-199.34788478847878,110.60511356245155L-199.34788478847878,113.8408072174696L-198.54060406040597,117.30344003043938L-200.2560756075607,118.6139669483481L-200.96244624462437,121.82504209858209L-201.56790679067902,125.59189326855996L-201.16426642664263,130.13739735254765L-202.2742774277427,130.92529646973958L-201.56790679067902,135.37312739321084L-200.3569856985698,136.7847486643149L-201.26517651765172,138.47652823009327L-199.95334533453337,139.22486166119478L-199.6506150615061,140.72889837442048L-200.86153615361528,141.4846509054871L-200.55880588058804,143.8366753409746L-201.66881688168812,149.1852239530244L-203.08155815581551,152.70371637728977L-202.77882788278822,154.81323975201045L-203.68701870187016,157.5350922671787L-205.80613061306124,159.39403850780474L-205.60431043104305,163.9997882982524L-204.59520952095204,165.60913714346253L-202.67791779177912,165.30163200718113L-202.77882788278822,168.6315250562744L-201.56790679067902,171.30319517190532L-194.80693069306926,171.9369374155585L-192.2841784178417,172.65226646577793L-194.70602060206014,172.57266091664846L-196.11876187618756,173.6899932346251L-198.64151415141507,175.37765470407464L-199.04515451545146,179.78362372761228L-200.2560756075607,179.86613964429586L-203.38428842884284,178.38605959631687L-206.61341134113405,175.055104873644L-210.1452645264526,172.4135434162031L-210.9525452545254,169.5704897322133L-210.1452645264526,166.92115079544055L-211.55800580058,163.9997882982524L-211.9616461646164,156.64853136206617L-210.75072507250718,152.55898716657444L-207.82433243324326,149.39902399060608L-212.0625562556255,148.1902263748397L-209.43889388938888,144.6029102316569L-208.42979297929784,138.06936969338543L-205.30158015801572,139.42937651161668L-203.88883888388833,131.45200989048786L-205.70522052205214,130.39974228582332L-206.61341134113405,135.17216303497602L-208.42979297929784,134.63710044900262L-207.52160216021593,129.2214416324245L-206.51250125012496,122.33247161483744L-205.30158015801572,119.86836568777682L-206.10886088608854,116.3094018072734L-206.31068106810673,112.37070864017839L-205.09975997599756,112.24856775297494L-203.38428842884284,106.62934665739905L-201.46699669966995,101.18075612679235L-200.2560756075607,96.17923727265949L-200.96244624462437,91.25989075281342L-200.05425542554246,88.54773867122556L-200.45789578957886,84.57750944575544L-198.74242424242416,80.70906427239836L-198.23787378737865,74.60743277648592L-197.32968296829677,68.23264618349178L-196.52240224022398,61.4346662244652L-196.72422242224218,56.54700403865306L-197.32968296829677,52.37543129289735L-195.81603160316027,51.60672516766671L-195.10966096609656,50.07271887001871L-193.69691969196913,52.11906786911505L-193.39418941894186,54.225100217414834L-191.8805380538053,55.462061819577855L-192.7887288728872,58.360791029826196L-191.27507750775072,61.74845337478782L-190.1650665066506,65.9014843333601Z", id: "Chile", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M309.23897389738994,-53.30289628137528L306.8171317131714,-51.86630622288082L304.4961996199622,-52.78936118188517L304.39528952895307,-55.31076727157739L305.8080308030805,-56.653967975029225L308.8353335333536,-57.482443907835695L310.44989498949906,-57.43062134085709L311.0553555355538,-56.29196582414159L309.8444344434445,-55.00132898489111ZM366.1522652265229,-131.39057441189456L364.33588358835914,-133.6416451763044L363.22587258725883,-131.5224008354673L358.8867386738677,-129.87977841333847L359.2903790379041,-127.9233450790075L356.8685368536855,-128.05328232828228L355.5567056705673,-129.2258688203514L353.63941394139437,-126.56318142915866L350.51120112011216,-124.56904517803083L348.19026902690297,-122.20982022427262L344.35568556855696,-121.13328193667843L342.23657365736597,-119.49565283647469L339.2092709270929,-118.4931054589714L340.7229222922293,-120.12425693106765L340.1174617461748,-121.57600354662752L342.33748374837495,-124.05703958029399L340.9247424742475,-125.98256764260344L338.4019901990202,-124.63312051543778L335.27377737773793,-122.08292859324001L333.55830583058327,-119.74690767927935L330.83373337333757,-119.55844325842386L329.3200820082011,-117.9308962081159L330.83373337333757,-115.50873538364692L333.1546654665469,-114.89129281832398L333.2555755575559,-113.29271764508461L335.4755975597561,-112.31377154866662L338.6038103810384,-114.82962876020673L341.1265626562659,-113.41534088058759L342.84203420342055,-113.3540221456882L343.34658465846604,-111.52102439113827L339.4110911091111,-110.48788838934833L338.0992599259928,-108.61406542554066L335.3746874687471,-106.87272310388512L333.8610361036106,-104.4887362523284L336.88833883388355,-102.65499152020728L337.9983498349836,-99.31368736611616L339.7138213821384,-96.24082088510703L341.63111311131127,-93.71354794659958L341.63111311131127,-91.26373800989218L339.8147314731475,-90.35708550347242L340.5211021102112,-88.6640992682984L342.1356635663568,-87.65260148400151L341.7320232023204,-85.02623657758075L341.02565256525673,-82.47577064023551L339.4110911091111,-82.19970525629837L337.3928892889291,-78.79475490479442L335.07195719571973,-74.66512163580525L332.5492049204922,-70.9554220435714L328.6137113711374,-68.12999380520579L324.7791279127914,-65.58820375379423L321.65091509150926,-65.21883668927566L319.93544354435465,-63.90232196818682L318.9263426342636,-64.84979657629438L317.31178117811794,-63.376861038975974L313.3762876287631,-61.85664673164194L310.44989498949906,-61.385934055644825L309.5417041704172,-58.20856567559254L307.92714271427167,-58.052872552587985L307.220772077208,-60.23740976397501L307.8262326232625,-61.385934055644825L304.0925592559257,-62.32786660683065L302.78072807280745,-61.85664673164194L299.9552455245527,-62.642297242401526L298.64341434143427,-63.84974668520927L299.04705470547077,-65.640997298041L296.52430243024327,-66.1693036920074L295.2124712471248,-67.333977412049L292.7906290629065,-65.69379756714181L290.0660566056607,-65.32433667584579L287.84603460346057,-65.37709669417173L286.3323832383239,-64.63906244519353L284.81873187318746,-64.16529616604903L285.323282328233,-60.70690188104627L283.80963096309654,-60.81130066447601L283.5069006900692,-61.49049327570507L283.40599059906003,-62.747158239880186L281.3877887788781,-61.85664673164194L280.17686768676896,-62.432651476682565L278.05775577557773,-63.586967699055954L278.96594659465967,-66.06358829872546L277.14956495649585,-66.69828915680066L276.4431943194321,-69.51351984309598L273.5168016801682,-68.98082384924783L273.81953195319545,-72.61760126706938L276.5441044104413,-75.20582058798335L276.6450145014503,-77.81239218749513L276.5441044104413,-80.2185729390573L275.33318331833203,-80.9876598360614L274.42499249925015,-82.86263962127963L272.7095209520953,-82.58625960772352L269.6822182218224,-83.08390625919127L270.6913191319133,-84.41457162709506L269.37948794879503,-86.42061146494613L267.3612861286131,-85.08189844834959L265.0403540354037,-85.86215156886388L261.81123112311246,-83.80402771052523L259.1875687568759,-81.42790823037868L256.9675467546757,-81.04266011646972L255.75662566256645,-81.92386341004479L254.24297429742998,-81.97901394405302L252.22477247724785,-82.69678456483527L250.71112111211139,-81.92386341004479L248.89473947394754,-79.56070709589736L248.5920092009202,-82.03417338773146L246.97744774477457,-81.37284635712207L243.6474147414743,-81.70335021194106L240.5192019201922,-82.420539632595L238.19826982698285,-83.80402771052523L236.0791579157917,-84.47013104406294L235.0700570057008,-85.97376744282154L233.55640564056415,-86.47650991521938L230.7309230923094,-88.5515530703473L228.40999099910007,-89.56590096670293L227.299979998,-88.7766850851449L223.36448644864498,-91.03682887644742L220.63991399139928,-93.14208572219515L219.83263326332653,-96.76038780311733L221.85083508350854,-96.29850595091604L221.95174517451755,-98.03427466272167L220.84173417341745,-99.72194910519734L221.1444644464448,-102.47816050590629L218.11716171617172,-106.51381784772998L213.4752975297532,-107.8921679478808L212.66801680168038,-110.54855116217344L210.64981498149828,-112.19165680297333L210.14526452645282,-113.23142736654036L209.64071407140727,-115.26158302723202L209.74162416241637,-116.62383732071059L208.12706270627083,-117.43218663485305L207.11796179617974,-117.05878764755022L206.4115911591161,-120.43914457154166L207.21887188718893,-121.2596943341443L206.81523152315248,-122.08292859324001L209.53980398039818,-123.80143334725969L211.4570957095711,-124.56904517803083L214.4843984398441,-124.05703958029399L215.49349934993518,-126.43403698948921L219.12626262626281,-126.88634163294108L220.1353635363537,-128.31336604808814L224.4744974497451,-130.4041912490347L224.8781378137816,-131.25882089482948L224.67631763176345,-133.37569880865786L226.59360936093623,-134.37455068892257L224.0708570857087,-141.1454744557386L229.62091209120933,-142.73148153522553L231.03365336533676,-143.6328650752903L233.05185518551878,-150.90635410178115L238.60191019101921,-149.5465101244095L240.21647164716484,-151.40948831120278L240.31738173817402,-155.62380902755012L242.63831383138339,-156.06451198457782L244.7574257425744,-158.87694176788702L245.8674367436745,-159.24978193067412L246.67471747174736,-156.21161456853704L248.99564956495675,-154.01558629434294L253.03205320532072,-152.41925557397414L254.94934493449355,-149.11883118062914L253.83933393339348,-144.39840373097408L254.84843484348454,-142.66229324970837L258.1784678467848,-141.9715718880951L261.9121412141216,-141.42050655592524L265.34308430843106,-138.9570726728605L267.0585558555857,-138.54906409849187L268.370387038704,-134.9090133335014L269.9849484948496,-132.64588736900257L273.1131613161319,-132.77841288779672L278.8650365036505,-131.91831883885055L282.5987098709873,-132.4472380717524L285.323282328233,-131.852286709087L289.4605960596062,-129.55260135060635L292.89153915391563,-129.55260135060635L294.10246024602475,-128.37843065529484L297.43249324932515,-130.4041912490347L301.9734473447347,-131.72027745328685L306.11076107610785,-131.852286709087L309.44079407940814,-133.2428380017517L311.45899589959015,-135.24367287967846L313.3762876287631,-136.58713051254088L312.9726472647266,-137.87065224398663L312.06445644564474,-139.36580712726035L313.47719771977216,-141.90261547862923L315.0917591759178,-141.55814751988666L317.9172417241727,-140.73354861007778L320.74272427242744,-142.86992171118652L324.9809480948097,-144.39840373097408L327.1000600060008,-147.0633311043563L329.01735173517375,-148.26595802067237L333.1546654665469,-148.76306611890644L335.3746874687471,-148.3369049125849L335.67741774177443,-149.76066221733552L333.1546654665469,-152.63624579463877L330.83373337333757,-154.01558629434294L328.7146214621464,-152.4915615533224L325.88913891389166,-153.1434019961889L324.375487548755,-152.56389161930989L323.66911691169133,-154.30709862912784L325.58640864086425,-158.50475581333686L326.99914991499173,-161.80269296584743L330.329182918292,-160.1472864612845L334.264676467647,-162.86296441404L334.264676467647,-164.84642322008452L336.78742874287457,-169.57580680828846L338.4019901990202,-170.9924160715487L338.301080108011,-173.5354179868665L336.78742874287457,-174.65809391438407L339.1083608360837,-176.9223848804489L342.53930393039315,-177.81896381623775L346.27297729773,-177.9006705398089L350.51120112011216,-176.5161715071469L352.9330433043307,-174.81898694644153L354.6485148514853,-170.20419900677092L355.7585258525854,-168.24683658381812L356.6667166716673,-165.53743201922217L357.77672767276744,-161.19921980180237L362.6204120412043,-159.84769484712209L365.9504450445046,-156.80103804066624L367.06045604560484,-152.85345320410175L371.298679867987,-152.85345320410175L373.7205220522054,-154.52599175430902L378.3623862386241,-155.69719666096088L376.94964496449666,-151.98592424939255L375.8396339633966,-150.4760166636491L374.83053305330543,-146.00757812425763L373.0141514151416,-142.0405492813035L369.58320832083234,-142.80069101593418L367.1613661366138,-141.35171733079125L367.9686468646867,-138.0061750440948L367.5650065006502,-133.44215728134495L366.05135513551375,-133.30925905434054Z", id: "China", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-21.64521452145202,-12.206157886508027L-21.443394339433834,-14.550630140710071L-21.140664066406554,-14.892779091311752L-21.24157415741565,-16.017465932054602L-22.452495249524834,-17.19188852237275L-23.360686068606736,-17.387713028237833L-24.167966796679554,-18.12228674273681L-23.56250625062492,-19.39645181322222L-23.86523652365228,-20.76999223173086L-23.663416341634093,-21.604658984508763L-23.25977597759765,-21.604658984508763L-23.057955795579463,-22.833171291861394L-23.360686068606736,-23.374133326511075L-23.057955795579463,-23.767725416536155L-22.048854885488463,-24.112234728468117L-22.654315431543015,-26.378969227434634L-23.360686068606736,-27.56365647519852L-23.158865886588554,-28.502585480514647L-22.55340534053392,-28.74983113978328L-22.149764976497554,-28.99714424922471L-21.443394339433834,-28.552029245373696L-19.223372337233652,-28.552029245373696L-18.71882188218811,-29.3929870314002L-18.21427142714257,-29.294009866863473L-17.406990699069837,-29.640478345332546L-17.00335033503339,-28.403705967459736L-16.39788978897876,-28.799288346305232L-15.186968696869572,-29.19504370752278L-13.97604760476039,-28.601475688896187L-13.47149714971485,-27.662446636071305L-12.159665966596576,-27.020494191640378L-11.25147514751467,-27.761247164464056L-9.939643964396314,-27.860058098867512L-8.022352235223408,-27.11922801829336L-7.215071507150593,-23.079030858937305L-8.425992599259855,-20.720911776489174L-9.1323632363235,-17.534598295459922L-7.921442144214315,-15.088322949705665L-8.022352235223408,-14.01309996537885L-9.334183418341762,-13.964241440428756L-11.25147514751467,-14.501757132009935L-13.067856785678483,-14.501757132009935L-16.39788978897876,-14.01309996537885L-18.315181518151743,-13.182677296159705L-21.140664066406554,-12.157344037576852Z", id: "Cote d'Ivoire", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M31.53440344034414,-6.306519504403868L26.993449344934607,-6.355231072210803L27.397089708971052,-8.596667832523048L26.287078707870883,-10.449533294474987L25.076157615761698,-10.937350402890145L24.470697069707068,-12.206157886508027L23.764326432643347,-12.596709583801713L23.764326432643347,-13.378038407766L24.470697069707068,-15.381680658193325L25.782528252825422,-18.07330358068904L26.589808980898237,-18.12228674273681L28.30528052805296,-19.7397006879037L29.415291529153052,-19.78874353142415L30.92894289428951,-18.66121335765616L32.8462346234625,-19.592583129456774L33.14896489648977,-20.76999223173086L33.7544254425444,-21.899384677163887L34.15806580658077,-23.32494416487882L35.67171717171731,-24.5060946672552L36.27717771777186,-26.47763797322391L36.88263826382649,-27.11922801829336L37.28627862786294,-28.601475688896187L37.992649264926584,-30.43292147799534L40.313581358135934,-32.615979970115724L40.515401540154116,-33.56048281983873L40.81813181318147,-34.10782173843054L39.70812081208131,-35.25352783978726L39.8090309030904,-36.15139817137067L40.616311631163214,-36.30115061884937L41.72632263226339,-34.50613139601044L41.92814281428157,-32.56630038567768L41.82723272327248,-30.68070933880795L43.34088408840894,-28.107131213945543L41.72632263226339,-28.107131213945543L40.91904190419057,-27.909467480356916L39.70812081208131,-28.20597887278574L39.10266026602675,-26.872412410569495L40.717221722172305,-25.195703134908943L41.92814281428157,-24.703079360106468L42.331783178317934,-23.570911798223825L43.239973997399844,-21.604658984508763L42.73542354235438,-20.819074616432324L41.32268226822694,-17.975342275252157L40.717221722172305,-17.48563492214732L40.515401540154116,-15.283889117144811L40.717221722172305,-14.11082090156109L40.515401540154116,-13.23151573790938L41.82723272327248,-11.76687322659182L42.129962996299746,-10.79099489309289L43.13906390639075,-9.327911861974366L44.4508950895091,-8.401700120770261L44.5518051805182,-7.134698696431206L44.85453545354547,-6.355231072210803L44.65271527152729,-4.7967263109388645L42.432693269327025,-5.478507924585893L40.11176117611775,-6.209098104201242L36.579907990799214,-6.355231072210803L36.27717771777186,-6.501369300322488L34.56170617061722,-6.1116789879567435L32.8462346234625,-6.501369300322488Z", id: "Cameroon", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M82.89763976397657,3.7709112947846215L82.09035903590375,4.549953248746317L81.98944894489465,6.254506125975437L81.58580858085821,6.4493534166387105L81.28307830783093,8.008497533624597L81.98944894489465,9.275851021649405L82.19126912691284,12.64222360748974L82.6958195819583,15.231680723636751L82.39308930893102,16.699120270833657L82.99854985498567,18.314914852883536L84.61311131113122,19.932557756262213L86.12676267626775,23.469182993476448L85.01675167516765,23.174055389176626L81.28307830783093,23.665978405104557L80.47579757975812,24.010455479569245L79.6685168516853,25.83312382689568L80.27397739773994,27.06651296311049L79.7694269426944,30.42956216472495L79.46669666966712,33.308448617850054L80.27397739773994,33.805851950483756L82.19126912691284,34.95110157026871L82.99854985498567,34.4031585612648L83.20037003700385,37.49690914995314L81.08125812581275,37.49690914995314L79.87033703370349,35.89849669264109L78.86123612361249,34.70198726818749L76.7421242124214,34.303575110978L76.03575357535767,32.76166841650032L74.42119211921204,33.706345857134L72.1002600260027,33.308448617850054L71.19206920692078,32.0166610938466L69.37568756875697,31.7188493505635L68.0638563856387,31.818107917771428L67.9629462946296,30.925208120861335L66.95384538453861,30.82605579167544L65.74292429242934,30.6773490508687L63.92654265426553,31.073958465519958L62.71562156215634,31.024372097319333L62.00925092509262,31.2723332524899L62.211071107110804,27.9061176379638L61.302880288028895,26.819710833626168L61.10106010601071,25.093819447035035L61.50470047004716,23.370798427993517L60.899239923992525,22.289134781112036L60.798329832983434,20.52128228616534L57.468296829683084,20.52128228616534L57.670117011701265,19.54022323578924L56.2573757375739,19.54022323578924L56.15646564656481,20.030659793914996L54.34008400840099,20.128769268904943L53.63371337133727,21.79780434457996L53.230073007300824,22.485724767238985L51.71642164216437,22.092577980131992L50.808230823082454,22.485724767238985L48.890939093909545,22.73150937398053L47.88183818381847,21.257574829223493L47.175467546754824,20.325010679654028L46.36818681868201,18.608889401518454L45.661816181618285,16.503384017620633L37.48809880988112,16.503384017620633L36.47899789979012,16.84593866935041L35.67171717171731,16.7969976503142L34.460796079608045,17.139617683251753L34.057155715571675,16.25874802059144L34.7635263526354,15.965234402319519L34.86443644364449,14.74282185670641L35.368986898689954,14.009787510644156L36.37808780878103,13.4235703366513L37.084458445844675,13.71665613080581L38.093559355935675,12.64222360748974L39.607210721072214,12.691048838265141L39.8090309030904,13.472414845072123L40.81813181318147,13.96092907325093L42.432693269327025,12.202848465945504L44.148164816481746,10.836471658243484L44.85453545354547,9.958506220679315L44.75362536253638,7.61864651300396L45.964546454645564,4.89081668860438L47.175467546754824,3.478794419994138L49.09275927592773,2.115718887289371L49.39548954895501,1.1908675656511325L49.4963996399641,0.16870817283960143L49.90004000400055,-0.8047699973549693L49.79912991299146,-2.3624114676925214L50.10186018601874,-4.845421985905639L50.70732073207336,-6.598797767868622L51.5146014601461,-8.109271660956667L51.71642164216437,-9.815514301679384L51.91824182418255,-11.76687322659182L53.02825282528264,-13.182677296159705L54.541904190419174,-14.11082090156109L56.862836283628454,-13.133840070931502L58.578307830783174,-12.108531309795499L60.69741974197434,-11.81567823329369L62.71562156215634,-11.278882080371623L63.62381238123825,-12.987335648908855L63.92654265426553,-13.182677296159705L65.23837383738389,-12.889672033488196L68.36658665866597,-14.30627844668355L69.47659765976614,-13.71996806483214L70.38478847884805,-13.817673583462076L70.78842884288441,-14.501757132009935L71.79752975297542,-14.746135661892204L73.91664166416659,-14.45288546281981L75.7330233023304,-14.35514612471865L76.6412141214123,-14.648380194895534L78.35668566856695,-12.352606205564978L79.6685168516853,-12.0109091995402L80.37488748874902,-12.49906477830379L81.6867186718673,-12.303788965965158L83.20037003700385,-12.889672033488196L83.90674067406756,-11.669266463293505L86.32858285828593,-9.815514301679384L86.22767276727684,-6.5500832328884036L87.33768376837702,-6.160388262828348L86.42949294929511,-5.137605546232783L85.31948194819493,-4.407176408281936L84.31038103810394,-2.9465764508572345L83.7049204920493,-1.632248288238757L83.50310031003112,0.6067732323849028L82.89763976397657,1.6776245502672165Z", id: "Democratic Republic of the Congo", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M33.350785078507954,14.156370602649469L31.02985298529868,11.177988585169322L33.14896489648977,9.617156923233539L32.13986398639877,7.764835264820526L33.04805480548068,7.082674140811878L34.965346534653584,6.74164223634493L35.16716671667177,5.475206119135097L36.68081808180831,6.839076755593891L39.203570357035844,6.936513791067077L40.01085108510866,5.621314500362225L40.414491449145025,3.7709112947846215L40.11176117611775,1.5802720634112344L38.69901990199031,-0.0746605535447471L40.01085108510866,-3.3360409563620452L39.30448044804494,-3.871587155420916L37.18536853685377,-3.6768384150597204L36.37808780878103,-5.08890713156123L36.579907990799214,-6.355231072210803L40.11176117611775,-6.209098104201242L42.432693269327025,-5.478507924585893L44.65271527152729,-4.7967263109388645L44.85453545354547,-6.355231072210803L46.26727672767292,-8.937891965537345L47.98274827482764,-10.449533294474987L49.90004000400055,-9.961812455980416L51.71642164216437,-9.815514301679384L51.5146014601461,-8.109271660956667L50.70732073207336,-6.598797767868622L50.10186018601874,-4.845421985905639L49.79912991299146,-2.3624114676925214L49.90004000400055,-0.8047699973549693L49.4963996399641,0.16870817283960143L49.39548954895501,1.1908675656511325L49.09275927592773,2.115718887289371L47.175467546754824,3.478794419994138L45.964546454645564,4.89081668860438L44.75362536253638,7.61864651300396L44.85453545354547,9.958506220679315L44.148164816481746,10.836471658243484L42.432693269327025,12.202848465945504L40.81813181318147,13.96092907325093L39.8090309030904,13.472414845072123L39.607210721072214,12.691048838265141L38.093559355935675,12.64222360748974L37.084458445844675,13.71665613080581L36.37808780878103,13.4235703366513L35.368986898689954,12.495754894364326L34.460796079608045,12.935192644521091Z", id: "Republic of Congo", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-221.04355435543548,-3.8228994478030884L-221.44719471947187,-4.699336279315192L-220.4380938093809,-4.942814676557256L-220.53900390039,-6.355231072210803L-219.8326332633263,-7.32959113639156L-218.52080208020797,-7.524494365069024L-217.30988098809877,-9.279156416213254L-216.19986998699866,-10.79099489309289L-217.20897089708967,-11.425268302557184L-216.70442044204418,-13.085004057677773L-217.30988098809877,-15.626184471541457L-216.80533053305328,-16.408842194741915L-217.20897089708967,-18.759222322771357L-218.31898189818975,-20.279273736352923L-218.01625162516248,-21.653774883935053L-217.10806080608057,-21.457323320475947L-216.50260026002596,-22.29246650882726L-217.20897089708967,-23.964574483404853L-216.80533053305328,-24.35838017197814L-215.39258925892582,-24.25991521094031L-213.2734773477347,-26.280310350555784L-212.16346634663458,-26.576316626163745L-212.16346634663458,-27.514265270559278L-211.55800580058,-29.88803929172921L-210.0443544354435,-31.226097610216808L-208.2279727972797,-31.275695913471427L-208.02615261526145,-31.87110678112377L-205.80613061306124,-31.622966812111695L-203.58610861086103,-33.112946001942426L-202.47609760976093,-33.70971870700007L-201.16426642664263,-35.103988905875674L-200.1551655165516,-34.95447993004523L-199.44879487948788,-34.15759909334405L-199.95334533453337,-33.212376597708385L-201.7697269726972,-32.71534838234358L-202.47609760976093,-31.325297163188257L-203.58610861086103,-30.482473304118198L-204.39338933893384,-29.4424797527499L-204.69611961196114,-27.41549058883992L-205.50340034003395,-25.737861227415L-204.09065906590652,-25.540679490563203L-203.68701870187016,-24.25991521094031L-203.08155815581551,-23.620111896017566L-202.87973797379735,-22.489057059996508L-203.1824682468246,-21.408215428296963L-203.08155815581551,-20.819074616432324L-202.37518751875183,-20.62275663574487L-201.7697269726972,-19.641620491561362L-198.13696369636958,-19.886834732377064L-196.52240224022398,-19.543547585209353L-194.50420042004194,-17.093985836781968L-193.39418941894186,-17.387713028237833L-191.3759875987598,-17.240842250101682L-189.76142614261417,-17.583563292484936L-188.7523252325232,-17.093985836781968L-189.25687568756868,-15.577280837913507L-189.9632463246324,-14.648380194895534L-190.1650665066506,-12.596709583801713L-189.559605960596,-10.742211717870424L-188.7523252325232,-9.913045493039137L-188.6514151415141,-9.279156416213254L-190.0641564156415,-7.865601841041458L-189.0550555055505,-7.280867026196362L-188.34868486848677,-6.306519504403868L-187.4404940494049,-3.4820950811633753L-188.0459545954595,-3.1413063943214032L-188.550505050505,-4.7967263109388645L-189.35778577857778,-5.673320266247903L-190.26597659765972,-4.699336279315192L-195.71512151215117,-4.7967263109388645L-195.71512151215117,-3.0439408631704223L-194.10056005600555,-2.7518508395307024L-194.10056005600555,-1.6809246168046172L-194.70602060206014,-1.9729859878951386L-196.32058205820576,-1.4862201844259346L-196.32058205820576,0.5580991735268765L-195.10966096609656,1.5802720634112344L-194.60511051105104,3.186689054122882L-194.70602060206014,4.403875280318411L-195.91694169416937,12.105222041231084L-197.32968296829677,10.592561043323757L-198.13696369636958,10.543781866268338L-196.42149214921486,7.667375389982108L-198.54060406040597,6.35192860300442L-200.2560756075607,6.595495096790317L-201.26517651765172,6.108376713013752L-202.77882788278822,6.839076755593891L-204.89793979397933,6.498066710906107L-206.51250125012496,3.5761653850684296L-207.82433243324326,2.8459127166589457L-208.7325232523252,1.5315960399995887L-210.548904890489,0.16870817283960143L-211.2552755275527,0.46075120515561424L-212.4661966196619,-0.22068183591016088L-213.8789378937893,-1.1454925125474393L-214.6862186218621,-0.7074214397876266L-217.00715071507145,-1.096817587581622L-217.71352135213516,-2.313732569973704L-218.21807180718068,-2.2650538848435935Z", id: "Colombia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-240.31738173817376,-31.226097610216808L-239.81283128312828,-31.622966812111695L-237.99644964496443,-30.87899157644864L-237.39098909890984,-31.226097610216808L-236.48279827982793,-30.978150119215698L-235.97824782478244,-30.383372515122893L-235.17096709670963,-30.23474275719105L-234.56550655065504,-30.829416668393517L-233.75822582258223,-29.294009866863473L-232.7491249124912,-28.107131213945543L-231.43729372937293,-26.92177048279641L-232.4463946394639,-26.67500522451294L-232.4463946394639,-25.491390033636897L-231.94184418441841,-25.097159708969347L-232.3454845484548,-24.752331284990134L-232.24457445744568,-24.25991521094031L-232.4463946394639,-23.66931419518898L-232.547304730473,-23.128209202192284L-234.0609560956095,-23.718518700455625L-234.6664166416641,-24.309146557699783L-234.36368636863682,-24.801585520022357L-234.4645964596459,-25.44210295810616L-235.2718771877187,-26.132340455840552L-236.38188818881883,-26.67500522451294L-237.29007900790074,-27.06985983784346L-237.49189918991894,-27.909467480356916L-238.19826982698265,-28.403705967459736L-237.99644964496443,-27.56365647519852L-238.60191019101907,-26.872412410569495L-239.2073707370737,-27.662446636071305L-240.11556155615557,-27.958879477791857L-240.519201920192,-28.552029245373696L-240.519201920192,-29.3929870314002L-240.11556155615557,-30.284283159601014L-240.92284228422838,-30.68070933880795Z", id: "Costa Rica", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-230.63001300130006,-66.80416832016742L-228.20817081708165,-66.59243742095391L-225.9881488148814,-66.53952182175942L-223.36448644864484,-65.53541692783999L-222.25447544754468,-64.42843392725419L-219.63081308130808,-64.74441628311857L-218.62171217121707,-64.06008690451401L-216.30078007800776,-62.170736675635055L-214.48439843984391,-60.81130066447601L-213.57620762076203,-60.863509257452264L-211.9616461646164,-60.23740976397501L-212.16346634663458,-59.40396779338598L-210.0443544354435,-59.299895506980725L-207.92524252425235,-58.052872552587985L-208.32888288828875,-57.37880451146095L-210.1452645264526,-56.96447570634788L-212.0625562556255,-56.80919634625504L-213.97984798479843,-57.068023686871705L-218.01625162516248,-56.75744789840878L-216.0989598959895,-58.41623813221529L-217.20897089708967,-59.19584704744593L-219.0253525352535,-59.40396779338598L-220.03445344534447,-60.28955120064812L-220.63991399139906,-62.0136634407979L-222.25447544754468,-61.85664673164194L-224.87813781378134,-62.69472455962523L-225.68541854185415,-63.32435050503823L-229.41909190919085,-63.797177906059964L-230.32728272827276,-64.37579325116087L-229.31818181818176,-65.11336339257134L-232.0427542754275,-65.27158334306019L-234.0609560956095,-63.692059833501034L-235.2718771877187,-63.692059833501034L-235.67551755175512,-62.9569567185228L-236.98734873487342,-62.58987628184957L-238.19826982698265,-62.904497522478934L-236.78552855285525,-63.84974668520927L-236.0791579157915,-64.90249665985958L-234.8682368236823,-65.58820375379423L-233.4554955495549,-66.1693036920074L-231.33638363836374,-66.48661305954333Z", id: "Cuba", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M95.20867086708681,-105.02335819645779L94.90594059405954,-105.14230188612466L94.30048004800491,-104.84503746957806L93.89683968396854,-104.96390532398435L93.79592959295944,-104.78562246600127L93.69501950195036,-105.14230188612466L93.4931993199321,-105.38034134832402L92.98864886488663,-105.38034134832402L92.18136813681383,-105.08282371355618L91.67681768176828,-105.26129624109808L91.87863786378655,-105.32081244523957L92.28227822782291,-106.1553776605963L94.30048004800491,-106.09568267672782L96.82323232323245,-107.11225283026113L95.00685068506864,-105.67817672941801Z", id: "Northern Cyprus", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M91.67681768176828,-105.26129624109808L92.18136813681383,-105.08282371355618L92.98864886488663,-105.38034134832402L93.4931993199321,-105.38034134832402L93.69501950195036,-105.14230188612466L93.79592959295944,-104.78562246600127L93.89683968396854,-104.96390532398435L94.30048004800491,-104.84503746957806L94.90594059405954,-105.14230188612466L95.20867086708681,-105.02335819645779L95.20867086708681,-104.72622006376149L92.38318831883201,-103.3634180589712L90.97044704470464,-103.77748662573379L90.36498649865,-105.14230188612466Z", id: "Cyprus", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M38.093559355935675,-157.39209185997177L36.47899789979012,-159.24978193067412L35.066256625662675,-160.2972417757189L34.7635263526354,-162.1050809402373L34.25897589758986,-163.39512052516287L36.27717771777186,-164.3870238213299L37.28627862786294,-165.46053957390882L39.30448044804494,-166.3079295352509L40.01085108510866,-167.15880436549105L40.81813181318147,-166.69425652286512L42.029052905290655,-167.15880436549105L43.34088408840894,-165.69130248677163L45.4599959996001,-165.30684011923512L45.258175817581844,-164.0813198686138L46.77182718271838,-163.242937627185L47.276377637763915,-164.3105557565444L49.193669366936824,-163.85233586148482L49.39548954895501,-162.4836799718876L51.5146014601461,-162.18074607431268L52.826432643264454,-160.07234871952232L51.91824182418255,-160.07234871952232L51.5146014601461,-159.32442874623817L50.909140914091545,-159.10056715856487L50.70732073207336,-158.1332209234009L50.20277027702783,-157.91061119999458L50.10186018601874,-157.54011152319455L49.09275927592773,-157.09636037615158L47.88183818381847,-157.17025482820864L47.4781978197821,-156.21161456853704L46.16636663666383,-157.02249149582772L44.85453545354547,-156.80103804066624L42.73542354235438,-158.1332209234009L41.72632263226339,-157.76233397390777L40.11176117611775,-156.06451198457782Z", id: "Czech Republic", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M39.50630063006312,-179.2948248797154L40.21267126712685,-176.9223848804489L39.40539053905403,-175.70620227188553L40.414491449145025,-174.0158012951556L41.12086208620875,-171.54598598171148L40.91904190419057,-170.04691990216415L42.029052905290655,-167.15880436549105L40.81813181318147,-166.69425652286512L40.01085108510866,-167.15880436549105L39.30448044804494,-166.3079295352509L37.28627862786294,-165.46053957390882L36.27717771777186,-164.3870238213299L34.25897589758986,-163.39512052516287L34.7635263526354,-162.1050809402373L35.066256625662675,-160.2972417757189L36.47899789979012,-159.24978193067412L38.093559355935675,-157.39209185997177L37.084458445844675,-155.47710900057626L36.075357535753675,-154.96444642304232L36.47899789979012,-152.20248192914818L36.17626762676277,-151.48145944623857L35.368986898689954,-152.34697365858983L33.95624562456259,-152.4915615533224L31.93804380438059,-151.76958192611866L29.516201620162146,-151.91378624312767L29.112561256125694,-150.8345723392135L27.69981998199833,-151.98592424939255L26.791629162916422,-151.76958192611866L23.865236523652516,-152.99837910788L23.259775977597883,-152.1302720698759L20.837933793379438,-152.1302720698759L21.24157415741589,-155.11079671978803L22.654315431543253,-158.05899179789986L18.617911791179257,-158.80245234119553L17.306080608060903,-159.9225529381452L17.406990699069993,-161.80269296584743L16.902440244024532,-162.7870525317744L17.205170517051812,-165.7682805655061L16.70062006200635,-170.51912078859803L18.416091609160993,-170.51912078859803L19.122462246224718,-172.18048608460975L19.82883288328844,-176.43502743835043L19.32428242824298,-178.06418424638397L19.82883288328844,-179.0480884525616L22.149764976497792,-179.2948248797154L22.755225522552347,-178.22783186475735L24.571607160716162,-180.61594523265617L23.966146614661607,-182.3633760037584L23.865236523652516,-185.14098389043392L25.984348434843607,-184.4640143079941L27.800730073007422,-185.2257695253688L27.800730073007422,-183.36888757454352L30.626212621262233,-182.19628757718303L30.626212621262233,-180.5331173687918L33.451695169517045,-181.44613205998385L35.066256625662675,-182.7817165704718L38.194469446944844,-180.86463647728712Z", id: "Germany", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M120.83983398339848,-32.31794848248395L119.83073307330748,-30.779844662697002L119.22527252725286,-31.275695913471427L118.51890189018914,-31.07732033017312L117.00525052505266,-31.126909823471518L116.90434043404359,-32.0200267885132L116.70252025202531,-32.814729152025265L117.71162116211632,-34.15759909334405L118.61981198119823,-35.40309686747903L119.83073307330748,-35.15383188180538L120.73892389238938,-35.85198587220753L121.34438443844402,-34.95447993004523L121.24347434743484,-33.80922523335671L119.6289128912893,-33.112946001942426Z", id: "Djibouti", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M35.46989698969913,-188.30278759523182L33.8553355335535,-184.37955695901428L30.92894289428951,-187.10040226371976L30.525302530253146,-189.16620372784845L34.66261626162631,-190.81735123790634ZM27.800730073007422,-185.2257695253688L25.984348434843607,-184.4640143079941L23.865236523652516,-185.14098389043392L22.755225522552347,-187.87251216007462L22.654315431543253,-193.0116161054394L23.057955795579698,-194.340274120988L23.865236523652516,-195.94690392531678L26.387988798879977,-196.2159914256043L27.397089708971052,-197.65756374201433L29.617111711171237,-199.11012610076523L29.516201620162146,-196.4854583038802L28.70892089208933,-194.78521070127678L29.011651165116604,-193.36502804453715L30.525302530253146,-192.57076160809336L29.81893189318942,-190.64288210847076L29.011651165116604,-191.25421378137017L26.993449344934607,-187.6148023437747Z", id: "Denmark", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-201.06335633563353,-51.405400878685484L-200.96244624462437,-52.22507372534039L-201.66881688168812,-53.09741939142694L-201.06335633563353,-53.61126966864587L-200.76062606260618,-54.74361387943L-201.06335633563353,-56.34366355247509L-200.65971597159714,-56.860950459529015L-198.54060406040597,-56.860950459529015L-196.82513251325125,-56.08523090748853L-196.11876187618756,-56.13690624907047L-195.61421142114204,-55.104453187850964L-194.10056005600555,-55.156023490207154L-194.20147014701465,-54.280068161020175L-192.8896389638963,-54.17711727918074L-191.577807780778,-53.09741939142694L-192.58690869086902,-51.86630622288082L-193.89873987398735,-52.532789244226315L-195.21057105710568,-52.37890826208059L-196.11876187618756,-52.532789244226315L-196.62331233123308,-52.02003298997507L-197.73332333233316,-51.81507418127909L-198.13696369636958,-52.532789244226315L-199.04515451545146,-52.12254309389299L-200.1551655165516,-50.07618048771315L-200.86153615361528,-50.535915000230546Z", id: "Dominican Republic", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M11.95784578457855,-54.692087165872984L8.829632963296461,-54.38304054374831L8.72872287228737,-56.29196582414159L7.517801780178107,-56.75744789840878L5.7014201420142925,-57.637946094608736L5.095959595959741,-59.03981892607825L-4.389588958895779,-65.58820375379423L-13.875137513751298,-72.29532429289583L-24.369786978697736,-79.83466720507121L-24.369786978697736,-80.49305091107814L-24.369786978697736,-80.71278979019303L-24.369786978697736,-84.47013104406294L-19.8288328832882,-86.81210192135298L-17.00335033503339,-87.31614002059774L-14.783328332833205,-88.15795237812533L-13.673317331733035,-89.79175175631488L-10.444194419441855,-91.09354072639665L-10.24237423742367,-93.54199733430447L-8.62781278127804,-93.82796851338277L-7.416891689168777,-95.03198758661827L-3.6832183218320553,-95.60701670914506L-3.1786678667865957,-96.87597009839502L-3.9859485948594107,-97.57040921595765L-4.894139413941319,-101.12607919808623L-5.095959595959502,-103.18614548395857L-6.105060506050502,-105.38034134832402L-3.481398139813871,-107.29203689883275L-0.45409540954087396,-107.8921679478808L1.3622862286229405,-109.27748829799482L4.086858685868662,-110.36660384487423L8.829632963296461,-110.97357434655629L13.471497149715091,-111.27757505551267L14.884238423842536,-110.73062162391348L17.507900790079088,-112.13062044168399L20.535203520352162,-112.13062044168399L21.645214521452253,-111.3384166230984L23.562506250625162,-111.52102439113827L22.95704570457061,-109.76099810376441L23.461596159616068,-106.4540455846736L22.755225522552347,-103.65911938546607L21.039753975397623,-101.71315659758297L21.24157415741589,-99.19714601798893L23.562506250625162,-97.22298661753582L23.562506250625162,-96.41390946869599L25.378887888788977,-95.08944121950118L26.488898889889146,-89.17104844442424L27.397089708971052,-86.30884324643475L27.598909890989237,-84.85930706327746L27.094359435943698,-82.25490041819543L27.29617961796188,-80.76774631133407L26.892539253925513,-79.06811786610052L27.195269526952792,-77.10458727376931L26.085258525852698,-75.80150962149472L27.69981998199833,-73.5322139098984L27.800730073007422,-72.18795931951173L28.809830983098422,-70.47419525458353L30.121662166216776,-71.0089285977805L32.341684168416954,-69.62014539436495L33.55260526052614,-67.70525612138582L23.966146614661607,-61.908979364586884L15.893339333933536,-56.033561147700915Z", id: "Algeria", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-221.04355435543548,-3.8228994478030884L-218.21807180718068,-2.2650538848435935L-217.71352135213516,-2.313732569973704L-217.00715071507145,-1.096817587581622L-214.6862186218621,-0.7074214397876266L-213.8789378937893,-1.1454925125474393L-212.4661966196619,-0.22068183591016088L-211.2552755275527,0.46075120515561424L-210.9525452545254,2.6025089816934055L-211.75982598259822,4.403875280318411L-214.88803880388033,7.326287814022289L-218.21807180718068,8.4471364233483L-219.93354335433537,10.885256758806433L-220.4380938093809,12.788702816664197L-222.0526552655265,13.96092907325093L-223.26357635763569,12.54457664007995L-224.37358735873585,12.202848465945504L-225.48359835983592,12.446934301255013L-225.58450845084502,11.42196006355764L-224.77722772277224,10.73890444826248L-225.07995799579953,9.568396316496885L-223.66721672167208,7.472464069871287L-224.27267726772675,6.254506125975437L-225.28177817781776,7.569918336990442L-226.99724972497245,6.3032170746587814L-226.39178917891783,5.523908403508693L-226.89633963396332,2.9919580598948583L-225.88723872387234,2.553828969990674L-225.38268826882683,0.801470069973832L-224.37358735873585,-0.9994680354764748L-224.57540754075401,-2.119019060246993L-222.9608460846084,-2.7518508395307024Z", id: "Ecuador", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M103.2814781478149,-63.21934874961347L92.18136813681383,-63.21934874961347L81.28307830783093,-63.21934874961347L69.9811481148116,-63.21934874961347L69.9811481148116,-74.50306616720174L69.9811481148116,-85.7505736137403L69.17386738673878,-88.3265792544225L69.8802380238025,-90.35708550347242L69.47659765976614,-91.71805172313232L70.48569856985715,-93.31341257367065L74.21937193719386,-93.37054278554655L76.94394439443958,-92.51470229541798L79.6685168516853,-91.54760646524274L80.98034803480358,-91.03682887644742L83.09945994599475,-92.05922278912612L84.31038103810394,-92.97085435385202L86.73222322232238,-93.25629299862275L88.75042504250438,-92.85675303208622L89.55770577057719,-91.20699528417308L90.16316631663182,-92.286878764575L92.38318831883201,-91.49081210069505L94.60321032103228,-91.32049104543763L96.01595159515963,-92.173029868744L97.83233323332344,-86.58833553985372L97.02505250525063,-85.30463964843162L96.41959195919608,-82.86263962127963L95.71322132213236,-81.20771364142576L95.00685068506864,-80.65784199741272L94.09865986598672,-81.70335021194106L92.78682868286845,-83.08390625919127L90.86953695369546,-87.70871246953946L90.56680668066818,-87.42825495576857L91.67681768176828,-84.02591466121662L93.392289228923,-80.82271156865968L95.51140114011417,-75.90992101999488L96.62141214121426,-74.23313101872475L97.42869286928708,-72.45642859176688L99.95144514451462,-69.08730566191038L99.44689468946909,-68.55518189398704L99.54780478047817,-66.53952182175942L102.77692769276943,-63.84974668520927Z", id: "Egypt", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M102.0705570557057,-40.80878029828456L101.76782678267844,-41.96566412868903L102.97874787478762,-46.26012164616849L103.2814781478149,-48.190290017117285L104.0887588758877,-49.10692946934912L106.20787078707889,-49.565830114218315L107.62061206120624,-51.25185690227232L109.23517351735187,-47.88508337330623L110.0424542454247,-45.19624979354202L111.55610561056123,-43.780746579982456L115.39068906890704,-41.0098270182718L116.90434043404359,-39.40318739775619L118.41799179918004,-37.70035565773935L119.32618261826195,-36.7505947929066L120.73892389238938,-35.85198587220753L119.83073307330748,-35.15383188180538L118.61981198119823,-35.40309686747903L117.71162116211632,-36.35107499401308L116.50070007000713,-38.05059258376281L115.28977897789795,-38.95202235034414L114.58340834083423,-39.95502609202073L112.16156615661578,-41.11037395812499L110.24427442744289,-41.160653341336385L109.53790379037915,-41.764315475668056L107.9233423342336,-41.06009851884908L106.20787078707889,-42.36855536900231L105.29967996799697,-40.20601440646477Z", id: "Eritrea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-5.398689868986778,-135.31066229502264L-4.288678867886687,-133.8413021373733L0.8577357735774808,-132.11652543080137L1.86683668366848,-132.91101268350016L5.095959595959741,-131.19297143592678L8.325082508250922,-131.72027745328685L8.425992599260013,-129.48721934465175L5.802330233023385,-127.01572567132133L2.2704770477048477,-126.24044814377372L1.9677467746775719,-124.95374701013112L0.25227522752284937,-122.90887783726718L-0.8577357735772417,-119.99841143817851L0.25227522752284937,-117.9308962081159L-1.362286228622781,-116.31360574880446L-1.967746774677333,-114.02931381584241L-4.086858685868503,-113.29271764508461L-6.105060506050502,-110.60922761770726L-9.636913691369038,-110.54855116217344L-12.260576057605668,-110.60922761770726L-14.076957695769483,-109.3982848883872L-15.086058605860483,-108.0724636786832L-16.498799879987928,-108.37322091033872L-17.507900790078928,-109.51913532446939L-18.315181518151743,-111.52102439113827L-20.93884388438829,-112.06959807205915L-21.140664066406554,-113.23142736654036L-20.131563156315554,-114.58311771618962L-19.72792279227911,-115.50873538364692L-20.73702370237011,-116.62383732071059L-19.929742974297294,-118.93123508619577L-21.039753975397463,-121.13328193667843L-19.8288328832882,-121.44943209792974L-19.72792279227911,-123.16356704391312L-19.32428242824274,-123.67372896935008L-19.223372337233652,-126.56318142915866L-17.911541154115294,-127.59880608871207L-18.71882188218811,-129.48721934465175L-20.33338333833374,-129.6180011378279L-20.837933793379204,-129.0952998391538L-22.55340534053392,-129.0952998391538L-23.25977597759765,-130.99553206464978L-24.369786978697736,-130.4041912490347L-25.378887888788736,-129.48721934465175L-25.277977797779645,-132.18263108332806L-26.387988798879817,-133.8413021373733L-22.452495249524834,-136.58713051254088L-19.021552155215385,-135.9144334899488L-15.186968696869572,-135.9144334899488L-12.260576057605668,-135.24367287967846L-9.939643964396314,-135.44469876899245Z", id: "Spain", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M78.35668566856695,-208.5465560775398L78.7603260326034,-207.59080711129718L76.84303430343049,-204.47104645756266L77.6503150315033,-199.47500762322107L76.43939393939404,-197.83852889432367L74.11846184618477,-197.83852889432367L71.69661966196632,-199.74912980325107L70.48569856985715,-200.39029332011765L68.0638563856387,-199.47500762322107L68.46749674967506,-202.6052080340414L67.35748574857497,-201.95650492910022L65.64201420142024,-203.8158968073863L65.33928392839297,-206.9246815849849L68.87113711371151,-208.45076053821066L72.40299029903004,-209.31469835406915L75.53120312031214,-208.35501418819888Z", id: "Estonia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M118.61981198119823,-35.40309686747903L117.71162116211632,-34.15759909334405L116.70252025202531,-32.814729152025265L116.90434043404359,-32.0200267885132L117.00525052505266,-31.126909823471518L118.51890189018914,-31.07732033017312L119.22527252725286,-31.275695913471427L119.83073307330748,-30.779844662697002L119.22527252725286,-29.789006518375675L120.23437343734385,-28.20597887278574L121.34438443844402,-26.82305685341712L122.35348534853503,-25.836466507994658L131.5363036303632,-22.439906294202686L133.85723572357253,-22.489057059996508L125.98624862486265,-14.01309996537885L122.35348534853503,-13.866528254026315L119.83073307330748,-11.913291519463248L118.01435143514368,-11.864484329406642L117.30798079807994,-10.986137582608915L115.39068906890704,-10.986137582608915L114.17976797679786,-11.913291519463248L111.65701570157032,-10.742211717870424L110.8497349734975,-9.571702064035755L108.93244324432459,-9.815514301679384L108.32698269826997,-10.10811886802566L107.72152215221534,-10.059349138958572L106.81333133313343,-10.059349138958572L103.2814781478149,-12.45024410719572L101.2632763276329,-12.45024410719572L100.35508550855099,-13.378038407766L100.35508550855099,-14.941662980433607L98.84143414341445,-15.4305785590575L97.2268726872689,-18.514212872331633L95.91504150415055,-19.151328117556726L95.41049104910509,-20.279273736352923L93.99774977497763,-21.653774883935053L92.28227822782291,-21.850258663440858L93.2913791379139,-23.472518187904445L94.80503050305046,-23.521713897091313L95.20867086708681,-24.40761605850776L95.10776077607771,-26.97113107488923L96.01595159515963,-29.937559890401605L97.32778277827798,-30.73027555446583L97.52960296029617,-31.920743771574646L98.74052405240535,-34.10782173843054L100.45599559956008,-35.50282633844522L101.56600660066017,-38.350937087620615L102.0705570557057,-40.80878029828456L105.29967996799697,-40.20601440646477L106.20787078707889,-42.36855536900231L107.9233423342336,-41.06009851884908L109.53790379037915,-41.764315475668056L110.24427442744289,-41.160653341336385L112.16156615661578,-41.11037395812499L114.58340834083423,-39.95502609202073L115.28977897789795,-38.95202235034414L116.50070007000713,-38.05059258376281L117.71162116211632,-36.35107499401308Z", id: "Ethiopia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M78.6594159415943,-214.2877489237992L73.51300130013014,-213.7942451547183L68.56840684068423,-211.73579805401815L64.02745274527462,-210.5697311922257L62.412891289129064,-213.69570249487077L59.68831883188334,-215.47757344709652L60.2937793779379,-221.23694853363432L58.981948194819616,-226.65457523857233L60.2937793779379,-230.28658807478195L62.816531653165434,-234.21388304947564L69.27477747774788,-241.18668796934023L71.0911591159117,-242.56843647988367L70.8893389338935,-245.48220872690064L66.95384538453861,-248.684095967386L66.0456545654567,-251.33685346197643L65.9447444744476,-262.4993774758172L61.50470047004716,-267.6264241270781L57.771027102710356,-271.40365885503377L59.486498649865084,-273.59991900307017L62.614711471147245,-269.3698415052773L66.24747474747488,-269.77468657063827L69.27477747774788,-267.89349710949364L71.9993499349936,-271.2673203376748L73.31118111811196,-277.22993019717L77.6503150315033,-279.93218800977496L81.28307830783093,-276.6664349569999L80.07215721572167,-271.1310898518859L79.6685168516853,-265.7683987216048L84.00765076507666,-260.69532055779365L81.38398839884003,-255.26856243963346L84.61311131113122,-247.2538426239943L82.79672967296739,-241.53111643551455L85.31948194819493,-236.65699651438774L84.10856085608576,-232.56705018157342L88.24587458745891,-228.24792827489878L87.23677367736784,-225.1800038238669L84.61311131113122,-221.6480065834223Z", id: "Finland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M499.8581358135816,49.40936247205049L500.86723672367253,50.225918364761995L500.36268626862716,51.76037443824608L498.6472147214724,52.17033026792641L497.1335633563359,51.81160103695497L496.83083308330856,50.53245037461104L497.9408440844086,49.51136385182834L499.1517651765179,49.86852150851928ZM-504.5,45.64879082160724L-504.49949549999985,45.64852158582181L-504.4999999999999,47.06857405979843L-504.5,47.068786666532844L-504.5,45.64879082160724ZM504.5,47.068786666532844L502.68361836183635,47.83078460235155L502.68361836183635,47.83078460235155L500.86723672367253,48.44130685291231L500.56450645064535,47.32252892245911L501.8763376337636,46.713229293436896L502.78452845284556,46.5610068542696L504.5,45.64879082160724L504.5,47.068786666532844ZM-504.2981798179818,46.91625609895335L-504.5,47.06857405979843L-504.5,45.64852158582181L-503.9954495449545,45.54722337865303Z", id: "Fiji", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-171.59760976097604,170.59258343691346L-168.26757675767567,167.85232071674577L-165.8457345734573,169.0222381040967L-164.13026302630257,167.23107384484354L-161.91024102410233,169.17873186715042L-162.71752175217517,170.8291790494415L-166.552105210521,172.17510068420782L-167.76302630263018,170.59258343691346L-170.18486848684864,172.65226646577793Z", id: "Falkland Islands", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-152.82833283328324,-6.452655965680684L-152.12196219621953,-7.670679039747701L-151.92014201420136,-8.937891965537345L-151.41559155915584,-10.156889528165681L-152.52560256025595,-11.81567823329369L-152.72742274227417,-13.71996806483214L-151.31468146814672,-16.115301018344393L-150.30558055805574,-15.821813498178443L-148.28737873787372,-15.1372123886649L-145.26007600760065,-12.792013175059987L-144.85643564356428,-11.620464697634409L-146.4709970997099,-9.084143131696031L-147.3791879187918,-6.988536273523168L-148.38828882888282,-5.916847463728824L-149.80103010301022,-5.7220246445338L-150.10376037603754,-6.501369300322488L-150.81013101310123,-6.64751290975341L-151.61741174117404,-5.868140954049999ZM26.791629162916422,-130.46982362599897L25.782528252825422,-127.59880608871207L24.571607160716162,-128.31336604808814L23.865236523652516,-130.86399649441603L24.470697069707068,-132.3148976691552L26.287078707870883,-133.77473100401136ZM15.893339333933536,-160.22225080475494L16.498799879988088,-159.84769484712209L17.306080608060903,-159.9225529381452L18.617911791179257,-158.80245234119553L22.654315431543253,-158.05899179789986L21.24157415741589,-155.11079671978803L20.837933793379438,-152.1302720698759L20.131563156315718,-151.40948831120278L18.81973197319744,-151.84167214285637L18.920642064206532,-150.76281414852357L16.902440244024532,-148.47886716216973L16.80153015301544,-146.64042800646874L18.21427142714281,-147.2750852785407L19.122462246224718,-145.4465501232649L19.021552155215627,-144.3287013754282L19.82883288328844,-142.80069101593418L18.81973197319744,-141.6269992966274L19.627012701270257,-138.54906409849187L21.140664066406796,-138.07396630081846L20.837933793379438,-136.3851170490797L18.21427142714281,-134.17444067038707L12.765126512651365,-135.24367287967846L8.627812781278278,-133.97450092693774L8.325082508250922,-131.72027745328685L5.095959595959741,-131.19297143592678L1.86683668366848,-132.91101268350016L0.8577357735774808,-132.11652543080137L-4.288678867886687,-133.8413021373733L-5.398689868986778,-135.31066229502264L-3.885038503850239,-137.6675170587483L-3.3804880488047795,-145.58667492039254L-6.306880688068685,-149.83209270667763L-8.325082508250683,-151.91378624312767L-12.664216421642035,-153.50638472797593L-12.96694669466939,-156.5798138518421L-9.334183418341762,-157.54011152319455L-4.591409140913963,-156.4324581050583L-5.49959995999587,-161.27455929140805L-2.775027502750148,-159.47380136338762L3.6832183218322947,-162.7870525317744L4.591409140914202,-166.46237372927885L7.013251325132647,-167.31388627270053L7.416891689169015,-165.7682805655061L8.72872287228737,-165.69130248677163L10.040554055405645,-163.92863592295623L11.95784578457855,-161.8782491283136L13.370587058705999,-162.18074607431268Z", id: "France", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M26.589808980898237,-2.8005318518877935L27.497999799980146,-2.9465764508572345L31.53440344034414,-2.9465764508572345L31.53440344034414,-6.306519504403868L32.8462346234625,-6.501369300322488L34.56170617061722,-6.1116789879567435L36.27717771777186,-6.501369300322488L36.579907990799214,-6.355231072210803L36.37808780878103,-5.08890713156123L37.18536853685377,-3.6768384150597204L39.30448044804494,-3.871587155420916L40.01085108510866,-3.3360409563620452L38.69901990199031,-0.0746605535447471L40.11176117611775,1.5802720634112344L40.414491449145025,3.7709112947846215L40.01085108510866,5.621314500362225L39.203570357035844,6.936513791067077L36.68081808180831,6.839076755593891L35.16716671667177,5.475206119135097L34.965346534653584,6.74164223634493L33.04805480548068,7.082674140811878L32.13986398639877,7.764835264820526L33.14896489648977,9.617156923233539L31.02985298529868,11.177988585169322L28.20437043704379,8.349655787857174L26.287078707870883,6.059668038095338L24.571607160716162,3.138005877505468L24.672517251725253,2.213075207885671L25.277977797779883,1.2882179442012323L25.984348434843607,-0.7074214397876266Z", id: "Gabon", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-17.406990699069837,-179.87173513517072L-19.526102610260924,-180.86463647728712L-21.24157415741565,-180.78170475036575L-20.73702370237011,-183.36888757454352L-21.24157415741565,-185.99049527461938L-18.920642064206294,-186.16084064465113L-15.893339333933298,-183.11702871662422ZM-3.1786678667865957,-183.4529121112032L-1.2613761376136892,-182.69797750630994L0.4540954095410332,-177.32942310164952L1.2613761376138486,-175.46384650040304L4.692319231923293,-174.57769549495896L4.288678867886926,-171.6251903575002L2.875937593759479,-170.28288395980596L3.98594859485957,-167.93538323126702L1.463196319632112,-165.61435298076623L-2.2704770477046883,-165.69130248677163L-7.013251325132408,-164.46351998324428L-8.325082508250683,-165.30684011923512L-10.141464146414497,-163.242937627185L-12.765126512651127,-163.77606370432008L-14.783328332833205,-162.1050809402373L-16.196069606960574,-162.9389038470763L-12.159665966596576,-167.62440041935042L-9.636913691369038,-168.55876236228272L-13.97604760476039,-169.34065613425008L-14.783328332833205,-171.15042551418057L-11.85693569356922,-172.57805687005748L-13.370587058705759,-175.06056747267672L-12.86603660366022,-178.06418424638397L-8.72872287228713,-177.65565045453909L-8.325082508250683,-180.45032405295686L-10.141464146414497,-183.36888757454352L-10.24237423742367,-183.4529121112032L-13.673317331733035,-184.29513589067525L-14.278777877787665,-185.65024858436425L-13.269676967696666,-187.7865710169997L-14.177867786778576,-189.16620372784845L-15.691519151915113,-186.8437097862021L-15.893339333933298,-191.6044161288335L-17.30608060806066,-194.2514104848156L-16.296979697969665,-199.56633769041508L-14.076957695769483,-203.90934998030883L-11.85693569356922,-203.44254755539174L-8.425992599259855,-203.90934998030883L-11.453295329532851,-198.20097591128658L-8.62781278127804,-198.92794788077597L-5.49959995999587,-198.92794788077597L-6.306880688068685,-194.69614077716554L-8.829632963296223,-190.1204161025135L-5.903240324032318,-189.77288646319914L-5.701420142014054,-189.25275669013186Z", id: "United Kingdom", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M111.9597459745976,-135.3776709190678L112.26247624762487,-135.84727057632432L114.68431843184332,-135.17670265587498L118.82163216321649,-134.57483143855146L122.55530553055321,-132.71214085203064L123.05985598559867,-131.98436932486806L124.77532753275338,-132.57965242224435L127.39898989899002,-131.78627291931437L128.20627062706282,-130.27298043855072L130.02265226522667,-129.35650861388103L129.31628162816293,-128.83437381539443L130.62811281128128,-126.8216753488414L130.325382538254,-126.43403698948921L128.81173117311747,-126.62777925657417L126.69261926192637,-127.72856962406507L125.98624862486265,-127.08044345570988L122.15166516651675,-126.49860067844905L119.42709270927104,-128.31336604808814L116.39978997899804,-128.18328927709555L116.8034303430344,-129.74885411883068L116.09705970597076,-132.3810586351686L114.48249824982514,-133.77473100401136L112.96884688468859,-134.17444067038707Z", id: "Georgia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-8.022352235223408,-14.01309996537885L-7.921442144214315,-15.088322949705665L-9.1323632363235,-17.534598295459922L-8.425992599259855,-20.720911776489174L-7.215071507150593,-23.079030858937305L-8.022352235223408,-27.11922801829336L-8.325082508250683,-29.294009866863473L-8.325082508250683,-30.87899157644864L-3.3804880488047795,-31.027733763721287L-2.1695669566955966,-30.829416668393517L-1.2613761376136892,-31.275695913471427L0.050455045504665466,-31.027733763721287L-0.15136513651351843,-30.185205198510292L0.9586458645865727,-28.700376631265716L0.9586458645865727,-26.625659679770248L1.2613761376138486,-24.40761605850776L1.9677467746775719,-23.374133326511075L1.3622862286229405,-20.819074616432324L1.5641064106412041,-19.39645181322222L2.2704770477048477,-17.632529917828652L2.875937593759479,-16.604566610604515L-1.4631963196318731,-14.990548250160202L-3.0777577757775036,-14.01309996537885L-5.600510051004961,-13.182677296159705Z", id: "Ghana", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-28.70892089208909,-23.620111896017566L-29.516201620161905,-23.472518187904445L-29.41529152915281,-24.5060946672552L-29.919841984198353,-25.24497837480348L-29.81893189318918,-26.08302205066274L-30.42439243924381,-27.26734781309064L-31.231673167316625,-28.25540666709295L-33.45169516951681,-28.30483711109034L-34.05715571557144,-27.761247164464056L-34.86443644364426,-27.662446636071305L-35.3689868986898,-27.06985983784346L-35.67171717171707,-26.280310350555784L-37.18536853685361,-25.047891513423576L-38.3962896289628,-26.724353265177104L-39.50630063006288,-27.810651328508044L-40.21267126712661,-28.20597887278574L-40.91904190419033,-28.74983113978328L-41.2217721772176,-30.03660953608136L-41.62541254125406,-30.631146010832794L-42.43269326932687,-31.126909823471518L-41.2217721772176,-32.51662387576279L-40.3135813581357,-32.466950435427385L-39.60721072107197,-32.91412231876378L-39.00175017501743,-32.91412231876378L-38.59810981098097,-33.31181974918285L-38.79992999299916,-34.257163508718506L-38.49719971997189,-34.55593475898612L-38.49719971997189,-35.55269612478195L-37.08445844584452,-35.50282633844522L-35.06625662566244,-34.80500077672772L-34.46079607960789,-34.85482385591734L-34.25897589758963,-35.20367819143393L-32.74532453245317,-34.95447993004523L-32.34168416841672,-35.103988905875674L-32.13986398639853,-34.05804761204233L-31.736223622362164,-34.05804761204233L-31.02985298529844,-34.45633130154358L-30.525302530252905,-34.35674089812391L-29.71802180218009,-33.659970229274954L-28.507100710070905,-33.4112754960893L-27.80073007300718,-34.0082767091887L-26.892539253925275,-34.40653447058198L-26.18616861686155,-34.80500077672772L-25.681618161816093,-34.7551809961009L-24.97524752475237,-34.10782173843054L-24.672517251725093,-33.31181974918285L-23.56250625062492,-32.119321886348594L-24.067056705670463,-31.37490136427477L-24.167966796679554,-30.43292147799534L-23.663416341634093,-30.73027555446583L-23.25977597759765,-30.383372515122893L-23.46159615961583,-29.54147349788897L-22.55340534053392,-28.74983113978328L-23.158865886588554,-28.502585480514647L-23.360686068606736,-27.56365647519852L-22.654315431543015,-26.378969227434634L-22.048854885488463,-24.112234728468117L-23.057955795579463,-23.767725416536155L-23.360686068606736,-23.374133326511075L-23.057955795579463,-22.833171291861394L-23.25977597759765,-21.604658984508763L-23.663416341634093,-21.604658984508763L-24.47069706970683,-21.653774883935053L-25.07615761576146,-20.524609156927884L-25.883438343834275,-20.524609156927884L-26.387988798879817,-21.11360970438644L-26.18616861686155,-22.29246650882726L-27.397089708970817,-24.01379232436989L-28.103460346034538,-23.66931419518898Z", id: "Guinea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-47.27637763776369,-37.15033829452927L-46.87273727372724,-38.451081137448114L-43.84543454345424,-38.50115866331635L-43.2399739973996,-39.20263215318992L-42.33178317831769,-39.25276533197783L-41.2217721772176,-38.55123986333896L-40.3135813581357,-38.55123986333896L-39.40539053905379,-39.00213684930659L-38.90084008400833,-38.20074844062174L-40.11176117611752,-37.550308102512886L-41.3226822682267,-37.600320370625056L-42.53360336033596,-38.20074844062174L-43.54270427042696,-37.550308102512886L-44.04725472547241,-37.50029941122093L-44.65271527152705,-37.1003580341599Z", id: "The Gambia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-46.77182718271814,-34.95447993004523L-45.35908590859078,-35.452959921022845L-44.34998499849977,-35.353237172779835L-43.64361436143606,-35.65244582434926L-38.49719971997189,-35.55269612478195L-38.49719971997189,-34.55593475898612L-38.79992999299916,-34.257163508718506L-38.59810981098097,-33.31181974918285L-39.00175017501743,-32.91412231876378L-39.60721072107197,-32.91412231876378L-40.3135813581357,-32.466950435427385L-41.2217721772176,-32.51662387576279L-42.43269326932687,-31.126909823471518L-43.94634463446333,-32.31794848248395L-45.1572657265726,-32.51662387576279L-45.76272627262714,-33.31181974918285L-45.76272627262714,-33.759470373367364L-46.57000700069996,-34.35674089812391Z", id: "Guinea-Bissau", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M26.993449344934607,-6.355231072210803L31.53440344034414,-6.306519504403868L31.53440344034414,-2.9465764508572345L27.497999799980146,-2.9465764508572345L26.589808980898237,-2.8005318518877935L25.984348434843607,-3.2386730801159054Z", id: "Equatorial Guinea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M66.34838483848397,-107.2320958275524L67.8620362036205,-106.09568267672782L70.0820582058207,-106.27480619618277L72.20117011701187,-106.03600053412133L72.1002600260027,-105.43988296124289L73.61391139113923,-105.85703104388038L73.31118111811196,-104.84503746957806L69.27477747774788,-104.548088357119L69.27477747774788,-105.08282371355618L65.8438343834385,-105.73778205520729ZM73.00845084508468,-125.53192848794869L71.29297929792996,-125.5962548744404L69.77932793279342,-125.98256764260344L66.44929492949306,-125.01792237251459L68.36658665866597,-122.90887783726718L66.95384538453861,-122.33677622638339L65.33928392839297,-122.33677622638339L63.92654265426553,-124.24891750028186L63.32108210821097,-123.41851711778801L64.02745274527462,-121.2596943341443L65.44019401940207,-119.55844325842386L64.33018301830197,-118.74337321286197L65.9447444744476,-117.05878764755022L67.25657565756589,-116.06568759902311L67.35748574857497,-114.02931381584241L64.73382338233834,-115.01466457869107L65.54110411041115,-113.17015129783023L63.82563256325644,-112.80279260886824L64.83473347334743,-109.70051214159363L63.018351835183616,-109.70051214159363L60.69741974197434,-111.21674731233655L59.58740874087425,-114.02931381584241L59.183768376837804,-116.37562234187783L58.07375737573771,-117.99330304037177L56.66101610161027,-120.06132637223287L56.459195919592084,-121.13328193667843L57.771027102710356,-122.90887783726718L57.87193719371953,-124.05703958029399L58.78012801280144,-124.63312051543778L58.881038103810525,-125.5962548744404L60.69741974197434,-125.91813991101967L61.80743074307444,-126.6923941756665L63.32108210821097,-126.62777925657417L63.72472247224734,-127.27470005063452L64.33018301830197,-127.40429063315905L66.34838483848397,-127.33948671321927L68.56840684068423,-128.31336604808814L70.58660866086623,-127.01572567132133L73.10936093609376,-127.40429063315905L73.10936093609376,-129.2258688203514L74.52210221022114,-128.24831892714474L73.61391139113923,-125.91813991101967Z", id: "Greece", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-131.13266326632657,-440.2160501740756L-121.74802480248015,-453.64247280694394L-111.85883588358827,-452.82107559209396L-108.32698269826973,-461.66119303684746L-98.43779377937784,-464.27835744023156L-76.03575357535743,-460.79813964474937L-58.47739773977384,-442.50592444680353L-63.62381238123801,-433.8985608453959L-74.4211921192118,-433.1712666062691L-89.45679567956786,-431.0087648156995L-88.0440544054405,-427.4674938403817L-78.15486548654853,-429.58296083638385L-69.67841784178408,-422.97650676689085L-64.22927292729264,-428.8747339331837L-61.90834083408329,-421.61930889870104L-65.03655365536545,-410.8353222901624L-57.87193719371929,-417.61451092292214L-44.24907490749068,-425.3792692006383L-35.87353735373526,-421.61930889870104L-34.25897589758963,-413.38462500602145L-45.66181618161806,-400.7225818277116L-47.27637763776369,-396.9051618615211L-56.25737573757366,-394.0283816999412L-49.69821982198213,-393.17515831626457L-53.0282528252824,-381.67621987553747L-55.24827482748267,-372.17616486150024L-55.14736473647357,-356.941849431441L-51.81733173317322,-348.5226004456661L-56.15646564656457,-348.09118364229073L-60.7983298329832,-344.0480490068426L-55.65191519151903,-337.85912788785515L-54.94554455445539,-328.2232248744557L-57.97284728472838,-327.2707239601286L-54.34008400840075,-318.0341989397547L-60.59650965096502,-317.3169324716384L-57.36738673867376,-313.25139564028956L-58.27557755775566,-309.6237868374239L-62.21107110711065,-308.09283430131075L-66.14656465646554,-308.09283430131075L-62.61471147114701,-301.6155051593675L-62.51380138013791,-297.5908431628119L-68.06385638563846,-301.2899690788277L-69.57750775077498,-298.8683060090683L-65.74292429242918,-296.6390557051236L-62.11016101610156,-291.0382613937762L-61.00015001500138,-284.1409848639528L-66.04565456545646,-282.53228614359557L-68.16476647664754,-285.76503426357715L-71.59570957095698,-290.7324764929599L-70.68751875187509,-284.87726749223657L-73.91664166416635,-280.50657249739857L-66.55020502050192,-280.07560303809737L-62.7156215621561,-279.64571884589844L-70.18296829682963,-272.635597447303L-77.85213521352125,-266.5622477450602L-86.02585258525842,-263.93014382188886L-89.15406540654058,-263.93014382188886L-91.97954795479541,-260.95189714094585L-95.9150415041503,-253.41456348605564L-101.96964696469638,-248.44491132109133L-103.88693869386927,-248.20605159843365L-107.620612061206,-246.54305051756097L-111.65701570157009,-244.89559724416065L-114.07885788578852,-240.8429271222796L-114.07885788578852,-236.21030109722847L-115.4915991599159,-232.02145070320609L-120.03255325532544,-227.0780975541229L-118.92254225422535,-222.36959666754933L-120.23437343734362,-217.5784569686785L-121.64711471147106,-212.02846403438068L-125.58260826082596,-211.63834534324536L-129.71992199219912,-216.27508161537992L-135.37088708870877,-216.27508161537992L-137.99454945494537,-219.50020637899266L-139.9118411841183,-225.2849331952615L-144.75552555255518,-233.00472783609575L-146.1682668266826,-237.10481337828205L-146.571907190719,-243.0314252237865L-150.40649064906484,-249.28348552193208L-149.3973897389738,-254.52460004217718L-151.31468146814672,-257.01691153970637L-148.590109010901,-265.6364445464295L-144.35188518851874,-268.56299517606624L-143.24187418741866,-271.81332443903204L-142.6364136413641,-278.0786685342655L-145.8655365536553,-275.1263182408768L-147.3791879187918,-274.01486420561537L-149.90194019401932,-272.91056558924123L-153.33288328832876,-275.4053114525217L-153.53470347034695,-280.9386330754494L-152.42469246924685,-285.4685967299457L-149.80103010301022,-285.61675088877354L-144.04915491549147,-283.4078737384848L-148.8928392839283,-288.75821036962054L-151.41559155915584,-291.8051477681577L-154.24107410741067,-290.5797907689555L-156.56200620061998,-292.7300207278473L-153.43379337933786,-301.2899690788277L-155.14926492649258,-304.73993641292884L-157.36928692869282,-311.514153603512L-160.6993199319931,-322.40383092280655L-164.3320832083208,-326.5126358218565L-164.23117311731167,-331.11396109208977L-171.79942994299424,-337.85912788785515L-177.7531253125312,-338.67105121871106L-185.22047204720462,-338.2645913935633L-192.08235823582353,-337.45465568087616L-195.31148114811475,-341.1310188535772L-200.1551655165516,-348.7387330224732L-192.7887288728872,-352.67840379071276L-187.1377637763776,-353.56683590328004L-199.14606460646056,-356.71468088980464L-205.50340034003395,-362.2553293732193L-205.09975997599756,-367.5039600531412L-194.50420042004194,-374.43671708368987L-184.21137113711364,-381.67621987553747L-183.10136013601354,-387.32442723892285L-190.66961696169608,-392.8917401369729L-188.2477747774777,-399.53843056936495L-178.560406040604,-412.1049743308223L-174.52400240023994,-414.0282498819104L-175.63401340134007,-422.636141582504L-168.97394739473938,-427.81816055243223L-160.39658965896584,-431.0087648156995L-151.81923192319226,-431.0087648156995L-148.69101910191011,-424.68912650680517L-141.32458245824574,-436.10023851046793L-134.56360636063602,-428.521777254163L-130.62811281128106,-426.76842713374634L-124.87623762376232,-420.27336762361494L-131.53630363036297,-431.0087648156995Z", id: "Greenland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-258.58210821082105,-41.160653341336385L-258.48119811981195,-42.01601136192321L-258.1784678467846,-42.670894822397756L-258.58210821082105,-43.22556867625927L-257.1693669366936,-45.601304091433086L-253.63751375137508,-45.601304091433086L-253.53660366036598,-46.61518302107534L-253.94024402440238,-46.76741997930413L-254.34388438843882,-47.427587894271014L-255.35298529852983,-48.08853573711062L-256.36208620862084,-49.05596457301592L-255.15116511651163,-49.10692946934912L-255.15116511651163,-50.74037004343163L-252.52750275027498,-50.74037004343163L-249.90384038403838,-50.68924882986594L-249.90384038403838,-48.393854994920204L-250.10566056605654,-45.09503007602514L-249.29837983798373,-45.09503007602514L-248.39018901890182,-44.53863250306118L-248.18836883688365,-44.99382781477445L-247.28017801780175,-44.639756745162934L-248.59200920092005,-43.52833004917968L-249.90384038403838,-42.7212990758034L-250.10566056605654,-42.11671794926598L-249.90384038403838,-41.56303101775112L-250.50930093009296,-40.85903609639476L-251.11476147614758,-40.658036358322924L-251.01385138513845,-40.30643664564345L-251.51840184018394,-40.00521608616468L-252.52750275027498,-39.25276533197783L-252.52750275027498,-38.85180450872307L-254.04115411541147,-39.353042949091815L-255.75662566256622,-39.40318739775619L-257.0684568456845,-39.95502609202073Z", id: "Guatemala", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-160.1947694769476,-16.751376037936424L-160.6993199319931,-14.208547049838772L-162.41479147914782,-13.475726353664788L-162.21297129712963,-12.84084201192193L-162.71752175217517,-11.376471848030993L-161.5066006600659,-9.327911861974366L-160.598409840984,-9.327911861974366L-160.1947694769476,-7.719408670177772L-158.4792979297929,-5.283703642018867L-159.1856685668566,-5.1863044332106965L-160.80023002300223,-5.429806109615318L-161.70842084208414,-4.699336279315192L-162.9193419341933,-4.212411322352487L-163.82753275327525,-4.066341588823973L-164.13026302630257,-3.530780423452073L-165.54300430042997,-3.6768384150597204L-167.2584758475847,-4.991511701206058L-167.46029602960292,-6.306519504403868L-168.16666666666657,-7.719408670177772L-167.66211621162108,-10.10811886802566L-166.95574557455737,-11.083714983868296L-167.56120612061198,-12.401424584462399L-168.570307030703,-12.792013175059987L-168.16666666666657,-14.061959784237192L-168.7721272127212,-14.697257249509834L-170.28577857785774,-14.550630140710071L-172.20307030703063,-16.702438018171495L-171.39578957895782,-17.48563492214732L-171.49669966996694,-18.808229411671707L-169.7812281228122,-19.249372234987483L-169.07485748574848,-19.78874353142415L-169.9830483048304,-20.819074616432324L-169.7812281228122,-21.850258663440858L-167.56120612061198,-23.521713897091313L-165.7448244824482,-22.489057059996508L-163.92844284428438,-20.62275663574487L-163.92844284428438,-19.151328117556726L-162.81843184318421,-19.10230872535885L-161.30478047804772,-17.730468071901587Z", id: "Guyana", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-246.06925692569249,-37.85043554229188L-245.9683468346834,-39.00213684930659L-246.2710771077107,-39.30290226222235L-246.87653765376535,-39.50348760115913L-248.08745874587456,-39.15250272069243L-248.18836883688365,-39.55364336624699L-249.09655965596556,-40.00521608616468L-249.70202020202015,-40.6077961790486L-250.50930093009296,-40.85903609639476L-249.90384038403838,-41.56303101775112L-250.10566056605654,-42.11671794926598L-249.90384038403838,-42.7212990758034L-248.59200920092005,-43.52833004917968L-247.28017801780175,-44.639756745162934L-247.07835783578355,-44.48807684186861L-246.3719871987198,-44.99382781477445L-245.6656165616561,-45.04442676606709L-245.3628862886288,-44.84205705891531L-244.9592459245924,-44.943233216748794L-243.6474147414741,-44.69032533683185L-242.33558355835578,-44.79147548832159L-241.4273927392739,-45.09503007602514L-241.12466246624658,-45.449375742293036L-240.21647164716467,-45.29748701055675L-239.51010101010098,-45.09503007602514L-238.80373037303724,-45.145637750049154L-238.19826982698265,-45.39874177033604L-236.98734873487342,-44.99382781477445L-236.48279827982793,-44.943233216748794L-235.67551755175512,-44.38697841231656L-234.8682368236823,-43.73025484648402L-233.8591359135913,-43.27601845981183L-233.0518551855185,-42.46931882838026L-234.0609560956095,-42.57009863206238L-234.4645964596459,-42.16707731392532L-235.3727872787278,-41.764315475668056L-236.0791579157915,-41.764315475668056L-236.78552855285525,-41.412109599845316L-237.29007900790074,-41.56303101775112L-237.79462946294623,-41.96566412868903L-238.09735973597353,-41.915320928715744L-238.40009000900082,-41.21093667372175L-238.70282028202814,-41.21093667372175L-238.70282028202814,-40.658036358322924L-239.71192119211918,-39.85465757048267L-240.21647164716467,-39.50348760115913L-240.519201920192,-39.15250272069243L-241.3264826482648,-39.70413337719164L-241.9319431943194,-38.95202235034414L-242.53740374037397,-38.95202235034414L-243.2437743774377,-38.90191157186808L-243.1428642864286,-37.50029941122093L-243.546504650465,-37.45029429164394L-243.9501450145014,-36.80055044353927L-244.75742574257418,-36.70064263762009L-245.26197619761967,-37.600320370625056Z", id: "Honduras", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M53.230073007300824,-140.93941838488473L51.91824182418255,-141.83368003381196L50.00095009500964,-141.7647655345702L47.579107910791194,-142.45485537111196L46.26727672767292,-142.3166690741936L45.661816181618285,-141.48931661264172L44.65271527152729,-142.45485537111196L44.047254725472655,-140.80215120008398L45.4599959996001,-138.9570726728605L46.065456545654655,-137.73520894233232L47.37728772877301,-136.2505388647929L48.38638863886401,-135.44469876899245L49.4963996399641,-133.8413021373733L52.01915191519164,-132.3810586351686L51.61551155115527,-131.72027745328685L48.99184918491864,-133.11005193528024L47.37728772877301,-134.5080521903453L44.85453545354547,-135.64589784610487L42.432693269327025,-138.54906409849187L43.03815381538166,-138.82098935542294L41.72632263226339,-140.4593444957192L41.72632263226339,-141.83368003381196L39.90994099409957,-142.45485537111196L39.10266026602675,-140.73354861007778L38.194469446944844,-142.0405492813035L38.29537953795394,-143.42453332618675L38.39628962896303,-143.49395582676138L40.313581358135934,-143.35513221530394L40.81813181318147,-144.05010821336555L41.82723272327248,-143.35513221530394L42.93724372437257,-143.28575247456453L42.93724372437257,-144.39840373097408L43.84543454345447,-144.81707354058406L44.148164816481746,-146.42927796596712L46.36818681868201,-147.55773927150724L47.276377637763915,-147.0633311043563L49.39548954895501,-145.30651319142999L51.71642164216437,-144.53787345904277L52.72552255225536,-145.16656396337L53.43189318931909,-143.56339973659837L54.34008400840099,-142.45485537111196Z", id: "Croatia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-201.06335633563353,-56.34366355247509L-200.76062606260618,-54.74361387943L-201.06335633563353,-53.61126966864587L-201.66881688168812,-53.09741939142694L-200.96244624462437,-52.22507372534039L-201.06335633563353,-51.405400878685484L-202.87973797379735,-51.91754336771378L-204.19156915691565,-51.71262538488327L-205.9070407040703,-51.91754336771378L-207.21887188718864,-51.35421450898471L-208.7325232523252,-52.27634675323448L-208.53070307030694,-53.25151917656978L-205.9070407040703,-52.84069116640172L-203.78792879287923,-52.584093252989234L-202.77882788278822,-53.25151917656978L-204.09065906590652,-54.53753953447774L-204.09065906590652,-55.67202861987171L-205.80613061306124,-56.13690624907047L-205.20067006700666,-56.96447570634788L-203.48519851985193,-56.80919634625504Z", id: "Haiti", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M47.579107910791194,-154.23418361015095L48.99184918491864,-153.1434019961889L50.00095009500964,-152.7086241020381L52.321882188218915,-153.2159498667923L52.62461246124627,-154.08842746608235L53.73462346234637,-154.16129323024836L55.04645464546464,-154.81819562237962L55.349184918492,-154.5990055635289L56.66101610161027,-155.11079671978803L57.367386738673986,-156.06451198457782L58.2755775577559,-156.35881827260255L61.302880288028895,-155.03760912258295L61.80743074307444,-155.47710900057626L63.42199219922007,-154.3800383105455L63.62381238123825,-153.2159498667923L61.90834083408353,-152.34697365858983L60.596509650965245,-149.5465101244095L58.881038103810525,-146.78130623233125L56.66101610161027,-146.00757812425763L54.844634463446454,-146.21832818976537L52.72552255225536,-145.16656396337L51.71642164216437,-144.53787345904277L49.39548954895501,-145.30651319142999L47.276377637763915,-147.0633311043563L46.36818681868201,-147.55773927150724L45.86363636363647,-148.90530316667912L45.35908590859101,-148.97645615762292L46.26727672767292,-151.6254730535378L45.76272627262738,-152.4915615533224L47.37728772877301,-152.56389161930989Z", id: "Hungary", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M338.301080108011,28.894857418113197L337.09015901590175,28.944322563632724L333.35648564856507,26.918424122003373L335.9801480148016,26.375624726089693L337.49379937993825,27.26400024855255L338.5029002900292,28.103780659580824ZM350.208470847085,25.044551410188348L350.51120112011216,25.58662946699818L350.51120112011216,26.47429313671649L348.69481948194834,28.59812333171008L346.27297729773,29.241170664108175L345.97024702470264,28.894857418113197L346.27297729773,27.9061176379638L347.4838983898392,26.178317469458964ZM330.43009300930123,22.780672625494372L331.43919391939215,23.56757630660706L333.1546654665469,23.32160941383723L333.8610361036106,24.50275628848019L330.63191319131937,25.093819447035035L328.6137113711374,25.488048490513048L327.1000600060008,25.438761576259267L328.1091609160918,23.81359810796501L329.6228122812283,23.81359810796501ZM344.4565956595662,22.780672625494372L344.0529552955298,24.355042256763518L339.8147314731475,25.143089826925927L336.0810581058108,24.79824620545523L336.0810581058108,23.764389326704542L338.301080108011,23.174055389176626L340.01655165516564,24.059675407727074L341.9338433843386,23.81359810796501ZM304.39528952895307,19.049967968711382L309.74352435243554,19.34409963375742L310.3489848984901,18.16795055304132L315.59630963096333,19.54022323578924L316.60541054105425,21.35578041307944L320.8436343634366,21.896054064275937L324.27457745774603,23.56757630660706L321.04545454545473,24.65049089540531L317.9172417241727,23.51837855422868L315.39448944894514,23.56757630660706L312.5690069006902,23.370798427993517L309.9453445344537,22.879005496274804L306.6153115311533,21.79780434457996L304.59710971097127,21.503103689078515L303.38618861886215,21.846928188477182L298.3406840684071,20.71758438632112L297.83613361336154,19.491189627520907L295.31338133813404,19.295073230727926L297.230673067307,16.601249072182878L300.56070607060724,16.74805818567345L302.8816381638166,17.825092555039543L303.99164916491674,18.069982777549953ZM377.5551055105512,17.48231545860345L376.1423642364239,19.39312783114209L375.8396339633966,17.286478546913493L376.34418441844207,16.25874802059144L376.94964496449666,15.329469243388276L377.5551055105512,16.11198450583232ZM356.5658065806583,9.714680798103338L355.5567056705673,10.641341196327485L353.63941394139437,10.153583041638361L353.0339533953397,8.934586968869178L355.8594359435946,8.788343373927471ZM365.64771477147735,8.690851696402298L366.6568156815683,10.836471658243484L364.2349734973499,9.665918415598338L361.9140414041406,9.470877741862292L360.4003900390041,9.617156923233539L358.38218821882214,9.519636590876882L359.0885588558859,8.008497533624597L362.5195019501953,7.862297997485221ZM395.1134613461348,7.326287814022289L395.21437143714394,16.454453782894227L395.21437143714394,25.685220005849924L392.6916191619164,23.370798427993517L389.8661366136615,22.780672625494372L389.1597659765978,23.61677625532684L385.62791279127936,23.665978405104557L386.8388338833886,21.40488618037829L388.6552155215524,20.619429505911132L387.84793479347957,17.531278722001534L386.53610361036124,15.182788577627594L381.08695869586984,12.788702816664197L378.7660266026604,12.54457664007995L374.52780278027825,9.958506220679315L373.7205220522054,11.324368345311937L372.7114211421145,11.568355548709178L372.0050505050507,10.543781866268338L372.0050505050507,9.324606409345781L369.8859385938596,7.911030446747442L372.9132413241326,6.936513791067077L374.93144314431464,6.985233263618093L374.62871287128723,6.254506125975437L370.59230923092326,6.205795752465731L369.48229822982324,4.549953248746317L366.9595459545957,4.0630406455894015L365.7486248624864,2.651189232526742L369.58320832083234,1.9696858531402903L370.99594959495965,1.0448428072002247L375.4359935993602,2.213075207885671L375.94054405440573,3.2353725235735937L376.74782478247846,7.764835264820526L379.5733073307333,9.470877741862292L381.99514951495166,6.498066710906107L385.1233623362338,4.793424953632565L387.64611461146137,4.793424953632565L390.0679567956797,5.767427533186208L392.08615861586185,6.790359183687252ZM351.0157515751577,-3.968963642579539L348.69481948194834,-1.1941675427514935L346.57570757075734,-0.6587472607257747L343.9520452045206,-1.1941675427514935L339.2092709270929,-1.0481427633820206L336.78742874287457,-0.6587472607257747L336.383788378838,1.482920157301928L338.90654065406557,3.9656627493918077L340.4201920192022,2.6998697269651704L345.6675167516754,1.7263010226570443L345.4656965696572,3.040640384867199L344.15386538653877,2.651189232526742L342.94294429442965,4.2578009549158855L340.5211021102112,5.377803056070783L343.14476447644785,8.934586968869178L342.64021402140236,9.909739319779213L345.1629662966299,13.1793662879068L345.1629662966299,15.036120540199068L343.64931493149345,15.818497586288714L342.53930393039315,14.84058258772047L343.9520452045206,12.54457664007995L341.1265626562659,13.618955849579812L340.4201920192022,12.837531573372347L340.82383238323854,11.763564480337228L338.8056305630566,10.104812444764136L339.0074507450747,7.3750125526554315L337.09015901590175,8.252178226182144L337.3928892889291,11.519555993249359L337.49379937993825,15.525063321894072L335.67741774177443,15.965234402319519L334.4664966496652,15.133897834765985L335.27377737773793,12.54457664007995L334.87013701370154,9.812208251583886L333.6592159215923,9.812208251583886L332.8519351935196,7.862297997485221L333.9619461946196,6.059668038095338L334.365586558656,3.8195986274083547L335.7783278327834,-0.41537718376416727L336.383788378838,-1.5835721096354398L338.8056305630566,-3.6281520859231398L340.9247424742475,-2.8005318518877935L344.4565956595662,-2.411090582473909L347.6857185718574,-2.5571292739348697L350.51120112011216,-4.60194797556242ZM360.6022102210223,-3.1413063943214032L360.5013001300131,-0.7074214397876266L359.0885588558859,-0.9507933993930073L358.58400840084033,0.7527957613095119L359.79492949294956,2.213075207885671L358.98764876487667,2.553828969990674L357.87763776377653,0.7527957613095119L357.0703570357038,-2.8005318518877935L357.57490749074924,-5.040209184713254L358.4830983098311,-6.062970275098539L358.6849184918493,-4.553254460435093L360.4003900390041,-4.309793073068007ZM307.32168216821697,-5.624616409595504L307.8262326232625,-3.7255250821002726L309.74352435243554,-2.119019060246993L311.45899589959015,-2.703170080031611L313.27537753775397,-2.508449481120896L314.8899389938996,-3.920275218853695L316.302680268027,-4.163721029982863L318.9263426342636,-3.384725352095099L321.2472747274729,-3.968963642579539L322.6600160016004,-7.865601841041458L323.7700270027005,-8.84039530964917L324.6782178217824,-12.05971969862834L327.90734073407367,-12.05971969862834L330.329182918292,-11.571664003261063L328.7146214621464,-9.035391912657559L330.83373337333757,-6.403943224473326L330.329182918292,-5.08890713156123L333.4573957395741,-2.508449481120896L330.1273627362738,-2.167697134453958L329.21917191719194,-0.2693556312840245L329.3200820082011,2.2617536709535417L326.59550955095517,4.2091103017704965L326.59550955095517,6.985233263618093L325.48549854985515,11.275574054161373L325.08185818581876,10.299900462025612L321.85273527352746,11.568355548709178L320.74272427242744,9.812208251583886L318.8254325432546,9.665918415598338L317.41269126912715,8.788343373927471L314.0826582658267,9.763444075260939L313.0735573557358,8.398395719124744L311.1562656265628,8.593363218780606L308.8353335333536,8.252178226182144L308.43169316931704,4.501260180356225L307.0189518951898,3.7222243087163074L305.70712071207134,1.2882179442012323L305.303480348035,-1.1454925125474393L305.60621062106236,-3.7255250821002726ZM296.52430243024327,16.454453782894227L293.396089608961,16.503384017620633L291.0751575157518,14.156370602649469L287.4423942394242,11.861175435457357L286.2314731473149,10.153583041638361L284.1123612361238,7.862297997485221L282.8005300530055,5.767427533186208L280.5805080508053,1.823654447724529L278.1586658665868,-0.5127250687662226L277.35138513851405,-2.897894653075956L276.34228422842295,-5.08890713156123L273.81953195319545,-6.8423796361550115L272.3058805880589,-9.230401824813438L270.1867686768678,-10.839779062655245L267.2603760376039,-13.915384204829989L267.0585558555857,-15.381680658193325L268.87493749374954,-15.234995467812269L273.21407140714086,-14.697257249509834L275.6359135913594,-11.962099807996541L277.8559355935596,-10.059349138958572L279.369586958696,-8.88914322844232L281.9932493249327,-5.868140954049999L284.9196419641966,-5.819434983948776L287.24057405740587,-3.920275218853695L288.8551355135515,-1.5348960765220694L290.97424742474266,-0.2693556312840245L289.8642364236426,2.018363344255223L291.4787978797882,2.9919580598948583L292.4878987898791,3.0893229892455563L292.9924492449246,5.036907674193586L293.90064006400655,6.595495096790317L296.0197519751977,6.839076755593891L297.331583158316,8.593363218780606L296.6252125212523,12.105222041231084Z", id: "Indonesia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M227.299979998,-88.7766850851449L225.48359835983615,-87.31614002059774L224.37358735873605,-84.30348057902378L227.0981598159818,-83.08390625919127L229.8227322732275,-81.5380584762504L233.4554955495551,-79.77985800635608L237.29007900790094,-79.34169323005761L238.90464046404657,-77.75789593957396L241.02375237523776,-77.43109277429721L244.4546954695472,-76.72403824457791L246.7756275627564,-76.778377818354L247.07835783578375,-78.03046046634702L246.67471747174736,-79.99914645558158L246.97744774477457,-81.37284635712207L248.5920092009202,-82.03417338773146L248.89473947394754,-79.56070709589736L248.89473947394754,-78.90407466228153L251.51840184018428,-77.75789593957396L253.23387338733892,-78.24866236762198L255.65571557155727,-78.03046046634702L257.87573757375765,-78.08499839564085L258.0775577557758,-80.05399011635528L256.9675467546757,-81.04266011646972L259.1875687568759,-81.42790823037868L261.81123112311246,-83.80402771052523L265.0403540354037,-85.86215156886388L267.3612861286131,-85.08189844834959L269.37948794879503,-86.42061146494613L270.6913191319133,-84.41457162709506L269.6822182218224,-83.08390625919127L272.7095209520953,-82.58625960772352L272.9113411341135,-81.42790823037868L272.0031503150316,-80.82271156865968L272.20497049704994,-78.90407466228153L270.1867686768678,-79.45118306323246L266.5540054005402,-77.2678029173165L266.65491549154933,-75.47646827659777L265.14126412641286,-72.8863748603199L264.9394439443947,-71.38368228351901L263.72852285228544,-68.82115470813864L261.5085008500852,-69.51351984309598L261.4075907590761,-66.38081601954619L260.80213021302154,-65.32433667584579L261.1048604860487,-64.06008690451401L259.6921192119214,-63.32435050503823L258.1784678467848,-68.1831176139511L257.4720972097211,-68.12999380520579L256.9675467546757,-66.2221715713642L255.4538953895391,-67.7583238182548L256.362086208621,-69.51351984309598L257.5730073007303,-69.67346900855256L258.88483848384857,-72.29532429289583L257.2702770277029,-72.83260486174503L254.64661466146634,-72.77884251024285L252.02295229522966,-73.20915583915264L251.72022202220245,-75.36818524907763L250.408390839084,-75.53062178839136L248.18836883688382,-76.88708150930648L247.1792679267929,-74.77319806064888L249.19746974697492,-73.1015314677506L247.4819981998201,-71.97332006047243L246.87653765376555,-70.84843113041033L248.5920092009202,-69.99356286586973L248.08745874587484,-68.1831176139511L249.09655965596573,-65.85223878924114L249.5002000200021,-63.376861038975974L249.09655965596573,-62.27548365295628L247.1792679267929,-62.32786660683065L243.74832483248346,-61.69968637776735L243.8492349234925,-59.40396779338598L242.43649364936502,-57.637946094608736L238.40009000900105,-55.67202861987171L235.17096709670977,-52.173805840806814L233.15276527652776,-50.33153924197131L230.32728272827305,-48.393854994920204L230.32728272827305,-47.02123918690471L228.9145414541456,-46.310831189386604L226.3917891789181,-45.29748701055675L225.07995799579976,-45.09503007602514L224.2726772677269,-42.922957268055534L224.77722772277244,-39.15250272069243L224.9790479047906,-36.7505947929066L223.7681268126815,-34.0082767091887L223.7681268126815,-29.145564742673148L222.35538553855406,-29.046615018371003L221.04355435543565,-26.872412410569495L221.85083508350854,-25.93508144749706L219.328082808281,-25.097159708969347L218.41989198919907,-23.177389699706147L217.30988098809897,-22.39075761687123L214.58530853085327,-24.99862565649532L213.374387438744,-28.99714424922471L212.26437643764393,-31.87110678112377L211.25527552755293,-33.212376597708385L209.74162416241637,-36.00167663465646L209.03525352535272,-39.6038029138285L208.6316131613163,-41.412109599845316L206.00795079507967,-45.39874177033604L204.8979397939796,-51.047202060211504L204.09065906590678,-54.846683596433884L204.09065906590678,-58.468170862981204L203.4851985198521,-61.28139965590655L199.44879487948813,-59.45601288703065L197.43059305930612,-59.82049619201364L193.79782978297848,-63.48190145132759L195.10966096609675,-64.58639543070561L194.30238023802394,-65.74660456766208L191.0732573257327,-68.34253133301475L192.88963896389657,-70.42076239505194L199.04515451545169,-70.36733686684485L198.54060406040622,-73.04773080967169L196.9260426042606,-74.61109526438247L196.6233123312333,-76.99581797452794L194.8069306930695,-78.41240177499328L197.8342334233425,-81.75846518664129L201.16426642664283,-81.48297893412365L204.09065906590678,-84.85930706327746L205.80613061306147,-88.10176308497121L208.5307030703072,-91.37725439977235L208.5307030703072,-93.71354794659958L210.85163516351656,-95.60701670914506L208.6316131613163,-97.2808621273143L207.6225122512253,-99.54690975954132L206.61341134113428,-102.47816050590629L208.02615261526165,-103.9551306552449L212.26437643764393,-103.12707926560921L215.39258925892602,-103.59995436722012L218.11716171617172,-106.51381784772998L221.1444644464448,-102.47816050590629L220.84173417341745,-99.72194910519734L221.95174517451755,-98.03427466272167L221.85083508350854,-96.29850595091604L219.83263326332653,-96.76038780311733L220.63991399139928,-93.14208572219515L223.36448644864498,-91.03682887644742Z", id: "India", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-21.24157415741565,-185.99049527461938L-20.73702370237011,-183.36888757454352L-21.24157415741565,-180.78170475036575L-19.526102610260924,-180.86463647728712L-17.406990699069837,-179.87173513517072L-17.00335033503339,-176.5161715071469L-19.12246224622448,-172.33942101655853L-24.067056705670463,-169.65425039479007L-28.002550255025366,-170.36159922071928L-25.782528252825188,-175.14115870794845L-27.19526952695255,-179.95428763133162L-23.360686068606736,-183.70520100927374Z", id: "Ireland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M171.49669966996717,-107.05235088188772L170.386688668867,-102.7729399369714L169.5794079407942,-100.30617594144081L170.79032903290346,-99.83870051032879L169.5794079407942,-97.97625162635373L170.4875987598761,-95.31936510314455L170.79032903290346,-93.25629299862275L172.90944094409454,-92.68568025193736L173.1112611261127,-90.58350319319383L170.58850885088526,-87.65260148400151L172.00125012501263,-85.91795476181409L173.1112611261127,-84.02591466121662L175.73492349234937,-82.58625960772352L175.83583358335846,-79.83466720507121L177.14766476647682,-79.28696111903807L177.4503950395041,-77.86689675658029L173.41399139914012,-76.23534889180247L172.30398039804,-72.61760126706938L167.05665566556675,-73.5322139098984L164.02935293529364,-74.28710235232528L160.80023002300248,-74.66512163580525L159.58930893089322,-78.52160338971413L158.27747774777495,-79.06811786610052L156.15836583658376,-78.52160338971413L153.33288328832896,-76.99581797452794L149.90194019401952,-78.03046046634702L147.0764576457647,-80.43813795360923L144.35188518851896,-81.37284635712207L142.43459345934608,-84.35902147481235L140.4163916391641,-88.6640992682984L138.90274027402754,-88.15795237812533L137.08635863586372,-89.22742592912236L136.0772577257727,-87.93325408199424L134.5636063606362,-89.67880623833294L134.4626962696271,-91.37725439977235L133.55450545054518,-91.37725439977235L134.05905590559072,-93.77075287462644L132.64631463146327,-96.29850595091604L129.21537153715383,-98.09230911580443L127.19716971697183,-101.30207648886903L127.90354035403556,-103.9551306552449L129.31628162816293,-105.14230188612466L129.11446144614473,-107.11225283026113L127.29807980798093,-108.19272686260747L125.48169816981711,-112.31377154866662L123.86713671367148,-115.13809461483358L124.47259725972611,-116.25160399076537L123.5644064406442,-120.37613568534216L125.48169816981711,-121.44943209792974L125.98624862486265,-120.06132637223287L127.39898989899002,-118.36806337661478L129.31628162816293,-117.9308962081159L130.325382538254,-117.99330304037177L133.55450545054518,-120.69133731522253L134.66451645164528,-120.94378223253293L135.4717971797181,-119.872628390288L134.4626962696271,-118.11816227269321L136.2790779077909,-116.25160399076537L136.98544854485465,-116.43765378278637L137.89363936393653,-113.78355289683907L140.5173017301732,-113.04764174106661L142.43459345934608,-111.27757505551267L146.47099709971013,-110.66991776770027L150.81013101310143,-111.64283224324554L151.11286128612878,-112.43594240549017L153.5347034703472,-113.10888942674002L155.55290529052922,-115.13809461483358L157.36928692869304,-115.01466457869107L158.68111811181132,-115.69425363868848L160.59840984098423,-115.38512991655253L163.72662266226638,-113.59938261359154L165.94664466446656,-113.17015129783023L169.17576757675783,-110.06363111056336L171.29487948794892,-109.9425372221408Z", id: "Iran", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M136.0772577257727,-87.93325408199424L134.361786178618,-88.10176308497121L132.54540454045417,-88.3828079074965L130.4262926292631,-85.30463964843162L125.27987798779894,-85.52753119317327L117.30798079807994,-92.05922278912612L113.17066706670677,-94.34339277691808L109.84063406340651,-95.26186771052738L108.62971297129724,-99.31368736611616L114.8861386138615,-102.83193249897725L115.8952395239525,-106.99246195213692L115.69341934193432,-109.51913532446939L117.20707070707084,-110.36660384487423L118.61981198119823,-112.55816946996929L119.83073307330748,-113.10888942674002L123.05985598559867,-112.61930411029137L124.06895689568974,-111.76469567869434L125.48169816981711,-112.31377154866662L127.29807980798093,-108.19272686260747L129.11446144614473,-107.11225283026113L129.31628162816293,-105.14230188612466L127.90354035403556,-103.9551306552449L127.19716971697183,-101.30207648886903L129.21537153715383,-98.09230911580443L132.64631463146327,-96.29850595091604L134.05905590559072,-93.77075287462644L133.55450545054518,-91.37725439977235L134.4626962696271,-91.37725439977235L134.5636063606362,-89.67880623833294Z", id: "Iraq", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-40.71722172217214,-251.8235131271127L-41.3226822682267,-247.2538426239943L-38.19446944694461,-242.68407018190112L-41.82723272327224,-237.66617110520914L-49.90004000400031,-233.33368879345545L-52.32188218821876,-232.1304379649364L-56.05555555555547,-233.1143144099913L-63.8256325632562,-235.0984279512817L-61.10106010601047,-237.89121036921352L-67.15566556655655,-241.18668796934023L-62.21107110711065,-242.45287825150055L-62.31198119811974,-244.4277074118692L-68.26567656765664,-245.95290619524798L-66.34838483848372,-250.48843669860796L-62.11016101610156,-251.45839172487396L-57.7710271027102,-246.77966267833972L-53.43189318931885,-250.48843669860796L-49.90004000400031,-248.5644629680492L-45.35908590859078,-252.3115285720338Z", id: "Iceland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M99.14416441644181,-93.02792088270341L99.2450745074509,-91.77488756052345L97.83233323332344,-86.58833553985372L96.01595159515963,-92.173029868744L96.82323232323245,-93.25629299862275L96.62141214121426,-93.42768364346294L97.32778277827798,-94.97454487007515L97.93324332433254,-97.45455643360948L98.336883688369,-98.32456129194772L98.43779377937807,-98.32456129194772L99.34598459845999,-98.32456129194772L99.54780478047817,-98.90599573172389L100.35508550855099,-98.96420261924746L100.35508550855099,-97.62835260982351L100.0523552355237,-97.10726942814134L100.0523552355237,-97.04942772911319L99.54780478047817,-96.01019168546351L98.53870387038717,-96.47162793986422L97.93324332433254,-94.28608032358875L98.63961396139625,-93.88519487213844L97.93324332433254,-93.48483515663999L97.83233323332344,-92.57168442684588Z", id: "Israel", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M43.44179417941803,-116.06568759902311L42.432693269327025,-113.29271764508461L42.83633363336347,-112.19165680297333L42.230873087308844,-110.4272392874917L40.11176117611775,-111.70375700708297L38.69901990199031,-112.13062044168399L34.7635263526354,-113.90640466648199L35.16716671667177,-115.69425363868848L38.49719971997212,-115.38512991655253L41.32268226822694,-115.7561224555002ZM25.782528252825422,-126.95102506875227L27.397089708971052,-124.31290988286031L27.094359435943698,-119.49565283647469L25.782528252825422,-119.74690767927935L24.672517251725253,-118.4931054589714L23.562506250625162,-119.49565283647469L23.461596159616068,-123.86531019934351L22.856135613561438,-125.98256764260344L24.369786978697977,-125.78933521649714ZM38.598109810981214,-147.55773927150724L38.29537953795394,-145.58667492039254L39.00175017501766,-143.8413898607527L36.7817281728174,-144.4681277522181L34.460796079608045,-143.00844682283852L34.66261626162631,-141.0767683678939L34.359885988598954,-139.91192236708315L35.26807680768086,-137.93840369778903L37.89173917391749,-135.98161576754347L39.30448044804494,-132.77841288779672L42.432693269327025,-129.74885411883068L44.5518051805182,-129.74885411883068L45.258175817581844,-128.89957886786988L44.4508950895091,-128.18328927709555L46.97364736473657,-126.8216753488414L49.09275927592773,-125.72495822395892L51.41369136913701,-123.80143334725969L51.71642164216437,-123.09987032143538L51.211871187118824,-121.76598040580309L49.698219821982285,-123.48229550337713L47.276377637763915,-124.12098236342163L46.065456545654655,-121.76598040580309L48.08365836583674,-120.37613568534216L47.78092809280938,-118.4931054589714L46.5700070007002,-118.30556523781718L45.05635563556366,-115.19983151771363L43.946344634463564,-114.95297142030842L43.946344634463564,-116.00374505334996L44.4508950895091,-117.9308962081159L45.05635563556366,-118.74337321286197L44.047254725472655,-120.81752819746404L43.13906390639075,-122.65444859094998L42.029052905290655,-123.09987032143538L41.12086208620875,-124.69721248730063L39.40539053905403,-125.40332621783364L38.194469446944844,-126.88634163294108L36.075357535753675,-127.08044345570988L33.8553355335535,-128.76918637269836L31.33258325832596,-131.25882089482948L29.415291529153052,-133.44215728134495L28.507100710071146,-137.26178137613817L27.094359435943698,-137.73520894233232L24.874337433743516,-139.02514456739883L23.562506250625162,-138.48113296560075L21.947944794479533,-136.65450738685976L20.837933793379438,-136.3851170490797L21.140664066406796,-138.07396630081846L19.627012701270257,-138.54906409849187L18.81973197319744,-141.6269992966274L19.82883288328844,-142.80069101593418L19.021552155215627,-144.3287013754282L19.122462246224718,-145.4465501232649L20.33338333833398,-144.60764087135283L21.645214521452253,-144.81707354058406L23.259775977597883,-146.14805600513608L23.764326432643347,-145.51660152855774L25.076157615761698,-145.6567703190166L25.68161816181633,-147.2750852785407L27.800730073007422,-146.78130623233125L29.011651165116604,-147.4870419506414L29.213471347134867,-149.11883118062914L30.92894289428951,-148.5498825622713L31.231673167316867,-149.33256663969692L34.057155715571675,-150.04652385365222L34.66261626162631,-148.6209208409061Z", id: "Italy", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-217.41079107910787,-52.7380364040547L-215.59440944094402,-52.481490413324714L-214.08075807580752,-51.76384723718639L-213.57620762076203,-50.9449047338751L-215.59440944094402,-50.89376357449724L-216.40169016901686,-50.38262576836156L-218.01625162516248,-50.84262741007862L-219.63081308130808,-51.91754336771378L-219.22717271727166,-52.635402445373046L-218.11716171617158,-52.84069116640172Z", id: "Jamaica", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M108.62971297129724,-99.31368736611616L109.84063406340651,-95.26186771052738L109.23517351735187,-94.74488297896008L103.68511851185134,-93.08499800242544L106.40969096909707,-89.8482396296328L105.50150015001515,-89.28381340543069L105.0978597859787,-88.21415149834914L102.87783778377853,-87.76483321355211L102.27237723772389,-86.58833553985372L101.0614561456147,-85.58327763292432L97.93324332433254,-86.08542130243876L97.83233323332344,-86.58833553985372L99.2450745074509,-91.77488756052345L99.14416441644181,-93.02792088270341L99.54780478047817,-93.99967978676317L99.54780478047817,-96.01019168546351L100.0523552355237,-97.04942772911319L103.18056805680581,-95.7797397285621Z", id: "Jordan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M377.353285328533,-101.88951435597436L377.6560156015604,-100.77440695501915L376.0414541454148,-98.73144441915792L374.93144314431464,-99.78031895025589L373.5187018701872,-99.0224210816767L372.7114211421145,-97.04942772911319L370.89503950395067,-98.03427466272167L370.99594959495965,-99.60524451988859L372.5096009600963,-101.59564503437807L374.1241624162419,-101.24339875946637L375.23417341734205,-102.65499152020728ZM395.1134613461348,-112.25270716795471L394.0034503450347,-109.45870336994123L394.5080008000802,-107.71199079971825L393.09525952595277,-105.26129624109808L389.46249624962513,-103.65911938546607L384.5179017901792,-103.48166148137086L380.58240824082424,-99.60524451988859L378.66511651165143,-100.8915833777808L378.5642064206423,-103.42253359254089L373.7205220522054,-102.65499152020728L370.39048904890507,-101.06743734557851L367.06045604560484,-101.00880743151959L369.8859385938596,-98.5569969231351L368.06955695569576,-92.91379840670062L366.2531753175319,-91.54760646524274L364.84043404340446,-92.79971822085248L365.5468046804682,-95.7797397285621L363.83133313331354,-96.76038780311733L362.6204120412043,-99.0224210816767L365.34498449845006,-100.07234410226789L366.7577257725775,-102.18368574693181L369.58320832083234,-103.9551306552449L371.60141014101436,-106.27480619618277L377.252375237524,-107.29203689883275L380.1787678767879,-106.63340114059106L383.206070607061,-112.80279260886824L385.0224522452248,-111.15593338170349L389.1597659765978,-114.64472372391931L390.7743274327434,-116.06568759902311L392.48979897989824,-120.43914457154166L391.9852485248527,-124.56904517803083L393.196169616962,-126.88634163294108L396.22347234723486,-127.59880608871207L397.7371237123715,-122.46379671161594L397.63621362136234,-119.49565283647469L395.0125512551258,-115.87990426289828ZM403.28717871787194,-138.27745971293373L405.3053805380539,-137.39694755673062L407.2226722672269,-139.09323664342264L407.82813281328146,-134.70844701475687L403.69081908190844,-133.6416451763044L401.2689768976899,-129.87977841333847L396.82893289328956,-132.51343599530549L395.3152815281529,-128.37843065529484L392.1870687068709,-128.31336604808814L391.78342834283455,-132.05043818341935L393.196169616962,-134.9759069623798L396.22347234723486,-135.17670265587498L397.03075307530776,-140.59640534116733L397.8380338033805,-143.7023518624518L401.16806680668094,-139.57044779096694Z", id: "Japan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M156.8647364736475,-127.33948671321927L155.35108510851106,-127.14517843699448L153.43379337933806,-130.07629884347872L151.51650165016514,-131.12714015531202L148.38828882888305,-130.33857685851203L147.0764576457647,-129.0952998391538L146.97554755475562,-130.01077414728766L147.68191819181934,-131.5883414275672L147.0764576457647,-132.91101268350016L143.84733473347353,-134.24112506795578L142.63641364136427,-137.6675170587483L141.0218521852187,-138.68498654567335L140.92094209420952,-139.98027846857767L143.64551455145525,-139.57044779096694L143.74642464246443,-142.45485537111196L146.1682668266828,-143.1470570254314L148.59010901090124,-142.5239801869494L149.0946594659468,-146.42927796596712L148.59010901090124,-148.97645615762292L145.76462646264642,-148.76306611890644L143.44369436943708,-149.76066221733552L140.2145714571459,-147.9823981783649L137.59090909090926,-147.13389336400417L136.1781678167818,-147.7699668173321L136.3799879988,-149.90354646135415L134.66451645164528,-152.63624579463877L132.54540454045417,-152.56389161930989L130.22447244724484,-155.4037965592781L131.83903390339046,-158.57914081876297L131.03175317531765,-159.47380136338762L133.2517751775179,-164.23411576123536L136.0772577257727,-161.72716397992357L136.48089808980907,-164.92308854747515L142.23277327732788,-169.81122779183852L146.57190719071923,-169.88976166296342L152.8283328332835,-166.77160863621944L156.15836583658376,-164.99978216656402L159.08475847584776,-166.84898972193514L163.52480248024818,-166.92639980883794L167.15756575657585,-164.69317732882007L167.96484648464866,-165.99938652130834L171.90034003400353,-165.7682805655061L172.60671067106725,-167.85759348852892L168.06575657565773,-170.9924160715487L170.68941894189436,-173.2157948137315L170.1848684868488,-174.4973290960303L172.90944094409454,-175.70620227188553L170.89123912391256,-178.88376706311385L172.10216021602173,-180.5331173687918L182.59680968096825,-182.19628757718303L184.0095509550957,-183.36888757454352L190.9723472347236,-185.14098389043392L193.49509950995113,-187.18604148109233L198.54060406040622,-186.16084064465113L199.44879487948813,-181.11363996987464L202.37518751875203,-182.27981412809197L206.00795079507967,-180.61594523265617L205.7052205220524,-178.06418424638397L208.4297929792981,-178.3097059782602L215.49349934993518,-182.86549118565497L214.38348834883507,-181.36295670189838L218.01625162516274,-177.65565045453909L224.2726772677269,-166.0764791743682L225.78632863286353,-168.4027403015922L229.62091209120933,-165.84528724527368L233.6573157315733,-167.00383892579103L235.17096709670977,-166.1536005420464L236.58370837083723,-163.62360299332715L238.5010001000102,-162.7870525317744L239.71192119211932,-160.89813123807582L243.34468446844696,-161.50073981680416L244.7574257425744,-158.87694176788702L242.63831383138339,-156.06451198457782L240.31738173817402,-155.62380902755012L240.21647164716484,-151.40948831120278L238.60191019101921,-149.5465101244095L233.05185518551878,-150.90635410178115L231.03365336533676,-143.6328650752903L229.62091209120933,-142.73148153522553L224.0708570857087,-141.1454744557386L226.59360936093623,-134.37455068892257L224.67631763176345,-133.37569880865786L224.8781378137816,-131.25882089482948L223.16266626662681,-131.78627291931437L221.74992499249936,-133.17643563426716L217.61261126112637,-133.57513044848278L212.97074707470765,-133.6416451763044L211.96164616461667,-133.2428380017517L207.92524252425255,-134.84213881063582L206.31068106810702,-134.0411286167226L205.90704070407057,-131.78627291931437L201.26517651765192,-133.11005193528024L199.44879487948813,-132.57965242224435L198.8433343334335,-130.92975522249563L197.22877287728787,-130.20740197328706L193.49509950995113,-127.59880608871207L192.28417841784196,-124.95374701013112L191.27507750775095,-124.88958835499864L190.46779677967814,-126.6923941756665L186.9359435943596,-126.8216753488414L186.33048304830496,-129.87977841333847L185.01865186518668,-129.87977841333847L185.22047204720488,-133.70817868923737L181.89043904390454,-136.51977317647652L177.04675467546772,-136.18327895768655L173.71672167216738,-135.64589784610487L171.09305930593072,-139.16134891916172L168.77212721272147,-140.66496666334436L164.4329932993301,-143.49395582676138L163.92844284428455,-143.8413898607527L156.66291629162933,-141.48931661264172Z", id: "Kazakhstan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M116.50070007000713,4.744729749327345L114.58340834083423,5.864838865763959L113.8770377037705,7.033953378702043L112.7670267026704,7.228840354230361L112.36338633863404,9.227096488008746L111.45519551955206,10.34867482713297L110.9506450645066,12.202848465945504L109.84063406340651,13.130529144989318L105.80423042304243,10.34867482713297L105.60241024102424,8.690851696402298L95.41049104910509,2.9919580598948583L95.00685068506864,2.6998697269651704L94.90594059405954,-0.2693556312840245L95.71322132213236,-1.4375444288744597L97.12596259625973,-3.287356867194463L98.13506350635082,-5.332403972815976L96.92414241424154,-8.547924728933557L96.62141214121426,-9.961812455980416L95.20867086708681,-11.913291519463248L97.02505250525063,-13.573419274825469L98.84143414341445,-15.4305785590575L100.35508550855099,-14.941662980433607L100.35508550855099,-13.378038407766L101.2632763276329,-12.45024410719572L103.2814781478149,-12.45024410719572L106.81333133313343,-10.059349138958572L107.72152215221534,-10.059349138958572L108.32698269826997,-10.10811886802566L108.93244324432459,-9.815514301679384L110.8497349734975,-9.571702064035755L111.65701570157032,-10.742211717870424L114.17976797679786,-11.913291519463248L115.39068906890704,-10.986137582608915L117.30798079807994,-10.986137582608915L114.78522852285242,-7.768139010871559L114.8861386138615,2.4077903249217867Z", id: "Kenya", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M224.8781378137816,-131.25882089482948L224.4744974497451,-130.4041912490347L220.1353635363537,-128.31336604808814L219.12626262626281,-126.88634163294108L215.49349934993518,-126.43403698948921L214.4843984398441,-124.05703958029399L211.4570957095711,-124.56904517803083L209.53980398039818,-123.80143334725969L206.81523152315248,-122.08292859324001L207.21887188718893,-121.2596943341443L206.4115911591161,-120.43914457154166L201.16426642664283,-119.872628390288L197.7333233323334,-121.00693296664573L194.60511051105124,-120.75442486908682L194.90784078407856,-122.84524618975499L197.9351435143516,-122.27329017194565L198.9442444244426,-123.35475509328688L201.16426642664283,-123.036189888951L204.6961196119614,-125.66059811486095L201.36608660866102,-127.59880608871207L199.34788478847904,-126.6923941756665L197.32968296829696,-128.11827708258738L199.6506150615063,-130.5354740053015L198.8433343334335,-130.92975522249563L199.44879487948813,-132.57965242224435L201.26517651765192,-133.11005193528024L205.90704070407057,-131.78627291931437L206.31068106810702,-134.0411286167226L207.92524252425255,-134.84213881063582L211.96164616461667,-133.2428380017517L212.97074707470765,-133.6416451763044L217.61261126112637,-133.57513044848278L221.74992499249936,-133.17643563426716L223.16266626662681,-131.78627291931437Z", id: "Kyrgyzstan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M287.4423942394242,-34.40653447058198L286.8369336933695,-37.85043554229188L288.6533153315333,-40.25622359846638L292.1851685168519,-40.80878029828456L294.80883088308843,-40.406874326349126L297.1297629762978,-39.25276533197783L298.44159415941607,-41.26122396052179L300.96434643464363,-40.20601440646477L301.56980698069816,-38.25080767276648L301.267076707671,-34.80500077672772L296.52430243024327,-32.615979970115724L297.7352235223524,-30.87899157644864L294.80883088308843,-30.68070933880795L292.3869886988701,-29.54147349788897L290.0660566056607,-29.937559890401605L288.8551355135515,-31.424508521639755Z", id: "Cambodia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M353.63941394139437,-114.39838653146775L353.74032403240346,-114.70634422550675L355.0521552155217,-114.58311771618962L356.0612561256128,-116.18961705497156L358.07945794579473,-116.37562234187783L359.2903790379041,-116.56176125937205L359.69401940194035,-117.43218663485305L362.1158615861588,-113.23142736654036L362.8222322232225,-110.97357434655629L362.8222322232225,-106.99246195213692L361.8131313131316,-105.08282371355618L359.18946894689486,-104.42939669497132L356.9694469446947,-103.0089837255467L354.44669466946715,-102.71395961421265L354.1439643964398,-104.60745302010552L354.6485148514853,-107.1721678084239L353.43759375937606,-110.79133919811852L355.5567056705673,-111.3384166230984Z", id: "Republic of Korea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M57.670117011701265,-129.35650861388103L57.468296829683084,-130.7325333164501L56.76192619261936,-131.12714015531202L56.15646564656481,-132.11652543080137L56.76192619261936,-132.9773404764598L57.367386738673986,-133.2428380017517L57.771027102710356,-134.57483143855146L58.2755775577559,-134.77528337673195L58.67921792179227,-134.24112506795578L59.183768376837804,-133.97450092693774L59.58740874087425,-133.37569880865786L59.99104910491062,-133.17643563426716L60.596509650965245,-132.4472380717524L61.000150015001616,-132.51343599530549L60.69741974197434,-131.5883414275672L60.2937793779379,-131.12714015531202L60.39468946894699,-130.86399649441603L59.78922892289244,-130.66682883458947L58.17466746674681,-130.07629884347872L57.97284728472862,-129.35650861388103Z", id: "Kosovo", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M135.67361736173635,-83.52687539670255L133.65541554155428,-83.47147236933912L132.94904490449065,-84.97058406198143L130.4262926292631,-85.30463964843162L132.54540454045417,-88.3828079074965L134.361786178618,-88.10176308497121L134.96724672467263,-86.70019951941329L134.76542654265444,-85.97376744282154Z", id: "Kuwait", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M280.5805080508053,-58.468170862981204L281.1859685968599,-59.56012100596364L283.5069006900692,-61.49049327570507L283.80963096309654,-60.81130066447601L285.323282328233,-60.70690188104627L284.81873187318746,-64.16529616604903L286.3323832383239,-64.63906244519353L287.94694469446955,-62.223107011334996L289.15786578657884,-59.50806395583816L292.68971897189743,-59.45601288703065L293.69881988198836,-56.860950459529015L291.9833483348337,-56.08523090748853L291.17606760676085,-55.00132898489111L294.50610061006125,-53.25151917656978L296.82703270327045,-49.7699117695587L298.64341434143427,-47.17358551899767L300.76252625262543,-45.145637750049154L301.4688968896892,-43.07424429840073L300.96434643464363,-40.20601440646477L298.44159415941607,-41.26122396052179L297.1297629762978,-39.25276533197783L294.80883088308843,-40.406874326349126L295.71702170217037,-41.713988356054955L295.9188418841885,-44.18483297413489L293.5979097909794,-46.71666979032021L293.49699969997016,-49.61684324157387L291.27697769777,-51.9687856215027L289.15786578657884,-52.173805840806814L288.6533153315333,-51.14951943451949L287.03875387538767,-51.098358238527965L286.13056305630573,-51.61019693278084L283.20417041704184,-49.82094434624015L283.10326032603285,-52.481490413324714L283.80963096309654,-55.62040330043108L281.89233923392356,-55.72365947357679L281.7914291429144,-57.534272218429535Z", id: "Laos", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M98.43779377937807,-98.32456129194772L99.44689468946909,-101.06743734557851L100.75872587258743,-103.48166148137086L100.85963596359652,-103.59995436722012L102.0705570557057,-103.42253359254089L102.57510751075125,-102.06598085923251L101.0614561456147,-100.83298921763826L100.35508550855099,-98.96420261924746L99.54780478047817,-98.90599573172389L99.34598459845999,-98.32456129194772Z", id: "Lebanon", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-32.13986398639853,-19.053291104663526L-31.43349334933481,-19.935883099097513L-31.33258325832572,-20.76999223173086L-30.020752075207447,-22.29246650882726L-28.70892089208909,-23.620111896017566L-28.103460346034538,-23.66931419518898L-27.397089708970817,-24.01379232436989L-26.18616861686155,-22.29246650882726L-26.387988798879817,-21.11360970438644L-25.883438343834275,-20.524609156927884L-25.07615761576146,-20.524609156927884L-24.47069706970683,-21.653774883935053L-23.663416341634093,-21.604658984508763L-23.86523652365228,-20.76999223173086L-23.56250625062492,-19.39645181322222L-24.167966796679554,-18.12228674273681L-23.360686068606736,-17.387713028237833L-22.452495249524834,-17.19188852237275L-21.24157415741565,-16.017465932054602L-21.140664066406554,-14.892779091311752L-21.443394339433834,-14.550630140710071L-21.64521452145202,-12.206157886508027L-22.35158515851574,-12.206157886508027L-25.277977797779645,-13.524572190061967L-27.80073007300718,-15.67508954980309L-30.222572257225625,-17.240842250101682Z", id: "Liberia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M33.55260526052614,-67.70525612138582L32.341684168416954,-69.62014539436495L30.121662166216776,-71.0089285977805L28.809830983098422,-70.47419525458353L27.800730073007422,-72.18795931951173L27.69981998199833,-73.5322139098984L26.085258525852698,-75.80150962149472L27.195269526952792,-77.10458727376931L26.892539253925513,-79.06811786610052L27.29617961796188,-80.76774631133407L27.094359435943698,-82.25490041819543L27.598909890989237,-84.85930706327746L27.397089708971052,-86.30884324643475L26.488898889889146,-89.17104844442424L27.901640164016513,-89.96124564886955L28.103460346034698,-91.32049104543763L27.800730073007422,-92.68568025193736L29.71802180218033,-93.94243196017044L30.626212621262233,-94.97454487007515L32.03895389538968,-95.95256210360938L32.13986398639877,-98.49887078188671L35.46989698969913,-97.33874892676779L36.579907990799214,-97.62835260982351L39.00175017501766,-97.10726942814134L42.63451345134529,-95.60701670914506L43.946344634463564,-92.68568025193736L46.4690969096911,-92.05922278912612L50.505500550055096,-90.6401331004394L53.43189318931909,-89.05832341499445L54.844634463446454,-89.90473759088566L56.15646564656481,-91.37725439977235L55.551005100510174,-93.88519487213844L56.35828582858299,-95.49192310025636L58.37648764876499,-97.04942772911319L60.2937793779379,-97.5124771604719L64.12836283628378,-96.81817334468103L65.0365536553657,-95.3768734593258L66.14656465646578,-95.31936510314455L67.0547554755477,-94.80228212429614L69.77932793279342,-94.40071603399998L70.48569856985715,-93.31341257367065L69.47659765976614,-91.71805172313232L69.8802380238025,-90.35708550347242L69.17386738673878,-88.3265792544225L69.9811481148116,-85.7505736137403L69.9811481148116,-74.50306616720174L69.9811481148116,-63.21934874961347L69.9811481148116,-57.223388388486775L66.75202520252041,-57.223388388486775L66.75202520252041,-55.930238349705526L55.551005100510174,-61.69968637776735L44.4508950895091,-67.49305510406698L41.52450245024512,-65.79941830617089L39.607210721072214,-64.69173606049952L37.992649264926584,-66.38081601954619Z", id: "Libya", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M229.21727172717294,-21.11360970438644L228.71272127212742,-18.1712715838236L227.60271027102732,-17.387713028237833L225.1808680868088,-16.751376037936424L223.7681268126815,-18.955261159257496L223.36448644864498,-23.029854665234886L224.57540754075424,-27.662446636071305L226.49269926992724,-26.08302205066274L227.80453045304552,-24.063012404482368Z", id: "Sri Lanka", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M81.18216821682184,84.85553564842856L82.19126912691284,85.8583686772858L81.28307830783093,87.42445384617719L80.7785278527854,88.491481077721L79.26487648764893,88.99815607247119L78.7603260326034,90.01393178590911L77.7512251225124,90.35324935207267L75.63211321132123,87.817157990114L77.14576457645776,85.80257560642693L78.6594159415943,84.52193210430146L79.97124712471258,83.91119206155878Z", id: "Lesotho", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M59.58740874087425,-186.24606897606847L58.981948194819616,-190.38147292096966L62.211071107110804,-191.95525469283194L66.85293529352951,-191.6044161288335L69.67841784178432,-192.13091344080038L69.9811481148116,-191.07935030811402L71.49479947994814,-190.73009701047556L74.21937193719386,-188.30278759523182L74.42119211921204,-186.16084064465113L72.20117011701187,-184.5485079765775L71.49479947994814,-181.8625338715236L68.46749674967506,-180.0368744217502L65.74292429242934,-180.0368744217502L65.13746374637479,-181.5293423700393L63.62381238123825,-182.02934029961062L63.42199219922007,-183.28489885537294L63.72472247224734,-184.63303800378438L62.513801380138155,-185.39545085331542Z", id: "Lithuania", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M17.306080608060903,-159.9225529381452L16.498799879988088,-159.84769484712209L15.893339333933536,-160.22225080475494L16.196069606960812,-162.6353113117805L16.902440244024532,-162.7870525317744L17.406990699069993,-161.80269296584743Z", id: "Luxembourg", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M68.0638563856387,-199.47500762322107L70.48569856985715,-200.39029332011765L71.69661966196632,-199.74912980325107L74.11846184618477,-197.83852889432367L76.43939393939404,-197.83852889432367L77.7512251225124,-196.5753651264552L78.05395539553967,-194.07380652185316L78.96214621462158,-191.07935030811402L75.93484348434858,-189.16620372784845L74.21937193719386,-188.30278759523182L71.49479947994814,-190.73009701047556L69.9811481148116,-191.07935030811402L69.67841784178432,-192.13091344080038L66.85293529352951,-191.6044161288335L62.211071107110804,-191.95525469283194L58.981948194819616,-190.38147292096966L59.08285828582871,-194.2514104848156L60.39468946894699,-197.4767703025852L63.11926192619271,-199.29247921382688L65.33928392839297,-195.40986191035554L67.55930593059315,-195.49926432320527Z", id: "Latvia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-6.105060506050502,-105.38034134832402L-5.095959595959502,-103.18614548395857L-4.894139413941319,-101.12607919808623L-3.9859485948594107,-97.57040921595765L-3.1786678667865957,-96.87597009839502L-3.6832183218320553,-95.60701670914506L-7.416891689168777,-95.03198758661827L-8.62781278127804,-93.82796851338277L-10.24237423742367,-93.54199733430447L-10.444194419441855,-91.09354072639665L-13.673317331733035,-89.79175175631488L-14.783328332833205,-88.15795237812533L-17.00335033503339,-87.31614002059774L-19.8288328832882,-86.81210192135298L-24.369786978697736,-84.47013104406294L-24.369786978697736,-80.71278979019303L-24.773427342734188,-80.71278979019303L-24.672517251725093,-79.0134283122789L-26.387988798879817,-78.90407466228153L-27.296179617961723,-78.19409933870047L-28.608010801079995,-78.19409933870047L-29.617111711170995,-78.57621682283326L-31.93804380438035,-78.24866236762198L-32.84623462346226,-75.80150962149472L-33.75442544254417,-75.58478330866089L-35.06625662566244,-71.65158704539085L-39.00175017501743,-68.34253133301475L-39.90994099409933,-64.16529616604903L-41.01995199519942,-62.79959828952928L-41.42359235923579,-61.69968637776735L-47.68001800180004,-61.43821055999662L-47.78092809280914,-61.49049327570507L-47.57910791079095,-62.852044714938884L-46.57000700069996,-63.692059833501034L-45.66181618161806,-65.27158334306019L-45.76272627262714,-66.27504624800106L-44.85453545354524,-68.44884245730454L-43.2399739973996,-70.42076239505194L-42.33178317831769,-70.90192289010147L-41.62541254125406,-72.72508779870068L-41.52450245024496,-74.341081526732L-40.51540154015389,-76.28961519249633L-38.69901990199007,-77.43109277429721L-36.88263826382625,-80.65784199741272L-36.78172817281717,-80.65784199741272L-35.3689868986898,-81.86872177776407L-32.84623462346226,-82.25490041819543L-30.626212621261995,-84.41457162709506L-29.213471347134625,-85.30463964843162L-26.892539253925275,-87.98941394549257L-27.598909890988995,-92.00233490773736L-26.488898889888908,-94.85969214832573L-26.08525852585246,-96.58709835480703L-24.268876887688645,-98.84780040915903L-21.544304430442924,-100.36466339073768L-19.425192519251834,-101.77193045155603L-17.507900790078928,-105.32081244523957L-16.700620062006113,-107.41195824264169L-14.581508150814942,-107.41195824264169L-12.96694669466939,-105.91667472868744L-10.24237423742367,-106.1553776605963L-7.315981598159684,-105.43988296124289Z", id: "Morocco", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M79.06305630563068,-143.42453332618675L78.55850585058522,-145.30651319142999L78.86123612361249,-146.9927912820941L78.7603260326034,-148.76306611890644L77.14576457645776,-151.2656172668565L76.23757375737586,-152.99837910788L75.43029302930304,-154.23418361015095L74.52210221022114,-154.67204412893716L75.22847284728486,-155.2572467019392L77.04485448544868,-155.69719666096088L79.16396639663976,-154.3800383105455L80.27397739773994,-154.23418361015095L81.58580858085821,-153.07087841752497L81.38398839884003,-151.6975155704813L82.39308930893102,-150.97815945831675L82.79672967296739,-149.26129840142363L83.80583058305848,-148.26595802067237L83.6040104010402,-147.62845917561796L84.10856085608576,-147.20447808180265L83.40219021902202,-146.92227387647668L81.6867186718673,-147.0633311043563L81.38398839884003,-147.62845917561796L80.87943794379449,-147.2750852785407L81.08125812581275,-146.57002237379422L80.27397739773994,-145.2365276245087L79.7694269426944,-143.91094111123223Z", id: "Moldova", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M138.80183018301844,35.25014812605353L139.50820082008215,36.49748338081867L140.2145714571459,38.39761260469765L140.71912191219135,41.8615691065139L141.42549254925507,43.222148532190225L141.1227622762278,44.585764568052255L140.61821182118226,45.44594282110088L139.71002100210035,43.77732330760329L139.2054705470549,44.63632855180057L139.71002100210035,46.763979174585074L139.40729072907308,48.0342170082567L138.70092009200934,48.6958913929712L138.49909990999117,51.19721662860667L137.38908890889098,54.63707313166932L135.9763476347636,58.7243995120563L134.26087608760892,64.42486489084055L133.2517751775179,68.65794357491997L131.93994399439956,72.23799857979755L129.61901190119028,72.99029115428891L127.19716971697183,74.28344306262406L125.58260826082619,73.52856201408358L123.36258625862602,72.39907858743645L122.6562156215623,70.79132099673167L122.45439543954411,68.0732761825039L121.44529452945312,65.63741789303545L121.14256425642576,63.42581737249743L121.6471147114713,61.27785658173327L122.95894589458958,60.75555931051721L122.95894589458958,59.764878065530944L124.27077707770792,57.47893036223273L124.5735073507352,55.56528409250908L123.96804680468057,54.173627824990916L123.36258625862602,52.32414831070928L123.16076607660784,49.61338460087158L124.16986698669884,47.93249146584069L124.5735073507352,46.10458309631862L125.88533853385356,46.00320492840784L127.49989998999911,45.39530914738132L128.5090009000902,44.838627692376235L129.71992199219937,44.838627692376235L131.334483448345,43.17170319654211L133.65541554155428,41.35840047741106L134.4626962696271,39.90143763717142L134.15996599659982,38.69810938727168L135.2699769976999,39.04885713954657L136.88453845384555,37.046993208685976L136.88453845384555,35.30000089130712L137.79272927292746,34.004902556247714Z", id: "Madagascar", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-247.58290829082907,-52.7380364040547L-248.08745874587456,-52.68671682713986L-249.09655965596556,-50.9449047338751L-249.60111011101105,-51.303033185412275L-249.90384038403838,-51.14951943451949L-249.90384038403838,-50.68924882986594L-252.52750275027498,-50.74037004343163L-255.15116511651163,-50.74037004343163L-255.15116511651163,-49.10692946934912L-256.36208620862084,-49.05596457301592L-255.35298529852983,-48.08853573711062L-254.34388438843882,-47.427587894271014L-253.94024402440238,-46.76741997930413L-253.53660366036598,-46.61518302107534L-253.63751375137508,-45.601304091433086L-257.1693669366936,-45.601304091433086L-258.58210821082105,-43.22556867625927L-258.1784678467846,-42.670894822397756L-258.48119811981195,-42.01601136192321L-258.58210821082105,-41.160653341336385L-261.71032103210314,-44.28589713738961L-263.12306230623057,-45.24686621190879L-265.44399439943993,-46.006641154484534L-267.0585558555855,-45.80393710367739L-269.2785778577857,-44.69032533683185L-270.69131913191313,-44.38697841231656L-272.6086108610861,-45.19624979354202L-274.72772277227716,-45.70261173946176L-277.3513851385138,-47.07201671933387L-279.47049704970493,-47.47840219208695L-282.6996199619961,-48.852152855350006L-285.0205520552054,-50.22938098165493L-285.7269226922692,-51.047202060211504L-287.2405740574057,-51.200685653871616L-290.16696669666965,-52.12254309389299L-291.2769776977697,-53.508457404008865L-294.3042804280428,-55.156023490207154L-295.7170217021702,-57.068023686871705L-296.4233923392339,-58.520109452569564L-295.4142914291429,-58.779890496272486L-295.7170217021702,-59.66425307480475L-295.11156115611556,-60.44601197969897L-295.11156115611556,-61.49049327570507L-296.0197519751975,-62.79959828952928L-296.3224822482248,-64.00749207139312L-297.2306730673067,-65.53541692783999L-299.6525152515251,-68.6083622464049L-302.4779977997799,-71.0089285977805L-303.89073907390735,-72.8863748603199L-306.31258125812576,-74.17916751869606L-306.81713171317125,-74.93537201204806L-306.41349134913486,-76.88708150930648L-307.8262326232623,-77.59445704736514L-309.4407940794079,-79.1228159160179L-310.14716471647165,-81.31779330646538L-311.6608160816081,-81.59314686465837L-313.27537753775374,-83.24995144120466L-314.587208720872,-84.80368256368004L-314.68811881188117,-85.80635785562067L-316.2017701770177,-88.27036045424518L-317.21087108710867,-90.75342355886015L-317.21087108710867,-92.00233490773736L-319.2290729072907,-93.31341257367065L-320.1372637263726,-93.14208572219515L-321.7518251825182,-94.05693836120778L-322.15546554655464,-92.74269396385026L-321.7518251825182,-91.15026285932436L-321.44909490949095,-88.72038722003064L-320.540904090409,-87.3721926345374L-318.4217921792179,-85.13756968254938L-317.9172417241724,-84.41457162709506L-317.51360136013597,-84.19242652419446L-317.1099609960996,-83.08390625919127L-316.7063206320632,-83.13924557276033L-316.1008600860086,-81.09766917226175L-315.29357935793576,-80.27345118597003L-314.68811881188117,-79.17752246969783L-312.87173717371735,-77.5399940086958L-311.96354635463547,-74.66512163580525L-311.15626562656263,-73.31681099849722L-310.34898489848985,-71.86604566196817L-310.14716471647165,-70.20710420100825L-308.8353335333533,-70.10031895368218L-307.7253225322532,-68.71474425328772L-306.71622162216215,-67.333977412049L-306.81713171317125,-66.80416832016742L-307.92714271427144,-65.69379756714181L-308.43169316931693,-65.69379756714181L-309.1380638063806,-67.54609490628766L-311.05535553555353,-69.3003552571586L-313.07355735573555,-70.7949467575416L-314.4862986298629,-71.54440271488599L-314.3853885388538,-73.85555061898633L-314.78902890289027,-75.53062178839136L-316.1008600860086,-76.50676158698913L-318.0181518151815,-77.86689675658029L-318.4217921792179,-77.48553925351337L-319.1281628162816,-78.30323377825013L-320.8436343634363,-79.06811786610052L-322.55910591059103,-80.87768556999879L-322.35728572857283,-81.15268701129331L-321.1463646364636,-80.93266832318606L-320.1372637263726,-82.14451903589762L-320.0363536353635,-83.58228755838766L-322.15546554655464,-85.86215156886388L-323.8709370937093,-86.75614591336587L-324.8800380038003,-88.7766850851449L-325.8891389138913,-90.92343598974769L-327.2009700970097,-93.54199733430447L-328.3109810981098,-96.47162793986422L-325.18276827682763,-96.76038780311733L-321.5500050005,-97.10726942814134L-321.85273527352734,-96.47162793986422L-317.61451145114506,-94.85969214832573L-311.2571757175717,-92.51470229541798L-305.6062106210621,-92.57168442684588L-303.38618861886187,-92.57168442684588L-303.38618861886187,-93.94243196017044L-298.542504250425,-93.88519487213844L-297.53340334033396,-92.74269396385026L-296.1206620662066,-91.71805172313232L-294.40519051905187,-90.30050652153L-293.49699969996993,-88.5515530703473L-292.7906290629063,-86.81210192135298L-291.3778877887788,-85.80635785562067L-289.0569556955695,-84.85930706327746L-287.2405740574057,-87.42825495576857L-285.0205520552054,-87.48432699280625L-283.00235023502347,-86.19711321463721L-281.58960896089604,-83.97042913270778L-280.68141814181416,-82.14451903589762L-278.96594659465944,-80.32833809884447L-278.3604860486048,-78.08499839564085L-277.553205320532,-76.61538360316699L-275.4340934093409,-75.69313040401761L-273.41589158915883,-74.98944584208623L-272.30588058805876,-75.0976173152805L-273.41589158915883,-72.3490181402741L-273.9204420442044,-70.15370792895783L-274.1222622262226,-66.01074077160564L-274.32408240824077,-64.53373501054419L-273.9204420442044,-62.904497522478934L-273.0122512251225,-61.43821055999662L-272.40679067906785,-59.091822365656306L-270.59040904090404,-56.860950459529015L-269.98494849484945,-55.156023490207154L-268.8749374937493,-53.71410313081833L-265.84763476347626,-52.94336677858768L-264.7376237623762,-51.71262538488327L-262.2148714871487,-52.532789244226315L-260.0957595759576,-52.84069116640172L-257.97664766476646,-53.35427865072013L-256.26117611761174,-53.86839317128964L-254.44479447944792,-55.052888354711L-253.83933393339328,-56.80919634625504L-253.53660366036598,-59.299895506980725L-253.03205320532047,-60.18527439513137L-251.21567156715668,-60.967944877128744L-248.18836883688365,-61.69968637776735L-245.76652665266522,-61.59507736631777L-244.0510551055105,-61.85664673164194L-243.3446844684468,-61.176890026313835L-243.44559455945588,-59.76840914285924L-244.9592459245924,-57.94910619826127L-245.6656165616561,-56.13690624907047L-245.1610661066106,-55.62040330043108L-245.564706470647,-54.331551661846795L-246.2710771077107,-52.02003298997507L-246.97744774477442,-52.78936118188517Z", id: "Mexico", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M60.39468946894699,-130.86399649441603L61.40379037903807,-131.0613270369069L62.71562156215634,-131.12714015531202L64.12836283628378,-129.87977841333847L64.33018301830197,-127.40429063315905L63.72472247224734,-127.27470005063452L63.32108210821097,-126.62777925657417L61.80743074307444,-126.6923941756665L60.69741974197434,-125.91813991101967L58.881038103810525,-125.5962548744404L57.670117011701265,-126.49860067844905L57.266476647664895,-128.11827708258738L57.670117011701265,-129.35650861388103L57.97284728472862,-129.35650861388103L58.17466746674681,-130.07629884347872L59.78922892289244,-130.66682883458947Z", id: "Macedonia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-13.875137513751298,-72.29532429289583L-4.389588958895779,-65.58820375379423L5.095959595959741,-59.03981892607825L5.7014201420142925,-57.637946094608736L7.517801780178107,-56.75744789840878L8.72872287228737,-56.29196582414159L8.829632963296461,-54.38304054374831L11.95784578457855,-54.692087165872984L11.95784578457855,-47.88508337330623L10.34328432843292,-45.955958462896604L10.141464146414737,-44.134307295971276L7.618711871187199,-43.679767331995926L3.7841284128413863,-43.427392857798495L2.775027502750387,-42.41893505829885L0.9586458645865727,-42.31817975520221L-0.7568256825681499,-42.267808211611964L-1.4631963196318731,-42.82211992559482L-3.0777577757775036,-42.41893505829885L-5.701420142014054,-41.21093667372175L-6.205970597059593,-40.30643664564345L-8.325082508250683,-39.05225507391249L-8.72872287228713,-38.300870553388876L-9.939643964396314,-37.70035565773935L-11.25147514751467,-38.100640901247175L-12.058755875587485,-37.40029273867859L-12.462396239623851,-35.40309686747903L-14.682418241824113,-33.01352792218591L-14.581508150814942,-32.06967282485451L-15.388788878887757,-30.87899157644864L-15.186968696869572,-29.19504370752278L-16.39788978897876,-28.799288346305232L-17.00335033503339,-28.403705967459736L-17.406990699069837,-29.640478345332546L-18.21427142714257,-29.294009866863473L-18.71882188218811,-29.3929870314002L-19.223372337233652,-28.552029245373696L-21.443394339433834,-28.552029245373696L-22.149764976497554,-28.99714424922471L-22.55340534053392,-28.74983113978328L-23.46159615961583,-29.54147349788897L-23.25977597759765,-30.383372515122893L-23.663416341634093,-30.73027555446583L-24.167966796679554,-30.43292147799534L-24.067056705670463,-31.37490136427477L-23.56250625062492,-32.119321886348594L-24.672517251725093,-33.31181974918285L-24.97524752475237,-34.10782173843054L-25.681618161816093,-34.7551809961009L-26.18616861686155,-34.80500077672772L-26.892539253925275,-34.40653447058198L-27.80073007300718,-34.0082767091887L-28.507100710070905,-33.4112754960893L-29.71802180218009,-33.659970229274954L-30.525302530252905,-34.35674089812391L-31.02985298529844,-34.45633130154358L-31.736223622362164,-34.05804761204233L-32.13986398639853,-34.05804761204233L-32.34168416841672,-35.103988905875674L-32.24077407740763,-36.00167663465646L-32.44259425942581,-37.15033829452927L-33.45169516951681,-37.950506827576945L-34.05715571557144,-39.6038029138285L-34.15806580658053,-41.412109599845316L-33.24987498749863,-41.915320928715744L-32.74532453245317,-43.62928403117567L-31.83713371337126,-43.679767331995926L-29.919841984198353,-42.87253653258831L-28.305280528052723,-43.4778593573295L-27.19526952695255,-43.27601845981183L-26.79162916291618,-43.932247147995945L-15.59060906090602,-43.98275581100252L-14.98514851485139,-46.006641154484534L-15.388788878887757,-46.361545226953375L-16.801530153015204,-59.14383173740127L-18.11336133613348,-72.24163802166449Z", id: "Mali", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M276.14046404640476,-27.958879477791857L275.9386438643866,-30.086138592830302L276.74592459245946,-32.268287271059506L275.8377337733776,-33.95850902488024L276.0395539553958,-37.1003580341599L274.9295429542957,-38.55123986333896L274.02135213521376,-42.01601136192321L273.5168016801682,-45.70261173946176L272.3058805880589,-48.13941053099144L270.3885888588861,-46.665924139401454L267.2603760376039,-44.58919246903303L265.64581458145824,-44.84205705891531L263.9303430343036,-45.500014116182264L264.9394439443947,-49.15789916361409L264.33398339833997,-51.91754336771378L262.1139613961398,-55.31076727157739L262.41669166916716,-56.39536689240499L260.80213021302154,-56.75744789840878L258.88483848384857,-59.19584704744593L258.6830183018304,-61.647378753793014L259.59120912091225,-61.176890026313835L259.6921192119214,-63.32435050503823L261.1048604860487,-64.06008690451401L260.80213021302154,-65.32433667584579L261.4075907590761,-66.38081601954619L261.5085008500852,-69.51351984309598L263.72852285228544,-68.82115470813864L264.9394439443947,-71.38368228351901L265.14126412641286,-72.8863748603199L266.65491549154933,-75.47646827659777L266.5540054005402,-77.2678029173165L270.1867686768678,-79.45118306323246L272.20497049704994,-78.90407466228153L272.0031503150316,-80.82271156865968L272.9113411341135,-81.42790823037868L272.7095209520953,-82.58625960772352L274.42499249925015,-82.86263962127963L275.33318331833203,-80.9876598360614L276.5441044104413,-80.2185729390573L276.6450145014503,-77.81239218749513L276.5441044104413,-75.20582058798335L273.81953195319545,-72.61760126706938L273.5168016801682,-68.98082384924783L276.4431943194321,-69.51351984309598L277.14956495649585,-66.69828915680066L278.96594659465967,-66.06358829872546L278.05775577557773,-63.586967699055954L280.17686768676896,-62.432651476682565L281.3877887788781,-61.85664673164194L283.40599059906003,-62.747158239880186L283.5069006900692,-61.49049327570507L281.1859685968599,-59.56012100596364L280.5805080508053,-58.468170862981204L278.96594659465967,-57.74164301771762L277.35138513851405,-56.447075849900415L275.33318331833203,-56.34366355247509L274.02135213521376,-53.148780737389174L272.9113411341135,-52.584093252989234L274.22317231723196,-50.02512347292505L276.0395539553958,-47.88508337330623L277.14956495649585,-45.955958462896604L276.14046404640476,-43.37693054525476L275.13136313631384,-42.87253653258831L275.8377337733776,-41.412109599845316L277.6541154115414,-39.102377029320834L278.05775577557773,-37.50029941122093L277.9568456845686,-36.15139817137067L279.06685668566865,-33.56048281983873L277.55320532053224,-30.87899157644864Z", id: "Myanmar", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M54.2391739173919,-129.42185510429445L53.63371337133727,-129.74885411883068L52.826432643264454,-130.99553206464978L51.61551155115527,-131.72027745328685L52.01915191519164,-132.3810586351686L52.422792279228084,-134.5080521903453L53.33098309831,-135.3776709190678L53.835533553355454,-135.7130027717005L54.541904190419174,-135.04281971434025L54.945544554455545,-134.5080521903453L55.853735373537454,-134.10777519226048L56.96374637463763,-133.30925905434054L56.76192619261936,-132.9773404764598L56.15646564656481,-132.11652543080137L55.45009500950109,-131.78627291931437L55.2482748274829,-132.51343599530549L54.037353735373635,-130.66682883458947Z", id: "Montenegro", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M326.99914991499173,-161.80269296584743L325.58640864086425,-158.50475581333686L323.66911691169133,-154.30709862912784L324.375487548755,-152.56389161930989L325.88913891389166,-153.1434019961889L328.7146214621464,-152.4915615533224L330.83373337333757,-154.01558629434294L333.1546654665469,-152.63624579463877L335.67741774177443,-149.76066221733552L335.3746874687471,-148.3369049125849L333.1546654665469,-148.76306611890644L329.01735173517375,-148.26595802067237L327.1000600060008,-147.0633311043563L324.9809480948097,-144.39840373097408L320.74272427242744,-142.86992171118652L317.9172417241727,-140.73354861007778L315.0917591759178,-141.55814751988666L313.47719771977216,-141.90261547862923L312.06445644564474,-139.36580712726035L312.9726472647266,-137.87065224398663L313.3762876287631,-136.58713051254088L311.45899589959015,-135.24367287967846L309.44079407940814,-133.2428380017517L306.11076107610785,-131.852286709087L301.9734473447347,-131.72027745328685L297.43249324932515,-130.4041912490347L294.10246024602475,-128.37843065529484L292.89153915391563,-129.55260135060635L289.4605960596062,-129.55260135060635L285.323282328233,-131.852286709087L282.5987098709873,-132.4472380717524L278.8650365036505,-131.91831883885055L273.1131613161319,-132.77841288779672L269.9849484948496,-132.64588736900257L268.370387038704,-134.9090133335014L267.0585558555857,-138.54906409849187L265.34308430843106,-138.9570726728605L261.9121412141216,-141.42050655592524L258.1784678467848,-141.9715718880951L254.84843484348454,-142.66229324970837L253.83933393339348,-144.39840373097408L254.94934493449355,-149.11883118062914L253.03205320532072,-152.41925557397414L248.99564956495675,-154.01558629434294L246.67471747174736,-156.21161456853704L245.8674367436745,-159.24978193067412L248.89473947394754,-159.997437553716L254.24297429742998,-163.69981942405738L258.4811981198122,-165.7682805655061L260.9030403040305,-164.46351998324428L263.8294329432944,-164.3870238213299L265.74672467246745,-162.33215829743614L268.47129712971315,-162.18074607431268L272.5077007700771,-161.04862169337073L275.2322732273229,-164.0813198686138L274.1222622262228,-166.69425652286512L277.0486548654867,-171.38766960593992L280.17686768676896,-169.49739325615022L282.69961996199635,-168.9493368225766L286.02965296529675,-167.85759348852892L286.5342034203423,-164.5400442699755L290.57060706070627,-162.6353113117805L293.1942694269428,-163.47125357116175L296.72612261226146,-164.00496391617412L299.5516051605162,-163.47125357116175L302.2761776177619,-161.34992577292044L303.99164916491674,-159.17516140990605L306.6153115311533,-159.17516140990605L310.1471647164719,-158.50475581333686L312.66991699169944,-159.5485272158695L316.40359035903606,-160.2972417757189L320.4399939994002,-163.3190152195687L322.15546554655486,-162.86296441404L323.66911691169133,-161.4253192726159Z", id: "Mongolia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M112.96884688468859,29.09273432179211L113.37248724872505,30.380013395792723L113.27157715771595,33.20900589263947L113.67521752175232,35.748827062430394L113.7761276127614,40.252819492942706L114.28067806780696,41.6602536811464L113.37248724872505,43.726831860305914L112.26247624762487,45.74983748599706L110.54700470047014,47.57659887383781L107.9233423342336,48.6958913929712L104.79512951295143,50.12378045662906L101.66691669166934,53.2994129514741L100.55690569056917,53.813470918468525L98.63961396139625,55.92673630234978L97.42869286928708,56.59872950243817L97.2268726872689,58.7243995120563L98.53870387038717,61.01663093591298L99.04325432543271,62.7960428610823L99.14416441644181,63.68849699445263L99.64871487148727,63.53086982038509L99.54780478047817,66.53593460189092L99.04325432543271,67.91396945475151L99.74962496249636,68.44523825805949L99.34598459845999,69.72318400912278L98.13506350635082,70.84480486905483L95.81413141314145,71.86240980034187L92.4840984098411,73.52856201408358L91.27317731773192,74.66145861315434L91.4749974997501,76.01468810600396L92.18136813681383,76.2316701456207L91.97954795479563,77.86320130021714L89.86043604360447,77.80869729551247L89.55770577057719,76.44878184686843L89.15406540654082,75.03986082764973L88.95224522452256,73.90581168845743L89.4567956795681,70.47057248716226L88.75042504250438,68.28578360934787L87.33768376837702,64.00392658682911L90.36498649865,60.59898994034326L91.07135713571374,58.4127175112897L91.4749974997501,58.153143505435864L91.77772777277737,56.39186143390471L91.37408740874102,55.51367019799956L91.4749974997501,53.2994129514741L91.97954795479563,51.2483875358781L91.97954795479563,47.52577564344177L90.56680668066818,46.6117431387505L89.2549754975499,46.40882510666905L88.64951495149529,45.69917732157037L87.33768376837702,45.04099622050387L85.01675167516765,45.091599234791L84.81493149314947,44.02984401094029L84.51220122012212,41.962250932330534L93.08955895589573,39.60040217613215L94.70412041204136,40.956151652044426L95.41049104910509,40.70487396245986L96.52050205020517,41.40869938959219L96.72232223222336,42.617077895093395L96.11686168616873,43.92882301483877L96.31868186818699,46.00320492840784L98.13506350635082,47.83078460235155L99.04325432543271,45.80050208453124L100.2541754175419,45.142206612778025L99.95144514451462,41.40869938959219L98.84143414341445,39.34964349089444L97.83233323332344,38.39761260469765L96.82323232323245,38.44768621299182L96.01595159515963,34.70198726818749L96.82323232323245,32.51325611689557L98.94234423442363,32.314581553312664L102.27237723772389,33.10957572179128L102.97874787478762,32.76166841650032L104.99694969496962,32.66229424936479L106.00605060506061,31.818107917771428L107.62061206120624,31.867741699197655L110.74882488248842,30.776483982570248Z", id: "Mozambique", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-46.16636663666359,-45.80393710367739L-46.46909690969087,-47.37677821137998L-45.66181618161806,-48.80121186495897L-45.25817581758169,-51.61019693278084L-45.66181618161806,-54.53753953447774L-45.96454645464532,-55.981896963756085L-45.66181618161806,-57.482443907835695L-46.36818681868177,-58.88384413906725L-47.88183818381831,-60.18527439513137L-47.27637763776369,-61.176890026313835L-36.2771777177717,-61.176890026313835L-36.78172817281717,-65.53541692783999L-36.17626762676261,-67.12197090714987L-33.55260526052598,-67.38699636364119L-33.55260526052598,-75.25993416742483L-24.369786978697736,-75.0976173152805L-24.369786978697736,-79.83466720507121L-13.875137513751298,-72.29532429289583L-18.11336133613348,-72.24163802166449L-16.801530153015204,-59.14383173740127L-15.388788878887757,-46.361545226953375L-14.98514851485139,-46.006641154484534L-15.59060906090602,-43.98275581100252L-26.79162916291618,-43.932247147995945L-27.19526952695255,-43.27601845981183L-28.305280528052723,-43.4778593573295L-29.919841984198353,-42.87253653258831L-31.83713371337126,-43.679767331995926L-32.74532453245317,-43.62928403117567L-33.24987498749863,-41.915320928715744L-34.15806580658053,-41.412109599845316L-35.97444744474435,-43.37693054525476L-37.68991899189907,-45.55065689742212L-39.60721072107197,-46.310831189386604L-40.91904190419033,-47.17358551899767L-42.43269326932687,-47.12279882820114L-43.84543454345424,-46.51371436032203L-45.25817581758169,-46.76741997930413Z", id: "Mauritania", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M93.08955895589573,39.60040217613215L91.5759075907592,38.84840758324684L92.38318831883201,36.14801432203566L93.2913791379139,35.15045262075316L92.78682868286845,32.76166841650032L93.2913791379139,30.479113796576467L93.79592959295944,29.686628505693218L93.08955895589573,27.26400024855255L91.77772777277737,26.030362745582767L94.50230023002318,26.52363105433439L95.10776077607771,27.313378440697743L96.01595159515963,28.647572276646013L96.82323232323245,32.51325611689557L96.01595159515963,34.70198726818749L96.82323232323245,38.44768621299182L97.83233323332344,38.39761260469765L98.84143414341445,39.34964349089444L99.95144514451462,41.40869938959219L100.2541754175419,45.142206612778025L99.04325432543271,45.80050208453124L98.13506350635082,47.83078460235155L96.31868186818699,46.00320492840784L96.11686168616873,43.92882301483877L96.72232223222336,42.617077895093395L96.52050205020517,41.40869938959219L95.41049104910509,40.70487396245986L94.70412041204136,40.956151652044426Z", id: "Malawi", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M286.2314731473149,-17.43667316794153L286.8369336933695,-17.19188852237275L288.5524052405243,-15.479477886248322L289.6624162416244,-13.622267612506809L289.8642364236426,-11.718069304768953L289.56150615061523,-10.449533294474987L289.8642364236426,-9.474183370519738L290.0660566056607,-7.816870066326845L291.0751575157518,-7.037256432330943L292.08425842584273,-4.553254460435093L292.08425842584273,-3.579466090212937L290.0660566056607,-3.4334100588699257L287.4423942394242,-5.478507924585893L284.1123612361238,-7.719408670177772L283.80963096309654,-9.132895187063061L282.1950695069509,-11.034925774760216L281.7914291429144,-13.329196289164184L280.7823282328235,-14.892779091311752L281.08505850585084,-16.94714366406925L280.47959795979614,-18.12228674273681L280.9841484148417,-18.612211472191767L283.20417041704184,-17.387713028237833L283.5069006900692,-15.96855061312221L285.323282328233,-16.31098911299735ZM330.329182918292,-11.571664003261063L327.90734073407367,-12.05971969862834L324.6782178217824,-12.05971969862834L323.7700270027005,-8.84039530964917L322.6600160016004,-7.865601841041458L321.2472747274729,-3.968963642579539L318.9263426342636,-3.384725352095099L316.302680268027,-4.163721029982863L314.8899389938996,-3.920275218853695L313.27537753775397,-2.508449481120896L311.45899589959015,-2.703170080031611L309.74352435243554,-2.119019060246993L307.8262326232625,-3.7255250821002726L307.32168216821697,-5.624616409595504L309.339883988399,-4.650641913695475L311.5599059905993,-5.1863044332106965L312.06445644564474,-7.524494365069024L313.27537753775397,-8.060536222464275L316.60541054105425,-8.694156418025019L318.6236123612364,-10.888564231080048L320.0363536353637,-12.69435903727728L321.3481848184821,-11.230088758183719L321.95364536453667,-12.157344037576852L323.265476547655,-12.108531309795499L323.3663866386641,-13.866528254026315L323.5682068206823,-15.283889117144811L325.68731873187335,-17.240842250101682L327.1000600060008,-19.44548193173006L328.2100710071008,-19.44548193173006L329.72372237223743,-18.02432209306552L329.8246324632464,-16.800315607813822L331.6410141014103,-16.017465932054602L333.9619461946196,-15.1372123886649L333.76012601260146,-14.061959784237192L331.94374437443764,-13.915384204829989L332.4482948294832,-12.54788660232581Z", id: "Malaysia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M32.8462346234625,49.256396621718906L34.15806580658077,48.6958913929712L35.87353735373549,48.237724306937366L37.68991899189931,48.28861287513535L39.30448044804494,49.61338460087158L39.8090309030904,49.40936247205049L51.11096109610973,49.30738041671596L53.12916291629173,50.685783194709146L59.89013901390153,51.146050749998174L65.0365536553657,49.91956351241081L67.35748574857497,49.256396621718906L69.17386738673878,49.40936247205049L70.28387838783888,50.07271887001871L70.28387838783888,50.328075957034315L68.66931693169333,50.99258322928428L67.8620362036205,50.99258322928428L66.0456545654567,52.17033026792641L64.93564356435652,50.94143740847462L60.596509650965245,51.96531143869938L58.578307830783174,52.06781060179651L58.477397739774084,62.69116999478825L55.752825282528356,62.7960428610823L55.752825282528356,71.70155611015878L55.752825282528356,83.30156409111798L53.230073007300824,84.91116884562192L51.71642164216437,85.18947506824821L49.90004000400055,84.57750944575544L48.68911891189129,84.29971546177372L48.18456845684583,82.96950460446712L47.07455745574573,82.08560127133416L45.76272627262738,83.68938106320185L43.643614361436285,81.25901760885743L42.533603360336116,78.95504039493912L41.92814281428157,75.90624556134068L41.221772177217844,73.63630883034772L40.313581358135934,68.92398512877588L40.313581358135934,65.26800711849036L39.90994099409957,63.58340573835704L38.7999299929994,62.37670389494377L37.38718871887203,59.86905736614842L35.87353735373549,56.28846112650183L35.26807680768086,54.431043535372076L33.04805480548068,51.55551890027586Z", id: "Namibia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M464.6405140514054,60.49464092512831L466.86053605360564,62.37670389494377L468.37418741874205,63.74105234542495L467.26417641764203,64.47751169585308L465.7505250525055,63.63594812757204L463.73232323232355,62.27193252532812L461.91594159415973,60.703363399175664L460.0995599559959,58.56853209395695L459.69591959195935,57.58259195349201L460.90684068406864,57.63443137902272L462.42049204920505,58.620482021253196L463.73232323232355,59.66072281180995Z", id: "New Caledonia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M0.9586458645865727,-42.31817975520221L2.775027502750387,-42.41893505829885L3.7841284128413863,-43.427392857798495L7.618711871187199,-43.679767331995926L10.141464146414737,-44.134307295971276L10.34328432843292,-45.955958462896604L11.95784578457855,-47.88508337330623L11.95784578457855,-54.692087165872984L15.893339333933536,-56.033561147700915L23.966146614661607,-61.908979364586884L33.55260526052614,-67.70525612138582L37.992649264926584,-66.38081601954619L39.607210721072214,-64.69173606049952L41.52450245024512,-65.79941830617089L42.230873087308844,-61.1246444846567L43.34088408840894,-60.341698711354496L43.34088408840894,-59.40396779338598L44.5518051805182,-58.36431125418033L43.946344634463564,-57.068023686871705L42.83633363336347,-51.047202060211504L42.73542354235438,-47.22437679721681L39.10266026602675,-44.48807684186861L37.89173917391749,-40.658036358322924L39.10266026602675,-39.6038029138285L39.10266026602675,-37.75037868696053L40.81813181318147,-37.70035565773935L40.616311631163214,-36.30115061884937L39.8090309030904,-36.15139817137067L39.70812081208131,-35.25352783978726L39.203570357035844,-35.20367819143393L37.28627862786294,-38.350937087620615L36.579907990799214,-38.451081137448114L34.460796079608045,-36.8505095945973L32.24077407740787,-37.65033622066434L30.727122712271324,-37.85043554229188L29.91984198419851,-37.45029429164394L28.30528052805296,-37.550308102512886L26.69071907190733,-36.30115061884937L25.177067706770792,-36.25122969339559L21.847034703470438,-37.70035565773935L20.535203520352162,-37.000408101141325L19.021552155215627,-37.05038130472711L18.012451245124627,-38.15069285182472L15.186968696869814,-39.20263215318992L12.159665966596815,-38.90191157186808L11.453295329533091,-38.25080767276648L11.049654965496643,-36.60074879277739L10.242374237423828,-35.452959921022845L10.040554055405645,-32.86442418328632L7.921442144214555,-34.55593475898612L6.912341234123555,-34.50613139601044L6.004150415041648,-33.70971870700007L6.004150415041648,-35.65244582434926L2.775027502750387,-36.30115061884937L2.775027502750387,-37.70035565773935L1.1604660466047565,-39.55364336624699L0.7568256825683887,-40.90929581227642Z", id: "Niger", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M7.517801780178107,-17.534598295459922L7.618711871187199,-22.095909147892034L7.618711871187199,-23.9153588768622L8.123262326232739,-25.68856219730808L8.930543054305554,-26.576316626163745L10.34328432843292,-28.30483711109034L10.040554055405645,-29.096088514571687L10.545104510451186,-30.23474275719105L9.939643964396552,-31.920743771574646L10.040554055405645,-32.86442418328632L10.242374237423828,-35.452959921022845L11.049654965496643,-36.60074879277739L11.453295329533091,-38.25080767276648L12.159665966596815,-38.90191157186808L15.186968696869814,-39.20263215318992L18.012451245124627,-38.15069285182472L19.021552155215627,-37.05038130472711L20.535203520352162,-37.000408101141325L21.847034703470438,-37.70035565773935L25.177067706770792,-36.25122969339559L26.69071907190733,-36.30115061884937L28.30528052805296,-37.550308102512886L29.91984198419851,-37.45029429164394L30.727122712271324,-37.85043554229188L32.24077407740787,-37.65033622066434L34.460796079608045,-36.8505095945973L36.579907990799214,-38.451081137448114L37.28627862786294,-38.350937087620615L39.203570357035844,-35.20367819143393L39.70812081208131,-35.25352783978726L40.81813181318147,-34.10782173843054L40.515401540154116,-33.56048281983873L40.313581358135934,-32.615979970115724L37.992649264926584,-30.43292147799534L37.28627862786294,-28.601475688896187L36.88263826382649,-27.11922801829336L36.27717771777186,-26.47763797322391L35.67171717171731,-24.5060946672552L34.15806580658077,-23.32494416487882L33.7544254425444,-21.899384677163887L33.14896489648977,-20.76999223173086L32.8462346234625,-19.592583129456774L30.92894289428951,-18.66121335765616L29.415291529153052,-19.78874353142415L28.30528052805296,-19.7397006879037L26.589808980898237,-18.12228674273681L25.782528252825422,-18.07330358068904L24.470697069707068,-15.381680658193325L23.764326432643347,-13.378038407766L20.837933793379438,-12.352606205564978L19.82883288328844,-12.49906477830379L18.718821882188347,-11.864484329406642L16.498799879988088,-11.913291519463248L14.985148514851629,-13.671117207658096L14.076957695769721,-15.723996077276967L12.058755875587643,-17.583563292484936L9.939643964396552,-17.534598295459922Z", id: "Nigeria", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-244.75742574257418,-36.70064263762009L-243.9501450145014,-36.80055044353927L-243.546504650465,-37.45029429164394L-243.1428642864286,-37.50029941122093L-243.2437743774377,-38.90191157186808L-242.53740374037397,-38.95202235034414L-241.9319431943194,-38.95202235034414L-241.3264826482648,-39.70413337719164L-240.519201920192,-39.15250272069243L-240.21647164716467,-39.50348760115913L-239.71192119211918,-39.85465757048267L-238.70282028202814,-40.658036358322924L-238.70282028202814,-41.21093667372175L-238.40009000900082,-41.21093667372175L-238.09735973597353,-41.915320928715744L-237.79462946294623,-41.96566412868903L-237.29007900790074,-41.56303101775112L-236.78552855285525,-41.412109599845316L-236.0791579157915,-41.764315475668056L-235.3727872787278,-41.764315475668056L-234.4645964596459,-42.16707731392532L-234.0609560956095,-42.57009863206238L-233.0518551855185,-42.46931882838026L-233.3545854585458,-42.21744073294721L-233.4554955495549,-41.56303101775112L-233.1527652765276,-40.5073274902509L-233.8591359135913,-39.50348760115913L-234.16186618661862,-38.350937087620615L-234.26277627762772,-37.1003580341599L-234.0609560956095,-36.35107499401308L-233.9600460046004,-35.054149258620605L-234.4645964596459,-34.7551809961009L-234.6664166416641,-33.56048281983873L-234.4645964596459,-32.814729152025265L-235.07005700570053,-32.06967282485451L-234.9691469146914,-31.275695913471427L-234.56550655065504,-30.829416668393517L-235.17096709670963,-30.23474275719105L-235.97824782478244,-30.383372515122893L-236.48279827982793,-30.978150119215698L-237.39098909890984,-31.226097610216808L-237.99644964496443,-30.87899157644864L-239.81283128312828,-31.622966812111695L-240.31738173817376,-31.226097610216808L-241.22557255725567,-32.16897397792597L-242.53740374037397,-33.31181974918285L-243.1428642864286,-34.257163508718506L-244.3537853785378,-35.15383188180538L-245.76652665266522,-36.45093411372776L-245.4637963796379,-36.90047225116163L-244.9592459245924,-36.500868868411644Z", id: "Nicaragua", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M19.32428242824298,-178.06418424638397L19.82883288328844,-176.43502743835043L19.122462246224718,-172.18048608460975L18.416091609160993,-170.51912078859803L16.70062006200635,-170.51912078859803L17.205170517051812,-165.7682805655061L15.691519151915273,-166.84898972193514L13.875137513751458,-168.79301786537914L11.251475147514828,-167.85759348852892L9.23327332733283,-168.24683658381812L10.646014601460276,-169.41900970818688L13.168766876687814,-176.1917918315964L17.003350335033627,-178.1459912991298Z", id: "Netherlands", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M87.13586358635874,-274.9869917776357L82.39308930893102,-271.81332443903204L80.07215721572167,-271.1310898518859L81.28307830783093,-276.6664349569999L77.6503150315033,-279.93218800977496L73.31118111811196,-277.22993019717L71.9993499349936,-271.2673203376748L69.27477747774788,-267.89349710949364L66.24747474747488,-269.77468657063827L62.614711471147245,-269.3698415052773L59.486498649865084,-273.59991900307017L57.771027102710356,-271.40365885503377L56.05555555555571,-271.1310898518859L55.651915191519265,-266.0326098287171L50.40459045904601,-267.22658845679325L49.597309730973194,-263.0182895044817L46.97364736473657,-263.0182895044817L45.05635563556366,-257.77160666633836L42.331783178317934,-250.00546324105346L37.992649264926584,-240.49983102806598L39.00175017501766,-238.22930338051157L37.992649264926584,-235.65349933429155L35.16716671667177,-235.76472087073662L33.350785078507954,-229.85547507791162L33.55260526052614,-221.85388371326522L35.368986898689954,-218.78984553411973L34.460796079608045,-212.12612218732423L32.13986398639877,-208.25931696822738L30.82803280328042,-205.12848851400156L29.011651165116604,-208.45076053821066L23.461596159616068,-202.23424754641925L19.727922792279347,-200.94159438689184L15.792429242924443,-203.72249003301124L14.783328332833365,-209.60357055928498L13.976047604760629,-222.78322130295123L16.498799879988088,-226.65457523857233L23.966146614661607,-231.9125295774058L29.415291529153052,-238.45505597253901L34.56170617061722,-247.84836912742958L41.32268226822694,-261.59500333192767L46.065456545654655,-267.22658845679325L53.73462346234637,-277.0888823310121L59.89013901390153,-280.6504711643641L64.43109310931106,-280.2191386512763L68.77022702270241,-287.25502784727354L73.81573157315742,-286.9559818832804L78.86123612361249,-288.60729155466544L87.64041404140428,-282.38679138398066L84.00765076507666,-280.07560303809737ZM69.27477747774788,-359.69264805129L63.018351835183616,-354.2363217369956L58.07375737573771,-357.3971304169546L59.99104910491062,-360.8525478117578L58.2755775577559,-365.09738038988075L64.12836283628378,-367.9895442164819L65.23837383738389,-362.72559960604866ZM51.11096109610973,-386.2334054980606L60.2937793779379,-374.94333043680484L53.230073007300824,-369.4549891054397L51.71642164216437,-359.23097181333986L49.294579457945915,-356.941849431441L47.88183818381847,-346.37671727483587L44.5518051805182,-345.95087114718297L38.49719971997212,-353.56683590328004L41.01995199519966,-358.08242508854187L36.88263826382649,-362.0206985204487L31.433493349335052,-373.67972559426244L29.213471347134867,-385.6906173072798L36.88263826382649,-391.2015007266973L38.39628962896303,-385.6906173072798L42.432693269327025,-385.9617857918818L43.44179417941803,-391.48199327788905L47.579107910791194,-392.0444300905786ZM71.29297929792996,-397.77819586955763L76.7421242124214,-392.0444300905786L72.60481048104823,-383.53733241817116L64.53200320032016,-381.67621987553747L56.2573757375739,-384.3414902215651L55.752825282528356,-388.6985427215557L51.71642164216437,-388.9747600443669L48.5882088208822,-396.3257279087029L57.266476647664895,-401.01997039601054L61.302880288028895,-396.9051618615211L64.22927292729288,-401.9154100654996Z", id: "Norway", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M227.299979998,-88.7766850851449L228.40999099910007,-89.56590096670293L230.7309230923094,-88.5515530703473L233.55640564056415,-86.47650991521938L235.0700570057008,-85.97376744282154L236.0791579157917,-84.47013104406294L238.19826982698285,-83.80402771052523L240.5192019201922,-82.420539632595L243.6474147414743,-81.70335021194106L246.97744774477457,-81.37284635712207L246.67471747174736,-79.99914645558158L247.07835783578375,-78.03046046634702L246.7756275627564,-76.778377818354L244.4546954695472,-76.72403824457791L241.02375237523776,-77.43109277429721L238.90464046404657,-77.75789593957396L237.29007900790094,-79.34169323005761L233.4554955495551,-79.77985800635608L229.8227322732275,-81.5380584762504L227.0981598159818,-83.08390625919127L224.37358735873605,-84.30348057902378L225.48359835983615,-87.31614002059774Z", id: "Nepal", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M484.92344234423456,125.91377257964938L485.52890289028926,127.46471666014652L487.5471047104713,125.97819916312612L488.354385438544,127.52955396775435L488.354385438544,129.0908750494386L487.244374437444,130.85953896914262L485.42799279928016,133.63713514857224L484.01525152515273,135.23913195828993L485.02435243524377,137.0546034409917L482.9052405240526,137.12211624151476L480.48339833983425,138.61240783117245L479.77702770277045,141.14081580024617L478.16246624662483,145.2317836742245L475.9424442444247,146.98800977399745L474.52970297029725,148.1902263748397L472.0069506950697,148.11932659224573L470.1905690569059,146.77652927705307L467.06235623562384,146.4948681293663L466.65871587158745,144.95206619256226L468.17236723672386,142.0358722245878L471.7042204220425,138.1371795268308L473.52060206020633,137.39236439891127L475.5388038803883,135.9098794995093L477.8597359735977,133.90337697520513L479.5752075207523,131.91384154289636L480.7861286128616,129.0908750494386L481.8961396139617,128.17888115715203L482.299779977998,126.04264268823694L484.21707170717104,124.37257875164198ZM489.36348634863515,108.85103547130943L491.3816881688171,112.55402529385223L491.48259825982626,110.1200917790904L492.6935193519354,111.09101174371516L493.0971597159719,113.77938947018919L495.41809180918113,114.88711178070395L497.2344734473449,115.19564553952502L498.8490349034905,113.8408072174696L500.261776177618,114.2711334291585L499.6563156315634,117.42796444892595L498.74812481248154,119.49139645662073L496.62901290129037,119.42862258869656L495.9226422642266,120.56093509656654L496.1244624462448,122.07862834567015L495.72082208220843,122.77731849048008L494.71172117211734,124.75697427192918L493.2989798979901,127.3350938897047L491.07895789578976,128.82995380944783L490.67531753175336,127.7890763685334L489.46439643964425,127.27030839655187L491.07895789578976,124.24457967007716L490.1707670767078,122.20551779661182L487.1434643464349,120.75014728523477L487.244374437444,119.42862258869656L489.26257625762594,118.17638019168015L489.66621662166244,115.44273537557362L489.56530653065323,113.16599753783062L488.4552955295532,110.78722235406461L488.5562056205622,110.18067177939443L487.1434643464349,108.73048185613092L485.02435243524377,105.67413618726124L483.81343134313454,103.24121833622554L484.8225322532256,103.00498138263282L486.336183618362,104.9004357302711L488.5562056205622,105.79335788202935Z", id: "New Zealand", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M148.79192919291944,-47.32597313790869L147.8837383738375,-49.36182603176582L145.66371637163732,-54.22859003541496L154.14016401640177,-57.223388388486775L155.9565456545656,-63.21934874961347L154.64471447144732,-65.37709669417173L154.7456245624564,-66.59243742095391L155.55290529052922,-67.86448019003224L155.55290529052922,-69.08730566191038L156.8647364736475,-69.67346900855256L156.36018601860204,-70.10031895368218L156.56200620062023,-72.13428817937357L157.9747474747476,-72.13428817937357L159.28657865786593,-70.04693726828388L160.80023002300248,-68.92759366530049L162.91934193419357,-68.5020086332118L164.5339033903392,-67.97066457734249L165.8457345734575,-66.2221715713642L166.5521052105212,-65.21883668927566L167.5612061206122,-64.84979657629438L167.5612061206122,-64.16529616604903L166.5521052105212,-62.32786660683065L166.14846484648484,-61.49049327570507L164.93754375437555,-60.55034961870511L163.92844284428455,-58.468170862981204L162.61661166116627,-58.62400423259563L162.01115111511166,-57.94910619826127L161.6075107510753,-56.39536689240499L161.91024102410256,-54.434534812580814L161.6075107510753,-54.074187851437074L160.39658965896604,-54.074187851437074L158.58020802080222,-52.99471241781154L158.37838783878402,-51.50778877926865L157.6720172017203,-50.89376357449724L155.9565456545656,-50.9449047338751L154.84653465346548,-50.178309236442644L154.84653465346548,-49.005004469030176L153.5347034703472,-48.190290017117285L151.9201420142016,-48.444758025429465L150.10376037603777,-47.47840219208695ZM157.6720172017203,-74.61109526438247L157.0665566556657,-75.63895284475264L157.8738373837385,-76.72403824457791L158.27747774777495,-76.4524627947725L157.9747474747476,-75.15171497303967Z", id: "Oman", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M218.11716171617172,-106.51381784772998L215.39258925892602,-103.59995436722012L212.26437643764393,-103.12707926560921L208.02615261526165,-103.9551306552449L206.61341134113428,-102.47816050590629L207.6225122512253,-99.54690975954132L208.6316131613163,-97.2808621273143L210.85163516351656,-95.60701670914506L208.5307030703072,-93.71354794659958L208.5307030703072,-91.37725439977235L205.80613061306147,-88.10176308497121L204.09065906590678,-84.85930706327746L201.16426642664283,-81.48297893412365L197.8342334233425,-81.75846518664129L194.8069306930695,-78.41240177499328L196.6233123312333,-76.99581797452794L196.9260426042606,-74.61109526438247L198.54060406040622,-73.04773080967169L199.04515451545169,-70.36733686684485L192.88963896389657,-70.42076239505194L191.0732573257327,-68.34253133301475L188.9541454145416,-69.14055730425171L188.14686468646877,-71.33012372888348L186.0277527752777,-73.69384733776975L180.78042804280446,-73.1015314677506L176.2394739473949,-73.04773080967169L172.30398039804,-72.61760126706938L173.41399139914012,-76.23534889180247L177.4503950395041,-77.86689675658029L177.14766476647682,-79.28696111903807L175.83583358335846,-79.83466720507121L175.73492349234937,-82.58625960772352L173.1112611261127,-84.02591466121662L172.00125012501263,-85.91795476181409L170.58850885088526,-87.65260148400151L175.2303730373039,-85.97376744282154L178.0558555855587,-86.47650991521938L179.77132713271342,-86.02958962024246L180.27587758775888,-86.75614591336587L182.29407940794098,-86.47650991521938L185.9268426842686,-87.82096372459209L186.0277527752777,-90.58350319319383L187.54140414041424,-92.45773067258064L189.66051605160533,-92.40076954922667L189.96324632463262,-93.37054278554655L192.08235823582376,-93.77075287462644L193.09145914591477,-93.48483515663999L194.20147014701485,-94.40071603399998L194.10056005600575,-96.41390946869599L195.31148114811495,-98.38265297617185L197.0269526952697,-99.25541087967176L195.9169416941696,-101.47818159528731L198.64151415141532,-101.36076619778107L199.34788478847904,-102.59603564447055L199.24697469746994,-103.89590354198543L200.6597159715973,-105.32081244523957L200.35698569857,-107.05235088188772L199.6506150615063,-108.49361658928967L201.36608660866102,-110.00307737764064L204.29247924792494,-110.73062162391348L207.5216021602162,-111.15593338170349L208.93434343434356,-111.82564827003178L210.64981498149828,-112.19165680297333L212.66801680168038,-110.54855116217344L213.4752975297532,-107.8921679478808Z", id: "Pakistan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-232.547304730473,-23.128209202192284L-232.4463946394639,-23.66931419518898L-232.24457445744568,-24.25991521094031L-232.3454845484548,-24.752331284990134L-231.94184418441841,-25.097159708969347L-232.4463946394639,-25.491390033636897L-232.4463946394639,-26.67500522451294L-231.43729372937293,-26.92177048279641L-230.42819281928186,-25.885772767997356L-230.42819281928186,-25.29425597231679L-229.31818181818176,-25.146430247881153L-229.11636163616353,-25.39281825921335L-228.30908090809078,-24.703079360106468L-226.89633963396332,-24.90010093950207L-225.68541854185415,-25.639265567638347L-224.07085708570852,-26.18166130436607L-223.0617561756175,-27.020494191640378L-221.54810481048096,-26.872412410569495L-221.6490149014901,-26.576316626163745L-220.03445344534447,-26.47763797322391L-218.82353235323527,-25.984392551261728L-217.91534153415336,-25.146430247881153L-216.80533053305328,-24.35838017197814L-217.20897089708967,-23.964574483404853L-216.50260026002596,-22.29246650882726L-217.10806080608057,-21.457323320475947L-218.01625162516248,-21.653774883935053L-218.31898189818975,-20.279273736352923L-219.22717271727166,-21.11360970438644L-219.8326332633263,-22.63652193509034L-219.22717271727166,-23.374133326511075L-219.93354335433537,-23.570911798223825L-220.4380938093809,-24.5060946672552L-221.8508350835083,-25.29425597231679L-223.0617561756175,-25.097159708969347L-223.566306630663,-24.112234728468117L-224.77722772277224,-23.42332466594886L-225.38268826882683,-23.32494416487882L-225.58450845084502,-22.734842380201457L-224.27267726772675,-21.211803714129402L-225.07995799579953,-20.819074616432324L-225.48359835983592,-20.426469302781165L-226.79542954295422,-20.279273736352923L-227.19906990699064,-21.94851272778745L-227.60271027102704,-21.457323320475947L-228.51090109010894,-21.653774883935053L-229.11636163616353,-22.78400577536331L-230.22637263726367,-22.980680616379836L-230.93274327432735,-23.275757176340587L-232.1436643664366,-23.275757176340587L-232.24457445744568,-22.68568110167652Z", id: "Panama", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-197.32968296829677,52.37543129289735L-200.05425542554246,50.685783194709146L-200.3569856985698,49.46036074358352L-205.9070407040703,46.51027509107242L-210.9525452545254,43.32305170476884L-213.07165716571652,41.559619997383855L-214.28257825782572,39.14910427978331L-213.7780278027802,38.29747637356416L-216.19986998699866,34.55255818543643L-218.9244424442444,29.290654930650657L-221.54810481048096,23.61677625532684L-222.7590259025902,22.338279154811175L-223.566306630663,20.226886218417956L-225.78632863286325,18.41289953104804L-227.80453045304523,17.23752333144835L-226.89633963396332,16.01414962099286L-228.20817081708165,13.32588503212922L-227.40089008900887,11.324368345311937L-225.07995799579953,9.568396316496885L-224.77722772277224,10.73890444826248L-225.58450845084502,11.42196006355764L-225.48359835983592,12.446934301255013L-224.37358735873585,12.202848465945504L-223.26357635763569,12.54457664007995L-222.0526552655265,13.96092907325093L-220.4380938093809,12.788702816664197L-219.93354335433537,10.885256758806433L-218.21807180718068,8.4471364233483L-214.88803880388033,7.326287814022289L-211.75982598259822,4.403875280318411L-210.9525452545254,2.6025089816934055L-211.2552755275527,0.46075120515561424L-210.548904890489,0.16870817283960143L-208.7325232523252,1.5315960399995887L-207.82433243324326,2.8459127166589457L-206.51250125012496,3.5761653850684296L-204.89793979397933,6.498066710906107L-202.77882788278822,6.839076755593891L-201.26517651765172,6.108376713013752L-200.2560756075607,6.595495096790317L-198.54060406040597,6.35192860300442L-196.42149214921486,7.667375389982108L-198.13696369636958,10.543781866268338L-197.32968296829677,10.592561043323757L-195.91694169416937,12.105222041231084L-198.43969396939687,11.958790765123398L-198.8433343334333,12.349296554698416L-201.16426642664263,12.935192644521091L-204.39338933893384,14.84058258772047L-204.59520952095204,16.16090418116679L-205.30158015801572,17.139617683251753L-204.99884988498843,18.657891169872986L-206.71432143214312,19.44215782751771L-206.71432143214312,20.668505986204032L-207.42069206920686,21.159377148552995L-206.20977097709763,23.71518276065759L-204.69611961196114,25.438761576259267L-205.30158015801572,26.671659713790085L-203.38428842884284,26.819710833626168L-202.37518751875183,28.35091875791928L-199.85243524352427,28.40035433533L-197.63241324132406,26.770357956772298L-197.73332333233316,31.073958465519958L-196.52240224022398,31.421145259919463L-194.90784078407836,30.925208120861335L-192.4859985998599,35.49944548704029L-193.09145914591454,36.49748338081867L-193.2932793279327,38.49776348995306L-193.2932793279327,40.956151652044426L-194.40329032903287,42.415519386607635L-193.89873987398735,43.47443779672528L-194.50420042004194,44.48464952455695L-193.2932793279327,46.91625609895335L-195.10966096609656,50.07271887001871L-195.81603160316027,51.60672516766671Z", id: "Peru", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M354.1439643964398,-23.66931419518898L354.44669466946715,-21.752012727970705L354.6485148514853,-20.18115278097541L353.63941394139437,-17.583563292484936L352.63031303130333,-20.475538279098725L351.318481848185,-19.053291104663526L352.22667266726694,-16.94714366406925L351.4193919391941,-15.626184471541457L348.08935893589376,-17.289797573920843L347.28207820782103,-19.298396969486422L348.19026902690297,-20.671833246046983L346.37388738873915,-21.997642819994088L345.5666066606663,-20.819074616432324L344.15386538653877,-20.917245192860165L342.1356635663568,-19.347423494019633L341.63111311131127,-20.18115278097541L342.74112411241146,-22.58736487574559L344.5575057505754,-23.374133326511075L346.0711571157118,-24.456854222021907L347.0802580258027,-23.128209202192284L349.1993699369939,-23.9153588768622L349.6030103010303,-25.195703134908943L351.62121212121224,-25.24497837480348L351.4193919391941,-27.464876643374993L353.74032403240346,-26.132340455840552L353.94214421442166,-24.703079360106468ZM347.4838983898392,-28.94767620228801L346.47479747974813,-28.008294095989307L345.5666066606663,-26.230984601012867L344.6584158415844,-25.343535932202006L342.94294429442965,-27.31672617850045L343.54840484048424,-28.107131213945543L344.254775477548,-28.898210872717197L344.5575057505754,-30.68070933880795L346.0711571157118,-30.829416668393517L345.6675167516754,-28.898210872717197L347.6857185718574,-31.67258882455182ZM332.04465446544685,-26.18166130436607L328.411891189119,-23.521713897091313L329.72372237223743,-25.491390033636897L331.74192419241945,-27.26734781309064L333.4573957395741,-29.19504370752278L334.87013701370154,-32.06967282485451L335.3746874687471,-29.739494333961126L333.55830583058327,-28.156553723344352ZM341.5302030203022,-33.56048281983873L343.2456745674569,-32.66566263402216L345.0620562056207,-32.66566263402216L344.9611461146117,-31.47411864019354L343.64931493149345,-30.23474275719105L341.9338433843386,-29.3929870314002L341.83293329332946,-30.73027555446583L342.0347534753478,-32.16897397792597ZM351.7221222122214,-34.30695057916896L352.5294029402941,-31.126909823471518L350.30938093809397,-31.87110678112377L350.4102910291031,-30.92856939175736L351.1166616661669,-29.145564742673148L349.7039203920394,-28.552029245373696L349.6030103010303,-30.53202799837508L348.79572957295755,-30.68070933880795L348.39208920892116,-32.41728005972934L350.0066506650668,-32.16897397792597L349.9057405740576,-33.262096601499884L348.29117911791195,-35.452959921022845L350.9148414841487,-35.40309686747903ZM340.5211021102112,-36.950438418314874L339.8147314731475,-34.45633130154358L338.6038103810384,-35.90187938208138L337.19106910691096,-38.05059258376281L339.6129112911293,-37.950506827576945ZM340.01655165516564,-52.7380364040547L341.7320232023204,-51.91754336771378L342.53930393039315,-52.68671682713986L342.84203420342055,-51.91754336771378L342.33748374837495,-50.74037004343163L343.34658465846604,-48.59749549233167L342.64021402140236,-46.15871602096279L340.9247424742475,-45.19624979354202L340.5211021102112,-42.87253653258831L341.1265626562659,-40.5575598914303L342.64021402140236,-40.25622359846638L343.8511351135116,-40.6077961790486L347.38298829883007,-39.00213684930659L347.0802580258027,-37.40029273867859L347.98844884488466,-36.70064263762009L347.6857185718574,-35.40309686747903L345.5666066606663,-36.80055044353927L344.4565956595662,-38.300870553388876L343.75022502250243,-37.25030942844448L342.0347534753478,-39.00213684930659L339.4110911091111,-38.55123986333896L337.9983498349836,-39.20263215318992L338.20017001700177,-40.406874326349126L339.1083608360837,-41.11037395812499L338.20017001700177,-41.81464660747258L337.89743974397464,-40.758528412718825L336.48469846984716,-42.41893505829885L336.0810581058108,-43.679767331995926L335.9801480148016,-46.46298680696107L337.09015901590175,-45.500014116182264L337.3928892889291,-50.07618048771315L338.301080108011,-52.78936118188517Z", id: "Philippines", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M436.89023902390267,19.19702578919502L436.08295829582977,19.491189627520907L434.87203720372054,18.363906341059945L433.6611161116114,16.601249072182878L433.0556555655567,14.449572206165215L433.358385838584,14.156370602649469L433.6611161116114,15.036120540199068L434.5693069306933,15.671773934031439L435.8811381138116,17.433353814000025L437.1929692969299,18.41289953104804ZM425.8910391039106,15.37836562627746L424.4782978297832,15.622868953854887L423.9737473747376,16.405525070417255L422.4600960096012,17.090667241319043L421.0473547354737,17.77611948213113L419.53370337033726,17.77611948213113L417.2127712771279,16.943825388990394L415.6991199119915,16.16090418116679L415.9009400940097,15.28057427736594L418.42369236923713,15.720680363109768L419.93734373437366,15.476162660954977L420.34098409841,14.107508270785699L420.7446244624465,14.058647241636596L421.0473547354737,15.57396541800164L422.6619161916194,15.329469243388276L423.46919691969225,14.351833048432663L424.98284828482866,13.374727067186882L424.68011801180137,11.71476063190078L426.39558955895615,11.665957863504591L426.9001400140017,12.105222041231084L426.9001400140017,13.667805359335787ZM395.21437143714394,25.685220005849924L395.21437143714394,16.454453782894227L395.1134613461348,7.326287814022289L399.9571457145717,9.227096488008746L405.2044704470449,10.836471658243484L407.1217621762177,12.300479392174212L408.63541354135435,13.71665613080581L409.13996399639996,15.37836562627746L413.78182818281846,17.090667241319043L414.4881988198822,18.608889401518454L411.8645364536456,18.902926047251686L412.4699969997002,20.766664710921823L414.99274927492775,22.633189215209914L416.8091309130915,25.635923538747907L418.42369236923713,25.537337785839807L418.32278227822803,26.819710833626168L420.44189418941914,27.313378440697743L419.63461346134625,27.85670843365085L422.6619161916194,29.043261010627937L422.258275827583,29.83516449486652L420.44189418941914,30.033251765071537L419.73552355235546,29.340141948162834L417.3136813681371,28.993790426189783L414.4881988198822,28.54867706994309L412.36908690869103,26.770357956772298L410.7545254525456,25.192362554610643L409.24087408740894,22.73150937398053L405.6081108110813,21.453993937486995L403.28717871787194,22.289134781112036L401.57170717071733,23.223237899138567L401.8744374437446,25.290915072365966L399.7553255325535,26.27696618307745L398.1407640764079,25.783820145160014ZM429.12016201620185,12.64222360748974L428.312881288129,13.374727067186882L427.80833083308363,11.763564480337228L427.1019601960199,10.641341196327485L425.8910391039106,9.714680798103338L424.276477647765,8.54462016867334L422.258275827583,7.71610497242183L422.9646464646467,7.033953378702043L424.4782978297832,7.813566271675656L425.48739873987427,8.4471364233483L426.5974097409743,9.129589964859578L427.80833083308363,10.299900462025612L428.8174317431745,11.177988585169322Z", id: "Papua New Guinea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M39.50630063006312,-179.2948248797154L41.42359235923603,-180.69880768100998L45.76272627262738,-182.9493013897613L49.294579457945915,-184.5485079765775L52.120062006200726,-183.78936919932622L52.321882188218915,-182.61427395532257L55.04645464546464,-182.53060587971763L58.477397739774084,-181.94591949806764L63.62381238123825,-182.02934029961062L65.13746374637479,-181.5293423700393L65.74292429242934,-180.0368744217502L65.8438343834385,-177.98241067157554L66.65111511151125,-176.1917918315964L66.65111511151125,-174.33669222821592L64.93564356435652,-173.37554333607406L65.8438343834385,-171.3085575435662L65.8438343834385,-169.26233250423184L67.25657565756589,-165.38367561663236L66.95384538453861,-164.15770380778557L65.64201420142024,-163.62360299332715L63.018351835183616,-159.997437553716L63.82563256325644,-158.05899179789986L63.22017201720188,-158.2817569520023L60.495599559956155,-159.997437553716L58.477397739774084,-159.32442874623817L57.165566556655804,-159.7728632549907L55.551005100510174,-158.87694176788702L54.138263826382726,-160.37225939999306L52.927342734273545,-159.84769484712209L52.826432643264454,-160.07234871952232L51.5146014601461,-162.18074607431268L49.39548954895501,-162.4836799718876L49.193669366936824,-163.85233586148482L47.276377637763915,-164.3105557565444L46.77182718271838,-163.242937627185L45.258175817581844,-164.0813198686138L45.4599959996001,-165.30684011923512L43.34088408840894,-165.69130248677163L42.029052905290655,-167.15880436549105L40.91904190419057,-170.04691990216415L41.12086208620875,-171.54598598171148L40.414491449145025,-174.0158012951556L39.40539053905403,-175.70620227188553L40.21267126712685,-176.9223848804489Z", id: "Poland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-185.8259325932593,-52.78936118188517L-184.4131913191318,-52.532789244226315L-183.90864086408632,-51.9687856215027L-184.61501150115004,-51.200685653871616L-186.7341234123412,-51.200685653871616L-188.34868486848677,-51.098358238527965L-188.550505050505,-52.37890826208059L-188.1468646864686,-52.78936118188517Z", id: "Puerto Rico", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M359.69401940194035,-117.43218663485305L359.2903790379041,-116.56176125937205L358.07945794579473,-116.37562234187783L356.0612561256128,-116.18961705497156L355.0521552155217,-114.58311771618962L353.74032403240346,-114.70634422550675L353.63941394139437,-114.39838653146775L352.22667266726694,-115.07637230601468L351.9239423942396,-114.39838653146775L351.1166616661669,-114.09078993879515L351.0157515751577,-114.76797923343703L350.208470847085,-115.07637230601468L349.5021002100212,-115.63239952955429L350.208470847085,-117.24541951378137L350.9148414841487,-117.6190893615964L350.7130213021303,-118.30556523781718L351.4193919391941,-120.2501649772785L351.2175717571759,-120.81752819746404L349.6030103010303,-121.2596943341443L348.19026902690297,-122.20982022427262L350.51120112011216,-124.56904517803083L353.63941394139437,-126.56318142915866L355.5567056705673,-129.2258688203514L356.8685368536855,-128.05328232828228L359.2903790379041,-127.9233450790075L358.8867386738677,-129.87977841333847L363.22587258725883,-131.5224008354673L364.33588358835914,-133.6416451763044L366.1522652265229,-131.39057441189456L366.4549954995501,-130.7325333164501L365.44589458945916,-130.99553206464978L364.2349734973499,-129.68341872200205L363.4276927692772,-128.37843065529484L363.52860286028624,-125.72495822395892L362.0149514951497,-124.88958835499864L361.5104010401042,-124.24891750028186L360.5013001300131,-123.16356704391312L358.58400840084033,-122.59088179223171L357.37308730873104,-121.57600354662752L357.272177217722,-119.99841143817851L356.9694469446947,-119.621249197243L358.07945794579473,-119.05655322860457Z", id: "Democratic People's Republic of Korea", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-20.93884388438829,-112.06959807205915L-22.048854885488463,-111.15593338170349L-23.56250625062492,-111.64283224324554L-24.97524752475237,-111.27757505551267L-24.571607160716002,-114.02931381584241L-24.87433743374328,-116.18961705497156L-26.08525852585246,-116.56176125937205L-26.79162916291618,-117.9308962081159L-26.488898889888908,-120.2501649772785L-25.378887888788736,-121.57600354662752L-25.17706770677055,-123.036189888951L-24.672517251725093,-125.27479118682295L-24.672517251725093,-126.8216753488414L-25.277977797779645,-128.18328927709555L-25.378887888788736,-129.48721934465175L-24.369786978697736,-130.4041912490347L-23.25977597759765,-130.99553206464978L-22.55340534053392,-129.0952998391538L-20.837933793379204,-129.0952998391538L-20.33338333833374,-129.6180011378279L-18.71882188218811,-129.48721934465175L-17.911541154115294,-127.59880608871207L-19.223372337233652,-126.56318142915866L-19.32428242824274,-123.67372896935008L-19.72792279227911,-123.16356704391312L-19.8288328832882,-121.44943209792974L-21.039753975397463,-121.13328193667843L-19.929742974297294,-118.93123508619577L-20.73702370237011,-116.62383732071059L-19.72792279227911,-115.50873538364692L-20.131563156315554,-114.58311771618962L-21.140664066406554,-113.23142736654036Z", id: "Portugal", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-163.12116211621156,57.789984247728455L-162.21297129712963,59.45248424768818L-162.41479147914782,63.53086982038509L-159.48839883988393,64.1091218973497L-158.3783878387838,63.53086982038509L-156.46109610961088,64.31959099764424L-155.9565456545654,65.26800711849036L-155.65381538153807,68.02016691854637L-155.35108510851077,69.24347064625822L-154.24107410741067,69.35002318293039L-153.2319731973197,68.87076256776882L-152.22287228722863,69.4033102377762L-152.22287228722863,71.11233516511894L-152.62651265126505,72.93650635984514L-153.1310631063106,74.71549234090557L-153.63561356135608,77.48184773707906L-156.15836583658358,79.88576830639626L-158.3783878387838,80.37951170851734L-161.5066006600659,79.9405941365719L-164.3320832083208,79.06440986321915L-161.607510751075,74.28344306262406L-162.0111511151114,72.93650635984514L-164.83663366336629,71.70155611015878L-168.26757675767567,69.45660449274624L-170.58850885088506,68.97721482850022L-175.73492349234917,64.00392658682911L-174.62491249124906,60.390316303756705L-174.52400240023994,58.776367087774176L-173.21217121712164,56.185083240004296L-168.3684868486848,55.30726972166332L-165.7448244824482,55.35886158732448L-163.12116211621156,56.85744155709604Z", id: "Paraguay", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M99.14416441644181,-93.02792088270341L97.83233323332344,-92.57168442684588L97.93324332433254,-93.48483515663999L98.63961396139625,-93.88519487213844L97.93324332433254,-94.28608032358875L98.53870387038717,-96.47162793986422L99.54780478047817,-96.01019168546351L99.54780478047817,-93.99967978676317Z", id: "Palestine", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M143.9482448244826,-71.2230289613682L143.2418741874189,-71.0089285977805L142.33368336833698,-71.59799113783933L142.1318631863188,-73.85555061898633L142.93914391439162,-75.53062178839136L143.64551455145525,-75.85571129443257L144.55370537053716,-74.88130610998823L144.55370537053716,-73.04773080967169Z", id: "Qatar", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M74.52210221022114,-154.67204412893716L75.43029302930304,-154.23418361015095L76.23757375737586,-152.99837910788L77.14576457645776,-151.2656172668565L78.7603260326034,-148.76306611890644L78.86123612361249,-146.9927912820941L78.55850585058522,-145.30651319142999L79.06305630563068,-143.42453332618675L80.37488748874902,-142.73148153522553L81.6867186718673,-143.35513221530394L82.89763976397657,-142.66229324970837L82.99854985498567,-141.6269992966274L81.58580858085821,-140.80215120008398L80.7785278527854,-141.1454744557386L79.97124712471258,-136.4524353611541L78.35668566856695,-136.85675541475484L76.33848384838495,-138.27745971293373L73.00845084508468,-137.32935460036225L71.59570957095723,-136.3851170490797L67.45839583958406,-136.58713051254088L65.33928392839297,-137.1942278663368L64.22927292729288,-136.85675541475484L63.42199219922007,-138.48113296560075L62.917441744174525,-139.16134891916172L63.62381238123825,-139.84358668561967L62.917441744174525,-140.3223659244132L62.00925092509262,-139.43400038455147L60.39468946894699,-140.59640534116733L60.19286928692881,-142.2476075546462L58.477397739774084,-143.1470570254314L58.17466746674681,-144.39840373097408L56.66101610161027,-146.00757812425763L58.881038103810525,-146.78130623233125L60.596509650965245,-149.5465101244095L61.90834083408353,-152.34697365858983L63.62381238123825,-153.2159498667923L64.83473347334743,-154.08842746608235L66.55020502050216,-153.65174850816538L68.36658665866597,-153.65174850816538L69.67841784178432,-152.63624579463877L70.58660866086623,-153.28852205228338L72.70572057205732,-153.65174850816538L73.41209120912104,-154.67204412893716Z", id: "Romania", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M402.58080808080825,-165.53743201922217L405.4062906290631,-157.83645967788183L401.2689768976899,-159.24978193067412L399.5535053505353,-153.1434019961889L402.278077807781,-148.90530316667912L402.17716771677186,-146.07780599011127L400.0580558055808,-148.47886716216973L398.24167416741705,-145.37652068428923L397.63621362136234,-148.76306611890644L398.0398539853987,-152.78102656426455L397.63621362136234,-157.31812054556937L398.3425842584261,-160.59747245133696L398.4434943494352,-166.46237372927885L396.82893289328956,-170.9134572427738L397.03075307530776,-177.16650855719294L399.6544154415443,-179.37713832254028L398.54440444044417,-181.5293423700393L399.7553255325535,-182.27981412809197L400.4616961696172,-179.0480884525616L401.4707970797081,-174.57769549495896L401.36988698869914,-170.04691990216415ZM55.04645464546464,-182.53060587971763L55.651915191519265,-184.63303800378438L59.58740874087425,-186.24606897606847L62.513801380138155,-185.39545085331542L63.72472247224734,-184.63303800378438L63.42199219922007,-183.28489885537294L63.62381238123825,-182.02934029961062L58.477397739774084,-181.94591949806764ZM-490.57440744074404,-252.67843487434266L-488.6571157115712,-250.97274349385918L-489.36348634863486,-256.14054583327186L-481.6943194319432,-255.02022257632362L-476.2451745174517,-248.44491132109133L-478.96974697469744,-245.48220872690064L-483.6116111611161,-244.7785085148411L-483.71252125212527,-238.3421438841016L-484.8225322532253,-236.99275368265313L-487.446194619462,-237.21694355824556L-489.56530653065306,-239.47450286433948L-493.2989798979898,-241.3014231361068L-493.9044404440444,-244.1942264487162L-496.72992299229924,-245.36473033772586L-499.9590459045904,-244.4277074118692L-501.472697269727,-246.77966267833972L-500.8672367236724,-249.4036092025648L-504.19726972697276,-247.72930305167134L-502.98634863486353,-244.54456371207405L-504.5,-241.76110773598387L-504.5,-270.3159653523707L-497.6381138113812,-264.4533685544572L-490.37258725872584,-257.14246718458054ZM504.5,-285.6166840126681L501.3717871787181,-285.1726751064964L500.86723672367253,-287.8547043580618L504.5,-291.4974812080019L504.5,-285.6166840126681ZM-504.5,-291.4974812080019L-504.49949549999985,-291.49797632961815L-504.4999999999999,-285.61675088877354L-504.4999999999999,-285.61675088877354L-504.5,-285.6166840126681L-504.5,-291.4974812080019ZM-500.8672367236724,-286.0619896187242L-504.5,-285.61675088877354L-504.5,-291.49797632961815L-504.19726972697276,-291.8051477681577L-501.77542754275424,-291.8051477681577L-497.7390239023902,-289.36323196655593L-498.04175417541757,-288.1553388656938ZM402.4798979897992,-307.24830772282013L398.1407640764079,-307.07991150971566L392.48979897989824,-308.2622512269816L391.9852485248527,-308.7715317218681L394.60891089108924,-312.7283260103742L398.1407640764079,-313.6010199389491L402.0762576257628,-309.7947593146505ZM422.4600960096012,-326.5126358218565L419.1300630063009,-322.21945633828693L414.6900190019004,-323.1433780818555L409.4426942694271,-327.460787693651L410.1490649064909,-330.91967075057386L415.3963896389641,-329.3734847921686ZM406.6172117211724,-331.6982014097382L404.3971897189721,-323.5143875839088L394.10436043604386,-323.88622612469555L389.36158615861615,-321.3006332093872L383.81153115311554,-328.41438232919785L385.325182518252,-336.0467378219504L389.0588558855888,-338.2645913935633L396.4252925292532,-337.85912788785515ZM161.20387038703885,-284.58237199643816L159.58930893089322,-283.8473614590782L150.40649064906506,-285.02490716662805L149.70012001200132,-288.75821036962054L144.55370537053716,-291.19136109686093L144.1500650065008,-296.00749983566953L147.0764576457647,-297.90930271629884L146.97554755475562,-303.0882633768467L152.52560256025615,-311.34141736500806L149.90194019401952,-312.5543323703782L156.66291629162933,-321.4839927466131L155.8556355635565,-326.32365293357316L162.11206120612076,-332.2845073416512L171.39578957895802,-339.69159296999766L180.67951795179536,-341.95921246971994L185.52320232023214,-346.37671727483587L190.9723472347236,-347.8758978985302L192.88963896389657,-343.20934095483204L191.0732573257327,-339.4869800997357L181.0831583158317,-333.6606728510349L172.5058005800582,-328.41438232919785L163.82753275327548,-318.21399841753566L159.6902190219023,-308.43183953031917L155.25017501750187,-299.18919003728524L155.8556355635565,-291.65149239001653ZM-504.5,-270.3164141992074L-504.49949549999985,-270.3159653523707L-504.4999999999999,-241.76110773598387L-504.5,-241.76053581811783L-504.5,-270.3164141992074ZM504.5,-241.76053581811783L504.3990899089912,-241.6460747820137L500.86723672367253,-238.79422276065952L497.2344734473449,-239.24745349999628L499.75722572257246,-235.87601171847803L501.3717871787181,-230.61060200887894L502.68361836183635,-228.99633305999515L502.9863486348637,-226.44318540432513L502.27997799779996,-224.86557958584717L497.03265326532676,-226.12656296455734L489.26257625762594,-221.6480065834223L486.7398239823984,-220.9292618271788L482.4006900690072,-216.87549051556294L478.364286428643,-213.30205666241247L477.3551855185521,-210.76356758735216L473.31878187818796,-214.6835044382605L466.0532553255327,-210.27935534019898L464.7414241424145,-212.32159311184725L462.0168516851687,-209.89289194198375L458.2831783178321,-210.6666240993489L457.37498749875016,-207.11476103108726L454.0449544954497,-201.8640147731464L454.1458645864589,-199.74912980325107L457.37498749875016,-198.56411451340597L456.97134713471365,-191.07935030811402L454.3476847684771,-190.9046448342658L453.1367636763679,-186.6727687062858L454.3476847684771,-184.63303800378438L449.4030903090312,-182.11279631351155L448.49489948994926,-176.75980078891237L444.2566756675669,-175.54459932788743L443.4493949394942,-170.9134572427738L439.4129912991302,-166.69425652286512L438.40389038903913,-169.81122779183852L437.1929692969299,-176.5161715071469L435.5784078407842,-187.18604148109233L436.9911491149117,-194.16258796716644L439.312081208121,-197.20590124821632L439.4129912991302,-199.65771173350106L443.8530353035306,-200.8495993129109L448.7976297629765,-207.59080711129718L453.64131413141337,-213.40038952935285L458.6868186818685,-217.9813643862469L460.90684068406864,-226.33758303115388L457.57680768076835,-225.81049334416568L455.8613361336135,-220.9292618271788L448.69671967196746,-214.4855205406254L446.47669766976713,-221.6480065834223L439.2111711171119,-219.70367424125257L432.1474647464748,-210.08602321587642L434.46839683968415,-206.73479515013332L428.21197119712,-205.31675282020748L423.87283728372864,-204.7525255286587L424.07465746574684,-208.6424008655635L419.73552355235546,-209.50722999630167L416.304580458046,-206.82971427001505L407.7272227222725,-207.78156575129148L398.54440444044417,-206.1662893086304L389.46249624962513,-195.76772238741253L378.66511651165143,-183.95781364645694L383.1051605160518,-183.36888757454352L384.5179017901792,-180.36756524874312L387.242474247425,-179.2948248797154L388.9579457945796,-181.69586799426614L392.08615861586185,-181.36295670189838L396.1225622562258,-176.1917918315964L396.22347234723486,-172.25993800798753L394.0034503450347,-167.70210211187305L393.8016301630165,-162.4836799718876L392.48979897989824,-155.62380902755012L388.2515751575159,-149.5465101244095L387.34338433843396,-146.78130623233125L383.5088008800882,-142.0405492813035L379.7751275127515,-137.53219273688202L377.9587458745877,-135.24367287967846L374.2250725072509,-132.9773404764598L372.4086908690871,-132.91101268350016L370.6932193219325,-134.77528337673195L366.9595459545957,-131.98436932486806L366.4549954995501,-130.7325333164501L366.1522652265229,-131.39057441189456L366.05135513551375,-133.30925905434054L367.5650065006502,-133.44215728134495L367.9686468646867,-138.0061750440948L367.1613661366138,-141.35171733079125L369.58320832083234,-142.80069101593418L373.0141514151416,-142.0405492813035L374.83053305330543,-146.00757812425763L375.8396339633966,-150.4760166636491L376.94964496449666,-151.98592424939255L378.3623862386241,-155.69719666096088L373.7205220522054,-154.52599175430902L371.298679867987,-152.85345320410175L367.06045604560484,-152.85345320410175L365.9504450445046,-156.80103804066624L362.6204120412043,-159.84769484712209L357.77672767276744,-161.19921980180237L356.6667166716673,-165.53743201922217L355.7585258525854,-168.24683658381812L354.6485148514853,-170.20419900677092L352.9330433043307,-174.81898694644153L350.51120112011216,-176.5161715071469L346.27297729773,-177.9006705398089L342.53930393039315,-177.81896381623775L339.1083608360837,-176.9223848804489L336.78742874287457,-174.65809391438407L338.301080108011,-173.5354179868665L338.4019901990202,-170.9924160715487L336.78742874287457,-169.57580680828846L334.264676467647,-164.84642322008452L334.264676467647,-162.86296441404L330.329182918292,-160.1472864612845L326.99914991499173,-161.80269296584743L323.66911691169133,-161.4253192726159L322.15546554655486,-162.86296441404L320.4399939994002,-163.3190152195687L316.40359035903606,-160.2972417757189L312.66991699169944,-159.5485272158695L310.1471647164719,-158.50475581333686L306.6153115311533,-159.17516140990605L303.99164916491674,-159.17516140990605L302.2761776177619,-161.34992577292044L299.5516051605162,-163.47125357116175L296.72612261226146,-164.00496391617412L293.1942694269428,-163.47125357116175L290.57060706070627,-162.6353113117805L286.5342034203423,-164.5400442699755L286.02965296529675,-167.85759348852892L282.69961996199635,-168.9493368225766L280.17686768676896,-169.49739325615022L277.0486548654867,-171.38766960593992L274.1222622262228,-166.69425652286512L275.2322732273229,-164.0813198686138L272.5077007700771,-161.04862169337073L268.47129712971315,-162.18074607431268L265.74672467246745,-162.33215829743614L263.8294329432944,-164.3870238213299L260.9030403040305,-164.46351998324428L258.4811981198122,-165.7682805655061L254.24297429742998,-163.69981942405738L248.89473947394754,-159.997437553716L245.8674367436745,-159.24978193067412L244.7574257425744,-158.87694176788702L243.34468446844696,-161.50073981680416L239.71192119211932,-160.89813123807582L238.5010001000102,-162.7870525317744L236.58370837083723,-163.62360299332715L235.17096709670977,-166.1536005420464L233.6573157315733,-167.00383892579103L229.62091209120933,-165.84528724527368L225.78632863286353,-168.4027403015922L224.2726772677269,-166.0764791743682L218.01625162516274,-177.65565045453909L214.38348834883507,-181.36295670189838L215.49349934993518,-182.86549118565497L208.4297929792981,-178.3097059782602L205.7052205220524,-178.06418424638397L206.00795079507967,-180.61594523265617L202.37518751875203,-182.27981412809197L199.44879487948813,-181.11363996987464L198.54060406040622,-186.16084064465113L193.49509950995113,-187.18604148109233L190.9723472347236,-185.14098389043392L184.0095509550957,-183.36888757454352L182.59680968096825,-182.19628757718303L172.10216021602173,-180.5331173687918L170.89123912391256,-178.88376706311385L172.90944094409454,-175.70620227188553L170.1848684868488,-174.4973290960303L170.68941894189436,-173.2157948137315L168.06575657565773,-170.9924160715487L172.60671067106725,-167.85759348852892L171.90034003400353,-165.7682805655061L167.96484648464866,-165.99938652130834L167.15756575657585,-164.69317732882007L163.52480248024818,-166.92639980883794L159.08475847584776,-166.84898972193514L156.15836583658376,-164.99978216656402L152.8283328332835,-166.77160863621944L146.57190719071923,-169.88976166296342L142.23277327732788,-169.81122779183852L136.48089808980907,-164.92308854747515L136.0772577257727,-161.72716397992357L133.2517751775179,-164.23411576123536L131.03175317531765,-159.47380136338762L131.83903390339046,-158.57914081876297L130.22447244724484,-155.4037965592781L132.54540454045417,-152.56389161930989L134.66451645164528,-152.63624579463877L136.3799879988,-149.90354646135415L136.1781678167818,-147.7699668173321L137.59090909090926,-147.13389336400417L136.2790779077909,-144.747240892162L133.55450545054518,-144.05010821336555L130.82993299329948,-139.98027846857767L133.352685268527,-136.2505388647929L133.04995499549972,-133.6416451763044L136.0772577257727,-129.16057548600796L134.4626962696271,-127.66367918975254L133.95814581458163,-126.75702620142187L132.74722472247237,-127.01572567132133L130.82993299329948,-129.2258688203514L130.02265226522667,-129.35650861388103L128.20627062706282,-130.27298043855072L127.39898989899002,-131.78627291931437L124.77532753275338,-132.57965242224435L123.05985598559867,-131.98436932486806L122.55530553055321,-132.71214085203064L118.82163216321649,-134.57483143855146L114.68431843184332,-135.17670265587498L112.26247624762487,-135.84727057632432L111.9597459745976,-135.3776709190678L108.32698269826997,-138.68498654567335L105.1987698769878,-140.1170520056442L102.77692769276943,-142.45485537111196L104.79512951295143,-143.0777412780506L107.11606160616078,-146.4996390338186L105.50150015001515,-148.05325402239748L109.63881388138824,-149.76066221733552L109.63881388138824,-150.69107950764726L107.11606160616078,-149.97502350309435L107.21697169716988,-151.84167214285637L108.62971297129724,-152.99837910788L111.35428542854297,-153.28852205228338L111.75792579257941,-154.67204412893716L111.15246524652478,-157.02249149582772L112.26247624762487,-159.24978193067412L112.26247624762487,-160.5223747119036L108.12516251625178,-161.95383249383227L106.51060106010615,-161.8782491283136L104.79512951295143,-163.92863592295623L102.57510751075125,-163.242937627185L99.04325432543271,-164.76978615648855L99.14416441644181,-165.69130248677163L98.13506350635082,-167.62440041935042L95.91504150415055,-167.77983312517145L95.61231123112327,-169.1840387880637L96.31868186818699,-170.12554433106115L94.50230023002318,-172.73730344625596L91.67681768176828,-172.25993800798753L90.76862686268638,-172.49848041588805L90.06225622562272,-171.46681240826345L89.05315531553165,-171.6251903575002L88.34678467846801,-174.57769549495896L87.74132413241338,-176.11077871626642L88.24587458745891,-176.59734839914566L90.4658965896591,-176.43502743835043L91.5759075907592,-177.41093010509704L90.76862686268638,-178.63753861262234L88.85133513351347,-179.5418673729234L89.05315531553165,-180.36756524874312L87.94314431443156,-181.19671069374965L86.12676267626775,-184.37955695901428L86.73222322232238,-185.73525485060614L86.53040304030421,-188.0445082658126L83.7049204920493,-189.16620372784845L82.29217921792193,-188.64769410098708L81.88853885388549,-189.85971048915653L78.96214621462158,-191.07935030811402L78.05395539553967,-194.07380652185316L77.7512251225124,-196.5753651264552L76.43939393939404,-197.83852889432367L77.6503150315033,-199.47500762322107L76.84303430343049,-204.47104645756266L78.7603260326034,-207.59080711129718L78.35668566856695,-208.5465560775398L81.58580858085821,-211.63834534324536L78.6594159415943,-214.2877489237992L84.61311131113122,-221.6480065834223L87.23677367736784,-225.1800038238669L88.24587458745891,-228.24792827489878L84.10856085608576,-232.56705018157342L85.31948194819493,-236.65699651438774L82.79672967296739,-241.53111643551455L84.61311131113122,-247.2538426239943L81.38398839884003,-255.26856243963346L84.00765076507666,-260.69532055779365L79.6685168516853,-265.7683987216048L80.07215721572167,-271.1310898518859L82.39308930893102,-271.81332443903204L87.13586358635874,-274.9869917776357L89.96134613461356,-277.79528749722743L94.60321032103228,-273.048214971254L102.27237723772389,-271.1310898518859L112.8679367936795,-262.4993774758172L114.9870487048706,-258.9098202491445L115.18886888688886,-254.15380389873297L112.0606560656067,-250.48843669860796L107.51970197019716,-248.5644629680492L95.00685068506864,-253.9070428970531L92.98864886488663,-253.04611199539406L97.52960296029617,-247.96751583027952L97.73142314231436,-244.7785085148411L97.93324332433254,-238.0038367238239L101.46509650965108,-236.09880173475523L103.68511851185134,-234.4346095214744L104.0887588758877,-237.55375799552473L102.37328732873299,-240.27146819829983L104.1896689668968,-242.79977946684141L110.9506450645066,-238.68109530923914L113.27157715771595,-240.27146819829983L111.35428542854297,-245.13000792736426L117.91344134413458,-251.9453895611566L120.5371037103712,-251.5800143377478L123.16076607660784,-249.04348429896686L124.77532753275338,-253.9070428970531L122.45439543954411,-258.15018451319236L123.76622662266239,-262.628959847733L121.7480248024804,-267.22658845679325L129.61901190119028,-264.8468283556316L131.13266326632674,-260.69532055779365L127.60081008100828,-259.80027672392805L127.60081008100828,-255.766304841525L129.82083208320847,-253.29166006126894L134.15996599659982,-254.7722354743813L134.86633663366354,-259.418093781075L140.71912191219135,-263.0182895044817L150.50740074007413,-269.5046841206592L152.62651265126533,-269.10047260493167L149.90194019401952,-264.4533685544572L153.33288328832896,-263.66912354677186L155.35108510851106,-266.2972257232824L160.59840984098423,-266.42968588428243L164.73572357235736,-269.63963241638044L167.96484648464866,-265.1096331647197L171.09305930593072,-270.1804859731944L168.16666666666683,-274.7086781515473L169.68031803180335,-277.37109444141026L177.9549454945496,-274.9869917776357L181.78952895289547,-272.4982783095549L191.9814481448146,-263.66912354677186L193.79782978297848,-267.6264241270781L190.9723472347236,-271.81332443903204L190.87143714371453,-273.46182663839056L187.54140414041424,-274.15340261767176L188.44959495949615,-278.0786685342655L186.9359435943596,-284.58237199643816L186.8350335033505,-287.25502784727354L192.08235823582376,-295.22136250490894L193.89873987398758,-303.74698592930946L196.0178517851787,-305.57190252827513L203.384288428843,-303.0882633768467L203.98974897489768,-297.90930271629884L201.36608660866102,-290.5797907689555L203.08155815581574,-287.8547043580618L203.98974897489768,-281.8060512267343L203.2833783378339,-270.72304475058297L206.4115911591161,-266.0326098287171L205.20067006700685,-261.0803278185884L199.7515251525154,-250.85154135298876L202.98064806480664,-249.76447400259505L204.09065906590678,-252.3115285720338L207.11796179617974,-254.15380389873297L207.92524252425255,-257.645596793066L210.347084708471,-261.2088536234799L208.6316131613163,-265.5045910686216L209.94344434443462,-270.5872445599875L206.91614161416157,-271.1310898518859L206.20977097709786,-275.54497859634023L208.4297929792981,-283.8473614590782L204.7970297029705,-290.88529994697745L209.84253425342547,-296.95572202417793L209.2370737073709,-303.58206312572656L210.64981498149828,-303.74698592930946L212.06255625562574,-298.5480317305691L210.95254525452566,-289.970419943379L213.9798479847987,-288.30585605437847L212.66801680168038,-294.751430323972L217.410791079108,-298.2283647716207L223.16266626662681,-298.70809280332446L228.40999099910007,-293.65997712509005L225.8872387238725,-301.2899690788277L225.58450845084533,-311.514153603512L230.42819281928206,-313.42611640376856L237.18916891689193,-313.0768572509053L243.24377437743794,-314.302469793833L241.02375237523776,-319.84097679038496L244.25287528752887,-326.70183385990464L247.4819981998201,-327.0808774185101L252.93114311431157,-332.67653299925814L260.297579757976,-334.05597111430563L261.3066806680669,-337.2527897556914L268.67311731173135,-338.2645913935633L270.8931393139315,-335.64666532370785L277.2504750475049,-341.95921246971994L282.3968896889691,-341.7517745257213L283.10326032603285,-347.01755508292143L285.82783278327855,-352.2359795041114L292.3869886988701,-357.62524464873843L297.230673067307,-353.3442778656852L293.396089608961,-350.2596505832128L299.75342534253434,-348.3067509056424L300.56070607060724,-342.3748714730493L303.0834583458348,-345.31415599041105L311.25717571757195,-345.1024624567586L317.6145114511453,-339.28262013139556L319.8345334533455,-334.84940857719096L319.1281628162818,-329.18122051158724L319.1281628162818,-329.18122051158724L315.99994999499967,-325.9463305837091L308.63351335133524,-320.02273615750755L306.6153115311533,-316.7809985961057L310.04625462546267,-315.3601961321406L314.18356835683585,-312.90250083928606L316.7063206320634,-314.8304959625952L318.11906190619084,-308.43183953031917L319.32998299829995,-310.9964787559514L323.87093709370953,-312.5543323703782L332.8519351935196,-310.82427562134234L333.55830583058327,-306.2404564387772L345.2638763876389,-304.9060002427558L345.3647864786481,-312.3805195267673L351.318481848185,-310.65224942599366L355.8594359435946,-310.65224942599366L360.4003900390041,-305.57190252827513L361.6113111311134,-299.5106862597443L359.99674967496776,-295.69260563323616L363.52860286028624,-288.60729155466544L367.9686468646867,-285.1726751064964L370.59230923092326,-294.4388667220275L375.13326332633284,-290.42724251293095L379.87603760376055,-292.7300207278473L385.325182518252,-289.970419943379L387.34338433843396,-292.5755238047655L391.9852485248527,-291.19136109686093L389.96704670467074,-299.671664711681L393.7007200720073,-303.74698592930946L418.92824282428273,-297.5908431628119L421.3500850085011,-292.2669524851827L428.7165216521655,-285.61675088877354L440.01845184518476,-287.25502784727354L445.56850685068525,-285.9134470935971L447.88943894389456,-282.38679138398066L447.5867086708674,-276.3853815265281L451.0176517651768,-274.01486420561537L454.7513251325135,-275.6847596966072L459.7968296829685,-275.9646645628825L465.04415441544177,-274.2920530240701L470.39238923892407,-275.2657580666869L475.236073607361,-268.2948838346133L478.66701670167043,-270.72304475058297L476.4469946994702,-275.8246549522944L477.65791579157934,-279.35972944168157L486.6389138913894,-277.0888823310121L492.4916991699172,-277.65377288544795L500.56450645064535,-273.73812259106944L504.5,-270.3164141992074L504.5,-241.76053581811783ZM294.4051905190521,-365.815653127805L278.6632163216323,-360.61991160826295L283.80963096309654,-379.0537318774976L286.02965296529675,-380.88504519674416L288.14876487648775,-379.8360692426939L295.31338133813404,-371.67803085710574ZM143.2418741874189,-400.1294295818108L139.50820082008215,-398.0702502215822L136.98544854485465,-396.61518725945837L136.58180818081826,-394.0283816999412L133.352685268527,-391.2015007266973L130.325382538254,-395.1730060807898L131.83903390339046,-400.4257355567666L125.68351835183529,-401.01997039601054L131.13266326632674,-404.02413076900734L135.370887088709,-404.32761992929323L135.9763476347636,-399.53843056936495L137.59090909090926,-403.7212066713771L140.2145714571459,-406.776134838883L144.35188518851896,-402.8158035342283ZM280.0759575957598,-373.9316672548746L273.9204420442046,-372.17616486150024L266.1503650365038,-376.47265109207393L261.5085008500852,-382.2058061629962L259.2884788478849,-393.45907013580677L255.55480548054825,-396.61518725945837L262.8203320332035,-408.6370206382388L268.87493749374954,-412.7435398886148L274.324082408241,-403.7212066713771L280.7823282328235,-387.59832614657347Z", id: "Russia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M85.31948194819493,6.790359183687252L83.90674067406756,6.595495096790317L82.99854985498567,8.2034405867717L81.28307830783093,8.008497533624597L81.58580858085821,6.4493534166387105L81.98944894489465,6.254506125975437L82.09035903590375,4.549953248746317L82.89763976397657,3.7709112947846215L83.50310031003112,4.0630406455894015L85.21857185718584,3.186689054122882L86.32858285828593,4.793424953632565L86.12676267626775,6.4493534166387105Z", id: "Rwanda", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-24.369786978697736,-80.71278979019303L-24.369786978697736,-80.49305091107814L-24.369786978697736,-79.83466720507121L-24.369786978697736,-75.0976173152805L-33.55260526052598,-75.25993416742483L-33.55260526052598,-67.38699636364119L-36.17626762676261,-67.12197090714987L-36.78172817281717,-65.53541692783999L-36.2771777177717,-61.176890026313835L-47.27637763776369,-61.176890026313835L-47.88183818381831,-60.18527439513137L-47.78092809280914,-61.49049327570507L-47.68001800180004,-61.43821055999662L-41.42359235923579,-61.69968637776735L-41.01995199519942,-62.79959828952928L-39.90994099409933,-64.16529616604903L-39.00175017501743,-68.34253133301475L-35.06625662566244,-71.65158704539085L-33.75442544254417,-75.58478330866089L-32.84623462346226,-75.80150962149472L-31.93804380438035,-78.24866236762198L-29.617111711170995,-78.57621682283326L-28.608010801079995,-78.19409933870047L-27.296179617961723,-78.19409933870047L-26.387988798879817,-78.90407466228153L-24.672517251725093,-79.0134283122789L-24.773427342734188,-80.71278979019303Z", id: "Western Sahara", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M97.93324332433254,-86.08542130243876L101.0614561456147,-85.58327763292432L102.27237723772389,-86.58833553985372L102.87783778377853,-87.76483321355211L105.0978597859787,-88.21415149834914L105.50150015001515,-89.28381340543069L106.40969096909707,-89.8482396296328L103.68511851185134,-93.08499800242544L109.23517351735187,-94.74488297896008L109.84063406340651,-95.26186771052738L113.17066706670677,-94.34339277691808L117.30798079807994,-92.05922278912612L125.27987798779894,-85.52753119317327L130.4262926292631,-85.30463964843162L132.94904490449065,-84.97058406198143L133.65541554155428,-83.47147236933912L135.67361736173635,-83.52687539670255L136.78362836283645,-80.76774631133407L138.09545954595472,-80.05399011635528L138.60001000100027,-78.95874724689143L140.5173017301732,-77.64892837704683L140.71912191219135,-76.34388960494653L140.4163916391641,-75.31405571868203L140.71912191219135,-74.28710235232528L141.52640264026417,-73.37065014152115L141.93004300430061,-72.40271957087205L142.33368336833698,-71.59799113783933L143.2418741874189,-71.0089285977805L143.9482448244826,-71.2230289613682L144.55370537053716,-70.04693726828388L144.65461546154634,-69.35363560617964L145.66371637163732,-66.2221715713642L154.14016401640177,-64.69173606049952L154.64471447144732,-65.37709669417173L155.9565456545656,-63.21934874961347L154.14016401640177,-57.223388388486775L145.66371637163732,-54.22859003541496L137.59090909090926,-53.09741939142694L134.96724672467263,-51.76384723718639L132.94904490449065,-48.69934417199367L131.63721372137226,-48.190290017117285L130.93084308430855,-49.15789916361409L129.92174217421757,-49.005004469030176L127.19716971697183,-49.310837089880536L126.69261926192637,-49.61684324157387L123.46349634963511,-49.565830114218315L122.6562156215623,-49.25985296828929L121.54620462046222,-50.02512347292505L120.83983398339848,-48.59749549233167L121.04165416541666,-47.37677821137998L119.83073307330748,-46.4122637643252L119.5280028002802,-47.68170564278548L118.61981198119823,-48.54657826857887L118.41799179918004,-49.71888406363122L117.00525052505266,-50.79149623494671L115.49159915991613,-53.25151917656978L114.68431843184332,-55.67202861987171L112.7670267026704,-57.74164301771762L111.45519551955206,-58.20856567559254L109.63881388138824,-61.072405116744136L109.33608360836097,-63.16685751532694L109.43699369937005,-64.95520337675461L107.82243224322443,-68.34253133301475L106.51060106010615,-69.51351984309598L104.99694969496962,-70.15370792895783L104.0887588758877,-71.91967909784016L104.1896689668968,-72.61760126706938L103.48329832983316,-74.23313101872475L102.67601760176035,-74.93537201204806L101.56600660066017,-77.2678029173165L99.85053505350552,-79.77985800635608L98.43779377937807,-81.97901394405302L97.02505250525063,-81.97901394405302L97.42869286928708,-83.6931393171476L97.52960296029617,-84.80368256368004Z", id: "Saudi Arabia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M64.02745274527462,-31.424508521639755L64.02745274527462,-32.119321886348594L63.018351835183616,-32.91412231876378L63.018351835183616,-34.605741395475526L62.412891289129064,-35.70232574765941L61.40379037903807,-35.55269612478195L61.70652065206534,-36.60074879277739L62.412891289129064,-37.800405313440045L62.11016101610171,-39.00213684930659L63.018351835183616,-39.85465757048267L62.412891289129064,-40.5575598914303L63.22017201720188,-42.36855536900231L64.53200320032016,-44.48807684186861L66.85293529352951,-44.28589713738961L66.75202520252041,-55.930238349705526L66.75202520252041,-57.223388388486775L69.9811481148116,-57.223388388486775L69.9811481148116,-63.21934874961347L81.28307830783093,-63.21934874961347L92.18136813681383,-63.21934874961347L103.2814781478149,-63.21934874961347L104.1896689668968,-60.23740976397501L103.58420842084224,-59.716328105846685L103.98784878487862,-56.653967975029225L104.99694969496962,-53.09741939142694L106.10696069606979,-52.37890826208059L107.62061206120624,-51.25185690227232L106.20787078707889,-49.565830114218315L104.0887588758877,-49.10692946934912L103.2814781478149,-48.190290017117285L102.97874787478762,-46.26012164616849L101.76782678267844,-41.96566412868903L102.0705570557057,-40.80878029828456L101.56600660066017,-38.350937087620615L100.45599559956008,-35.50282633844522L98.74052405240535,-34.10782173843054L97.52960296029617,-31.920743771574646L97.32778277827798,-30.73027555446583L96.01595159515963,-29.937559890401605L95.10776077607771,-26.97113107488923L95.10776077607771,-26.625659679770248L94.70412041204136,-26.67500522451294L94.80503050305046,-28.107131213945543L94.50230023002318,-29.096088514571687L92.98864886488663,-30.185205198510292L92.68591859185936,-32.268287271059506L92.98864886488663,-34.35674089812391L91.67681768176828,-34.55593475898612L91.5759075907592,-33.908744554129335L89.86043604360447,-33.759470373367364L90.56680668066818,-32.963823563411786L90.76862686268638,-31.226097610216808L89.2549754975499,-29.640478345332546L87.84223422342248,-27.613050262099776L86.42949294929511,-27.31672617850045L84.00765076507666,-28.99714424922471L82.99854985498567,-28.403705967459736L82.6958195819583,-27.56365647519852L81.28307830783093,-27.020494191640378L81.18216821682184,-26.42830236432594L78.35668566856695,-26.42830236432594L77.95304530453058,-27.020494191640378L75.93484348434858,-27.11922801829336L74.92574257425758,-26.625659679770248L74.11846184618477,-26.872412410569495L72.70572057205732,-28.552029245373696L72.20117011701187,-29.294009866863473L70.18296829682978,-28.94767620228801L69.47659765976614,-27.613050262099776L68.77022702270241,-25.047891513423576L67.76112611261142,-24.55533739894315L66.85293529352951,-24.2106861269685L66.65111511151125,-24.35838017197814L65.74292429242934,-25.195703134908943L65.54110411041115,-26.033706084060217L65.9447444744476,-27.217972001119108L65.9447444744476,-28.403705967459736L64.33018301830197,-30.185205198510292Z", id: "Sudan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M98.84143414341445,-15.4305785590575L97.02505250525063,-13.573419274825469L95.20867086708681,-11.913291519463248L93.4931993199321,-10.595868113025155L91.5759075907592,-10.595868113025155L89.355885588559,-9.961812455980416L87.5395039503952,-10.595868113025155L86.32858285828593,-9.815514301679384L83.90674067406756,-11.669266463293505L83.20037003700385,-12.889672033488196L81.6867186718673,-12.303788965965158L80.37488748874902,-12.49906477830379L79.6685168516853,-12.0109091995402L78.35668566856695,-12.352606205564978L76.6412141214123,-14.648380194895534L76.23757375737586,-15.577280837913507L74.11846184618477,-16.6535015439252L73.41209120912104,-18.36722783088425L72.30208020802095,-19.592583129456774L70.38478847884805,-21.06451564500956L70.38478847884805,-21.997642819994088L68.77022702270241,-23.128209202192284L66.85293529352951,-24.2106861269685L67.76112611261142,-24.55533739894315L68.77022702270241,-25.047891513423576L69.47659765976614,-27.613050262099776L70.18296829682978,-28.94767620228801L72.20117011701187,-29.294009866863473L72.70572057205732,-28.552029245373696L74.11846184618477,-26.872412410569495L74.92574257425758,-26.625659679770248L75.93484348434858,-27.11922801829336L77.95304530453058,-27.020494191640378L78.35668566856695,-26.42830236432594L81.18216821682184,-26.42830236432594L81.28307830783093,-27.020494191640378L82.6958195819583,-27.56365647519852L82.99854985498567,-28.403705967459736L84.00765076507666,-28.99714424922471L86.42949294929511,-27.31672617850045L87.84223422342248,-27.613050262099776L89.2549754975499,-29.640478345332546L90.76862686268638,-31.226097610216808L90.56680668066818,-32.963823563411786L89.86043604360447,-33.759470373367364L91.5759075907592,-33.908744554129335L91.67681768176828,-34.55593475898612L92.98864886488663,-34.35674089812391L92.68591859185936,-32.268287271059506L92.98864886488663,-30.185205198510292L94.50230023002318,-29.096088514571687L94.80503050305046,-28.107131213945543L94.70412041204136,-26.67500522451294L95.10776077607771,-26.625659679770248L95.20867086708681,-24.40761605850776L94.80503050305046,-23.521713897091313L93.2913791379139,-23.472518187904445L92.28227822782291,-21.850258663440858L93.99774977497763,-21.653774883935053L95.41049104910509,-20.279273736352923L95.91504150415055,-19.151328117556726L97.2268726872689,-18.514212872331633Z", id: "South Sudan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-46.16636663666359,-45.80393710367739L-45.25817581758169,-46.76741997930413L-43.84543454345424,-46.51371436032203L-42.43269326932687,-47.12279882820114L-40.91904190419033,-47.17358551899767L-39.60721072107197,-46.310831189386604L-37.68991899189907,-45.55065689742212L-35.97444744474435,-43.37693054525476L-34.15806580658053,-41.412109599845316L-34.05715571557144,-39.6038029138285L-33.45169516951681,-37.950506827576945L-32.44259425942581,-37.15033829452927L-32.24077407740763,-36.00167663465646L-32.34168416841672,-35.103988905875674L-32.74532453245317,-34.95447993004523L-34.25897589758963,-35.20367819143393L-34.46079607960789,-34.85482385591734L-35.06625662566244,-34.80500077672772L-37.08445844584452,-35.50282633844522L-38.49719971997189,-35.55269612478195L-43.64361436143606,-35.65244582434926L-44.34998499849977,-35.353237172779835L-45.35908590859078,-35.452959921022845L-46.77182718271814,-34.95447993004523L-47.27637763776369,-37.15033829452927L-44.65271527152705,-37.1003580341599L-44.04725472547241,-37.50029941122093L-43.54270427042696,-37.550308102512886L-42.53360336033596,-38.20074844062174L-41.3226822682267,-37.600320370625056L-40.11176117611752,-37.550308102512886L-38.90084008400833,-38.20074844062174L-39.40539053905379,-39.00213684930659L-40.3135813581357,-38.55123986333896L-41.2217721772176,-38.55123986333896L-42.33178317831769,-39.25276533197783L-43.2399739973996,-39.20263215318992L-43.84543454345424,-38.50115866331635L-46.87273727372724,-38.451081137448114L-48.0836583658365,-40.70828043447266L-49.49639963996386,-41.713988356054955L-48.18456845684559,-42.267808211611964L-46.87273727372724,-44.28589713738961Z", id: "Senegal", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M454.3476847684771,29.58761847016023L455.15496549654983,30.528668296230936L453.1367636763679,30.528668296230936L452.12766276627696,28.79593525881922L453.7422242224226,29.48861955505132ZM450.8158315831585,27.85670843365085L449.7058205820584,27.9061176379638L447.9903490349038,27.609701477870228L447.38488848884907,27.16525151880118L447.5867086708674,26.030362745582767L449.4030903090312,26.47429313671649L450.31128112811314,27.06651296311049ZM453.1367636763679,27.06651296311049L452.6322132213223,27.56030786618796L450.6140114011403,25.143089826925927L450.00855085508573,23.419989619635782L451.0176517651768,23.419989619635782L452.02675267526774,25.685220005849924ZM448.09125912591276,23.469182993476448L448.19216921692197,24.059675407727074L445.97214721472176,22.82983799802568L444.4584958495851,21.846928188477182L443.348484848485,20.864831152215654L443.7521252125214,20.619429505911132L445.0639563956398,21.257574829223493L447.38488848884907,22.58403229855783ZM441.5321032103212,20.668505986204032L440.92664266426664,20.81574696466629L439.7157215721574,20.177826807021365L438.60571057105733,19.049967968711382L438.7066206620665,18.559889358080966L440.42209220922115,19.736375844293764Z", id: "Solomon Islands", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-37.18536853685361,-25.047891513423576L-35.67171717171707,-26.280310350555784L-35.3689868986898,-27.06985983784346L-34.86443644364426,-27.662446636071305L-34.05715571557144,-27.761247164464056L-33.45169516951681,-28.30483711109034L-31.231673167316625,-28.25540666709295L-30.42439243924381,-27.26734781309064L-29.81893189318918,-26.08302205066274L-29.919841984198353,-25.24497837480348L-29.41529152915281,-24.5060946672552L-29.516201620161905,-23.472518187904445L-28.70892089208909,-23.620111896017566L-30.020752075207447,-22.29246650882726L-31.33258325832572,-20.76999223173086L-31.43349334933481,-19.935883099097513L-32.13986398639853,-19.053291104663526L-32.84623462346226,-19.249372234987483L-34.86443644364426,-20.377402223320217L-36.3780878087808,-21.899384677163887L-36.88263826382625,-22.93150870766786Z", id: "Sierra Leone", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-250.20657065706567,-38.05059258376281L-251.82113211321126,-38.25080767276648L-252.52750275027498,-38.85180450872307L-252.52750275027498,-39.25276533197783L-251.51840184018394,-40.00521608616468L-251.01385138513845,-40.30643664564345L-251.11476147614758,-40.658036358322924L-250.50930093009296,-40.85903609639476L-249.70202020202015,-40.6077961790486L-249.09655965596556,-40.00521608616468L-248.18836883688365,-39.55364336624699L-248.08745874587456,-39.15250272069243L-246.87653765376535,-39.50348760115913L-246.2710771077107,-39.30290226222235L-245.9683468346834,-39.00213684930659L-246.06925692569249,-37.85043554229188L-246.4728972897289,-37.15033829452927L-248.08745874587456,-37.20032209092652L-249.09655965596556,-37.50029941122093Z", id: "El Salvador", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M133.85723572357253,-22.489057059996508L131.5363036303632,-22.439906294202686L122.35348534853503,-25.836466507994658L121.34438443844402,-26.82305685341712L120.23437343734385,-28.20597887278574L119.22527252725286,-29.789006518375675L119.83073307330748,-30.779844662697002L120.83983398339848,-32.31794848248395L121.7480248024804,-31.771841811635642L122.35348534853503,-30.631146010832794L123.5644064406442,-29.3929870314002L124.97714771477166,-29.3929870314002L127.60081008100828,-30.135670478681913L130.72902290229038,-30.482473304118198L133.15086508650882,-31.37490136427477L134.5636063606362,-31.523731724847792L135.5727072707272,-32.06967282485451L137.18726872687282,-32.16897397792597L137.08635863586372,-32.119321886348594L137.08635863586372,-30.92856939175736L137.08635863586372,-28.057711339767398L137.08635863586372,-26.576316626163745L135.87543754375454,-24.85084206994533Z", id: "Somaliland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M116.50070007000713,4.744729749327345L114.8861386138615,2.4077903249217867L114.78522852285242,-7.768139010871559L117.30798079807994,-10.986137582608915L118.01435143514368,-11.864484329406642L119.83073307330748,-11.913291519463248L122.35348534853503,-13.866528254026315L125.98624862486265,-14.01309996537885L133.85723572357253,-22.489057059996508L135.87543754375454,-24.85084206994533L137.08635863586372,-26.576316626163745L137.08635863586372,-28.057711339767398L137.08635863586372,-30.92856939175736L137.08635863586372,-32.119321886348594L137.18726872687282,-32.16897397792597L137.99454945494563,-32.21862910451849L139.30638063806398,-32.66566263402216L140.82003200320042,-32.963823563411786L142.1318631863188,-33.908744554129335L143.2418741874189,-33.908744554129335L143.2418741874189,-33.112946001942426L143.0400540054007,-31.47411864019354L143.0400540054007,-29.987083303562244L142.43459345934608,-28.94767620228801L141.62731273127326,-25.885772767997356L140.315481548155,-22.68568110167652L138.60001000100027,-19.10230872535885L136.1781678167818,-14.941662980433607L133.75632563256337,-11.81567823329369L130.4262926292631,-7.963067566242288L127.70172017201737,-5.7220246445338L123.46349634963511,-2.9465764508572345L120.83983398339848,-0.8047699973549693L117.81253125312548,2.6025089816934055L117.10616061606176,4.0630406455894015Z", id: "Somalia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M63.42199219922007,-138.48113296560075L62.71562156215634,-137.59984499620404L63.018351835183616,-136.18327895768655L64.33018301830197,-134.5080521903453L63.32108210821097,-133.30925905434054L62.816531653165434,-132.11652543080137L63.11926192619271,-131.65430029477523L62.71562156215634,-131.12714015531202L61.40379037903807,-131.0613270369069L60.39468946894699,-130.86399649441603L60.2937793779379,-131.12714015531202L60.69741974197434,-131.5883414275672L61.000150015001616,-132.51343599530549L60.596509650965245,-132.4472380717524L59.99104910491062,-133.17643563426716L59.58740874087425,-133.37569880865786L59.183768376837804,-133.97450092693774L58.67921792179227,-134.24112506795578L58.2755775577559,-134.77528337673195L57.771027102710356,-134.57483143855146L57.367386738673986,-133.2428380017517L56.76192619261936,-132.9773404764598L56.96374637463763,-133.30925905434054L55.853735373537454,-134.10777519226048L54.945544554455545,-134.5080521903453L54.541904190419174,-135.04281971434025L53.835533553355454,-135.7130027717005L54.440994099410084,-135.9144334899488L54.844634463446454,-137.73520894233232L53.53280328032818,-139.22948141286477L54.2391739173919,-140.93941838488473L53.230073007300824,-140.93941838488473L54.34008400840099,-142.45485537111196L53.43189318931909,-143.56339973659837L52.72552255225536,-145.16656396337L54.844634463446454,-146.21832818976537L56.66101610161027,-146.00757812425763L58.17466746674681,-144.39840373097408L58.477397739774084,-143.1470570254314L60.19286928692881,-142.2476075546462L60.39468946894699,-140.59640534116733L62.00925092509262,-139.43400038455147L62.917441744174525,-140.3223659244132L63.62381238123825,-139.84358668561967L62.917441744174525,-139.16134891916172Z", id: "Serbia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-151.31468146814672,-16.115301018344393L-152.72742274227417,-13.71996806483214L-152.52560256025595,-11.81567823329369L-151.41559155915584,-10.10811886802566L-151.92014201420136,-8.937891965537345L-152.12196219621953,-7.621950115084152L-152.82833283328324,-6.452655965680684L-154.44289428942886,-7.037256432330943L-155.75472547254716,-6.744945032199435L-156.96564656465637,-7.037256432330943L-157.16746674667462,-6.209098104201242L-156.7638263826382,-5.624616409595504L-156.96564656465637,-5.08890713156123L-158.4792979297929,-5.283703642018867L-160.1947694769476,-7.719408670177772L-160.598409840984,-9.327911861974366L-161.5066006600659,-9.327911861974366L-162.71752175217517,-11.376471848030993L-162.21297129712963,-12.84084201192193L-162.41479147914782,-13.475726353664788L-160.6993199319931,-14.208547049838772L-160.1947694769476,-16.751376037936424L-156.8647364736473,-16.164220794870275L-156.56200620061998,-16.702438018171495L-154.34198419841977,-16.898199416284655Z", id: "Suriname", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M63.22017201720188,-158.2817569520023L62.412891289129064,-157.17025482820864L61.80743074307444,-155.47710900057626L61.302880288028895,-155.03760912258295L58.2755775577559,-156.35881827260255L57.367386738673986,-156.06451198457782L56.66101610161027,-155.11079671978803L55.349184918492,-154.5990055635289L55.04645464546464,-154.81819562237962L53.73462346234637,-154.16129323024836L52.62461246124627,-154.08842746608235L52.321882188218915,-153.2159498667923L50.00095009500964,-152.7086241020381L48.99184918491864,-153.1434019961889L47.579107910791194,-154.23418361015095L47.276377637763915,-155.69719666096088L47.4781978197821,-156.21161456853704L47.88183818381847,-157.17025482820864L49.09275927592773,-157.09636037615158L50.10186018601874,-157.54011152319455L50.20277027702783,-157.91061119999458L50.70732073207336,-158.1332209234009L50.909140914091545,-159.10056715856487L51.5146014601461,-159.32442874623817L51.91824182418255,-160.07234871952232L52.826432643264454,-160.07234871952232L52.927342734273545,-159.84769484712209L54.138263826382726,-160.37225939999306L55.551005100510174,-158.87694176788702L57.165566556655804,-159.7728632549907L58.477397739774084,-159.32442874623817L60.495599559956155,-159.997437553716Z", id: "Slovakia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M45.35908590859101,-148.97645615762292L45.86363636363647,-148.90530316667912L46.36818681868201,-147.55773927150724L44.148164816481746,-146.42927796596712L43.84543454345447,-144.81707354058406L42.93724372437257,-144.39840373097408L42.93724372437257,-143.28575247456453L41.82723272327248,-143.35513221530394L40.81813181318147,-144.05010821336555L40.313581358135934,-143.35513221530394L38.39628962896303,-143.49395582676138L39.00175017501766,-143.8413898607527L38.29537953795394,-145.58667492039254L38.598109810981214,-147.55773927150724L40.91904190419057,-147.2750852785407L42.331783178317934,-148.19503392243496L44.85453545354547,-148.26595802067237Z", id: "Slovenia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M30.82803280328042,-205.12848851400156L32.13986398639877,-208.25931696822738L34.460796079608045,-212.12612218732423L35.368986898689954,-218.78984553411973L33.55260526052614,-221.85388371326522L33.350785078507954,-229.85547507791162L35.16716671667177,-235.76472087073662L37.992649264926584,-235.65349933429155L39.00175017501766,-238.22930338051157L37.992649264926584,-240.49983102806598L42.331783178317934,-250.00546324105346L45.05635563556366,-257.77160666633836L46.97364736473657,-263.0182895044817L49.597309730973194,-263.0182895044817L50.40459045904601,-267.22658845679325L55.651915191519265,-266.0326098287171L56.05555555555571,-271.1310898518859L57.771027102710356,-271.40365885503377L61.50470047004716,-267.6264241270781L65.9447444744476,-262.4993774758172L66.0456545654567,-251.33685346197643L66.95384538453861,-248.684095967386L62.11016101610171,-246.77966267833972L59.385588558855986,-241.99139789649993L59.89013901390153,-238.0038367238239L55.349184918492,-232.8952082180332L50.00095009500964,-227.50261446085776L47.88183818381847,-219.09394834496464L49.90004000400055,-215.08011119425896L52.62461246124627,-211.9308573365979L50.00095009500964,-205.69384930129215L47.07455745574573,-204.37731374122998L46.065456545654655,-195.58870850879958L44.4508950895091,-190.81735123790634L41.01995199519966,-191.25421378137017L39.50630063006312,-187.3574327481068L36.17626762676277,-187.10040226371976L35.368986898689954,-191.7797557070826L32.94714471447159,-197.65756374201433Z", id: "Sweden", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M89.15406540654082,75.03986082764973L89.55770577057719,76.44878184686843L89.86043604360447,77.80869729551247L89.2549754975499,79.22852780163946L87.64041404140428,79.55699388807517L85.92494249424956,77.86320130021714L85.92494249424956,76.7746935527584L86.73222322232238,75.58111111952975L86.93404340434056,74.71549234090557L87.74132413241338,74.49940474733681Z", id: "Swaziland", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M100.0523552355237,-97.04942772911319L100.0523552355237,-97.10726942814134L100.35508550855099,-97.62835260982351L100.35508550855099,-98.96420261924746L101.0614561456147,-100.83298921763826L102.57510751075125,-102.06598085923251L102.0705570557057,-103.42253359254089L100.85963596359652,-103.59995436722012L100.55690569056917,-106.21508549674039L101.2632763276329,-107.65195804934797L101.96964696469661,-108.37322091033872L102.77692769276943,-109.15674546098077L102.87783778377853,-111.09513325175755L103.88693869386952,-110.4272392874917L106.91424142414252,-111.39927202697089L108.42789278927906,-110.73062162391348L110.74882488248842,-110.73062162391348L113.97794779477958,-112.06959807205915L115.49159915991613,-112.00858968208205L118.61981198119823,-112.55816946996929L117.20707070707084,-110.36660384487423L115.69341934193432,-109.51913532446939L115.8952395239525,-106.99246195213692L114.8861386138615,-102.83193249897725L108.62971297129724,-99.31368736611616L103.18056805680581,-95.7797397285621Z", id: "Syria", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M41.52450245024512,-65.79941830617089L44.4508950895091,-67.49305510406698L55.551005100510174,-61.69968637776735L66.75202520252041,-55.930238349705526L66.85293529352951,-44.28589713738961L64.53200320032016,-44.48807684186861L63.22017201720188,-42.36855536900231L62.412891289129064,-40.5575598914303L63.018351835183616,-39.85465757048267L62.11016101610171,-39.00213684930659L62.412891289129064,-37.800405313440045L61.70652065206534,-36.60074879277739L61.40379037903807,-35.55269612478195L62.412891289129064,-35.70232574765941L63.018351835183616,-34.605741395475526L63.018351835183616,-32.91412231876378L64.02745274527462,-32.119321886348594L64.02745274527462,-31.424508521639755L62.211071107110804,-30.92856939175736L60.798329832983434,-29.739494333961126L58.78012801280144,-26.67500522451294L56.15646564656481,-25.343535932202006L53.43189318931909,-25.540679490563203L52.72552255225536,-25.24497837480348L52.927342734273545,-24.25991521094031L51.5146014601461,-23.275757176340587L50.30368036803692,-22.145045392953346L46.77182718271838,-21.06451564500956L46.065456545654655,-21.702892796863054L45.560906090609194,-21.752012727970705L45.05635563556366,-21.06451564500956L42.73542354235438,-20.819074616432324L43.239973997399844,-21.604658984508763L42.331783178317934,-23.570911798223825L41.92814281428157,-24.703079360106468L40.717221722172305,-25.195703134908943L39.10266026602675,-26.872412410569495L39.70812081208131,-28.20597887278574L40.91904190419057,-27.909467480356916L41.72632263226339,-28.107131213945543L43.34088408840894,-28.107131213945543L41.82723272327248,-30.68070933880795L41.92814281428157,-32.56630038567768L41.72632263226339,-34.50613139601044L40.616311631163214,-36.30115061884937L40.81813181318147,-37.70035565773935L39.10266026602675,-37.75037868696053L39.10266026602675,-39.6038029138285L37.89173917391749,-40.658036358322924L39.10266026602675,-44.48807684186861L42.73542354235438,-47.22437679721681L42.83633363336347,-51.047202060211504L43.946344634463564,-57.068023686871705L44.5518051805182,-58.36431125418033L43.34088408840894,-59.40396779338598L43.34088408840894,-60.341698711354496L42.230873087308844,-61.1246444846567Z", id: "Chad", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M0.050455045504665466,-31.027733763721287L2.4722972297231114,-30.978150119215698L2.0686568656866635,-29.49197523996061L2.9768476847685714,-28.650924815915257L3.98594859485957,-27.662446636071305L4.086858685868662,-26.230984601012867L4.591409140914202,-25.68856219730808L4.49049904990511,-19.151328117556726L5.1968696869688324,-17.240842250101682L2.875937593759479,-16.604566610604515L2.2704770477048477,-17.632529917828652L1.5641064106412041,-19.39645181322222L1.3622862286229405,-20.819074616432324L1.9677467746775719,-23.374133326511075L1.2613761376138486,-24.40761605850776L0.9586458645865727,-26.625659679770248L0.9586458645865727,-28.700376631265716L-0.15136513651351843,-30.185205198510292Z", id: "Togo", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M286.2314731473149,-17.43667316794153L285.323282328233,-16.31098911299735L283.5069006900692,-15.96855061312221L283.20417041704184,-17.387713028237833L280.9841484148417,-18.612211472191767L280.47959795979614,-18.12228674273681L279.369586958696,-19.20034928588873L278.8650365036505,-20.62275663574487L277.35138513851405,-22.194183698337913L276.0395539553958,-23.570911798223825L275.53500350035023,-21.899384677163887L275.0304530453047,-23.472518187904445L275.33318331833203,-25.24497837480348L276.14046404640476,-27.958879477791857L277.55320532053224,-30.87899157644864L279.06685668566865,-33.56048281983873L277.9568456845686,-36.15139817137067L278.05775577557773,-37.50029941122093L277.6541154115414,-39.102377029320834L275.8377337733776,-41.412109599845316L275.13136313631384,-42.87253653258831L276.14046404640476,-43.37693054525476L277.14956495649585,-45.955958462896604L276.0395539553958,-47.88508337330623L274.22317231723196,-50.02512347292505L272.9113411341135,-52.584093252989234L274.02135213521376,-53.148780737389174L275.33318331833203,-56.34366355247509L277.35138513851405,-56.447075849900415L278.96594659465967,-57.74164301771762L280.5805080508053,-58.468170862981204L281.7914291429144,-57.534272218429535L281.89233923392356,-55.72365947357679L283.80963096309654,-55.62040330043108L283.10326032603285,-52.481490413324714L283.20417041704184,-49.82094434624015L286.13056305630573,-51.61019693278084L287.03875387538767,-51.098358238527965L288.6533153315333,-51.14951943451949L289.15786578657884,-52.173805840806814L291.27697769777,-51.9687856215027L293.49699969997016,-49.61684324157387L293.5979097909794,-46.71666979032021L295.9188418841885,-44.18483297413489L295.71702170217037,-41.713988356054955L294.80883088308843,-40.406874326349126L292.1851685168519,-40.80878029828456L288.6533153315333,-40.25622359846638L286.8369336933695,-37.85043554229188L287.4423942394242,-34.40653447058198L284.9196419641966,-35.70232574765941L282.5987098709873,-35.65244582434926L283.0023502350237,-37.9004693786317L280.47959795979614,-37.9004693786317L280.27777777777794,-34.7551809961009L278.7641264126415,-30.581585565651146L277.8559355935596,-28.057711339767398L278.05775577557773,-25.984392551261728L279.8741374137416,-25.885772767997356L280.9841484148417,-23.32494416487882L281.48869886988723,-20.868158935254726L283.10326032603285,-19.249372234987483L284.81873187318746,-18.906248825287538Z", id: "Thailand", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M206.4115911591161,-120.43914457154166L207.11796179617974,-117.05878764755022L208.12706270627083,-117.43218663485305L209.74162416241637,-116.62383732071059L209.64071407140727,-115.26158302723202L210.14526452645282,-113.23142736654036L207.21887188718893,-113.23142736654036L205.30158015801595,-113.4766738620303L203.4851985198521,-111.88661479305814L202.27427742774293,-111.58192137524087L201.26517651765192,-110.79133919811852L200.15516551655185,-111.94759525974666L200.4578957895791,-114.95297142030842L199.6506150615063,-115.07637230601468L199.9533453345336,-116.18961705497156L198.43969396939713,-116.99660702160907L197.22877287728787,-115.7561224555002L196.9260426042606,-114.33683837454709L196.42149214921503,-113.78355289683907L194.8069306930695,-113.90640466648199L193.89873987398758,-112.25270716795471L192.99054905490567,-112.9251888772137L190.87143714371453,-111.82564827003178L190.06415641564172,-112.25270716795471L191.67871787178734,-115.81800599267201L191.0732573257327,-118.4931054589714L188.9541454145416,-119.37011848947583L189.66051605160533,-120.94378223253293L192.08235823582376,-120.75442486908682L193.39418941894203,-122.78163077561037L194.30238023802394,-125.14632327745841L198.03605360536068,-126.04701231682655L197.43059305930612,-124.31290988286031L197.8342334233425,-123.291009415627L198.9442444244426,-123.35475509328688L197.9351435143516,-122.27329017194565L194.90784078407856,-122.84524618975499L194.60511051105124,-120.75442486908682L197.7333233323334,-121.00693296664573L201.16426642664283,-119.872628390288Z", id: "Tajikistan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M151.11286128612878,-112.43594240549017L150.60831083108323,-114.95297142030842L151.01195119511968,-118.68078329264769L148.79192919291944,-119.872628390288L149.49829982998315,-122.40027840159827L147.68191819181934,-122.59088179223171L148.28737873787398,-125.72495822395892L150.91104110411058,-124.8254463925293L153.33288328832896,-125.98256764260344L151.31468146814694,-128.24831892714474L150.50740074007413,-130.4041912490347L148.28737873787398,-129.42185510429445L147.9846484648466,-126.6923941756665L147.0764576457647,-129.0952998391538L148.38828882888305,-130.33857685851203L151.51650165016514,-131.12714015531202L153.43379337933806,-130.07629884347872L155.35108510851106,-127.14517843699448L156.8647364736475,-127.33948671321927L159.99294929492967,-127.33948671321927L159.48839883988413,-129.2258688203514L161.91024102410256,-130.5354740053015L164.23117311731184,-132.77841288779672L168.06575657565773,-130.7325333164501L168.36848684868502,-127.72856962406507L169.377587758776,-127.01572567132133L172.4048904890491,-127.14517843699448L173.41399139914012,-126.49860067844905L174.7258225822584,-122.65444859094998L177.9549454945496,-120.18720312822953L179.77132713271342,-118.4931054589714L182.69771977197735,-116.68592828120751L186.43139313931405,-115.19983151771363L186.43139313931405,-112.98640822861826L185.52320232023214,-113.10888942674002L184.21137113711387,-114.09078993879515L183.80773077307745,-112.80279260886824L181.38588858885907,-112.13062044168399L180.88133813381356,-109.33787986825297L179.2667766776679,-108.25287829758554L177.04675467546772,-107.77203669207955L176.44129412941308,-106.21508549674039L174.322182218222,-105.73778205520729L171.49669966996717,-107.05235088188772L171.29487948794892,-109.9425372221408L169.17576757675783,-110.06363111056336L165.94664466446656,-113.17015129783023L163.72662266226638,-113.59938261359154L160.59840984098423,-115.38512991655253L158.68111811181132,-115.69425363868848L157.36928692869304,-115.01466457869107L155.55290529052922,-115.13809461483358L153.5347034703472,-113.10888942674002Z", id: "Turkmenistan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M350.51120112011216,26.47429313671649L350.51120112011216,25.58662946699818L350.208470847085,25.044551410188348L350.51120112011216,24.404277989093885L352.9330433043307,23.764389326704542L354.9512451245127,23.665978405104557L355.7585258525854,23.272422572455636L356.8685368536855,23.665978405104557L355.8594359435946,24.404277989093885L352.9330433043307,25.635923538747907Z", id: "Timor-Leste", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-172.90944094409437,-30.333826410618432L-171.29487948794875,-30.68070933880795L-170.68941894189413,-30.581585565651146L-170.79032903290323,-28.453144389486898L-173.21217121712164,-28.156553723344352L-173.71672167216715,-28.403705967459736L-172.90944094409437,-29.19504370752278Z", id: "Trinidad and Tobago", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M23.562506250625162,-111.52102439113827L26.589808980898237,-112.98640822861826L28.608010801080237,-112.55816946996929L28.507100710071146,-110.79133919811852L30.82803280328042,-112.06959807205915L31.02985298529868,-111.39927202697089L29.617111711171237,-109.70051214159363L29.617111711171237,-108.0724636786832L30.626212621262233,-107.2320958275524L30.222572257225867,-104.25145320001452L28.406190619062052,-102.53709197652594L28.910741074107513,-100.65727808151891L30.424392439244052,-100.59873145024233L31.130763076307776,-99.0224210816767L32.13986398639877,-98.49887078188671L32.03895389538968,-95.95256210360938L30.626212621262233,-94.97454487007515L29.71802180218033,-93.94243196017044L27.800730073007422,-92.68568025193736L28.103460346034698,-91.32049104543763L27.901640164016513,-89.96124564886955L26.488898889889146,-89.17104844442424L25.378887888788977,-95.08944121950118L23.562506250625162,-96.41390946869599L23.562506250625162,-97.22298661753582L21.24157415741589,-99.19714601798893L21.039753975397623,-101.71315659758297L22.755225522552347,-103.65911938546607L23.461596159616068,-106.4540455846736L22.95704570457061,-109.76099810376441Z", id: "Tunisia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M116.39978997899804,-128.18328927709555L119.42709270927104,-128.31336604808814L122.15166516651675,-126.49860067844905L122.55530553055321,-125.21054884926697L122.35348534853503,-123.41851711778801L124.37168716871702,-122.52733117047603L125.48169816981711,-121.44943209792974L123.5644064406442,-120.37613568534216L124.47259725972611,-116.25160399076537L123.86713671367148,-115.13809461483358L125.48169816981711,-112.31377154866662L124.06895689568974,-111.76469567869434L123.05985598559867,-112.61930411029137L119.83073307330748,-113.10888942674002L118.61981198119823,-112.55816946996929L115.49159915991613,-112.00858968208205L113.97794779477958,-112.06959807205915L110.74882488248842,-110.73062162391348L108.42789278927906,-110.73062162391348L106.91424142414252,-111.39927202697089L103.88693869386952,-110.4272392874917L102.87783778377853,-111.09513325175755L102.77692769276943,-109.15674546098077L101.96964696469661,-108.37322091033872L101.2632763276329,-107.65195804934797L100.2541754175419,-109.21711016607854L101.2632763276329,-110.48788838934833L99.54780478047817,-110.24537389048956L97.2268726872689,-111.0343469106534L95.3095809580959,-109.03605628519662L91.07135713571374,-108.61406542554066L88.75042504250438,-110.48788838934833L85.82403240324047,-110.60922761770726L85.11766176617675,-109.15674546098077L83.20037003700385,-108.73456751035336L80.47579757975812,-110.60922761770726L77.44849484948504,-110.54855116217344L75.7330233023304,-114.02931381584241L73.71482148214832,-116.00374505334996L75.12756275627576,-118.80597847633693L73.31118111811196,-120.50216916399786L76.43939393939404,-123.9931133014944L80.6776177617763,-124.18494166527903L81.88853885388549,-127.01572567132133L87.23677367736784,-126.49860067844905L90.56680668066818,-128.89957886786988L93.89683968396854,-130.01077414728766L98.53870387038717,-130.07629884347872L103.38238823882399,-127.40429063315905L107.41879187918806,-125.98256764260344L110.64791479147932,-126.56318142915866L113.06975697569769,-126.24044814377372ZM73.00845084508468,-125.53192848794869L73.61391139113923,-125.91813991101967L74.52210221022114,-128.24831892714474L73.10936093609376,-129.2258688203514L76.03575357535767,-130.46982362599897L78.45759575957612,-129.94526734250175L78.7603260326034,-128.50861239005212L81.18216821682184,-127.27470005063452L80.6776177617763,-126.36949034733833L77.34758475847596,-126.17595255255259L76.13666366636677,-125.01792237251459L73.81573157315742,-123.036189888951L72.9075407540755,-124.76132110814964Z", id: "Turkey", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M341.22747274727493,-70.52763545236208L339.6129112911293,-65.58820375379423L338.4019901990202,-63.114372701463815L336.88833883388355,-65.69379756714181L336.5856085608564,-67.91756887838284L338.20017001700177,-70.9554220435714L340.5211021102112,-73.31681099849722L341.7320232023204,-72.3490181402741Z", id: "Taiwan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M109.84063406340651,13.130529144989318L108.52880288028815,16.601249072182878L108.73062306230634,18.216936963491705L110.44609460946106,19.24604861741848L110.54700470047014,19.98160784774504L109.84063406340651,21.69956273376836L109.94154415441561,22.53487748413254L109.73972397239741,23.912022335009773L110.74882488248842,25.685220005849924L111.9597459745976,28.499233486511848L112.96884688468859,29.09273432179211L110.74882488248842,30.776483982570248L107.62061206120624,31.867741699197655L106.00605060506061,31.818107917771428L104.99694969496962,32.66229424936479L102.97874787478762,32.76166841650032L102.27237723772389,33.10957572179128L98.94234423442363,32.314581553312664L96.82323232323245,32.51325611689557L96.01595159515963,28.647572276646013L95.10776077607771,27.313378440697743L94.50230023002318,26.52363105433439L91.77772777277737,26.030362745582767L90.16316631663182,25.143089826925927L88.34678467846801,24.699740358755392L87.23677367736784,24.20734867242641L86.12676267626775,23.469182993476448L84.61311131113122,19.932557756262213L82.99854985498567,18.314914852883536L82.39308930893102,16.699120270833657L82.6958195819583,15.231680723636751L82.19126912691284,12.64222360748974L83.30128012801292,12.495754894364326L84.31038103810394,11.519555993249359L85.42039203920403,10.056042778656648L86.12676267626775,9.42211976494248L86.12676267626775,8.54462016867334L85.52130213021319,7.911030446747442L85.31948194819493,6.790359183687252L86.12676267626775,6.4493534166387105L86.32858285828593,4.793424953632565L85.21857185718584,3.186689054122882L86.22767276727684,2.8459127166589457L89.2549754975499,2.894594230266081L95.00685068506864,2.6998697269651704L95.41049104910509,2.9919580598948583L105.60241024102424,8.690851696402298L105.80423042304243,10.34867482713297Z", id: "Tanzania", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M85.21857185718584,3.186689054122882L83.50310031003112,4.0630406455894015L82.89763976397657,3.7709112947846215L82.89763976397657,1.6776245502672165L83.50310031003112,0.6067732323849028L83.7049204920493,-1.632248288238757L84.31038103810394,-2.9465764508572345L85.31948194819493,-4.407176408281936L86.42949294929511,-5.137605546232783L87.33768376837702,-6.160388262828348L86.22767276727684,-6.5500832328884036L86.32858285828593,-9.815514301679384L87.5395039503952,-10.595868113025155L89.355885588559,-9.961812455980416L91.5759075907592,-10.595868113025155L93.4931993199321,-10.595868113025155L95.20867086708681,-11.913291519463248L96.62141214121426,-9.961812455980416L96.92414241424154,-8.547924728933557L98.13506350635082,-5.332403972815976L97.12596259625973,-3.287356867194463L95.71322132213236,-1.4375444288744597L94.90594059405954,-0.2693556312840245L95.00685068506864,2.6998697269651704L89.2549754975499,2.894594230266081L86.22767276727684,2.8459127166589457Z", id: "Uganda", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M107.11606160616078,-149.97502350309435L104.79512951295143,-149.68925497162454L102.97874787478762,-148.3369049125849L100.35508550855099,-148.12413259671948L97.93324332433254,-146.64042800646874L98.13506350635082,-144.119724104493L99.44689468946909,-143.1470570254314L102.37328732873299,-143.35513221530394L101.76782678267844,-141.9715718880951L98.74052405240535,-141.2829489183146L94.90594059405954,-138.9570726728605L93.392289228923,-139.77527140571655L93.99774977497763,-141.6269992966274L90.86953695369546,-142.80069101593418L91.37408740874102,-143.56339973659837L94.09865986598672,-144.88692797433745L93.2913791379139,-145.7970272177381L88.95224522452256,-146.85177886678682L88.75042504250438,-148.3369049125849L86.12676267626775,-147.84075459687506L85.11766176617675,-145.6567703190166L82.89763976397657,-142.66229324970837L81.6867186718673,-143.35513221530394L80.37488748874902,-142.73148153522553L79.06305630563068,-143.42453332618675L79.7694269426944,-143.91094111123223L80.27397739773994,-145.2365276245087L81.08125812581275,-146.57002237379422L80.87943794379449,-147.2750852785407L81.38398839884003,-147.62845917561796L81.6867186718673,-147.0633311043563L83.40219021902202,-146.92227387647668L84.10856085608576,-147.20447808180265L83.6040104010402,-147.62845917561796L83.80583058305848,-148.26595802067237L82.79672967296739,-149.26129840142363L82.39308930893102,-150.97815945831675L81.38398839884003,-151.6975155704813L81.58580858085821,-153.07087841752497L80.27397739773994,-154.23418361015095L79.16396639663976,-154.3800383105455L77.04485448544868,-155.69719666096088L75.22847284728486,-155.2572467019392L74.52210221022114,-154.67204412893716L73.41209120912104,-154.67204412893716L72.70572057205732,-153.65174850816538L70.58660866086623,-153.28852205228338L69.67841784178432,-152.63624579463877L68.36658665866597,-153.65174850816538L66.55020502050216,-153.65174850816538L64.83473347334743,-154.08842746608235L63.62381238123825,-153.2159498667923L63.42199219922007,-154.3800383105455L61.80743074307444,-155.47710900057626L62.412891289129064,-157.17025482820864L63.22017201720188,-158.2817569520023L63.82563256325644,-158.05899179789986L63.018351835183616,-159.997437553716L65.64201420142024,-163.62360299332715L66.95384538453861,-164.15770380778557L67.25657565756589,-165.38367561663236L65.8438343834385,-169.26233250423184L67.25657565756589,-169.41900970818688L68.77022702270241,-170.67676395565096L70.8893389338935,-170.7556312156865L73.81573157315742,-170.44034482010503L76.94394439443958,-169.34065613425008L79.06305630563068,-169.26233250423184L80.17306730673084,-168.55876236228272L81.18216821682184,-169.34065613425008L81.98944894489465,-168.32477366464244L84.51220122012212,-168.55876236228272L85.62221222122228,-168.09105097236656L85.72312231223137,-170.36159922071928L86.63131313131328,-171.38766960593992L89.05315531553165,-171.6251903575002L90.06225622562272,-171.46681240826345L90.76862686268638,-172.49848041588805L91.67681768176828,-172.25993800798753L94.50230023002318,-172.73730344625596L96.31868186818699,-170.12554433106115L95.61231123112327,-169.1840387880637L95.91504150415055,-167.77983312517145L98.13506350635082,-167.62440041935042L99.14416441644181,-165.69130248677163L99.04325432543271,-164.76978615648855L102.57510751075125,-163.242937627185L104.79512951295143,-163.92863592295623L106.51060106010615,-161.8782491283136L108.12516251625178,-161.95383249383227L112.26247624762487,-160.5223747119036L112.26247624762487,-159.24978193067412L111.15246524652478,-157.02249149582772L111.75792579257941,-154.67204412893716L111.35428542854297,-153.28852205228338L108.62971297129724,-152.99837910788L107.21697169716988,-151.84167214285637Z", id: "Ukraine", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-149.59920992099205,100.711866170962L-150.81013101310123,102.82793265065196L-154.0392539253925,104.72219327271922L-156.0574557455745,104.01035361869596L-157.57110711071098,104.3660479914839L-160.1947694769476,102.94595287207818L-162.11206120612053,103.00498138263282L-163.82753275327525,101.18075612679235L-163.62571257125708,98.96025605784968L-163.02025202520247,98.26254388035684L-163.02025202520247,94.91321980646123L-162.21297129712963,91.5437557058387L-161.607510751075,88.94181914181625L-159.7911291129112,88.60400615156568L-156.96564656465637,91.08969556342065L-155.8556355635563,91.03298441029295L-153.03015301530144,93.13821506643167L-150.81013101310123,94.91321980646123L-149.19556955695563,97.21906329628673L-150.40649064906484,98.78567243131197Z", id: "Uruguay", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-435.98204820482044,-54.48603447420338L-436.3856885688569,-53.97127983104106L-437.09205920592063,-54.38304054374831L-436.9911491149115,-55.25918052616702L-437.495699569957,-56.34366355247509L-437.39478947894787,-56.653967975029225L-436.8902390239024,-57.11980621728808L-437.09205920592063,-57.74164301771762L-436.8902390239024,-58.00098647336909L-436.6884188418842,-57.94910619826127L-435.57840784078405,-57.43062134085709L-435.07385738573856,-57.17159444915501L-434.67021702170223,-56.80919634625504L-433.96384638463843,-55.72365947357679L-433.96384638463843,-55.568783509327L-435.07385738573856,-54.94977507249806ZM-437.495699569957,-59.14383173740127L-438.40389038903885,-58.93582981890845L-438.90844084408445,-59.56012100596364L-439.2111711171117,-59.76840914285924L-439.3120812081208,-59.97679347408866L-439.0093509350935,-60.23740976397501L-438.0002500250025,-59.92468835144896L-437.29387938793883,-59.50806395583816ZM-439.4129912991299,-60.70690188104627L-439.513901390139,-60.39385230230128L-441.0275527552755,-60.49817774976127L-440.82573257325737,-60.863509257452264ZM-441.93574357435745,-61.176890026313835L-442.03665366536654,-60.967944877128744L-442.23847384738474,-61.020171916319356L-443.2475747574757,-61.1246444846567L-443.55030503050307,-61.80432036039263L-443.7521252125212,-61.961318265535176L-442.9448444844484,-62.32786660683065L-442.74302430243023,-62.170736675635055ZM-446.67851785178516,-63.16685751532694L-446.98124812481245,-62.852044714938884L-447.8894389438944,-63.4293780189362L-447.7885288528853,-63.63951052722793L-447.38488848884884,-63.90232196818682L-446.67851785178516,-63.84974668520927ZM-188.2477747774777,-142.0405492813035L-187.74322432243218,-140.73354861007778L-190.7705270527052,-138.82098935542294L-193.59600960096006,-137.46456026298395L-196.52240224022398,-136.31781822277802L-198.03605360536048,-134.0411286167226L-198.54060406040597,-133.17643563426716L-198.54060406040597,-131.19297143592678L-197.63241324132406,-129.16057548600796L-196.42149214921486,-129.0952998391538L-196.72422242224218,-130.46982362599897L-195.91694169416937,-129.6180011378279L-196.11876187618756,-128.57372954841907L-198.03605360536048,-127.9233450790075L-199.34788478847878,-127.98830499885794L-201.46699669966995,-127.33948671321927L-202.67791779177912,-127.14517843699448L-204.29247924792475,-127.01572567132133L-206.61341134113405,-125.91813991101967L-202.57700770077003,-126.62777925657417L-201.66881688168812,-125.91813991101967L-205.60431043104305,-124.8254463925293L-207.42069206920686,-124.76132110814964L-207.31978197819777,-125.27479118682295L-208.12706270627052,-124.24891750028186L-207.31978197819777,-124.05703958029399L-207.92524252425235,-121.44943209792974L-210.0443544354435,-118.61820870242796L-210.2461746174617,-119.55844325842386L-210.8516351635163,-119.74690767927935L-211.75982598259822,-120.62826552219359L-211.1543654365436,-118.68078329264769L-210.44799479947991,-118.05572505752124L-210.44799479947991,-116.68592828120751L-211.35618561856182,-115.32334915597818L-212.86983698369832,-112.49704890573308L-213.1725672567256,-112.61930411029137L-212.2643764376437,-115.01466457869107L-213.6771177117711,-116.37562234187783L-214.08075807580752,-119.37011848947583L-214.585308530853,-117.80612804583133L-213.97984798479843,-115.57056011542682L-215.79622962296227,-116.1276449286459L-213.8789378937893,-114.95297142030842L-213.7780278027802,-111.64283224324554L-212.9707470747074,-111.39927202697089L-212.66801680168012,-110.1847793553154L-212.2643764376437,-106.69321219256558L-214.08075807580752,-104.13288674364442L-217.00715071507145,-103.12707926560921L-218.82353235323527,-101.12607919808623L-220.2362736273627,-100.95018944566546L-221.6490149014901,-99.72194910519734L-222.0526552655265,-98.5569969231351L-225.07995799579953,-96.41390946869599L-226.69451945194515,-94.85969214832573L-228.00635063506346,-92.85675303208622L-228.40999099909985,-90.52688348874648L-227.90544054405436,-88.3265792544225L-226.99724972497245,-85.52753119317327L-225.78632863286325,-83.24995144120466L-225.78632863286325,-81.92386341004479L-224.47449744974494,-78.24866236762198L-224.47449744974494,-76.12684059605536L-224.6763176317631,-74.93537201204806L-225.38268826882683,-72.99393782715971L-226.18996899689964,-72.61760126706938L-227.60271027102704,-72.99393782715971L-228.00635063506346,-74.341081526732L-229.01545154515446,-75.0976173152805L-230.529102910291,-77.75789593957396L-231.8409340934093,-80.16370335033024L-232.24457445744568,-81.42790823037868L-231.7400240024002,-83.52687539670255L-232.4463946394639,-85.30463964843162L-234.6664166416641,-87.98941394549257L-235.77642764276422,-88.49529480682769L-238.60191019101907,-87.03602226268201L-239.1064606460646,-87.1480403374712L-240.4182918291829,-88.6640992682984L-242.2346734673467,-89.45303587129244L-245.3628862886288,-89.05832341499445L-247.88563856385633,-89.45303587129244L-250.00475047504744,-89.22742592912236L-251.11476147614758,-88.72038722003064L-250.61021102110203,-87.82096372459209L-250.7111211121112,-86.53241793738303L-250.10566056605654,-85.91795476181409L-250.61021102110203,-85.47179418315386L-251.72022202220217,-85.97376744282154L-252.72932293229317,-85.3603484190825L-254.74752475247521,-85.41606659455773L-256.8666366636663,-87.1480403374712L-259.28847884788473,-86.75614591336587L-261.30668066806675,-87.48432699280625L-263.12306230623057,-87.26009710544086L-265.44399439943993,-86.53241793738303L-267.9667466746674,-84.13691334880085L-270.7922292229223,-82.75206055952623L-272.30588058805876,-81.20771364142576L-272.91134113411334,-79.83466720507121L-273.0122512251225,-77.64892837704683L-272.81043104310424,-76.12684059605536L-272.30588058805876,-75.0976173152805L-273.41589158915883,-74.98944584208623L-275.4340934093409,-75.69313040401761L-277.553205320532,-76.61538360316699L-278.3604860486048,-78.08499839564085L-278.96594659465944,-80.32833809884447L-280.68141814181416,-82.14451903589762L-281.58960896089604,-83.97042913270778L-283.00235023502347,-86.19711321463721L-285.0205520552054,-87.48432699280625L-287.2405740574057,-87.42825495576857L-289.0569556955695,-84.85930706327746L-291.3778877887788,-85.80635785562067L-292.7906290629063,-86.81210192135298L-293.49699969996993,-88.5515530703473L-294.40519051905187,-90.30050652153L-296.1206620662066,-91.71805172313232L-297.53340334033396,-92.74269396385026L-298.542504250425,-93.88519487213844L-303.38618861886187,-93.94243196017044L-303.38618861886187,-92.57168442684588L-305.6062106210621,-92.57168442684588L-311.2571757175717,-92.51470229541798L-317.61451145114506,-94.85969214832573L-321.85273527352734,-96.47162793986422L-321.5500050005,-97.10726942814134L-325.18276827682763,-96.76038780311733L-328.3109810981098,-96.47162793986422L-328.8155315531553,-98.20841231143136L-330.6319131913191,-100.13078438861254L-331.9437443744374,-100.54019667569843L-332.2464746474647,-101.47818159528731L-333.76012601260123,-101.65439479530286L-334.7692269226922,-102.59603564447055L-337.3928892889288,-102.9499543827492L-338.0992599259926,-103.48166148137086L-338.50290029002895,-105.32081244523957L-341.2274727472747,-108.79483854953358L-343.548404840484,-113.66075840826115L-343.44749474947497,-114.52152618984402L-344.65841584158414,-115.69425363868848L-346.87843784378435,-118.68078329264769L-347.18116811681165,-121.6393131943387L-348.6948194819482,-123.60990141487642L-348.0893589358936,-126.6923941756665L-348.1902690269026,-129.87977841333847L-349.09845984598456,-132.84470349278573L-347.98844884488443,-136.4524353611541L-347.6857185718572,-139.98027846857767L-347.28207820782075,-143.56339973659837L-347.78662866286624,-149.0476321551311L-348.6948194819482,-152.56389161930989L-349.502100210021,-154.52599175430902L-349.19936993699366,-155.33050913433075L-345.16296629662963,-153.869977635045L-343.6493149314931,-149.97502350309435L-342.9429442944295,-151.04998843093642L-343.3465846584658,-154.4530026777983L-344.3556855685568,-157.98478856505434L-336.38378837883783,-157.98478856505434L-328.10916091609164,-157.98478856505434L-325.2836783678367,-157.98478856505434L-316.8072307230723,-157.98478856505434L-308.532603260326,-157.98478856505434L-300.0561556155615,-157.98478856505434L-291.6806180618061,-157.98478856505434L-282.19506950695063,-157.98478856505434L-272.6086108610861,-157.98478856505434L-266.7558255825582,-157.98478856505434L-266.7558255825582,-159.62327946494017L-265.84763476347626,-159.62327946494017L-265.3430843084308,-157.24417487650322L-264.4348934893489,-156.5798138518421L-262.517601760176,-156.28520376848738L-259.5912091209121,-155.62380902755012L-256.8666366636663,-154.30709862912784L-254.6466146614661,-154.81819562237962L-251.21567156715668,-153.79721010100718L-250.30748074807477,-153.79721010100718L-247.78472847284723,-154.96444642304232L-245.1610661066106,-153.43373945985812L-242.33558355835578,-151.84167214285637L-240.11556155615557,-150.4760166636491L-237.89553955395533,-149.19005325556805L-237.69371937193714,-148.05325402239748L-236.98734873487342,-147.69920168390706L-237.18916891689162,-147.2750852785407L-236.38188818881883,-147.13389336400417L-235.87733773377332,-147.55773927150724L-235.77642764276422,-146.64042800646874L-235.17096709670963,-146.00757812425763L-234.36368636863682,-146.00757812425763L-233.9600460046004,-145.4465501232649L-234.36368636863682,-144.747240892162L-231.43729372937293,-142.86992171118652L-230.83183318331825,-139.2976341428012L-230.22637263726367,-135.9144334899488L-231.03365336533648,-133.6416451763044L-232.4463946394639,-131.5224008354673L-233.0518551855185,-130.20740197328706L-233.0518551855185,-129.81430734403148L-232.7491249124912,-129.2911798577739L-231.8409340934093,-128.70401652428697L-231.13456345634557,-128.70401652428697L-227.80453045304523,-130.66682883458947L-224.97904790479043,-131.32468854811478L-221.3462846284628,-133.17643563426716L-221.2453745374537,-133.57513044848278L-221.54810481048096,-134.77528337673195L-221.95174517451738,-135.51174586199383L-220.63991399139906,-136.11603848403993L-217.91534153415336,-136.11603848403993L-215.39258925892582,-136.11603848403993L-214.48439843984391,-137.6675170587483L-214.08075807580752,-137.93840369778903L-211.1543654365436,-140.80215120008398L-209.84253425342527,-141.48931661264172L-205.60431043104305,-141.55814751988666L-200.45789578957886,-141.55814751988666L-200.1551655165516,-142.5239801869494L-199.24697469746968,-142.73148153522553L-198.13696369636958,-143.35513221530394L-197.12786278627857,-145.16656396337L-196.21967196719666,-148.3369049125849L-194.10056005600555,-151.40948831120278L-193.1923692369236,-150.3327587800466L-191.27507750775072,-151.04998843093642L-190.0641564156415,-149.83209270667763L-190.0641564156415,-144.3287013754282ZM-428.9183418341834,-195.94690392531678L-431.6429142914291,-193.9850661027602L-433.15656565656565,-195.3205012230449L-433.5602060206021,-197.7480248295186L-431.03745374537453,-199.56633769041508L-429.523802380238,-200.39029332011765L-427.6065106510651,-200.0236486814306L-426.496499649965,-198.38245856592022ZM-464.13596359635966,-210.95760655311378L-465.8514351435144,-210.08602321587642L-467.66781678167814,-211.1518485848037L-469.3832883288329,-212.61518699742763L-466.65871587158716,-213.59721238070608L-464.43869386938695,-213.10554772247175ZM-481.3915891589159,-233.99342848911527L-479.67611761176113,-232.78575546398667L-477.8597359735973,-233.44347678756483L-475.63971397139716,-231.8036744973247L-472.81423142314236,-230.93520073513L-473.11696169616965,-230.28658807478195L-475.2360736073607,-228.88922774730875L-477.3551855185519,-230.28658807478195L-478.3642864286429,-231.36891283612175L-480.8870387038705,-231.0435306760223L-481.492499249925,-231.5861621143552ZM-395.21437143714377,-276.24502764923864L-395.21437143714377,-248.5644629680492L-395.21437143714377,-213.20377608164998L-392.489798979898,-213.00737152039665L-389.76522652265226,-211.4435934686095L-387.7470247024702,-209.02627369567816L-385.32518251825184,-205.4109558725899L-382.6006100610061,-208.45076053821066L-379.7751275127512,-210.27935534019898L-378.2614761476147,-207.4002431090608L-376.34418441844184,-205.12848851400156L-373.8214321432143,-202.69806226087735L-372.10596059605956,-198.92794788077597L-369.1795679567957,-193.0116161054394L-364.43679367936795,-189.85971048915653L-364.33588358835874,-186.6727687062858L-365.9504450445045,-184.37955695901428L-367.46409640964094,-186.16084064465113L-369.88593859385935,-187.7865710169997L-370.69321932193213,-192.13091344080038L-374.3259825982598,-196.2159914256043L-375.8396339633963,-201.21784829366123L-378.56420642064205,-201.58681571464115L-383.00425042504247,-201.67917021865222L-386.2333733373337,-203.25615023069153L-392.08615861586156,-208.83423842570764L-394.70982098209817,-209.89289194198375L-399.6544154415442,-211.9308573365979L-403.48899889988996,-211.4435934686095L-409.0390539053905,-213.991488372216L-412.36908690869086,-216.47500007583793L-415.49729972997295,-215.2787351164433L-414.89183918391836,-211.34629417942168L-416.506400640064,-210.95760655311378L-419.73552355235523,-209.7964014714735L-422.1573657365737,-207.9725194972897L-425.28557855785573,-206.73479515013332L-425.68921892189223,-209.98943250314736L-424.37738773877385,-215.57707318321886L-421.4509950995099,-217.27685597789008L-422.25827582758274,-218.78984553411973L-425.7901290129013,-215.57707318321886L-427.7074207420742,-211.73579805401815L-431.7438243824383,-207.87701820671302L-429.7256225622562,-205.22259705270667L-432.3492849284928,-201.3100226645199L-435.37658765876586,-199.11012610076523L-438.1011601160116,-197.56714558271068L-438.8075307530753,-195.2311822141418L-443.2475747574757,-192.57076160809336L-444.05485548554856,-190.20739596184006L-447.38488848884884,-188.13056331132591L-449.30218021802176,-188.47516441382294L-451.9258425842584,-187.10040226371976L-454.7513251325132,-185.39545085331542L-457.0722572257226,-183.78936919932622L-461.9159415941594,-182.44697324175732L-462.3195819581958,-183.20094591545887L-459.29227922792285,-185.48034662546053L-456.567706770677,-187.0148006026256L-453.54040404040404,-189.77288646319914L-450.1094609460946,-190.29441488695576L-448.69671967196723,-192.3947018955372L-444.76122612261224,-195.40986191035554L-444.1557655765576,-196.4854583038802L-442.1375637563756,-198.29169560183144L-441.6330133013302,-202.32691931213407L-440.22027202720267,-205.5052062660337L-443.44939493949397,-203.8158968073863L-444.35758575857585,-204.7525255286587L-445.87123712371243,-202.79096223667105L-447.68761876187625,-205.5052062660337L-448.3939893989398,-203.62912960256068L-449.50400040004,-206.26092046429136L-452.3294829482948,-204.09639574073614L-454.0449544954496,-204.09639574073614L-454.2467746774678,-207.4002431090608L-453.7422242224222,-209.4109392813612L-455.558605860586,-211.34629417942168L-459.1913691369137,-210.27935534019898L-461.512301230123,-212.90924741105582L-463.4295929592959,-214.2877489237992L-463.530503050305,-217.5784569686785L-465.6496149614962,-220.0093012175126L-464.539603960396,-223.40542681933573L-462.3195819581958,-226.8662124027074L-461.3104810481048,-229.96315656258426L-458.9895489548955,-230.39452788917026L-457.0722572257226,-229.4253919188417L-454.8522352235223,-232.45779747047186L-452.83403340334036,-231.9125295774058L-450.61401140114015,-233.88330294133317L-451.21947194719473,-236.7688453492458L-452.7331233123312,-237.89121036921352L-450.7149214921492,-240.49983102806598L-452.43039303930396,-240.38561289332975L-455.3567856785678,-238.9074222032437L-456.26497649764974,-237.55375799552473L-458.48499849985,-238.9074222032437L-462.42049204920494,-238.22930338051157L-466.4568956895689,-239.81562172142404L-467.66781678167814,-242.45287825150055L-471.19966996699674,-246.30675564293128L-467.26417641764175,-249.28348552193208L-461.0077507750775,-252.67843487434266L-458.6868186818682,-252.67843487434266L-459.09045904590454,-249.16344392844144L-453.23767376737675,-249.4036092025648L-455.45769576957696,-253.78379292096338L-458.8886388638864,-256.51559173012487L-460.90684068406836,-260.18330223256874L-463.6314131413141,-263.27832963662905L-467.46599659966,-265.6364445464295L-465.8514351435144,-269.63963241638044L-460.90684068406836,-269.9098467620684L-457.3749874987499,-273.59991900307017L-456.66861686168613,-277.5123752689276L-453.84313431343134,-281.3717906702683L-451.1185618561856,-282.38679138398066L-445.7703270327032,-286.0619896187242L-443.2475747574757,-285.4685967299457L-438.90844084408445,-290.12255736034996L-434.67021702170223,-288.30585605437847L-432.65201520152016,-284.4351157048986L-431.44109410941087,-286.0619896187242L-426.6983198319832,-285.61675088877354L-426.79922992299225,-283.5542436348991L-422.56100610061003,-282.2414207370865L-419.63461346134613,-282.96951735674577L-413.78182818281834,-280.362795065468L-408.4335933593359,-279.64571884589844L-406.2135713571357,-278.5046227414995L-402.479897989799,-279.93218800977496L-398.24167416741676,-277.37109444141026Z", id: "United States", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M156.8647364736475,-127.33948671321927L156.66291629162933,-141.48931661264172L163.92844284428455,-143.8413898607527L164.4329932993301,-143.49395582676138L168.77212721272147,-140.66496666334436L171.09305930593072,-139.16134891916172L173.71672167216738,-135.64589784610487L177.04675467546772,-136.18327895768655L181.89043904390454,-136.51977317647652L185.22047204720488,-133.70817868923737L185.01865186518668,-129.87977841333847L186.33048304830496,-129.87977841333847L186.9359435943596,-126.8216753488414L190.46779677967814,-126.6923941756665L191.27507750775095,-124.88958835499864L192.28417841784196,-124.95374701013112L193.49509950995113,-127.59880608871207L197.22877287728787,-130.20740197328706L198.8433343334335,-130.92975522249563L199.6506150615063,-130.5354740053015L197.32968296829696,-128.11827708258738L199.34788478847904,-126.6923941756665L201.36608660866102,-127.59880608871207L204.6961196119614,-125.66059811486095L201.16426642664283,-123.036189888951L198.9442444244426,-123.35475509328688L197.8342334233425,-123.291009415627L197.43059305930612,-124.31290988286031L198.03605360536068,-126.04701231682655L194.30238023802394,-125.14632327745841L193.39418941894203,-122.78163077561037L192.08235823582376,-120.75442486908682L189.66051605160533,-120.94378223253293L188.9541454145416,-119.37011848947583L191.0732573257327,-118.4931054589714L191.67871787178734,-115.81800599267201L190.06415641564172,-112.25270716795471L187.94504450445058,-112.98640822861826L186.43139313931405,-112.98640822861826L186.43139313931405,-115.19983151771363L182.69771977197735,-116.68592828120751L179.77132713271342,-118.4931054589714L177.9549454945496,-120.18720312822953L174.7258225822584,-122.65444859094998L173.41399139914012,-126.49860067844905L172.4048904890491,-127.14517843699448L169.377587758776,-127.01572567132133L168.36848684868502,-127.72856962406507L168.06575657565773,-130.7325333164501L164.23117311731184,-132.77841288779672L161.91024102410256,-130.5354740053015L159.48839883988413,-129.2258688203514L159.99294929492967,-127.33948671321927Z", id: "Uzbekistan", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M-167.56120612061198,-23.521713897091313L-169.7812281228122,-21.850258663440858L-169.9830483048304,-20.819074616432324L-169.07485748574848,-19.78874353142415L-169.7812281228122,-19.249372234987483L-171.49669966996694,-18.808229411671707L-171.39578957895782,-17.48563492214732L-172.20307030703063,-16.702438018171495L-170.28577857785774,-14.550630140710071L-169.8821382138213,-13.768820188582136L-170.89123912391233,-12.69435903727728L-174.01945194519445,-11.669266463293505L-176.03765376537646,-11.230088758183719L-176.84493449344927,-10.547088869947137L-179.06495649564948,-11.230088758183719L-181.18406840684062,-11.620464697634409L-181.6886188618861,-11.376471848030993L-180.47769776977694,-10.644648332357841L-180.57860786078604,-8.742901908945642L-180.17496749674962,-6.988536273523168L-177.8540354035403,-6.744945032199435L-177.65221522152206,-6.160388262828348L-179.67041704170413,-5.332403972815976L-179.97314731473142,-4.163721029982863L-181.18406840684062,-3.6768384150597204L-183.20227022702264,-3.0439408631704223L-183.80773077307722,-2.167697134453958L-185.9268426842684,-2.021663491441054L-187.4404940494049,-3.4820950811633753L-188.34868486848677,-6.306519504403868L-189.0550555055505,-7.280867026196362L-190.0641564156415,-7.865601841041458L-188.6514151415141,-9.279156416213254L-188.7523252325232,-9.913045493039137L-189.559605960596,-10.742211717870424L-190.1650665066506,-12.596709583801713L-189.9632463246324,-14.648380194895534L-189.25687568756868,-15.577280837913507L-188.7523252325232,-17.093985836781968L-189.76142614261417,-17.583563292484936L-191.3759875987598,-17.240842250101682L-193.39418941894186,-17.387713028237833L-194.50420042004194,-17.093985836781968L-196.52240224022398,-19.543547585209353L-198.13696369636958,-19.886834732377064L-201.7697269726972,-19.641620491561362L-202.37518751875183,-20.62275663574487L-203.08155815581551,-20.819074616432324L-203.1824682468246,-21.408215428296963L-202.87973797379735,-22.489057059996508L-203.08155815581551,-23.620111896017566L-203.68701870187016,-24.25991521094031L-204.09065906590652,-25.540679490563203L-205.50340034003395,-25.737861227415L-204.69611961196114,-27.41549058883992L-204.39338933893384,-29.4424797527499L-203.58610861086103,-30.482473304118198L-202.47609760976093,-31.325297163188257L-201.7697269726972,-32.71534838234358L-199.95334533453337,-33.212376597708385L-200.05425542554246,-32.51662387576279L-201.66881688168812,-32.21862910451849L-200.76062606260618,-30.92856939175736L-200.86153615361528,-29.4424797527499L-202.07245724572454,-27.761247164464056L-200.96244624462437,-25.491390033636897L-199.7515251525152,-25.68856219730808L-199.14606460646056,-27.761247164464056L-200.05425542554246,-28.74983113978328L-200.1551655165516,-30.92856939175736L-196.72422242224218,-32.06967282485451L-197.02695269526947,-33.4112754960893L-196.11876187618756,-34.30695057916896L-195.10966096609656,-32.31794848248395L-193.09145914591454,-32.268287271059506L-191.27507750775072,-30.68070933880795L-191.17416741674162,-29.739494333961126L-188.6514151415141,-29.689984944567872L-185.62411241124104,-29.987083303562244L-184.11046104610455,-28.700376631265716L-181.89043904390434,-28.35427020960361L-180.3767876787678,-29.244525413969527L-180.2758775877587,-29.987083303562244L-176.84493449344927,-30.135670478681913L-173.51490149014896,-30.185205198510292L-175.83583358335824,-29.34349707105611L-174.92764276427636,-28.008294095989307L-172.70762076207615,-27.761247164464056L-170.58850885088506,-26.378969227434634L-170.0839583958395,-24.112234728468117L-168.6712171217121,-24.16145930105413Z", id: "Venezuela", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M292.3869886988701,-29.54147349788897L294.80883088308843,-30.68070933880795L297.7352235223524,-30.87899157644864L296.52430243024327,-32.615979970115724L301.267076707671,-34.80500077672772L301.56980698069816,-38.25080767276648L300.96434643464363,-40.20601440646477L301.4688968896892,-43.07424429840073L300.76252625262543,-45.145637750049154L298.64341434143427,-47.17358551899767L296.82703270327045,-49.7699117695587L294.50610061006125,-53.25151917656978L291.17606760676085,-55.00132898489111L291.9833483348337,-56.08523090748853L293.69881988198836,-56.860950459529015L292.68971897189743,-59.45601288703065L289.15786578657884,-59.50806395583816L287.94694469446955,-62.223107011334996L286.3323832383239,-64.63906244519353L287.84603460346057,-65.37709669417173L290.0660566056607,-65.32433667584579L292.7906290629065,-65.69379756714181L295.2124712471248,-67.333977412049L296.52430243024327,-66.1693036920074L299.04705470547077,-65.640997298041L298.64341434143427,-63.84974668520927L299.9552455245527,-62.642297242401526L302.78072807280745,-61.85664673164194L299.04705470547077,-59.299895506980725L296.72612261226146,-56.447075849900415L296.1206620662067,-54.38304054374831L298.23977397739793,-51.303033185412275L300.8634363436346,-47.427587894271014L303.38618861886215,-45.65195570363795L305.1016601660168,-43.32647241436845L306.4134913491351,-37.950506827576945L306.0098509850987,-32.91412231876378L303.6889188918894,-31.027733763721287L300.4597959795981,-29.19504370752278L298.1388638863889,-26.82305685341712L294.70792079207945,-24.16145930105413L293.69881988198836,-25.984392551261728L294.4051905190521,-27.909467480356916Z", id: "Vietnam", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M470.39238923892407,46.81473359890211L469.4841984198422,47.22093320525073L468.47509750975127,45.952522539105615L468.57600760076025,45.142206612778025ZM468.27327732773307,42.36513997378069L468.77782778277844,44.68689685072296L467.9705470547057,44.333009188669536L467.4659965996602,44.48464952455695L467.06235623562384,43.67634463165652L466.9614461446146,41.459002276814196Z", id: "Vanuatu", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M119.83073307330748,-46.4122637643252L121.04165416541666,-47.37677821137998L120.83983398339848,-48.59749549233167L121.54620462046222,-50.02512347292505L122.6562156215623,-49.25985296828929L123.46349634963511,-49.565830114218315L126.69261926192637,-49.61684324157387L127.19716971697183,-49.310837089880536L129.92174217421757,-49.005004469030176L130.93084308430855,-49.15789916361409L131.63721372137226,-48.190290017117285L132.94904490449065,-48.69934417199367L134.96724672467263,-51.76384723718639L137.59090909090926,-53.09741939142694L145.66371637163732,-54.22859003541496L147.8837383738375,-49.36182603176582L148.79192919291944,-47.32597313790869L146.77372737273743,-46.51371436032203L146.26917691769188,-45.24686621190879L146.1682668266828,-44.23536291948644L143.34278427842798,-43.02381114564965L138.90274027402754,-41.663665243371035L136.3799879988,-39.6038029138285L135.1690669066908,-39.45333561338741L134.361786178618,-39.653966249082956L132.64631463146327,-38.451081137448114L130.93084308430855,-37.9004693786317L128.5090009000902,-37.75037868696053L127.80263026302646,-37.550308102512886L127.19716971697183,-36.80055044353927L126.49079907990811,-36.60074879277739L126.08715871587175,-35.85198587220753L124.6744174417443,-35.951776301214174L123.76622662266239,-35.55269612478195L121.84893489348948,-35.70232574765941L121.14256425642576,-37.35029474722318L121.14256425642576,-38.95202235034414L120.73892389238938,-39.80447903270558L120.13346334633476,-41.915320928715744L119.32618261826195,-43.12468160087417L119.93164316431657,-43.27601845981183L119.6289128912893,-44.58919246903303L119.93164316431657,-45.145637750049154Z", id: "Yemen", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M45.76272627262738,83.68938106320185L47.07455745574573,82.08560127133416L48.18456845684583,82.96950460446712L48.68911891189129,84.29971546177372L49.90004000400055,84.57750944575544L51.71642164216437,85.18947506824821L53.230073007300824,84.91116884562192L55.752825282528356,83.30156409111798L55.752825282528356,71.70155611015878L56.459195919592084,72.18432039054247L58.17466746674681,75.14804711538555L57.87193719371953,77.04651147192581L58.477397739774084,78.13584639794783L60.495599559956155,77.80869729551247L61.90834083408353,76.39449173984663L63.22017201720188,75.4727971733187L63.92654265426553,73.9597356006053L65.23837383738389,73.2593302884753L66.44929492949306,73.63630883034772L67.76112611261142,74.49940474733681L70.0820582058207,74.66145861315434L71.8984398439845,73.9597356006053L72.20117011701187,72.99029115428891L72.70572057205732,71.4871894647615L74.21937193719386,71.27294234111376L75.02665266526668,70.09669965719206L75.93484348434858,68.0732761825039L78.45759575957612,65.79583753145201L82.39308930893102,63.53086982038509L83.6040104010402,63.58340573835704L84.91584158415856,64.0565209775018L85.92494249424956,63.74105234542495L87.33768376837702,64.00392658682911L88.75042504250438,68.28578360934787L89.4567956795681,70.47057248716226L88.95224522452256,73.90581168845743L89.15406540654082,75.03986082764973L87.74132413241338,74.49940474733681L86.93404340434056,74.71549234090557L86.73222322232238,75.58111111952975L85.92494249424956,76.7746935527584L85.92494249424956,77.86320130021714L87.64041404140428,79.55699388807517L89.2549754975499,79.22852780163946L89.86043604360447,77.80869729551247L91.97954795479563,77.86320130021714L91.27317731773192,80.15998372338596L90.97044704470464,82.80359718595419L90.16316631663182,84.2441844409967L88.24587458745891,85.8583686772858L87.74132413241338,86.30505519537526L86.53040304030421,87.92944702090237L85.82403240324047,89.6185213348639L84.20947094709484,91.94160176494404L80.98034803480358,95.37297427459184L79.06305630563068,97.33482407477301L76.94394439443958,98.84385541583212L74.01755175517567,100.18527326060466L72.60481048104823,100.36069780074749L72.20117011701187,101.29809799348061L70.48569856985715,100.77043574072452L69.0729572957297,101.41548777542663L66.0456545654567,100.77043574072452L64.33018301830197,101.18075612679235L63.22017201720188,101.00483298812712L60.2937793779379,102.35634088742854L57.97284728472862,102.88693663159104L56.15646564656481,104.18814458641799L54.945544554455545,104.24743321411647L53.73462346234637,103.00498138263282L52.826432643264454,102.94595287207818L51.61551155115527,101.47420066034111L51.41369136913701,101.9443369559143L51.11096109610973,101.00483298812712L51.11096109610973,99.01847373523178L50.20277027702783,96.81425536032522L51.11096109610973,96.17923727265949L51.01005100510064,93.65247656580674L49.193669366936824,90.57966427984982L47.78092809280938,87.87329761372328L47.78092809280938,87.817157990114ZM81.18216821682184,84.85553564842856L79.97124712471258,83.91119206155878L78.6594159415943,84.52193210430146L77.14576457645776,85.80257560642693L75.63211321132123,87.817157990114L77.7512251225124,90.35324935207267L78.7603260326034,90.01393178590911L79.26487648764893,88.99815607247119L80.7785278527854,88.491481077721L81.28307830783093,87.42445384617719L82.19126912691284,85.8583686772858Z", id: "South Africa", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M93.08955895589573,39.60040217613215L84.51220122012212,41.962250932330534L84.81493149314947,44.02984401094029L82.6958195819583,44.43409845405478L81.08125812581275,45.59787027332435L80.7785278527854,46.6117431387505L79.7694269426944,46.81473359890211L77.34758475847596,49.256396621718906L75.7330233023304,51.146050749998174L74.82483248324849,51.19721662860667L73.91664166416659,50.890296587914456L70.78842884288441,50.53245037461104L70.28387838783888,50.328075957034315L70.28387838783888,50.07271887001871L69.17386738673878,49.40936247205049L67.35748574857497,49.256396621718906L65.0365536553657,49.91956351241081L63.22017201720188,48.085086797891215L61.302880288028895,45.69917732157037L61.40379037903807,36.49748338081867L67.25657565756589,36.49748338081867L67.0547554755477,35.54931504481883L67.45839583958406,34.45295517115473L66.95384538453861,33.10957572179128L67.25657565756589,31.7188493505635L66.95384538453861,30.82605579167544L67.9629462946296,30.925208120861335L68.0638563856387,31.818107917771428L69.37568756875697,31.7188493505635L71.19206920692078,32.0166610938466L72.1002600260027,33.308448617850054L74.42119211921204,33.706345857134L76.03575357535767,32.76166841650032L76.7421242124214,34.303575110978L78.86123612361249,34.70198726818749L79.87033703370349,35.89849669264109L81.08125812581275,37.49690914995314L83.20037003700385,37.49690914995314L82.99854985498567,34.4031585612648L82.19126912691284,34.95110157026871L80.27397739773994,33.805851950483756L79.46669666966712,33.308448617850054L79.7694269426944,30.42956216472495L80.27397739773994,27.06651296311049L79.6685168516853,25.83312382689568L80.47579757975812,24.010455479569245L81.28307830783093,23.665978405104557L85.01675167516765,23.174055389176626L86.12676267626775,23.469182993476448L87.23677367736784,24.20734867242641L88.34678467846801,24.699740358755392L90.16316631663182,25.143089826925927L91.77772777277737,26.030362745582767L93.08955895589573,27.26400024855255L93.79592959295944,29.686628505693218L93.2913791379139,30.479113796576467L92.78682868286845,32.76166841650032L93.2913791379139,35.15045262075316L92.38318831883201,36.14801432203566L91.5759075907592,38.84840758324684Z", id: "Zambia", style: countryStyle }),
                        React.createElement("path", { className: "country", d: "M82.39308930893102,63.53086982038509L80.6776177617763,62.167186403010604L78.45759575957612,61.69613993145593L77.6503150315033,59.81696470689092L77.6503150315033,58.7243995120563L76.43939393939404,58.4127175112897L73.31118111811196,55.15252705562653L72.40299029903004,53.45357480385669L71.79752975297542,52.88854587612344L70.78842884288441,50.53245037461104L73.91664166416659,50.890296587914456L74.82483248324849,51.19721662860667L75.7330233023304,51.146050749998174L77.34758475847596,49.256396621718906L79.7694269426944,46.81473359890211L80.7785278527854,46.6117431387505L81.08125812581275,45.59787027332435L82.6958195819583,44.43409845405478L84.81493149314947,44.02984401094029L85.01675167516765,45.091599234791L87.33768376837702,45.04099622050387L88.64951495149529,45.69917732157037L89.2549754975499,46.40882510666905L90.56680668066818,46.6117431387505L91.97954795479563,47.52577564344177L91.97954795479563,51.2483875358781L91.4749974997501,53.2994129514741L91.37408740874102,55.51367019799956L91.77772777277737,56.39186143390471L91.4749974997501,58.153143505435864L91.07135713571374,58.4127175112897L90.36498649865,60.59898994034326L87.33768376837702,64.00392658682911L85.92494249424956,63.74105234542495L84.91584158415856,64.0565209775018L83.6040104010402,63.58340573835704Z", id: "Zimbabwe", style: countryStyle }))))));
    };
    CountryFacet.contextTypes = {
        searchState: React.PropTypes.object,
        transition: React.PropTypes.func
    };
    return CountryFacet;
}(React.Component));
exports.CountryFacet = CountryFacet;
//# sourceMappingURL=MapFacet.js.map